"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _AutoComplete = require("webiny-ui/AutoComplete");

var _components = require("webiny-app/components");

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _reactApollo = require("react-apollo");

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    query LoadCategories($search: SearchInput) {\n        cms {\n            categories: listCategories(search: $search) {\n                data {\n                    id\n                    name\n                }\n            }\n        }\n    }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    query LoadCategory($id: ID!) {\n        cms {\n            getCategory(id: $id) {\n                data {\n                    id\n                    name\n                }\n            }\n        }\n    }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var loadCategory = (0, _graphqlTag.default)(_templateObject());
var listCategories = (0, _graphqlTag.default)(_templateObject2());

var CategoriesAutoComplete = function CategoriesAutoComplete(props) {
  return React.createElement(_reactApollo.Query, {
    skip: !props.value,
    variables: {
      id: props.value
    },
    query: loadCategory
  }, function (_ref) {
    var data = _ref.data;
    return React.createElement(_AutoComplete.AutoComplete, (0, _extends2.default)({}, props, {
      value: (0, _get2.default)(data, "cms.getCategory.data")
    }));
  });
};

var _default = (0, _compose2.default)((0, _components.withAutoComplete)({
  response: function response(data) {
    return (0, _get2.default)(data, "cms.categories");
  },
  search: function search(query) {
    return {
      query: query,
      fields: ["name"]
    };
  },
  query: listCategories
}))(CategoriesAutoComplete);

exports.default = _default;
//# sourceMappingURL=CategoriesAutoComplete.js.map