"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _AutoComplete = require("webiny-ui/AutoComplete");

var _components = require("webiny-app/components");

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _reactApollo = require("react-apollo");

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    query listPublishedPages($search: String) {\n        cms {\n            pages: listPublishedPages(search: $search) {\n                data {\n                    parent\n                    published\n                    title\n                }\n            }\n        }\n    }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    query getPublishedPage($parent: String) {\n        cms {\n            page: getPublishedPage(parent: $parent) {\n                data {\n                    parent\n                    published\n                    title\n                }\n            }\n        }\n    }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

// We utilize the same "listPages" GraphQL field.
var getPage = (0, _graphqlTag.default)(_templateObject());
var listPages = (0, _graphqlTag.default)(_templateObject2());

var PagesAutoComplete = function PagesAutoComplete(props) {
  return React.createElement(_reactApollo.Query, {
    skip: !props.value,
    variables: {
      parent: props.value
    },
    query: getPage
  }, function (_ref) {
    var data = _ref.data;
    var value = (0, _get2.default)(data, "cms.page.data");
    return React.createElement(_AutoComplete.AutoComplete, (0, _extends2.default)({}, props, {
      valueProp: "parent",
      textProp: "title",
      value: value
    }));
  });
};

var _default = (0, _compose2.default)((0, _components.withAutoComplete)({
  response: function response(data) {
    return (0, _get2.default)(data, "cms.pages");
  },
  query: listPages
}))(PagesAutoComplete);

exports.default = _default;
//# sourceMappingURL=PagesAutoComplete.js.map