"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _shouldUpdate2 = _interopRequireDefault(require("recompose/shouldUpdate"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _emotion = require("emotion");

var _webinyPlugins = require("webiny-plugins");

var _Dialog = require("webiny-ui/Dialog");

var _Input = require("webiny-ui/Input");

var _Grid = require("webiny-ui/Grid");

var _webinyForm = require("webiny-form");

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var narrowDialog =
/*#__PURE__*/
(0, _emotion.css)({
  ".mdc-dialog__surface": {
    width: 600,
    minWidth: 600
  }
}, "label:narrowDialog;");
var PreviewBox =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eagc6dt0",
  label: "PreviewBox"
})({
  width: 500,
  minHeight: 250,
  border: "1px solid var(--mdc-theme-on-background)",
  backgroundColor: "#fff",
  // this must always be white
  display: "flex",
  justifyContent: "center",
  alignItems: "center",
  img: {
    maxHeight: 500,
    maxWidth: 500
  }
});

var EditElementDialog = function EditElementDialog(props) {
  var open = props.open,
      onClose = props.onClose,
      onSubmit = props.onSubmit,
      pluginName = props.plugin;
  var plugin = (0, _webinyPlugins.getPlugin)(pluginName);
  return _react.default.createElement(_Dialog.Dialog, {
    open: open,
    onClose: onClose,
    className: narrowDialog
  }, plugin && _react.default.createElement(_webinyForm.Form, {
    onSubmit: onSubmit,
    data: plugin
  }, function (_ref) {
    var submit = _ref.submit,
        Bind = _ref.Bind;
    return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_Dialog.DialogHeader, null, _react.default.createElement(_Dialog.DialogHeaderTitle, null, "Update ", plugin.title)), _react.default.createElement(_Dialog.DialogBody, null, _react.default.createElement(_Grid.Grid, null, _react.default.createElement(_Grid.Cell, {
      span: 12
    }, _react.default.createElement(Bind, {
      name: "title",
      validators: "required"
    }, _react.default.createElement(_Input.Input, {
      label: "Name",
      autoFocus: true
    })))), _react.default.createElement(_Grid.Grid, null, _react.default.createElement(_Grid.Cell, {
      span: 12
    }, _react.default.createElement(PreviewBox, null, plugin.toolbar.preview())))), _react.default.createElement(_Dialog.DialogFooter, null, _react.default.createElement(_Dialog.DialogCancel, null, "Cancel"), _react.default.createElement(_Dialog.DialogFooterButton, {
      onClick: submit
    }, "Save")));
  }));
};

var _default = (0, _compose2.default)((0, _shouldUpdate2.default)(function (props, nextProps) {
  return props.open !== nextProps.open;
}))(EditElementDialog);

exports.default = _default;
//# sourceMappingURL=EditElementDialog.js.map