"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _withState2 = _interopRequireDefault(require("recompose/withState"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _reactApollo = require("react-apollo");

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _webinyPlugins = require("webiny-plugins");

var _Typography = require("webiny-ui/Typography");

var _Button = require("webiny-ui/Button");

var _components = require("webiny-admin/components");

var _ConfirmationDialog = require("webiny-ui/ConfirmationDialog");

var _close = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/close.svg");

var _edit = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/edit.svg");

var _graphql = require("./graphql");

var _EditElementDialog = _interopRequireDefault(require("./EditElementDialog"));

var _createElementPlugin = _interopRequireDefault(require("webiny-app-cms/admin/components/withSavedElements/createElementPlugin"));

var EditIconWrapper =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e168vg7i0",
  label: "EditIconWrapper"
})({
  position: "absolute",
  top: 0,
  right: 48
});
var DeleteIconWrapper =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e168vg7i1",
  label: "DeleteIconWrapper"
})({
  position: "absolute",
  top: 0,
  right: 16
});

var Title = function Title(props) {
  var pluginName = props.plugin,
      deleteElement = props.deleteElement,
      title = props.title,
      updateElement = props.updateElement,
      editDialogOpened = props.editDialogOpened,
      openEditDialog = props.openEditDialog;
  return React.createElement(React.Fragment, null, React.createElement(_Typography.Typography, {
    use: "overline"
  }, title, React.createElement(React.Fragment, null, React.createElement(EditIconWrapper, null, React.createElement(_Button.IconButton, {
    icon: React.createElement(_edit.ReactComponent, null),
    onClick: function onClick() {
      return openEditDialog(true);
    }
  })), " ", React.createElement(_EditElementDialog.default, {
    onSubmit: updateElement,
    plugin: pluginName,
    open: !!editDialogOpened,
    onClose: function onClose() {
      return openEditDialog(false);
    }
  })), React.createElement(DeleteIconWrapper, null, React.createElement(_Button.IconButton, {
    icon: React.createElement(_close.ReactComponent, null),
    onClick: deleteElement
  }))));
};

var _default = (0, _compose2.default)((0, _ConfirmationDialog.withConfirmation)(function (_ref) {
  var title = _ref.title;
  return {
    title: "Delete saved element",
    message: React.createElement("p", null, "Are you sure you want to permanently delete the ", React.createElement("strong", null, title), " element?")
  };
}), (0, _components.withSnackbar)(), (0, _withState2.default)("editDialogOpened", "openEditDialog", false), (0, _reactApollo.graphql)(_graphql.deleteElement, {
  name: "deleteElement"
}), (0, _reactApollo.graphql)(_graphql.updateElement, {
  name: "updateElement"
}), (0, _withHandlers2.default)({
  deleteElement: function deleteElement(_ref2) {
    var id = _ref2.id,
        title = _ref2.title,
        plugin = _ref2.plugin,
        showConfirmation = _ref2.showConfirmation,
        showSnackbar = _ref2.showSnackbar,
        _deleteElement = _ref2.deleteElement,
        refresh = _ref2.refresh;
    return function () {
      showConfirmation(
      /*#__PURE__*/
      (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var _ref4, res, error;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return _deleteElement({
                  variables: {
                    id: id
                  }
                });

              case 2:
                _ref4 = _context.sent;
                res = _ref4.data;
                error = res.cms.deleteElement.error;

                if (!error) {
                  _context.next = 7;
                  break;
                }

                return _context.abrupt("return", showSnackbar(error.message));

              case 7:
                (0, _webinyPlugins.unregisterPlugin)(plugin);
                refresh();
                showSnackbar(React.createElement("span", null, "Element ", React.createElement("strong", null, title), " deleted!"));

              case 10:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      })));
    };
  },
  updateElement: function updateElement(_ref5) {
    var id = _ref5.id,
        showSnackbar = _ref5.showSnackbar,
        _updateElement = _ref5.updateElement,
        openEditDialog = _ref5.openEditDialog,
        refresh = _ref5.refresh;
    return (
      /*#__PURE__*/
      function () {
        var _ref6 = (0, _asyncToGenerator2.default)(
        /*#__PURE__*/
        _regenerator.default.mark(function _callee2(plugin) {
          var name, response, _response$data$cms$up, error, data;

          return _regenerator.default.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  name = plugin.title;
                  _context2.next = 3;
                  return _updateElement({
                    variables: {
                      id: id,
                      data: {
                        name: name
                      }
                    }
                  });

                case 3:
                  response = _context2.sent;
                  _response$data$cms$up = response.data.cms.updateElement, error = _response$data$cms$up.error, data = _response$data$cms$up.data;

                  if (!error) {
                    _context2.next = 9;
                    break;
                  }

                  openEditDialog(false);
                  setTimeout(function () {
                    // For better UX, success message is shown after 300ms has passed.
                    showSnackbar(error.message);
                  }, 300);
                  return _context2.abrupt("return");

                case 9:
                  // This will replace previously registered block plugin.
                  (0, _createElementPlugin.default)(data);
                  openEditDialog(false);
                  refresh();
                  setTimeout(function () {
                    // For better UX, success message is shown after 300ms has passed.
                    showSnackbar("Element " + plugin.title + " successfully saved.");
                  }, 300);

                case 13:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }));

        return function (_x) {
          return _ref6.apply(this, arguments);
        };
      }()
    );
  }
}))(Title);

exports.default = _default;
//# sourceMappingURL=Title.js.map