"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));

var _webinyPlugins = require("webiny-plugins");

var _Title = _interopRequireDefault(require("./Title"));

var _default = function _default(el) {
  var rootPlugin = (0, _webinyPlugins.getPlugin)(el.content.type);

  if (!rootPlugin) {
    return;
  }

  var name = "cms-saved-element-" + el.id;
  (0, _webinyPlugins.registerPlugins)({
    name: name,
    title: el.name,
    type: "cms-element",
    target: rootPlugin.target,
    toolbar: {
      title: function title(_ref) {
        var refresh = _ref.refresh;
        return _react.default.createElement(_Title.default, {
          plugin: name,
          title: el.name,
          id: el.id,
          refresh: refresh
        });
      },
      group: "cms-element-group-saved",
      preview: function preview() {
        return _react.default.createElement("img", {
          src: el.preview.src,
          alt: el.name,
          style: {
            width: 227,
            height: "auto",
            backgroundColor: "#fff"
          }
        });
      }
    },
    onCreate: "skip",
    settings: rootPlugin ? rootPlugin.settings : [],
    create: function create() {
      return (0, _cloneDeep.default)(el.content);
    }
  });
};

exports.default = _default;
//# sourceMappingURL=createElementPlugin.js.map