"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withSavedElements = void 0;

var _reactApollo = require("react-apollo");

var _dotPropImmutable = require("dot-prop-immutable");

var _pages = require("webiny-app-cms/admin/graphql/pages");

var _createElementPlugin = _interopRequireDefault(require("./createElementPlugin"));

var _createBlockPlugin = _interopRequireDefault(require("./createBlockPlugin"));

var elementsAdded = false;

var withSavedElements = function withSavedElements() {
  return (0, _reactApollo.graphql)(_pages.listElements, {
    props: function props(_ref) {
      var data = _ref.data;

      if (data.loading) {
        return {
          elements: null
        };
      }

      var elements = (0, _dotPropImmutable.get)(data, "cms.elements.data");

      if (!elementsAdded) {
        elements.forEach(function (el) {
          if (el.type === "element") {
            (0, _createElementPlugin.default)(el);
          } else {
            (0, _createBlockPlugin.default)(el);
          }
        });
        elementsAdded = true;
      }

      return {
        elements: elements
      };
    }
  });
};

exports.withSavedElements = withSavedElements;
//# sourceMappingURL=withSavedElements.js.map