"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.updateElement = exports.createElement = exports.listElements = exports.deletePage = exports.deleteRevision = exports.publishRevision = exports.createRevisionFrom = exports.getPage = exports.listPages = exports.createPage = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _webinyPlugins = require("webiny-plugins");

function _templateObject10() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    mutation CmsUpdateElement($id: ID!, $data: UpdateElementInput!) {\n        cms {\n            element: updateElement(id: $id, data: $data) {\n                data {\n                    ", "\n                }\n                ", "\n            }\n        }\n    }\n"]);

  _templateObject10 = function _templateObject10() {
    return data;
  };

  return data;
}

function _templateObject9() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    mutation CmsCreateElement($data: ElementInput!) {\n        cms {\n            element: createElement(data: $data) {\n                data {\n                    ", "\n                }\n                ", "\n            }\n        }\n    }\n"]);

  _templateObject9 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    query CmsListElements {\n        cms {\n            elements: listElements(perPage: 1000) {\n                data {\n                    ", "\n                }\n            }\n        }\n    }\n"]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    mutation DeletePage($id: ID!) {\n        cms {\n            deletePage(id: $id) {\n                data\n                ", "\n            }\n        }\n    }\n"]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    mutation CmsDeleteRevision($id: ID!) {\n        cms {\n            deleteRevision(id: $id) {\n                data\n                ", "\n            }\n        }\n    }\n"]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    mutation CmsPublishRevision($id: ID!) {\n        cms {\n            publishRevision(id: $id) {\n                data {\n                    ", "\n                }\n                ", "\n            }\n        }\n    }\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    mutation CmsCreateRevisionFrom($revision: ID!) {\n        cms {\n            revision: createRevisionFrom(revision: $revision) {\n                data {\n                    id\n                }\n                ", "\n            }\n        }\n    }\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    query CmsGetPage($id: ID!) {\n        cms {\n            page: getPage(id: $id) {\n                data {\n                    ", "\n                    snippet\n                    content\n                    settings {\n                        _empty\n                        ", "\n                    }\n                    category {\n                        id\n                        name\n                        url\n                    }\n                    revisions {\n                        ", "\n                    }\n                }\n                ", "\n            }\n        }\n    }\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    query CmsListPages($sort: JSON, $page: Int, $perPage: Int, $search: String) {\n        cms {\n            pages: listPages(sort: $sort, page: $page, perPage: $perPage, search: $search) {\n                data {\n                    ", "\n                    category {\n                        id\n                        name\n                    }\n                    createdBy {\n                        firstName\n                        lastName\n                    }\n                }\n                meta {\n                    totalCount\n                    to\n                    from\n                    nextPage\n                    previousPage\n                }\n            }\n        }\n    }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    mutation CmsCreatePage($category: ID!) {\n        cms {\n            page: createPage(data: { category: $category }) {\n                data {\n                    id\n                }\n                ", "\n            }\n        }\n    }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var error = "\nerror {\n    code\n    message\n}";
var sharedFields = "\n    id\n    title\n    url\n    version\n    parent\n    published\n    locked\n    savedOn\n";
var createPage = (0, _graphqlTag.default)(_templateObject(), error);
exports.createPage = createPage;
var listPages = (0, _graphqlTag.default)(_templateObject2(), sharedFields);
exports.listPages = listPages;

var getPage = function getPage() {
  return (0, _graphqlTag.default)(_templateObject3(), sharedFields, (0, _webinyPlugins.getPlugins)("cms-editor-page-settings").map(function (pl) {
    return pl.fields;
  }).join("\n"), sharedFields, error);
};

exports.getPage = getPage;
var createRevisionFrom = (0, _graphqlTag.default)(_templateObject4(), error);
exports.createRevisionFrom = createRevisionFrom;
var publishRevision = (0, _graphqlTag.default)(_templateObject5(), sharedFields, error);
exports.publishRevision = publishRevision;
var deleteRevision = (0, _graphqlTag.default)(_templateObject6(), error);
exports.deleteRevision = deleteRevision;
var deletePage = (0, _graphqlTag.default)(_templateObject7(), error);
exports.deletePage = deletePage;
var elementFields =
/*GraphQL*/
"\nid\nname\ntype\ncategory\ncontent\npreview {\n    src\n    meta\n}\n";
var listElements = (0, _graphqlTag.default)(_templateObject8(), elementFields);
exports.listElements = listElements;
var createElement = (0, _graphqlTag.default)(_templateObject9(), elementFields, error);
exports.createElement = createElement;
var updateElement = (0, _graphqlTag.default)(_templateObject10(), elementFields, error);
exports.updateElement = updateElement;
//# sourceMappingURL=pages.js.map