"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _get2 = _interopRequireDefault(require("lodash/get"));

var React = _interopRequireWildcard(require("react"));

var _webinyForm = require("webiny-form");

var _Input = require("webiny-ui/Input");

var _Typography = require("webiny-ui/Typography");

var _Grid = require("webiny-ui/Grid");

var _Button = require("webiny-ui/Button");

var _Select = require("webiny-ui/Select");

var _components = require("webiny-app-cms/admin/components");

var _Elevation = require("webiny-ui/Elevation");

var LinkForm = function LinkForm(_ref) {
  var data = _ref.data,
      onSubmit = _ref.onSubmit,
      onCancel = _ref.onCancel;
  return React.createElement(_Elevation.Elevation, {
    z: 4
  }, React.createElement(_webinyForm.Form, {
    data: data,
    onSubmit: onSubmit
  }, function (_ref2) {
    var submit = _ref2.submit,
        Bind = _ref2.Bind;
    return React.createElement(React.Fragment, null, React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
      span: 12
    }, React.createElement(_Typography.Typography, {
      use: "overline"
    }, "Page list menu item"))), React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
      span: 12
    }, React.createElement(Bind, {
      name: "title",
      validators: ["required"]
    }, React.createElement(_Input.Input, {
      label: "Title"
    })))), React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
      span: 12
    }, React.createElement(Bind, {
      name: "category",
      validators: ["required"]
    }, React.createElement(_components.CategoriesAutoComplete, {
      label: "Category"
    })))), React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
      span: 12
    }, React.createElement(Bind, {
      name: "sortBy",
      defaultValue: "publishedOn",
      validators: ["required"]
    }, React.createElement(_Select.Select, {
      label: "Sort by..."
    }, React.createElement("option", {
      value: "publishedOn"
    }, "Published on"), React.createElement("option", {
      value: "title"
    }, "Title"))))), React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
      span: 12
    }, React.createElement(Bind, {
      name: "sortDir",
      defaultValue: "-1",
      validators: ["required"]
    }, React.createElement(_Select.Select, {
      label: "Sort direction..."
    }, React.createElement("option", {
      value: "1"
    }, "Ascending"), React.createElement("option", {
      value: "-1"
    }, "Descending"))))), React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
      span: 12
    }, React.createElement(Bind, {
      name: "tags"
    }, React.createElement(_components.TagsMultiAutoComplete, null)))), React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
      span: 12
    }, (0, _get2.default)(data, "tags.length", 0) > 0 && React.createElement(Bind, {
      name: "tagsRule",
      defaultValue: "ALL"
    }, React.createElement(_Select.Select, {
      label: "Tags rule...",
      validators: ["required"]
    }, React.createElement("option", {
      value: "ALL"
    }, "Must include all tags"), React.createElement("option", {
      value: "ANY"
    }, "Must include any of the tags"))))), React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
      span: 12
    }, React.createElement(_Button.ButtonSecondary, {
      onClick: onCancel
    }, "Cancel"), React.createElement(_Button.ButtonPrimary, {
      onClick: submit,
      style: {
        float: "right"
      }
    }, "Save menu item"))));
  }));
};

var _default = LinkForm;
exports.default = _default;
//# sourceMappingURL=PageListForm.js.map