"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _emotion = require("emotion");

var _plugins = require("webiny-app/plugins");

var _Typography = require("webiny-ui/Typography");

var _Grid = require("webiny-ui/Grid");

var headerTitle =
/*#__PURE__*/
(0, _emotion.css)({
  "&.mdc-layout-grid": {
    borderBottom: "1px solid var(--mdc-theme-on-background)",
    color: "var(--mdc-theme-text-primary-on-background)",
    background: "var(--mdc-theme-surface)",
    paddingTop: 10,
    paddingBottom: 9,
    ".mdc-layout-grid__inner": {
      alignItems: "center"
    }
  }
}, "label:headerTitle;");
var pageTitle =
/*#__PURE__*/
(0, _emotion.css)({
  whiteSpace: "nowrap",
  overflow: "hidden",
  textOverflow: "ellipsis"
}, "label:pageTitle;");
var headerActions =
/*#__PURE__*/
(0, _emotion.css)({
  justifyContent: "flex-end",
  marginRight: "-15px",
  display: "flex",
  alignItems: "center"
}, "label:headerActions;");

var PageActions = function PageActions(_ref) {
  var pageDetails = _ref.pageDetails,
      page = _ref.pageDetails.page;
  return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_Grid.Grid, {
    className: headerTitle
  }, _react.default.createElement(_Grid.Cell, {
    span: 8,
    className: pageTitle
  }, _react.default.createElement(_Typography.Typography, {
    use: "headline5"
  }, page.title)), _react.default.createElement(_Grid.Cell, {
    span: 4,
    className: headerActions
  }, (0, _plugins.renderPlugins)("cms-page-details-header-left", {
    pageDetails: pageDetails
  }), (0, _plugins.renderPlugins)("cms-page-details-header-right", {
    pageDetails: pageDetails
  }))));
};

var _default = PageActions;
exports.default = _default;
//# sourceMappingURL=Header.js.map