"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _dotPropImmutable = _interopRequireDefault(require("dot-prop-immutable"));

var _reactApollo = require("react-apollo");

var _components = require("webiny-app/components");

var _components2 = require("webiny-admin/components");

var _Button = require("webiny-ui/Button");

var _Tooltip = require("webiny-ui/Tooltip");

var _ConfirmationDialog = require("webiny-ui/ConfirmationDialog");

var _delete = require("@svgr/webpack!webiny-app-cms/admin/assets/delete.svg");

var _pages = require("webiny-app-cms/admin/graphql/pages");

var DeletePage = function DeletePage(_ref) {
  var confirmDelete = _ref.confirmDelete;
  return _react.default.createElement(_Tooltip.Tooltip, {
    content: "Delete",
    placement: "top"
  }, _react.default.createElement(_Button.IconButton, {
    icon: _react.default.createElement(_delete.ReactComponent, null),
    onClick: confirmDelete
  }));
};

var _default = (0, _compose2.default)((0, _components.withRouter)(), (0, _ConfirmationDialog.withConfirmation)(function (_ref2) {
  var page = _ref2.pageDetails.page;
  return {
    title: "Delete page",
    message: _react.default.createElement("p", null, "You are about to delete the entire page and all of its revisions! ", _react.default.createElement("br", null), "Are you sure you want to permanently delete the page ", _react.default.createElement("strong", null, page.title), "?")
  };
}), (0, _reactApollo.graphql)(_pages.deletePage, {
  name: "deletePage"
}), (0, _components2.withDialog)(), (0, _components2.withSnackbar)(), (0, _withHandlers2.default)({
  confirmDelete: function confirmDelete(_ref3) {
    var page = _ref3.pageDetails.page,
        router = _ref3.router,
        showConfirmation = _ref3.showConfirmation,
        deletePage = _ref3.deletePage,
        showDialog = _ref3.showDialog,
        showSnackbar = _ref3.showSnackbar;
    return function () {
      showConfirmation(
      /*#__PURE__*/
      (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var _ref5, res, _dot$get, error;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return deletePage({
                  variables: {
                    id: page.parent
                  },
                  refetchQueries: ["CmsListPages"]
                });

              case 2:
                _ref5 = _context.sent;
                res = _ref5.data;
                _dot$get = _dotPropImmutable.default.get(res, "cms.deletePage"), error = _dot$get.error;

                if (!error) {
                  _context.next = 7;
                  break;
                }

                return _context.abrupt("return", showDialog(error.message, {
                  title: "Could not delete page"
                }));

              case 7:
                showSnackbar(_react.default.createElement("span", null, "The page", " ", _react.default.createElement("strong", null, page.title.substr(0, 20), "..."), " ", "was deleted successfully!"));
                router.goToRoute({
                  name: "Cms.Pages"
                });

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      })));
    };
  }
}))(DeletePage);

exports.default = _default;
//# sourceMappingURL=DeletePage.js.map