"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _components = require("webiny-app/components");

var _Button = require("webiny-ui/Button");

var _Tooltip = require("webiny-ui/Tooltip");

var _ConfirmationDialog = require("webiny-ui/ConfirmationDialog");

var _edit = require("@svgr/webpack!webiny-app-cms/admin/assets/edit.svg");

var _withRevisionHandlers = _interopRequireDefault(require("../../pageRevisions/withRevisionHandlers"));

var _pages = require("webiny-app-cms/admin/graphql/pages");

var _reactApollo = require("react-apollo");

var _components2 = require("webiny-admin/components");

var _roundAdd24px = require("@svgr/webpack!./icons/round-add-24px.svg");

var EditRevision = function EditRevision(_ref) {
  var page = _ref.pageDetails.page,
      router = _ref.router,
      gqlCreate = _ref.gqlCreate,
      showSnackbar = _ref.showSnackbar;
  var unpublishedRevision = ((0, _get2.default)(page, "revisions") || []).find(function (item) {
    return !item.published && !item.locked;
  });

  if (unpublishedRevision) {
    return _react.default.createElement(_Tooltip.Tooltip, {
      content: "Edit",
      placement: "top"
    }, _react.default.createElement(_Button.IconButton, {
      icon: _react.default.createElement(_edit.ReactComponent, null),
      onClick: function onClick() {
        return router.goToRoute({
          name: "Cms.Editor",
          params: {
            id: unpublishedRevision.id
          }
        });
      }
    }));
  }

  return _react.default.createElement(_Tooltip.Tooltip, {
    content: "New draft",
    placement: "top"
  }, _react.default.createElement(_ConfirmationDialog.ConfirmationDialog, {
    title: "Create new draft",
    message: "You are about to create a new draft, do you want to continue?"
  }, function (_ref2) {
    var showConfirmation = _ref2.showConfirmation;
    return _react.default.createElement(_Button.IconButton, {
      icon: _react.default.createElement(_roundAdd24px.ReactComponent, null),
      onClick: function onClick() {
        var _page$revisions = (0, _slicedToArray2.default)(page.revisions, 1),
            latestRevision = _page$revisions[0];

        showConfirmation(
        /*#__PURE__*/
        (0, _asyncToGenerator2.default)(
        /*#__PURE__*/
        _regenerator.default.mark(function _callee() {
          var _ref4, res, _res$cms$revision, data, error;

          return _regenerator.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return gqlCreate({
                    variables: {
                      revision: latestRevision.id
                    }
                  });

                case 2:
                  _ref4 = _context.sent;
                  res = _ref4.data;
                  _res$cms$revision = res.cms.revision, data = _res$cms$revision.data, error = _res$cms$revision.error;

                  if (!error) {
                    _context.next = 7;
                    break;
                  }

                  return _context.abrupt("return", showSnackbar(error.message));

                case 7:
                  router.goToRoute({
                    name: "Cms.Editor",
                    params: {
                      id: data.id
                    }
                  });

                case 8:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        })));
      }
    });
  }));
};

var _default = (0, _compose2.default)((0, _components2.withSnackbar)(), (0, _reactApollo.graphql)(_pages.createRevisionFrom, {
  name: "gqlCreate"
}), (0, _components.withRouter)(), _withRevisionHandlers.default)(EditRevision);

exports.default = _default;
//# sourceMappingURL=EditRevision.js.map