"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _get2 = _interopRequireDefault(require("lodash/get"));

var _withState2 = _interopRequireDefault(require("recompose/withState"));

var _withProps2 = _interopRequireDefault(require("recompose/withProps"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _withPublishRevisionHandler = _interopRequireDefault(require("../../utils/withPublishRevisionHandler"));

var _PublishRevisionDialog = _interopRequireDefault(require("./PublishRevisionDialog"));

var _Button = require("webiny-ui/Button");

var _Tooltip = require("webiny-ui/Tooltip");

var _roundPublish24px = require("@svgr/webpack!webiny-app-cms/admin/assets/round-publish-24px.svg");

function getPublishSuggestion(page, revisions) {
  if (!page.published) {
    return page.id;
  }

  if (revisions[0]) {
    return revisions[0].id;
  }

  return "";
}

function getPublishableRevisions(revisions) {
  return revisions.filter(function (r) {
    return !r.published;
  }).sort(function (a, b) {
    return new Date(b.savedOn) - new Date(a.savedOn);
  });
}

var PublishRevision = function PublishRevision(_ref) {
  var openDialog = _ref.openDialog,
      showDialog = _ref.showDialog,
      hideDialog = _ref.hideDialog,
      publishRevision = _ref.publishRevision,
      publishableRevisions = _ref.publishableRevisions,
      publishSuggestion = _ref.publishSuggestion;

  if (!publishableRevisions.length) {
    return null;
  }

  return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_Tooltip.Tooltip, {
    content: "Publish",
    placement: "top"
  }, _react.default.createElement(_Button.IconButton, {
    icon: _react.default.createElement(_roundPublish24px.ReactComponent, null),
    onClick: showDialog
  })), _react.default.createElement(_PublishRevisionDialog.default, {
    open: openDialog,
    onClose: hideDialog,
    onSubmit: publishRevision,
    selected: publishSuggestion,
    revisions: publishableRevisions
  }));
};

var _default = (0, _compose2.default)((0, _withProps2.default)(function (_ref2) {
  var page = _ref2.pageDetails.page;
  var publishableRevisions = getPublishableRevisions((0, _get2.default)(page, "revisions") || []);
  return {
    publishableRevisions: publishableRevisions,
    publishSuggestion: getPublishSuggestion(page, publishableRevisions)
  };
}), (0, _withPublishRevisionHandler.default)("publish"), (0, _withState2.default)("openDialog", "setOpenDialog", false), (0, _withHandlers2.default)({
  showDialog: function showDialog(_ref3) {
    var setOpenDialog = _ref3.setOpenDialog;
    return function () {
      return setOpenDialog(true);
    };
  },
  hideDialog: function hideDialog(_ref4) {
    var setOpenDialog = _ref4.setOpenDialog;
    return function () {
      return setOpenDialog(false);
    };
  }
}), (0, _withHandlers2.default)({
  publishRevision: function publishRevision(_ref5) {
    var publish = _ref5.publish,
        hideDialog = _ref5.hideDialog;
    return function (revision) {
      hideDialog();
      publish(revision);
    };
  }
}))(PublishRevision);

exports.default = _default;
//# sourceMappingURL=PublishRevision.js.map