"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _emotion = require("emotion");

var _Dialog = require("webiny-ui/Dialog");

var _Select = require("webiny-ui/Select");

var _webinyForm = require("webiny-form");

var narrowDialog =
/*#__PURE__*/
(0, _emotion.css)({
  ".mdc-dialog__surface": {
    width: 600,
    minWidth: 600
  }
}, "label:narrowDialog;");

var PublishRevisionDialog = function PublishRevisionDialog(_ref) {
  var open = _ref.open,
      onClose = _ref.onClose,
      _onSubmit = _ref.onSubmit,
      revisions = _ref.revisions,
      selected = _ref.selected;
  return _react.default.createElement(_Dialog.Dialog, {
    open: open,
    onClose: onClose,
    className: narrowDialog
  }, _react.default.createElement(_webinyForm.Form, {
    data: {
      revision: selected || ""
    },
    onSubmit: function onSubmit(_ref2) {
      var revision = _ref2.revision;
      return _onSubmit(revisions.find(function (r) {
        return r.id === revision;
      }));
    }
  }, function (_ref3) {
    var submit = _ref3.submit,
        Bind = _ref3.Bind;
    return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_Dialog.DialogHeader, null, _react.default.createElement(_Dialog.DialogHeaderTitle, null, "Select a revision to publish")), _react.default.createElement(_Dialog.DialogBody, null, _react.default.createElement(Bind, {
      name: "revision",
      validators: ["required"]
    }, _react.default.createElement(_Select.Select, {
      label: "Revision to publish"
    }, revisions.filter(function (r) {
      return !r.published;
    }).map(function (rev) {
      return _react.default.createElement("option", {
        key: rev.id,
        value: rev.id
      }, rev.title, " (#", rev.version, ")");
    })))), _react.default.createElement(_Dialog.DialogFooter, null, _react.default.createElement(_Dialog.DialogCancel, null, "Cancel"), _react.default.createElement(_Dialog.DialogAccept, {
      onClick: submit
    }, "Publish")));
  }));
};

var _default = PublishRevisionDialog;
exports.default = _default;
//# sourceMappingURL=PublishRevisionDialog.js.map