"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireDefault(require("react"));

var _emotion = require("emotion");

var _components = require("webiny-app/components");

var _Button = require("webiny-ui/Button");

var _Icon = require("webiny-ui/Icon");

var _roundArrow_drop_down24px = require("@svgr/webpack!webiny-app-cms/admin/assets/round-arrow_drop_down-24px.svg");

var _menu = require("@rmwc/menu");

var _Typography = require("webiny-ui/Typography");

var _Menu = require("webiny-ui/Menu");

var buttonStyle =
/*#__PURE__*/
(0, _emotion.css)({
  "&.mdc-button": {
    color: "var(--mdc-theme-text-primary-on-background) !important"
  }
}, "label:buttonStyle;");
var menuList =
/*#__PURE__*/
(0, _emotion.css)({
  ".mdc-list-item": {
    flexDirection: "column",
    justifyContent: "center",
    alignItems: "baseline",
    textAlign: "left"
  }
}, "label:menuList;");

var RevisionSelector = function RevisionSelector(_ref) {
  var router = _ref.router,
      page = _ref.pageDetails.page;
  return _react.default.createElement(_Menu.Menu, {
    className: menuList,
    onSelect: function onSelect(evt) {
      return router.goToRoute({
        params: {
          id: page.revisions[evt.detail.index].id
        },
        merge: true
      });
    },
    handle: _react.default.createElement(_Button.ButtonDefault, {
      className: buttonStyle
    }, "v", page.version, " ", _react.default.createElement(_Icon.Icon, {
      icon: _react.default.createElement(_roundArrow_drop_down24px.ReactComponent, null)
    }))
  }, ((0, _get2.default)(page, "revisions") || []).map(function (rev) {
    var status = "draft";
    if (rev.published) status = "published";
    if (rev.locked && !rev.published) status = "locked";
    return _react.default.createElement(_menu.MenuItem, {
      key: rev.id
    }, _react.default.createElement(_Typography.Typography, {
      use: "body2"
    }, "v", rev.version), _react.default.createElement(_Typography.Typography, {
      use: "caption"
    }, "(", status, ")"));
  }));
};

var _default = (0, _components.withRouter)()(RevisionSelector);

exports.default = _default;
//# sourceMappingURL=RevisionSelector.js.map