"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _emotion = require("emotion");

var _timeagoReact = _interopRequireDefault(require("timeago-react"));

var _List = require("webiny-ui/List");

var _Button = require("webiny-ui/Button");

var _Icon = require("webiny-ui/Icon");

var _Menu = require("webiny-ui/Menu");

var _components = require("webiny-app/components");

var _components2 = require("webiny-admin/components");

var _ConfirmationDialog = require("webiny-ui/ConfirmationDialog");

var _Tooltip = require("webiny-ui/Tooltip");

var _components3 = require("webiny-app-cms/admin/components");

var _more_vert = require("@svgr/webpack!webiny-app-cms/admin/assets/more_vert.svg");

var _lock = require("@svgr/webpack!webiny-app-cms/admin/assets/lock.svg");

var _beenhere = require("@svgr/webpack!webiny-app-cms/admin/assets/beenhere.svg");

var _gesture = require("@svgr/webpack!webiny-app-cms/admin/assets/gesture.svg");

var _withRevisionHandlers = _interopRequireDefault(require("./withRevisionHandlers"));

var _add = require("@svgr/webpack!webiny-app-cms/admin/assets/add.svg");

var _edit = require("@svgr/webpack!webiny-app-cms/admin/assets/edit.svg");

var _roundPublish24px = require("@svgr/webpack!webiny-app-cms/admin/assets/round-publish-24px.svg");

var _delete = require("@svgr/webpack!webiny-app-cms/admin/assets/delete.svg");

var _visibility = require("@svgr/webpack!webiny-app-cms/admin/assets/visibility.svg");

var primaryColor =
/*#__PURE__*/
(0, _emotion.css)({
  color: "var(--mdc-theme-primary)"
}, "label:primaryColor;");
var revisionsMenu =
/*#__PURE__*/
(0, _emotion.css)({
  width: 250,
  right: -105,
  left: "auto !important"
}, "label:revisionsMenu;");

var getIcon = function getIcon(rev) {
  switch (true) {
    case rev.locked && !rev.published:
      return {
        icon: _react.default.createElement(_Icon.Icon, {
          icon: _react.default.createElement(_lock.ReactComponent, null)
        }),
        text: "This revision is locked (it has already been published)"
      };

    case rev.published:
      return {
        icon: _react.default.createElement(_Icon.Icon, {
          icon: _react.default.createElement(_beenhere.ReactComponent, null),
          className: primaryColor
        }),
        text: "This revision is currently published!"
      };

    default:
      return {
        icon: _react.default.createElement(_Icon.Icon, {
          icon: _react.default.createElement(_gesture.ReactComponent, null)
        }),
        text: "This is a draft"
      };
  }
};

var Revision = function Revision(props) {
  var rev = props.rev,
      createRevision = props.createRevision,
      editRevision = props.editRevision,
      deleteRevision = props.deleteRevision,
      publishRevision = props.publishRevision,
      getPagePreviewUrl = props.cmsSettings.getPagePreviewUrl;

  var _getIcon = getIcon(rev),
      icon = _getIcon.icon,
      tooltipText = _getIcon.text;

  return _react.default.createElement(_ConfirmationDialog.ConfirmationDialog, {
    title: "Confirmation required!",
    message: _react.default.createElement("span", null, "Are you sure you want to delete this revision?")
  }, function (_ref) {
    var showConfirmation = _ref.showConfirmation;
    return _react.default.createElement(_List.ListItem, null, _react.default.createElement(_List.ListItemGraphic, null, _react.default.createElement(_Tooltip.Tooltip, {
      content: tooltipText,
      placement: "bottom"
    }, icon)), _react.default.createElement(_List.ListItemText, null, _react.default.createElement(_List.ListItemTextPrimary, null, rev.title), _react.default.createElement(_List.ListItemTextSecondary, null, "Last modified ", _react.default.createElement(_timeagoReact.default, {
      datetime: rev.savedOn
    }), " (#", rev.version, ")")), _react.default.createElement(_List.ListItemMeta, null, _react.default.createElement(_Menu.Menu, {
      handle: _react.default.createElement(_Button.IconButton, {
        icon: _react.default.createElement(_more_vert.ReactComponent, null)
      }),
      className: revisionsMenu,
      openSide: "left"
    }, _react.default.createElement(_Menu.MenuItem, {
      onClick: createRevision
    }, _react.default.createElement(_List.ListItemGraphic, null, _react.default.createElement(_Icon.Icon, {
      icon: _react.default.createElement(_add.ReactComponent, null)
    })), "New from current"), !rev.locked && _react.default.createElement(_Menu.MenuItem, {
      onClick: editRevision
    }, _react.default.createElement(_List.ListItemGraphic, null, _react.default.createElement(_Icon.Icon, {
      icon: _react.default.createElement(_edit.ReactComponent, null)
    })), "Edit"), !rev.published && _react.default.createElement(_Menu.MenuItem, {
      onClick: function onClick() {
        return publishRevision(rev);
      }
    }, _react.default.createElement(_List.ListItemGraphic, null, _react.default.createElement(_Icon.Icon, {
      icon: _react.default.createElement(_roundPublish24px.ReactComponent, null)
    })), "Publish"), _react.default.createElement(_Menu.MenuItem, {
      onClick: function onClick() {
        return window.open(getPagePreviewUrl(rev), "_blank");
      }
    }, _react.default.createElement(_List.ListItemGraphic, null, _react.default.createElement(_Icon.Icon, {
      icon: _react.default.createElement(_visibility.ReactComponent, null)
    })), "Preview"), !rev.locked && _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_Menu.MenuDivider, null), _react.default.createElement(_Menu.MenuItem, {
      onClick: function onClick() {
        return showConfirmation(deleteRevision);
      }
    }, _react.default.createElement(_List.ListItemGraphic, null, _react.default.createElement(_Icon.Icon, {
      icon: _react.default.createElement(_delete.ReactComponent, null)
    })), "Delete")))));
  });
};

var _default = (0, _compose2.default)((0, _components.withRouter)(), (0, _components2.withSnackbar)(), (0, _components3.withPageDetails)(), _withRevisionHandlers.default, (0, _components3.withCmsSettings)())(Revision);

exports.default = _default;
//# sourceMappingURL=Revision.js.map