"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _List = require("webiny-ui/List");

var _Revision = _interopRequireDefault(require("./Revision"));

var _Elevation = require("webiny-ui/Elevation");

var _emotion = require("emotion");

var _Progress = require("webiny-ui/Progress");

var listWrapper =
/*#__PURE__*/
(0, _emotion.css)({
  margin: 25,
  display: "flex",
  flexDirection: "column",
  overflow: "scroll",
  maxHeight: "calc(100vh - 160px)",
  ".mdc-list .mdc-list-item": {
    borderBottom: "1px solid var(--mdc-theme-on-background)"
  },
  ".mdc-list .mdc-list-item:last-child": {
    borderBottom: "none"
  }
}, "label:listWrapper;");

var RevisionsList = function RevisionsList(_ref) {
  var page = _ref.pageDetails.page,
      loading = _ref.loading;
  return _react.default.createElement(_Elevation.Elevation, {
    className: listWrapper,
    z: 2
  }, _react.default.createElement("div", {
    style: {
      position: "relative"
    }
  }, loading && _react.default.createElement(_Progress.CircularProgress, null), _react.default.createElement(_List.List, {
    nonInteractive: true,
    twoLine: true
  }, page.revisions.map(function (rev) {
    return _react.default.createElement(_Revision.default, {
      rev: rev,
      key: rev.id
    });
  }))));
};

var _default = RevisionsList;
exports.default = _default;
//# sourceMappingURL=RevisionsList.js.map