"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _reactApollo = require("react-apollo");

var _pages = require("webiny-app-cms/admin/graphql/pages");

var _withPublishRevisionHandler = _interopRequireDefault(require("../utils/withPublishRevisionHandler"));

var _default = (0, _compose2.default)((0, _reactApollo.graphql)(_pages.createRevisionFrom, {
  name: "gqlCreate"
}), (0, _reactApollo.graphql)(_pages.deleteRevision, {
  name: "gqlDelete"
}), (0, _withPublishRevisionHandler.default)("publishRevision"), (0, _withHandlers2.default)({
  createRevision: function createRevision(_ref) {
    var rev = _ref.rev,
        router = _ref.router,
        gqlCreate = _ref.gqlCreate,
        showSnackbar = _ref.showSnackbar;
    return (
      /*#__PURE__*/
      (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var _ref3, res, _res$cms$revision, data, error;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return gqlCreate({
                  variables: {
                    revision: rev.id
                  }
                });

              case 2:
                _ref3 = _context.sent;
                res = _ref3.data;
                _res$cms$revision = res.cms.revision, data = _res$cms$revision.data, error = _res$cms$revision.error;

                if (!error) {
                  _context.next = 7;
                  break;
                }

                return _context.abrupt("return", showSnackbar(error.message));

              case 7:
                router.goToRoute({
                  name: "Cms.Editor",
                  params: {
                    id: data.id
                  }
                });

              case 8:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }))
    );
  },
  editRevision: function editRevision(_ref4) {
    var rev = _ref4.rev,
        router = _ref4.router;
    return function () {
      router.goToRoute({
        name: "Cms.Editor",
        params: {
          id: rev.id
        }
      });
    };
  },
  deleteRevision: function deleteRevision(_ref5) {
    var rev = _ref5.rev,
        page = _ref5.pageDetails.page,
        gqlDelete = _ref5.gqlDelete,
        showSnackbar = _ref5.showSnackbar,
        router = _ref5.router;
    return (
      /*#__PURE__*/
      (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2() {
        var _ref7, res, error;

        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return gqlDelete({
                  refetchQueries: ["CmsLoadPageRevisions"],
                  variables: {
                    id: rev.id
                  }
                });

              case 2:
                _ref7 = _context2.sent;
                res = _ref7.data;
                error = res.cms.deleteRevision.error;

                if (!error) {
                  _context2.next = 7;
                  break;
                }

                return _context2.abrupt("return", showSnackbar(error.message));

              case 7:
                if (rev.id === page.id) {
                  router.goToRoute({
                    params: {
                      id: null
                    }
                  });
                }

              case 8:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }))
    );
  }
}));

exports.default = _default;
//# sourceMappingURL=withRevisionHandlers.js.map