"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _emotion = require("emotion");

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _Typography = require("webiny-ui/Typography");

var _Select = require("webiny-ui/Select");

var _Element = _interopRequireDefault(require("webiny-app-cms/render/components/Element"));

var _Zoom = _interopRequireDefault(require("./Zoom"));

var pageInnerWrapper =
/*#__PURE__*/
(0, _emotion.css)({
  overflowY: "scroll",
  overflowX: "hidden",
  height: "calc(100vh - 230px)",
  position: "relative",
  ".webiny-cms-page-document": {
    transform: "scale(var(--webiny-cms-page-preview-scale))",
    transition: "transform 0.5s ease-in-out",
    transformOrigin: "top center"
  }
}, "label:pageInnerWrapper;");
var PagePreviewToolbar =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e62chup0",
  label: "PagePreviewToolbar"
})({
  position: "sticky",
  bottom: 0,
  height: 30,
  paddingLeft: 15,
  color: "var(--mdc-theme-text-secondary-on-background)",
  borderTop: "1px solid var(--mdc-theme-on-background)",
  backgroundColor: "var(--mdc-theme-background)",
  width: "100%",
  transform: "translateZ(0)",
  display: "flex",
  overflow: "hidden",
  select: {
    fontSize: 14,
    color: "var(--mdc-theme-text-secondary-on-background)",
    width: 75
  }
});

var PagePreview = function PagePreview(_ref) {
  var pageDetails = _ref.pageDetails;
  return React.createElement(_Zoom.default, null, function (_ref2) {
    var zoom = _ref2.zoom,
        setZoom = _ref2.setZoom;
    return React.createElement("div", {
      className: pageInnerWrapper,
      style: {
        "--webiny-cms-page-preview-scale": zoom
      }
    }, React.createElement(_Element.default, {
      element: pageDetails.page.content
    }), React.createElement(PagePreviewToolbar, null, React.createElement("span", null, React.createElement(_Typography.Typography, {
      use: "overline"
    }, "Zoom:\xA0")), React.createElement(_Select.Select, {
      value: zoom.toString(),
      onChange: setZoom
    }, React.createElement("option", {
      value: "1"
    }, "100%"), React.createElement("option", {
      value: "0.75"
    }, "75%"), React.createElement("option", {
      value: "0.5"
    }, "50%"))));
  });
};

var _default = PagePreview;
exports.default = _default;
//# sourceMappingURL=PagePreview.js.map