"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _withHandlers3 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _dotPropImmutable = require("dot-prop-immutable");

var _reactApollo = require("react-apollo");

var _components = require("webiny-admin/components");

var _pages = require("webiny-app-cms/admin/graphql/pages");

var _default = function _default(prop) {
  return (0, _compose2.default)((0, _reactApollo.graphql)(_pages.publishRevision, {
    name: "gqlPublish"
  }), (0, _components.withSnackbar)(), (0, _withHandlers3.default)((0, _defineProperty2.default)({}, prop, function (_ref) {
    var page = _ref.pageDetails.page,
        gqlPublish = _ref.gqlPublish,
        showSnackbar = _ref.showSnackbar;
    return (
      /*#__PURE__*/
      function () {
        var _ref2 = (0, _asyncToGenerator2.default)(
        /*#__PURE__*/
        _regenerator.default.mark(function _callee(revision) {
          var _ref3, res, error;

          return _regenerator.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return gqlPublish({
                    variables: {
                      id: revision.id
                    },
                    refetchQueries: ["CmsListPages"],
                    update: function update(cache, _ref4) {
                      var data = _ref4.data;

                      // Don't do anything if there was an error during publishing!
                      if (data.cms.publishRevision.error) {
                        return;
                      }

                      var getPageQuery = (0, _pages.getPage)(); // Update revisions

                      var pageFromCache = cache.readQuery({
                        query: getPageQuery,
                        variables: {
                          id: page.id
                        }
                      });
                      page.revisions.forEach(function (r) {
                        // Update published/locked fields on the revision that was just published.
                        if (r.id === revision.id) {
                          r.published = true;
                          r.locked = true;
                          return;
                        } // Unpublish other published revisions


                        if (r.published) {
                          r.published = false;
                        }
                      }); // Write our data back to the cache.

                      cache.writeQuery({
                        query: getPageQuery,
                        data: (0, _dotPropImmutable.set)(pageFromCache, "cms.page.data", page)
                      });
                    }
                  });

                case 2:
                  _ref3 = _context.sent;
                  res = _ref3.data;
                  error = res.cms.publishRevision.error;

                  if (!error) {
                    _context.next = 7;
                    break;
                  }

                  return _context.abrupt("return", showSnackbar(error.message));

                case 7:
                  showSnackbar(_react.default.createElement("span", null, "Successfully published revision ", _react.default.createElement("strong", null, "#", revision.version), "!"));

                case 8:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        return function (_x) {
          return _ref2.apply(this, arguments);
        };
      }()
    );
  })));
};

exports.default = _default;
//# sourceMappingURL=withPublishRevisionHandler.js.map