"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var React = _interopRequireWildcard(require("react"));

var _webinyForm = require("webiny-form");

var _Grid = require("webiny-ui/Grid");

var _Button = require("webiny-ui/Button");

var _reactApollo = require("react-apollo");

var _components = require("webiny-admin/components");

var _graphql = _interopRequireDefault(require("./graphql"));

var _PagesAutoComplete = _interopRequireDefault(require("webiny-app-cms/admin/components/PagesAutoComplete"));

var _Progress = require("webiny-ui/Progress");

var _Image = _interopRequireDefault(require("./Image"));

var _SimpleForm = require("webiny-admin/components/SimpleForm");

var CmsSettings =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(CmsSettings, _React$Component);

  function CmsSettings() {
    (0, _classCallCheck2.default)(this, CmsSettings);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(CmsSettings).apply(this, arguments));
  }

  (0, _createClass2.default)(CmsSettings, [{
    key: "render",
    value: function render() {
      var _this = this;

      var showSnackbar = this.props.showSnackbar;
      return React.createElement(_reactApollo.Query, {
        query: _graphql.default.query
      }, function (_ref) {
        var data = _ref.data,
            queryInProgress = _ref.loading;
        return React.createElement(_reactApollo.Mutation, {
          mutation: _graphql.default.mutation
        }, function (update, _ref2) {
          var mutationInProgress = _ref2.loading;
          return React.createElement(_webinyForm.Form, {
            data: data.settings,
            onSubmit:
            /*#__PURE__*/
            function () {
              var _ref3 = (0, _asyncToGenerator2.default)(
              /*#__PURE__*/
              _regenerator.default.mark(function _callee(data) {
                return _regenerator.default.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _this.setState({
                          loading: true
                        });

                        _context.next = 3;
                        return update({
                          variables: {
                            data: data.cms
                          }
                        });

                      case 3:
                        _this.setState({
                          loading: false
                        });

                        showSnackbar("Settings updated successfully.");

                      case 5:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee, this);
              }));

              return function (_x) {
                return _ref3.apply(this, arguments);
              };
            }()
          }, function (_ref4) {
            var Bind = _ref4.Bind,
                form = _ref4.form;
            return React.createElement(_SimpleForm.SimpleForm, null, (queryInProgress || mutationInProgress) && React.createElement(_Progress.CircularProgress, null), React.createElement(_SimpleForm.SimpleFormHeader, {
              title: "CMS Settings"
            }), React.createElement(_SimpleForm.SimpleFormContent, null, React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
              span: 6
            }, React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
              span: 12
            }, React.createElement(Bind, {
              name: "cms.pages.home"
            }, React.createElement(_PagesAutoComplete.default, {
              label: "Homepage",
              description: "This is the homepage of your website."
            }))), React.createElement(_Grid.Cell, {
              span: 12
            }, React.createElement(Bind, {
              name: "cms.pages.error"
            }, React.createElement(_PagesAutoComplete.default, {
              label: "Error page",
              description: "Shown when an error occurs during a page load."
            }))), React.createElement(_Grid.Cell, {
              span: 12
            }, React.createElement(Bind, {
              name: "cms.pages.notFound"
            }, React.createElement(_PagesAutoComplete.default, {
              label: "Not found (404) page",
              description: "Shown when the requested page is not found."
            }))))), React.createElement(_Grid.Cell, {
              span: 6
            }, React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
              span: 12
            }, React.createElement(Bind, {
              name: "cms.social.image"
            }, React.createElement(_Image.default, {
              imageEditor: {
                crop: {
                  autoEnable: true,
                  aspectRatio: 1596 / 545
                }
              },
              label: "Default Open Graph image",
              description: "Any CMS page that doesn't have an Open Graph image set, will use this one."
            }))))))), React.createElement(_SimpleForm.SimpleFormFooter, null, React.createElement(_Button.ButtonPrimary, {
              type: "primary",
              onClick: form.submit,
              align: "right"
            }, "Save")));
          });
        });
      });
    }
  }]);
  return CmsSettings;
}(React.Component);

var _default = (0, _components.withSnackbar)()(CmsSettings);

exports.default = _default;
//# sourceMappingURL=CmsSettings.js.map