"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var React = _interopRequireWildcard(require("react"));

var _webinyForm = require("webiny-form");

var _Grid = require("webiny-ui/Grid");

var _Input = require("webiny-ui/Input");

var _Button = require("webiny-ui/Button");

var _Image = _interopRequireDefault(require("./Image"));

var _reactApollo = require("react-apollo");

var _components = require("webiny-admin/components");

var _graphql = _interopRequireDefault(require("./graphql"));

var _Progress = require("webiny-ui/Progress");

var _SimpleForm = require("webiny-admin/components/SimpleForm");

var GeneralSettings = function GeneralSettings(_ref) {
  var showSnackbar = _ref.showSnackbar;
  return React.createElement(_reactApollo.Query, {
    query: _graphql.default.query
  }, function (_ref2) {
    var data = _ref2.data,
        queryInProgress = _ref2.loading;
    return React.createElement(_reactApollo.Mutation, {
      mutation: _graphql.default.mutation
    }, function (update, _ref3) {
      var mutationInProgress = _ref3.loading;
      return React.createElement(_webinyForm.Form, {
        data: data.settings,
        onSubmit:
        /*#__PURE__*/
        function () {
          var _ref4 = (0, _asyncToGenerator2.default)(
          /*#__PURE__*/
          _regenerator.default.mark(function _callee(data) {
            return _regenerator.default.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.next = 2;
                    return update({
                      variables: {
                        data: data.cms
                      }
                    });

                  case 2:
                    showSnackbar("Settings updated successfully.");

                  case 3:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee, this);
          }));

          return function (_x) {
            return _ref4.apply(this, arguments);
          };
        }()
      }, function (_ref5) {
        var Bind = _ref5.Bind,
            form = _ref5.form;
        return React.createElement(_SimpleForm.SimpleForm, null, (queryInProgress || mutationInProgress) && React.createElement(_Progress.CircularProgress, null), React.createElement(_SimpleForm.SimpleFormHeader, {
          title: "General Settings"
        }), React.createElement(_SimpleForm.SimpleFormContent, null, React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
          span: 6
        }, React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
          span: 12
        }, React.createElement(Bind, {
          name: "cms.name"
        }, React.createElement(_Input.Input, {
          validators: ["required", "url"],
          label: "Website name"
        }))), React.createElement(_Grid.Cell, {
          span: 6
        }, React.createElement(Bind, {
          name: "cms.favicon"
        }, React.createElement(_Image.default, {
          label: "Favicon",
          accept: ["image/png"]
        }))), React.createElement(_Grid.Cell, {
          span: 6
        }, React.createElement(Bind, {
          name: "cms.logo"
        }, React.createElement(_Image.default, {
          label: "Logo"
        }))))), React.createElement(_Grid.Cell, {
          span: 6
        }, React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
          span: 12
        }, React.createElement(Bind, {
          name: "cms.social.facebook",
          validators: ["url"]
        }, React.createElement(_Input.Input, {
          label: "Facebook"
        }))), React.createElement(_Grid.Cell, {
          span: 12
        }, React.createElement(Bind, {
          name: "cms.social.twitter",
          validators: ["url"]
        }, React.createElement(_Input.Input, {
          label: "Twitter"
        }))), React.createElement(_Grid.Cell, {
          span: 12
        }, React.createElement(Bind, {
          name: "cms.social.instagram",
          validators: ["url"]
        }, React.createElement(_Input.Input, {
          label: "Instagram"
        }))))))), React.createElement(_SimpleForm.SimpleFormFooter, null, React.createElement(_Button.ButtonPrimary, {
          type: "primary",
          onClick: form.submit,
          align: "right"
        }, "Save")));
      });
    });
  });
};

var _default = (0, _components.withSnackbar)()(GeneralSettings);

exports.default = _default;
//# sourceMappingURL=GeneralSettings.js.map