"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _CmsSettings = _interopRequireDefault(require("./components/CmsSettings"));

var _GeneralSettings = _interopRequireDefault(require("./components/generalSettings/GeneralSettings"));

var _webinyAppSecurity = require("webiny-app-security");

var _components = require("webiny-app-security/components");

var _default = [{
  type: "settings",
  name: "settings-cms",
  settings: {
    show: function show() {
      return (0, _webinyAppSecurity.hasRoles)(["cms-settings", "cms-editor"]);
    },
    type: "app",
    name: "CMS",
    component: React.createElement(_components.SecureRoute, {
      roles: ["cms-settings", "cms-editor"]
    }, React.createElement(_CmsSettings.default, null)),
    route: {
      name: "Settings.Cms",
      path: "/cms",
      title: "CMS"
    }
  }
}, {
  type: "settings",
  name: "settings-general-settings",
  settings: {
    show: function show() {
      return (0, _webinyAppSecurity.hasRoles)(["cms-settings"]);
    },
    type: "other",
    name: "General settings",
    component: React.createElement(_components.SecureRoute, {
      roles: ["cms-settings"]
    }, React.createElement(_GeneralSettings.default, null)),
    route: {
      name: "Settings.GeneralSettings",
      path: "/general",
      title: "General Settings"
    }
  }
}];
exports.default = _default;
//# sourceMappingURL=index.js.map