"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _pick2 = _interopRequireDefault(require("lodash/pick"));

var React = _interopRequireWildcard(require("react"));

var _dotPropImmutable = require("dot-prop-immutable");

var _i18n = require("webiny-app/i18n");

var _components = require("webiny-admin/components");

var _SplitView = require("webiny-admin/components/SplitView");

var _FloatingActionButton = require("webiny-admin/components/FloatingActionButton");

var _CategoriesDataList = _interopRequireDefault(require("./CategoriesDataList"));

var _CategoriesForm = _interopRequireDefault(require("./CategoriesForm"));

var _graphql = require("./graphql");

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2.default)(["Category {name} saved successfully."]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["Category {name} deleted."]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var t = _i18n.i18n.namespace("Cms.Categories");

var Categories = function Categories(_ref) {
  var router = _ref.router,
      formProps = _ref.formProps,
      listProps = _ref.listProps;
  return React.createElement(React.Fragment, null, React.createElement(_SplitView.SplitView, null, React.createElement(_SplitView.LeftPanel, null, React.createElement(_CategoriesDataList.default, listProps)), React.createElement(_SplitView.RightPanel, null, React.createElement(_CategoriesForm.default, formProps))), React.createElement(_FloatingActionButton.FloatingActionButton, {
    onClick: function onClick() {
      return router.goToRoute({
        params: {
          id: null
        },
        merge: true
      });
    }
  }));
};

var _default = (0, _components.withCrud)({
  list: {
    get: {
      query: _graphql.loadCategories,
      variables: {
        sort: {
          savedOn: -1
        }
      },
      response: function response(data) {
        return (0, _dotPropImmutable.get)(data, "cms.categories");
      }
    },
    delete: {
      mutation: _graphql.deleteCategory,
      response: function response(data) {
        return data.cms.deleteCategory;
      },
      snackbar: function snackbar(data) {
        return t(_templateObject())({
          name: data.name
        });
      }
    }
  },
  form: {
    get: {
      query: _graphql.loadCategory,
      response: function response(data) {
        return (0, _dotPropImmutable.get)(data, "cms.category");
      }
    },
    save: {
      create: _graphql.createCategory,
      update: _graphql.updateCategory,
      response: function response(data) {
        return data.cms.category;
      },
      variables: function variables(form) {
        return {
          data: (0, _pick2.default)(form, ["name", "slug", "url", "layout"])
        };
      },
      snackbar: function snackbar(data) {
        return t(_templateObject2())({
          name: data.name
        });
      }
    }
  }
})(Categories);

exports.default = _default;
//# sourceMappingURL=Categories.js.map