"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var React = _interopRequireWildcard(require("react"));

var _i18n = require("webiny-app/i18n");

var _ConfirmationDialog = require("webiny-ui/ConfirmationDialog");

var _icons = require("webiny-ui/List/DataList/icons");

var _List = require("webiny-ui/List");

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["CMS Categories"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var t = _i18n.i18n.namespace("Cms.CategoriesDataList");

var CategoriesDataList = function CategoriesDataList(_ref) {
  var dataList = _ref.dataList,
      router = _ref.router,
      deleteRecord = _ref.deleteRecord;
  return React.createElement(_List.DataList, (0, _extends2.default)({}, dataList, {
    title: t(_templateObject()),
    sorters: [{
      label: "Newest to oldest",
      sorters: {
        createdOn: -1
      }
    }, {
      label: "Oldest to newest",
      sorters: {
        createdOn: 1
      }
    }, {
      label: "Name A-Z",
      sorters: {
        name: 1
      }
    }, {
      label: "Name Z-A",
      sorters: {
        name: -1
      }
    }]
  }), function (_ref2) {
    var data = _ref2.data;
    return React.createElement(_List.List, null, data.map(function (item) {
      return React.createElement(_List.ListItem, {
        key: item.id
      }, React.createElement(_List.ListItemText, {
        onClick: function onClick() {
          return router.goToRoute({
            params: {
              id: item.id
            },
            merge: true
          });
        }
      }, item.name, React.createElement(_List.ListItemTextSecondary, null, item.url)), React.createElement(_List.ListItemMeta, null, React.createElement(_List.ListActions, null, React.createElement(_ConfirmationDialog.ConfirmationDialog, null, function (_ref3) {
        var showConfirmation = _ref3.showConfirmation;
        return React.createElement(_icons.DeleteIcon, {
          onClick: function onClick() {
            showConfirmation(function () {
              return deleteRecord(item);
            });
          }
        });
      }))));
    }));
  });
};

var _default = CategoriesDataList;
exports.default = _default;
//# sourceMappingURL=CategoriesDataList.js.map