"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var React = _interopRequireWildcard(require("react"));

var _i18n = require("webiny-app/i18n");

var _webinyForm = require("webiny-form");

var _Grid = require("webiny-ui/Grid");

var _Input = require("webiny-ui/Input");

var _Select = require("webiny-ui/Select");

var _Button = require("webiny-ui/Button");

var _context = require("webiny-app-cms/context");

var _SimpleForm = require("webiny-admin/components/SimpleForm");

var _validators = require("./validators");

var _Progress = require("webiny-ui/Progress");

function _templateObject5() {
  var data = (0, _taggedTemplateLiteral2.default)(["Save category"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2.default)(["Layout"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2.default)(["URL"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2.default)(["Slug"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["Name"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var t = _i18n.i18n.namespace("Cms.CategoriesForm");

var CategoriesForm = function CategoriesForm(_ref) {
  var data = _ref.data,
      invalidFields = _ref.invalidFields,
      onSubmit = _ref.onSubmit,
      loading = _ref.loading,
      theme = _ref.cms.theme;
  return React.createElement(_webinyForm.Form, {
    data: data || {},
    invalidFields: invalidFields,
    onSubmit: onSubmit
  }, function (_ref2) {
    var data = _ref2.data,
        form = _ref2.form,
        Bind = _ref2.Bind;
    return React.createElement(_SimpleForm.SimpleForm, null, loading && React.createElement(_Progress.CircularProgress, null), React.createElement(_SimpleForm.SimpleFormContent, null, React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
      span: 6
    }, React.createElement(Bind, {
      name: "name",
      validators: ["required"]
    }, React.createElement(_Input.Input, {
      label: t(_templateObject())
    }))), React.createElement(_Grid.Cell, {
      span: 6
    }, React.createElement(Bind, {
      name: "slug",
      validators: ["required"]
    }, React.createElement(_Input.Input, {
      disabled: data.id,
      label: t(_templateObject2())
    }))), React.createElement(_Grid.Cell, {
      span: 12
    }, React.createElement(Bind, {
      name: "url",
      validators: ["required", _validators.categoryUrlValidator]
    }, React.createElement(_Input.Input, {
      disabled: data.id,
      label: t(_templateObject3())
    }))), React.createElement(_Grid.Cell, {
      span: 6
    }, React.createElement(Bind, {
      name: "layout",
      defaultValue: theme.layouts[0].name
    }, React.createElement(_Select.Select, {
      label: t(_templateObject4())
    }, theme.layouts.map(function (_ref3) {
      var name = _ref3.name,
          title = _ref3.title;
      return React.createElement("option", {
        key: name,
        value: name
      }, title);
    })))))), React.createElement(_SimpleForm.SimpleFormFooter, null, React.createElement(_Button.ButtonPrimary, {
      onClick: form.submit,
      align: "right"
    }, t(_templateObject5()))));
  });
};

var _default = (0, _context.withCms)()(CategoriesForm);

exports.default = _default;
//# sourceMappingURL=CategoriesForm.js.map