"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deleteCategory = exports.updateCategory = exports.createCategory = exports.loadCategory = exports.loadCategories = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

function _templateObject5() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    mutation DeleteCategory($id: ID!) {\n        cms {\n            deleteCategory(id: $id) {\n                data\n                error {\n                    code\n                    message\n                }\n            }\n        }\n    }\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    mutation UpdateCategory($id: ID!, $data: CategoryInput!){\n        cms {\n            category: updateCategory(id: $id, data: $data) {\n                data {\n                    ", "\n                }\n                error {\n                    code\n                    message\n                    data\n                }\n            }\n        }\n    }\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    mutation CreateCategory($data: CategoryInput!){\n        cms {\n            category: createCategory(data: $data) {\n                data {\n                    ", "\n                }\n                error {\n                    code\n                    message\n                    data\n                }\n            }\n        }\n    }\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    query LoadCategory($id: ID!) {\n        cms {\n            category: getCategory(id: $id){\n                data {\n                    ", "\n                }\n                error {\n                    code\n                    message\n                }\n            }\n        }\n    }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    query LoadCategories(\n        $where: JSON\n        $sort: JSON\n        $page: Int\n        $perPage: Int\n        $search: SearchInput\n    ) {\n        cms {\n            categories: listCategories(\n                where: $where\n                sort: $sort\n                page: $page\n                perPage: $perPage\n                search: $search\n            ) {\n                data {\n                    id\n                    name\n                    slug\n                    url\n                    createdOn\n                }\n                meta {\n                    totalCount\n                    to\n                    from\n                    nextPage\n                    previousPage\n                }\n            }\n        }\n    }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var fields = "\n    id\n    name\n    slug\n    url\n    layout\n";
var loadCategories = (0, _graphqlTag.default)(_templateObject());
exports.loadCategories = loadCategories;
var loadCategory = (0, _graphqlTag.default)(_templateObject2(), fields);
exports.loadCategory = loadCategory;
var createCategory = (0, _graphqlTag.default)(_templateObject3(), fields);
exports.createCategory = createCategory;
var updateCategory = (0, _graphqlTag.default)(_templateObject4(), fields);
exports.updateCategory = updateCategory;
var deleteCategory = (0, _graphqlTag.default)(_templateObject5());
exports.deleteCategory = deleteCategory;
//# sourceMappingURL=graphql.js.map