"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _pick2 = _interopRequireDefault(require("lodash/pick"));

var React = _interopRequireWildcard(require("react"));

var _dotPropImmutable = require("dot-prop-immutable");

var _i18n = require("webiny-app/i18n");

var _components = require("webiny-admin/components");

var _SplitView = require("webiny-admin/components/SplitView");

var _FloatingActionButton = require("webiny-admin/components/FloatingActionButton");

var _MenusDataList = _interopRequireDefault(require("./MenusDataList"));

var _MenusForm = _interopRequireDefault(require("./MenusForm"));

var _graphql = require("./graphql");

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2.default)(["Menu {name} saved successfully."]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["Menu {name} deleted."]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var t = _i18n.i18n.namespace("Cms.Menus");

var Menus = function Menus(_ref) {
  var router = _ref.router,
      formProps = _ref.formProps,
      listProps = _ref.listProps;
  return React.createElement(React.Fragment, null, React.createElement(_SplitView.SplitView, null, React.createElement(_SplitView.LeftPanel, {
    span: 4
  }, React.createElement(_MenusDataList.default, listProps)), React.createElement(_SplitView.RightPanel, {
    span: 8
  }, React.createElement(_MenusForm.default, formProps))), React.createElement(_FloatingActionButton.FloatingActionButton, {
    onClick: function onClick() {
      return router.goToRoute({
        params: {
          id: null
        },
        merge: true
      });
    }
  }));
};

var _default = (0, _components.withCrud)({
  list: {
    get: {
      query: _graphql.loadMenus,
      variables: {
        sort: {
          savedOn: -1
        }
      },
      response: function response(data) {
        return (0, _dotPropImmutable.get)(data, "cms.menus");
      }
    },
    delete: {
      mutation: _graphql.deleteMenu,
      response: function response(data) {
        return data.cms.deleteMenu;
      },
      snackbar: function snackbar(data) {
        return t(_templateObject())({
          name: data.name
        });
      }
    }
  },
  form: {
    get: {
      query: _graphql.loadMenu,
      response: function response(data) {
        return (0, _dotPropImmutable.get)(data, "cms.menu");
      }
    },
    save: {
      create: _graphql.createMenu,
      update: _graphql.updateMenu,
      response: function response(data) {
        return data.cms.menu;
      },
      variables: function variables(data) {
        return {
          data: (0, _pick2.default)(data, ["items", "title", "slug", "description"])
        };
      },
      snackbar: function snackbar(data) {
        return t(_templateObject2())({
          name: data.title
        });
      }
    }
  }
})(Menus);

exports.default = _default;
//# sourceMappingURL=Menus.js.map