"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _emotion = require("emotion");

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _uniqid = _interopRequireDefault(require("uniqid"));

var _webinyPlugins = require("webiny-plugins");

var _Grid = require("webiny-ui/Grid");

var _Icon = require("webiny-ui/Icon");

var _Menu = require("webiny-ui/Menu");

var _List = require("webiny-ui/List");

var _Button = require("webiny-ui/Button");

var _MenuItemsList = _interopRequireDefault(require("./MenuItems/MenuItemsList"));

var _MenuItemForm = _interopRequireDefault(require("./MenuItems/MenuItemForm"));

var _findObject = _interopRequireDefault(require("./MenuItems/findObject"));

var _Typography = require("webiny-ui/Typography");

var leftPanel =
/*#__PURE__*/
(0, _emotion.css)({
  padding: 25,
  backgroundColor: "var(--mdc-theme-background)",
  overflow: "scroll"
}, "label:leftPanel;");
var menuItems =
/*#__PURE__*/
(0, _emotion.css)({
  width: 170
}, "label:menuItems;");
var MenuHolder =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e1gtu4k60",
  label: "MenuHolder"
})({
  textAlign: "center",
  color: "var(--mdc-theme-text-primary-on-background)"
});
var AddMenu =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e1gtu4k61",
  label: "AddMenu"
})({
  width: 180,
  margin: "25px auto 0 auto"
});

var MenuItems =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(MenuItems, _React$Component);

  function MenuItems() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, MenuItems);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(MenuItems)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "form", _react.default.createRef());
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "state", {
      currentMenuItem: null
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "addItem", function (plugin) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          value = _this$props.value;
      var newItem = {
        type: plugin.name,
        id: (0, _uniqid.default)(),
        __new: true
      };
      onChange([].concat((0, _toConsumableArray2.default)(value), [newItem]));

      _this.editItem(newItem);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "editItem", function (data) {
      _this.setState({
        currentMenuItem: data
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "deleteItem", function (item) {
      var _this$props2 = _this.props,
          value = _this$props2.value,
          onChange = _this$props2.onChange;
      var target = (0, _findObject.default)(value, item.id);
      target && target.source.splice(target.index, 1);
      onChange(value);

      _this.editItem(null);
    });
    return _this;
  }

  (0, _createClass2.default)(MenuItems, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          items = _this$props3.value,
          onChange = _this$props3.onChange;
      var currentMenuItem = this.state.currentMenuItem;
      var plugins = (0, _webinyPlugins.getPlugins)("cms-menu-item");
      return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_Grid.Grid, null, _react.default.createElement(_Grid.Cell, {
        span: 6,
        className: leftPanel
      }, _react.default.createElement(_MenuItemsList.default, {
        menuForm: this.props.menuForm,
        items: items,
        onChange: onChange,
        editItem: this.editItem,
        deleteItem: this.deleteItem
      })), _react.default.createElement(_Grid.Cell, {
        span: 6
      }, !currentMenuItem && _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(MenuHolder, null, _react.default.createElement(_Typography.Typography, {
        use: "body2"
      }, "To build your menu you need to create menu items! Begin by clicking the \"Add menu item\" button"), _react.default.createElement(AddMenu, null, _react.default.createElement(_Menu.Menu, {
        handle: _react.default.createElement(_Button.ButtonPrimary, null, "+ Add menu item"),
        anchor: "topEnd"
      }, _react.default.createElement(_List.List, {
        className: menuItems
      }, plugins.map(function (pl) {
        return _react.default.createElement(_List.ListItem, {
          key: pl.name,
          onClick: function onClick() {
            return _this2.addItem(pl);
          },
          style: {
            whiteSpace: "nowrap"
          }
        }, _react.default.createElement(_List.ListItemGraphic, null, _react.default.createElement(_Icon.Icon, {
          icon: pl.icon
        })), pl.title);
      })))))), currentMenuItem && _react.default.createElement(_MenuItemForm.default, {
        currentMenuItem: currentMenuItem,
        editItem: this.editItem,
        deleteItem: this.deleteItem,
        items: items,
        onChange: onChange
      }))));
    }
  }]);
  return MenuItems;
}(_react.default.Component);

var _default = MenuItems;
exports.default = _default;
//# sourceMappingURL=MenuItems.js.map