"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _isNull2 = _interopRequireDefault(require("lodash/isNull"));

var _omitBy2 = _interopRequireDefault(require("lodash/omitBy"));

var _omit2 = _interopRequireDefault(require("lodash/omit"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _webinyPlugins = require("webiny-plugins");

var _findObject = _interopRequireDefault(require("./findObject"));

var _uniqid = _interopRequireDefault(require("uniqid"));

var MenuItemForm = function MenuItemForm(_ref) {
  var onSubmit = _ref.onSubmit,
      onCancel = _ref.onCancel,
      currentMenuItem = _ref.currentMenuItem;
  var plugin = (0, _webinyPlugins.getPlugin)(currentMenuItem.type);

  if (!plugin) {
    return null;
  }

  return plugin.renderForm({
    onSubmit: onSubmit,
    onCancel: onCancel,
    data: currentMenuItem
  });
};

var _default = (0, _compose2.default)((0, _withHandlers2.default)({
  onCancel: function onCancel(_ref2) {
    var editItem = _ref2.editItem,
        currentMenuItem = _ref2.currentMenuItem,
        deleteItem = _ref2.deleteItem;
    return function () {
      if (currentMenuItem.__new) {
        deleteItem(currentMenuItem);
      } else {
        editItem(null);
      }
    };
  },
  onSubmit: function onSubmit(_ref3) {
    var items = _ref3.items,
        onChange = _ref3.onChange,
        editItem = _ref3.editItem;
    return function (data) {
      var item = (0, _omit2.default)((0, _omitBy2.default)(data, _isNull2.default), ["__new"]);

      if (item.id) {
        var target = (0, _findObject.default)(items, item.id);

        if (target) {
          target.source[target.index] = item;
          onChange((0, _toConsumableArray2.default)(items));
        }
      } else {
        item.id = (0, _uniqid.default)();
        onChange([].concat((0, _toConsumableArray2.default)(items), [item]));
      }

      editItem(null);
    };
  }
}))(MenuItemForm);

exports.default = _default;
//# sourceMappingURL=MenuItemForm.js.map