"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var _reactSortableTree = require("react-sortable-tree");

var _classnames = _interopRequireDefault(require("classnames"));

var _webinyPlugins = require("webiny-plugins");

var _Button = require("webiny-ui/Button");

var _Typography = require("webiny-ui/Typography");

require("./MenuItemRenderer.css");

var _roundEdit24px = require("@svgr/webpack!./icons/round-edit-24px.svg");

var _roundDelete24px = require("@svgr/webpack!./icons/round-delete-24px.svg");

var NodeRendererDefault =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(NodeRendererDefault, _React$Component);

  function NodeRendererDefault() {
    (0, _classCallCheck2.default)(this, NodeRendererDefault);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(NodeRendererDefault).apply(this, arguments));
  }

  (0, _createClass2.default)(NodeRendererDefault, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          scaffoldBlockPxWidth = _this$props.scaffoldBlockPxWidth,
          toggleChildrenVisibility = _this$props.toggleChildrenVisibility,
          connectDragPreview = _this$props.connectDragPreview,
          connectDragSource = _this$props.connectDragSource,
          isDragging = _this$props.isDragging,
          canDrop = _this$props.canDrop,
          canDrag = _this$props.canDrag,
          node = _this$props.node,
          title = _this$props.title,
          draggedNode = _this$props.draggedNode,
          path = _this$props.path,
          treeIndex = _this$props.treeIndex,
          editItem = _this$props.editItem,
          deleteItem = _this$props.deleteItem,
          className = _this$props.className,
          style = _this$props.style,
          didDrop = _this$props.didDrop;
      var nodeTitle = title || node.title;
      var plugin = (0, _webinyPlugins.getPlugin)(node.type);

      if (!plugin) {
        return null;
      }

      var handle = connectDragSource(React.createElement("div", {
        className: "rst__moveHandle"
      }, plugin.icon), {
        dropEffect: "copy"
      });
      var isDraggedDescendant = draggedNode && (0, _reactSortableTree.isDescendant)(draggedNode, node);
      var isLandingPadActive = !didDrop && isDragging;
      var buttonStyle = {
        left: -0.5 * scaffoldBlockPxWidth
      };
      return React.createElement("div", {
        style: {
          height: "100%"
        }
      }, toggleChildrenVisibility && node.children && (node.children.length > 0 || typeof node.children === "function") && React.createElement("div", null, React.createElement("button", {
        type: "button",
        "aria-label": node.expanded ? "Collapse" : "Expand",
        className: (0, _classnames.default)(node.expanded ? "rst__collapseButton" : "rst__expandButton"),
        style: buttonStyle,
        onClick: function onClick() {
          return toggleChildrenVisibility({
            node: node,
            path: path,
            treeIndex: treeIndex
          });
        }
      }), node.expanded && !isDragging && React.createElement("div", {
        style: {
          width: scaffoldBlockPxWidth
        },
        className: (0, _classnames.default)("rst__lineChildren")
      })), React.createElement("div", {
        className: (0, _classnames.default)("rst__rowWrapper")
      }, connectDragPreview(React.createElement("div", {
        className: (0, _classnames.default)("rst__row", isLandingPadActive && "rst__rowLandingPad", isLandingPadActive && !canDrop && "rst__rowCancelPad", className),
        style: (0, _objectSpread2.default)({
          opacity: isDraggedDescendant ? 0.5 : 1
        }, style)
      }, handle, React.createElement("div", {
        className: (0, _classnames.default)("rst__rowContents", !canDrag && "rst__rowContentsDragDisabled")
      }, React.createElement("div", {
        className: (0, _classnames.default)("rst__rowLabel")
      }, React.createElement("span", {
        className: (0, _classnames.default)("rst__rowTitle", node.subtitle && "rst__rowTitleWithSubtitle")
      }, React.createElement(_Typography.Typography, {
        use: "overline"
      }, nodeTitle))), React.createElement("div", {
        className: "rst__rowToolbar"
      }, React.createElement(_Button.IconButton, {
        icon: React.createElement(_roundEdit24px.ReactComponent, null),
        onClick: function onClick() {
          return editItem(node);
        }
      }), React.createElement(_Button.IconButton, {
        icon: React.createElement(_roundDelete24px.ReactComponent, null),
        onClick: function onClick() {
          return deleteItem(node);
        }
      })))))));
    }
  }]);
  return NodeRendererDefault;
}(React.Component);

(0, _defineProperty2.default)(NodeRendererDefault, "defaultProps", {
  canDrag: false,
  toggleChildrenVisibility: null,
  buttons: [],
  className: "",
  style: {},
  parentNode: null,
  draggedNode: null,
  canDrop: false,
  title: null,
  subtitle: null
});
var _default = NodeRendererDefault;
exports.default = _default;
//# sourceMappingURL=MenuItemRenderer.js.map