"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireDefault(require("react"));

var _reactSortableTree = _interopRequireDefault(require("react-sortable-tree"));

var _webinyPlugins = require("webiny-plugins");

var _MenuItemRenderer = _interopRequireDefault(require("./MenuItemRenderer"));

var _Typography = require("webiny-ui/Typography");

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var TreeWrapper =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eb0b1r60",
  label: "TreeWrapper"
})({
  width: "100%",
  height: 400
});
var EmptyTree =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eb0b1r61",
  label: "EmptyTree"
})({
  width: "100%",
  height: "100%",
  display: "flex",
  alignItems: "center",
  justifyContent: "center"
});

var MenuItemsList =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(MenuItemsList, _React$Component);

  function MenuItemsList() {
    (0, _classCallCheck2.default)(this, MenuItemsList);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(MenuItemsList).apply(this, arguments));
  }

  (0, _createClass2.default)(MenuItemsList, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          items = _this$props.items,
          onChange = _this$props.onChange,
          editItem = _this$props.editItem,
          deleteItem = _this$props.deleteItem;
      var data = Array.isArray(items) ? (0, _toConsumableArray2.default)(items) : [];

      var dom = _react.default.createElement(EmptyTree, null, _react.default.createElement(_Typography.Typography, {
        use: "overline"
      }, "There are no menu items to display"));

      if (data.length > 0) {
        dom = _react.default.createElement(_reactSortableTree.default, {
          treeData: data,
          onChange: onChange,
          canNodeHaveChildren: MenuItemsList.canHaveChildren,
          nodeContentRenderer: _MenuItemRenderer.default,
          rowHeight: 45,
          generateNodeProps: function generateNodeProps() {
            return {
              editItem: editItem,
              deleteItem: deleteItem
            };
          },
          getNodeKey: function getNodeKey(_ref) {
            var node = _ref.node;
            return node.id;
          }
        });
      }

      return _react.default.createElement(TreeWrapper, null, dom);
    }
  }], [{
    key: "canHaveChildren",
    value: function canHaveChildren(node) {
      var plugin = (0, _webinyPlugins.getPlugin)(node.type);
      return plugin ? plugin.canHaveChildren : false;
    }
  }]);
  return MenuItemsList;
}(_react.default.Component);

var _default = MenuItemsList;
exports.default = _default;
//# sourceMappingURL=MenuItemsList.js.map