"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _each2 = _interopRequireDefault(require("lodash/each"));

var _findIndex2 = _interopRequireDefault(require("lodash/findIndex"));

/**
 * Recursively search for an object with given ID in the given source array.
 * @param source
 * @param id
 * @returns {*}
 */
var findObject = function findObject(source, id) {
  var index = (0, _findIndex2.default)(source, {
    id: id
  });

  if (index >= 0) {
    return {
      source: source,
      index: index,
      item: source[index]
    };
  }

  var res = null;
  (0, _each2.default)(source, function (s) {
    if (s.children) {
      var result = findObject(s.children, id);

      if (result) {
        res = result;
        return false;
      }
    }
  });
  return res;
};

var _default = findObject;
exports.default = _default;
//# sourceMappingURL=findObject.js.map