"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deleteMenu = exports.updateMenu = exports.createMenu = exports.loadMenu = exports.loadMenus = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

function _templateObject5() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    mutation DeleteMenu($id: ID!) {\n        cms {\n            deleteMenu(id: $id) {\n                data\n                error {\n                    code\n                    message\n                }\n            }\n        }\n    }\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    mutation UpdateMenu($id: ID!, $data: MenuInput!){\n        cms {\n            menu: updateMenu(id: $id, data: $data) {\n                data {\n                    ", "\n                }\n                error {\n                    code\n                    message\n                    data\n                }\n            }\n        }\n    }\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    mutation CreateMenu($data: MenuInput!){\n        cms {\n            menu: createMenu(data: $data) {\n                data {\n                    ", "\n                }\n                error {\n                    code\n                    message\n                    data\n                }\n            }\n        }\n    }\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    query LoadMenu($id: ID!) {\n        cms {\n            menu: getMenu(id: $id){\n                data {\n                    ", "\n                }\n                error {\n                    code\n                    message\n                }\n            }\n        }\n    }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    query LoadMenus($where: JSON, $sort: JSON, $page: Int, $perPage: Int, $search: SearchInput) {\n        cms {\n            menus: listMenus(\n                where: $where\n                sort: $sort\n                page: $page\n                perPage: $perPage\n                search: $search\n            ) {\n                data {\n                    id\n                    title\n                    slug\n                    description\n                    createdOn\n                }\n                meta {\n                    totalCount\n                    totalPages\n                    to\n                    from\n                    nextPage\n                    previousPage\n                }\n            }\n        }\n    }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var fields = "\n    id\n    title\n    slug\n    description\n    items\n";
var loadMenus = (0, _graphqlTag.default)(_templateObject());
exports.loadMenus = loadMenus;
var loadMenu = (0, _graphqlTag.default)(_templateObject2(), fields);
exports.loadMenu = loadMenu;
var createMenu = (0, _graphqlTag.default)(_templateObject3(), fields);
exports.createMenu = createMenu;
var updateMenu = (0, _graphqlTag.default)(_templateObject4(), fields);
exports.updateMenu = updateMenu;
var deleteMenu = (0, _graphqlTag.default)(_templateObject5());
exports.deleteMenu = deleteMenu;
//# sourceMappingURL=graphql.js.map