"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _emotion = require("emotion");

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _reactApollo = require("react-apollo");

var _Dialog = require("webiny-ui/Dialog");

var _List = require("webiny-ui/List");

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    query ListCategories($sort: JSON) {\n        cms {\n            listCategories(sort: $sort) {\n                data {\n                    id\n                    name\n                    url\n                }\n            }\n        }\n    }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var narrowDialog =
/*#__PURE__*/
(0, _emotion.css)({
  ".mdc-dialog__surface": {
    width: 400,
    minWidth: 400
  }
}, "label:narrowDialog;");
var loadCategories = (0, _graphqlTag.default)(_templateObject());

var CategoriesDialog = function CategoriesDialog(_ref) {
  var open = _ref.open,
      onClose = _ref.onClose,
      onSelect = _ref.onSelect;
  return _react.default.createElement(_Dialog.Dialog, {
    open: open,
    onClose: onClose,
    className: narrowDialog
  }, _react.default.createElement(_Dialog.DialogHeader, null, _react.default.createElement(_Dialog.DialogHeaderTitle, null, "Select a category")), _react.default.createElement(_Dialog.DialogBody, null, _react.default.createElement(_List.List, {
    twoLine: true
  }, _react.default.createElement(_reactApollo.Query, {
    query: loadCategories,
    variables: {
      sort: {
        name: 1
      }
    }
  }, function (_ref2) {
    var data = _ref2.data,
        loading = _ref2.loading;

    if (loading) {
      return "Loading categories...";
    }

    return _react.default.createElement(_react.default.Fragment, null, data.cms.listCategories.data.map(function (item) {
      return _react.default.createElement(_List.ListItem, {
        key: item.id,
        onClick: function onClick() {
          return onSelect(item);
        }
      }, _react.default.createElement(_List.ListItemText, null, _react.default.createElement(_List.ListItemTextPrimary, null, item.name), _react.default.createElement(_List.ListItemTextSecondary, null, item.url)));
    }));
  }))));
};

var _default = CategoriesDialog;
exports.default = _default;
//# sourceMappingURL=CategoriesDialog.js.map