"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _reactRedux = require("react-redux");

var _editor = require("webiny-app-cms/editor");

var _utils = require("webiny-app-cms/editor/utils");

var _redux = require("webiny-app-cms/editor/redux");

var _actions = require("webiny-app-cms/editor/actions");

var _components = require("webiny-app/components");

var _reactApollo = require("react-apollo");

var _pages = require("webiny-app-cms/admin/graphql/pages");

var _components2 = require("webiny-app-cms/admin/components");

var _Snackbar = _interopRequireDefault(require("webiny-admin/plugins/Snackbar/Snackbar"));

var _components3 = require("webiny-admin/components");

var _Typography = require("webiny-ui/Typography");

var _EditorStyled = require("./EditorStyled.js");

var _editorMock = _interopRequireDefault(require("webiny-app-cms/admin/assets/editor-mock.png"));

var getEmptyData = function getEmptyData() {
  var page = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var revisions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  return {
    ui: {
      activeElement: null,
      dragging: false,
      highlightElement: null,
      plugins: {},
      resizing: false
    },
    tmp: {},
    page: page,
    revisions: revisions
  };
};

var pageSet = null;

var Editor = function Editor(_ref) {
  var renderEditor = _ref.renderEditor,
      router = _ref.router,
      showSnackbar = _ref.showSnackbar;
  return _react.default.createElement(_reactApollo.Query, {
    query: (0, _pages.getPage)(),
    variables: {
      id: router.getParams("id")
    },
    onCompleted: function onCompleted(data) {
      var error = (0, _get2.default)(data, "cms.page.error.message");

      if (error) {
        router.goToRoute({
          name: "Cms.Pages",
          params: {
            id: null
          },
          merge: true
        });
        showSnackbar(error);
      }
    }
  }, renderEditor);
};

var _default = (0, _compose2.default)(_reactApollo.withApollo, (0, _components.withRouter)(), (0, _components3.withSnackbar)(), (0, _components2.withSavedElements)(), (0, _withHandlers2.default)({
  // eslint-disable-next-line react/display-name
  renderEditor: function renderEditor(_ref2) {
    var elements = _ref2.elements,
        client = _ref2.client;
    return function (_ref3) {
      var data = _ref3.data,
          loading = _ref3.loading;

      if (loading || !Array.isArray(elements)) {
        return _react.default.createElement(_EditorStyled.LoadingEditor, null, _react.default.createElement("img", {
          src: _editorMock.default
        }), _react.default.createElement(_EditorStyled.LoadingTitle, null, _react.default.createElement(_Typography.Typography, {
          tag: "div",
          use: "headline6"
        }, "Loading Editor", _react.default.createElement("span", null, "."), _react.default.createElement("span", null, "."), _react.default.createElement("span", null, "."))));
      }

      if (!(0, _get2.default)(data, "cms.page.data")) {
        return null;
      }

      if (!_redux.redux.store) {
        _redux.redux.initStore({}, {
          client: client
        });
      }

      if (!loading) {
        var _data$cms$page$data = data.cms.page.data,
            revisions = _data$cms$page$data.revisions,
            page = (0, _objectWithoutProperties2.default)(_data$cms$page$data, ["revisions"]);

        if (!page.content) {
          page.content = (0, _utils.createElement)("cms-element-document");
        }

        if (pageSet !== page.id) {
          pageSet = page.id;

          _redux.redux.store.dispatch({
            type: _actions.SETUP_EDITOR,
            payload: getEmptyData(page, revisions)
          });

          _redux.redux.store.dispatch({
            type: "@@redux-undo/INIT"
          });
        }
      }

      return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_reactRedux.Provider, {
        store: _redux.redux.store
      }, _react.default.createElement(_editor.Editor, null)), _react.default.createElement("div", {
        style: {
          zIndex: 10,
          position: "absolute"
        }
      }, _react.default.createElement(_Snackbar.default, null)));
    };
  }
}))(Editor);

exports.default = _default;
//# sourceMappingURL=Editor.js.map