"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _get2 = _interopRequireDefault(require("lodash/get"));

var _withProps2 = _interopRequireDefault(require("recompose/withProps"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _reactApollo = require("react-apollo");

var _plugins = require("webiny-app/plugins");

var _components = require("webiny-app/components");

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _Elevation = require("webiny-ui/Elevation");

var _pages = require("webiny-app-cms/admin/graphql/pages");

var _PageDetailsContext = require("../../components/PageDetailsContext");

var _components2 = require("webiny-app-cms/render/components");

var _components3 = require("webiny-admin/components");

var EmptySelect =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e4rukx30",
  label: "EmptySelect"
})({
  width: "100%",
  height: "100%",
  display: "flex",
  alignItems: "center",
  justifyContent: "center",
  ".select-page": {
    maxWidth: 400,
    padding: "50px 100px",
    textAlign: "center",
    display: "block",
    borderRadius: 2,
    backgroundColor: "var(--mdc-theme-surface)"
  }
});
var DetailsContainer =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e4rukx31",
  label: "DetailsContainer"
})({
  height: "calc(100% - 10px)",
  overflow: "hidden",
  position: "relative",
  nav: {
    backgroundColor: "var(--mdc-theme-surface)"
  }
});

var EmptyPageDetails = function EmptyPageDetails() {
  return React.createElement(EmptySelect, null, React.createElement(_Elevation.Elevation, {
    z: 2,
    className: "select-page"
  }, "Select a page on the left side, or click the green button to create a new one."));
};

var PageDetails = function PageDetails(_ref) {
  var pageId = _ref.pageId,
      router = _ref.router,
      showSnackbar = _ref.showSnackbar;

  if (!pageId) {
    return React.createElement(EmptyPageDetails, null);
  }

  return React.createElement(_reactApollo.Query, {
    query: (0, _pages.getPage)(),
    variables: {
      id: pageId
    },
    onCompleted: function onCompleted(data) {
      var error = (0, _get2.default)(data, "cms.page.error.message");

      if (error) {
        router.goToRoute({
          params: {
            id: null
          },
          merge: true
        });
        showSnackbar(error);
      }
    }
  }, function (_ref2) {
    var data = _ref2.data,
        loading = _ref2.loading;
    var details = {
      page: (0, _get2.default)(data, "cms.page.data") || {},
      loading: loading
    };
    return React.createElement(_components2.ElementAnimation, null, function (_ref3) {
      var refresh = _ref3.refresh;
      return React.createElement(DetailsContainer, {
        onScroll: refresh
      }, React.createElement(_PageDetailsContext.PageDetailsProvider, {
        value: details
      }, React.createElement(_PageDetailsContext.PageDetailsConsumer, null, function (pageDetails) {
        return React.createElement(React.Fragment, null, (0, _plugins.renderPlugins)("cms-page-details", {
          pageDetails: pageDetails,
          loading: loading
        }));
      })));
    });
  });
};

var _default = (0, _compose2.default)((0, _components.withRouter)(), (0, _components3.withSnackbar)(), (0, _withProps2.default)(function (_ref4) {
  var router = _ref4.router;
  return {
    pageId: router.getQuery("id")
  };
}))(PageDetails);

exports.default = _default;
//# sourceMappingURL=PageDetails.js.map