"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var React = _interopRequireWildcard(require("react"));

var _timeagoReact = _interopRequireDefault(require("timeago-react"));

var _components = require("webiny-app/components");

var _i18n = require("webiny-app/i18n");

var _emotion = require("emotion");

var _Typography = require("webiny-ui/Typography");

var _List = require("webiny-ui/List");

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["CMS Pages"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var t = _i18n.i18n.namespace("Cms.PagesDataList");

var rightAlign =
/*#__PURE__*/
(0, _emotion.css)({
  alignItems: "flex-end !important"
}, "label:rightAlign;");

var PagesDataList = function PagesDataList(props) {
  var dataList = props.dataList,
      router = props.router;
  return React.createElement(_List.DataList, (0, _extends2.default)({}, dataList, {
    title: t(_templateObject()),
    sorters: [{
      label: "Newest to oldest",
      sorters: {
        createdOn: -1
      }
    }, {
      label: "Oldest to newest",
      sorters: {
        createdOn: 1
      }
    }, {
      label: "Title A-Z",
      sorters: {
        title: 1
      }
    }, {
      label: "Title Z-A",
      sorters: {
        title: -1
      }
    }]
  }), function (_ref) {
    var _ref$data = _ref.data,
        data = _ref$data === void 0 ? [] : _ref$data;
    return React.createElement(_List.List, null, data.map(function (page) {
      return React.createElement(_List.ListItem, {
        key: page.id
      }, React.createElement(_List.ListItemText, {
        onClick: function onClick() {
          return router.goToRoute({
            params: {
              id: page.id
            },
            merge: true
          });
        }
      }, page.title, React.createElement(_List.ListTextOverline, null, page.category.name), page.createdBy && React.createElement(_List.ListItemTextSecondary, null, "Created by: ", page.createdBy.firstName, ". Last modified:", " ", React.createElement(_timeagoReact.default, {
        datetime: page.savedOn
      }), ".")), React.createElement(_List.ListItemMeta, {
        className: rightAlign
      }, React.createElement(_Typography.Typography, {
        use: "subtitle2"
      }, page.locked ? "Published" : "Draft", " (v", page.version, ")")));
    }));
  });
};

var _default = (0, _components.withRouter)()(PagesDataList);

exports.default = _default;
//# sourceMappingURL=PagesDataList.js.map