"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.saveRevision = exports.updateRevision = exports.dropElement = exports.deleteElement = exports.updateElement = exports.elementCreated = exports.dragEnd = exports.dragStart = exports.blurSlateEditor = exports.focusSlateEditor = exports.deactivateElement = exports.activateElement = exports.highlightElement = exports.deactivatePlugin = exports.togglePlugin = exports.FINISH_SAVING = exports.START_SAVING = exports.SAVING_REVISION = exports.UPDATE_REVISION = exports.SETUP_EDITOR = exports.FLATTEN_ELEMENTS = exports.DELETE_ELEMENT = exports.UPDATE_ELEMENT = exports.DEACTIVATE_ELEMENT = exports.ACTIVATE_ELEMENT = exports.HIGHLIGHT_ELEMENT = exports.BLUR_SLATE_EDITOR = exports.FOCUS_SLATE_EDITOR = exports.DEACTIVATE_PLUGIN = exports.TOGGLE_PLUGIN = exports.ELEMENT_DROPPED = exports.ELEMENT_CREATED = exports.DRAG_END = exports.DRAG_START = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _merge3 = _interopRequireDefault(require("lodash/merge"));

var _cloneDeep2 = _interopRequireDefault(require("lodash/cloneDeep"));

var _debounce2 = _interopRequireDefault(require("lodash/debounce"));

var _pick2 = _interopRequireDefault(require("lodash/pick"));

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var _invariant = _interopRequireDefault(require("invariant"));

var _dotPropImmutable = _interopRequireDefault(require("dot-prop-immutable"));

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _redux = require("webiny-app-cms/editor/redux");

var _webinyPlugins = require("webiny-plugins");

var _selectors = require("webiny-app-cms/editor/selectors");

var _utils = require("webiny-app-cms/editor/utils");

var _history = _interopRequireDefault(require("./history"));

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n        mutation UpdateRevision($id: ID!, $data: UpdatePageInput!) {\n            cms {\n                updateRevision(id: $id, data: $data) {\n                    data {\n                        id\n                    }\n                    error {\n                        code\n                        message\n                        data\n                    }\n                }\n            }\n        }\n    "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var DRAG_START = "Drag start";
exports.DRAG_START = DRAG_START;
var DRAG_END = "Drag end";
exports.DRAG_END = DRAG_END;
var ELEMENT_CREATED = "Element created";
exports.ELEMENT_CREATED = ELEMENT_CREATED;
var ELEMENT_DROPPED = "Element dropped";
exports.ELEMENT_DROPPED = ELEMENT_DROPPED;
var TOGGLE_PLUGIN = "Toggle plugin";
exports.TOGGLE_PLUGIN = TOGGLE_PLUGIN;
var DEACTIVATE_PLUGIN = "Deactivate plugin";
exports.DEACTIVATE_PLUGIN = DEACTIVATE_PLUGIN;
var FOCUS_SLATE_EDITOR = "Focus slate editor";
exports.FOCUS_SLATE_EDITOR = FOCUS_SLATE_EDITOR;
var BLUR_SLATE_EDITOR = "Blur slate editor";
exports.BLUR_SLATE_EDITOR = BLUR_SLATE_EDITOR;
var HIGHLIGHT_ELEMENT = "Highlight element";
exports.HIGHLIGHT_ELEMENT = HIGHLIGHT_ELEMENT;
var ACTIVATE_ELEMENT = "Activate element";
exports.ACTIVATE_ELEMENT = ACTIVATE_ELEMENT;
var DEACTIVATE_ELEMENT = "Deactivate element";
exports.DEACTIVATE_ELEMENT = DEACTIVATE_ELEMENT;
var UPDATE_ELEMENT = "Update element";
exports.UPDATE_ELEMENT = UPDATE_ELEMENT;
var DELETE_ELEMENT = "Delete element";
exports.DELETE_ELEMENT = DELETE_ELEMENT;
var FLATTEN_ELEMENTS = "Flatten elements";
exports.FLATTEN_ELEMENTS = FLATTEN_ELEMENTS;
var SETUP_EDITOR = "Setup editor";
exports.SETUP_EDITOR = SETUP_EDITOR;
var UPDATE_REVISION = "Update revision";
exports.UPDATE_REVISION = UPDATE_REVISION;
var SAVING_REVISION = "Save revision";
exports.SAVING_REVISION = SAVING_REVISION;
var START_SAVING = "Started saving";
exports.START_SAVING = START_SAVING;
var FINISH_SAVING = "Finished saving";
/***************** HISTORY REDUCER *****************/

exports.FINISH_SAVING = FINISH_SAVING;
var horStatePath = "page.content";
(0, _redux.addHigherOrderReducer)([UPDATE_ELEMENT, DELETE_ELEMENT, ELEMENT_DROPPED, SETUP_EDITOR, "@@redux-undo/UNDO", "@@redux-undo/REDO", "@@redux-undo/INIT"], horStatePath, function () {
  return (0, _history.default)(function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var action = arguments.length > 1 ? arguments[1] : undefined;

    var _ref = arguments.length > 2 ? arguments[2] : undefined,
        statePath = _ref.statePath,
        reducer = _ref.reducer;

    // Get original reducer state path
    var relativeStatePath = statePath !== horStatePath ? statePath.replace(horStatePath + ".", "") : null;
    var relativeStateSlice = relativeStatePath ? _dotPropImmutable.default.get(state, relativeStatePath) : state; // Execute original reducer

    var newState = reducer(relativeStateSlice, action); // Assign new data to HOR state

    return relativeStatePath ? _dotPropImmutable.default.set(state, relativeStatePath, newState) : newState;
  }, {
    initTypes: ["@@redux-undo/INIT"],
    ignoreInitialState: true,
    filter: function filter(action) {
      if (action.payload && action.payload.history === false) {
        return false;
      }

      return true;
    }
  });
});
(0, _redux.addReducer)(["@@redux-undo/UNDO", "@@redux-undo/REDO", "@@redux-undo/INIT"], "page.content", function (state) {
  return state;
});
/***************** EDITOR ACTIONS *****************/

(0, _redux.addReducer)([SETUP_EDITOR], null, function (state, action) {
  return (0, _objectSpread2.default)({}, state, action.payload);
});
var togglePlugin = (0, _redux.createAction)(TOGGLE_PLUGIN);
exports.togglePlugin = togglePlugin;
(0, _redux.addReducer)([TOGGLE_PLUGIN], "ui.plugins", function (state, action) {
  var _action$payload = action.payload,
      name = _action$payload.name,
      params = _action$payload.params,
      _action$payload$close = _action$payload.closeOtherInGroup,
      closeOtherInGroup = _action$payload$close === void 0 ? false : _action$payload$close;
  var plugin = (0, _webinyPlugins.getPlugin)(name);

  if (!plugin) {
    return state;
  }

  var typePlugins = _dotPropImmutable.default.get(state, plugin.type);

  if (!Array.isArray(typePlugins)) {
    typePlugins = [];
  }

  var alreadyActive = typePlugins.findIndex(function (pl) {
    return pl.name === plugin.name;
  });

  if (alreadyActive > -1) {
    typePlugins = _dotPropImmutable.default.delete(typePlugins, alreadyActive);
  } else {
    if (closeOtherInGroup) {
      typePlugins = [{
        name: name,
        params: params
      }];
    } else {
      typePlugins.push({
        name: name,
        params: params
      });
    }
  }

  return _dotPropImmutable.default.set(state, "".concat(plugin.type), typePlugins);
});
var deactivatePlugin = (0, _redux.createAction)(DEACTIVATE_PLUGIN);
exports.deactivatePlugin = deactivatePlugin;
(0, _redux.addReducer)([DEACTIVATE_PLUGIN], "ui.plugins", function (state, action) {
  var name = action.payload.name;
  var plugin = (0, _webinyPlugins.getPlugin)(name);

  if (!plugin) {
    return state;
  }

  var typePlugins = _dotPropImmutable.default.get(state, plugin.type);

  if (!Array.isArray(typePlugins)) {
    typePlugins = [];
  }

  var alreadyActive = typePlugins.findIndex(function (pl) {
    return pl.name === plugin.name;
  });

  if (alreadyActive > -1) {
    typePlugins = _dotPropImmutable.default.delete(typePlugins, alreadyActive);
  }

  return _dotPropImmutable.default.set(state, "".concat(plugin.type), typePlugins);
});
var highlightElement = (0, _redux.createAction)(HIGHLIGHT_ELEMENT, {
  log: false
});
exports.highlightElement = highlightElement;
(0, _redux.addReducer)([HIGHLIGHT_ELEMENT], "ui.highlightElement", function (state, action) {
  return action.payload.element ? action.payload.element : null;
});
var activateElement = (0, _redux.createAction)(ACTIVATE_ELEMENT);
exports.activateElement = activateElement;
(0, _redux.addReducer)([ACTIVATE_ELEMENT], "ui.activeElement", function (state, action) {
  return action.payload.element;
});
var deactivateElement = (0, _redux.createAction)(DEACTIVATE_ELEMENT);
exports.deactivateElement = deactivateElement;
(0, _redux.addReducer)([DEACTIVATE_ELEMENT], "ui.activeElement", function () {
  return null;
});
var focusSlateEditor = (0, _redux.createAction)(FOCUS_SLATE_EDITOR);
exports.focusSlateEditor = focusSlateEditor;
(0, _redux.addReducer)([FOCUS_SLATE_EDITOR], "ui.slateFocused", function () {
  return true;
});
var blurSlateEditor = (0, _redux.createAction)(BLUR_SLATE_EDITOR);
exports.blurSlateEditor = blurSlateEditor;
(0, _redux.addReducer)([BLUR_SLATE_EDITOR], "ui.slateFocused", function () {
  return false;
});
var dragStart = (0, _redux.createAction)(DRAG_START);
exports.dragStart = dragStart;
(0, _redux.addReducer)([DRAG_START], "ui.dragging", function () {
  return true;
});
var dragEnd = (0, _redux.createAction)(DRAG_END);
exports.dragEnd = dragEnd;
(0, _redux.addReducer)([DRAG_END], "ui.dragging", function () {
  return false;
});
var elementCreated = (0, _redux.createAction)(ELEMENT_CREATED);
exports.elementCreated = elementCreated;
var updateElement = (0, _redux.createAction)(UPDATE_ELEMENT);
exports.updateElement = updateElement;
(0, _redux.addReducer)([UPDATE_ELEMENT], function (action) {
  var element = action.payload.element;

  if (element.type === "cms-element-document") {
    return "page.content";
  } // .slice(2) removes `0.` from the beginning of the generated path


  return "page.content." + action.payload.element.path.replace(/\./g, ".elements.").slice(2);
}, function (state, action) {
  var _action$payload2 = action.payload,
      element = _action$payload2.element,
      _action$payload2$merg = _action$payload2.merge,
      merge = _action$payload2$merg === void 0 ? false : _action$payload2$merg;

  if (element.elements && typeof element.elements[0] === "string") {
    delete element["elements"];
  }

  (0, _utils.updateChildPaths)(element);

  if (!merge) {
    return (0, _objectSpread2.default)({}, state, element);
  }

  return (0, _merge3.default)({}, state, element);
});
var deleteElement = (0, _redux.createAction)(DELETE_ELEMENT);
exports.deleteElement = deleteElement;
(0, _redux.addMiddleware)([DELETE_ELEMENT], function (_ref2) {
  var store = _ref2.store,
      next = _ref2.next,
      action = _ref2.action;
  next(action);
  store.dispatch(deactivateElement());
  var state = store.getState();
  var element = action.payload.element;
  var parent = (0, _selectors.getParentElementWithChildren)(state, element.id); // Remove child from parent
  // $FlowFixMe

  var index = parent.elements.findIndex(function (el) {
    return el.id === element.id;
  });
  parent = _dotPropImmutable.default.delete(parent, "elements." + index);
  store.dispatch(updateElement({
    element: parent
  })); // Execute `onChildDeleted` if defined

  var plugin = (0, _webinyPlugins.getPlugin)(parent.type);

  if (!plugin) {
    return;
  }

  if (typeof plugin.onChildDeleted === "function") {
    plugin.onChildDeleted({
      element: parent,
      child: element
    });
  }
});
var dropElement = (0, _redux.createAction)(ELEMENT_DROPPED);
exports.dropElement = dropElement;
(0, _redux.addMiddleware)([ELEMENT_DROPPED], function (_ref3) {
  var store = _ref3.store,
      next = _ref3.next,
      action = _ref3.action;
  next(action);
  var state = store.getState();
  var target = (0, _selectors.getElementWithChildren)(state, action.payload.target.id);
  var plugin = (0, _webinyPlugins.getPlugin)(target.type);

  if (!plugin) {
    return;
  }

  (0, _invariant.default)(plugin.onReceived, "To accept drops, element plugin must implement `onReceived` function");
  var source = action.payload.source;

  if (source.path) {
    source = (0, _selectors.getElementWithChildren)(state, source.id);
  }

  var targetPlugin = (0, _webinyPlugins.getPlugin)(target.type);

  if (!targetPlugin) {
    return;
  }

  targetPlugin.onReceived({
    source: source,
    target: target,
    position: action.payload.target.position
  });
});
var updateRevision = (0, _redux.createAction)(UPDATE_REVISION);
exports.updateRevision = updateRevision;
(0, _redux.addMiddleware)([UPDATE_REVISION], function (_ref4) {
  var store = _ref4.store,
      next = _ref4.next,
      action = _ref4.action;
  next(action);

  if (action.payload.history === false) {
    return;
  }

  var onFinish = action.meta.onFinish;
  store.dispatch(saveRevision(null, {
    onFinish: onFinish
  }));
});
(0, _redux.addReducer)([UPDATE_REVISION], "page", function (state, action) {
  return (0, _objectSpread2.default)({}, state, action.payload);
}); // Flatten page content

var flattenContent = function flattenContent(el) {
  var els = {};
  el.elements = Array.isArray(el.elements) && el.elements.map(function (child) {
    els = (0, _objectSpread2.default)({}, els, flattenContent(child));
    return child.id;
  });
  els[el.id] = el;
  return els;
};

(0, _redux.addReducer)([FLATTEN_ELEMENTS], "elements", function (state, action) {
  return action.payload;
});
(0, _redux.addMiddleware)([UPDATE_ELEMENT, DELETE_ELEMENT, "@@redux-undo/UNDO", "@@redux-undo/REDO", "@@redux-undo/INIT"], function (_ref5) {
  var store = _ref5.store,
      next = _ref5.next,
      action = _ref5.action;
  var result = next(action);
  var state = store.getState();

  if (state.page.content) {
    var content = _dotPropImmutable.default.get(state, "page.content.present") || null;

    if (!content) {
      return result;
    }

    var elements = flattenContent((0, _cloneDeep2.default)(content));
    store.dispatch({
      type: FLATTEN_ELEMENTS,
      payload: elements,
      meta: {
        log: true
      }
    });
  }

  return result;
});
/************************* SAVE REVISION *************************/

var lastSavedRevision = null;

var dataChanged = function dataChanged(revision) {
  if (!lastSavedRevision) {
    return true;
  }

  var content = revision.content,
      other = (0, _objectWithoutProperties2.default)(revision, ["content"]);
  var _lastSavedRevision = lastSavedRevision,
      lastContent = _lastSavedRevision.content,
      lastOther = (0, _objectWithoutProperties2.default)(_lastSavedRevision, ["content"]);
  return !(0, _isEqual2.default)(content, lastContent) || !(0, _isEqual2.default)(other, lastOther);
};

var saveRevision = (0, _redux.createAction)(SAVING_REVISION);
exports.saveRevision = saveRevision;
var debouncedSave = null;
(0, _redux.addMiddleware)([UPDATE_REVISION, UPDATE_ELEMENT, DELETE_ELEMENT, "@@redux-undo/UNDO", "@@redux-undo/REDO"], function (_ref6) {
  var store = _ref6.store,
      next = _ref6.next,
      action = _ref6.action;
  next(action);

  var _ref7 = action.meta || {},
      onFinish = _ref7.onFinish;

  if (action.type === UPDATE_ELEMENT && action.payload.history === false) {
    return;
  }

  var page = (0, _selectors.getPage)(store.getState());

  if (page.locked) {
    return;
  }

  if (debouncedSave) {
    debouncedSave.cancel();
  }

  debouncedSave = (0, _debounce2.default)(function () {
    return store.dispatch(saveRevision(null, {
      onFinish: onFinish
    }));
  }, 1000);
  debouncedSave();
});
var startSaving = {
  type: START_SAVING,
  payload: {
    progress: true
  }
};
var finishSaving = {
  type: FINISH_SAVING,
  payload: {
    progress: false
  }
};
(0, _redux.addReducer)([START_SAVING, FINISH_SAVING], "ui.saving", function (state, action) {
  return action.payload.progress;
});
(0, _redux.addMiddleware)([SAVING_REVISION], function (_ref8) {
  var store = _ref8.store,
      next = _ref8.next,
      action = _ref8.action;
  next(action);
  var data = (0, _selectors.getPage)(store.getState());

  if (data.locked) {
    return;
  } // Construct page payload


  var revision = (0, _pick2.default)(data, ["title", "snippet", "url", "settings"]);
  revision.content = data.content.present;
  revision.category = data.category.id; // Check if API call is necessary

  if (!dataChanged(revision)) {
    return;
  }

  lastSavedRevision = revision;
  var updateRevision = (0, _graphqlTag.default)(_templateObject());
  store.dispatch(startSaving);
  action.meta.client.mutate({
    mutation: updateRevision,
    variables: {
      id: data.id,
      data: revision
    }
  }).then(function (data) {
    store.dispatch(finishSaving);
    action.meta.onFinish && action.meta.onFinish();
    return data;
  }).catch(function (err) {
    store.dispatch(finishSaving);
    console.log(err); // eslint-disable-line
  });
});
//# sourceMappingURL=actions.js.map