"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var _react = _interopRequireDefault(require("react"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _emotion = require("emotion");

var _reactColor = require("react-color");

var _Menu = require("webiny-ui/Menu");

var _context = require("webiny-app-cms/context");

var _roundColor_lens24px = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/round-color_lens-24px.svg");

var ColorPickerStyle =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "ebob2xf0",
  label: "ColorPickerStyle"
})({
  display: "flex",
  flexWrap: "wrap",
  justifyContent: "space-between"
});
var CompactColorPicker =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "ebob2xf1",
  label: "CompactColorPicker"
})({
  ".mdc-menu-surface": {
    overflow: "visible"
  }
});
var ColorList =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "ebob2xf2",
  label: "ColorList"
})({
  display: "flex"
});
var ColorBox =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "ebob2xf3",
  label: "ColorBox"
})({
  cursor: "pointer",
  width: 50,
  height: 40,
  margin: 10,
  padding: 5,
  borderRadius: 2,
  boxSizing: "border-box",
  transition: "transform 0.2s",
  color: "var(--mdc-theme-text-secondary-on-background)"
});
var Color =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "ebob2xf4",
  label: "Color"
})({
  cursor: "pointer",
  width: 40,
  height: 30,
  border: "1px solid var(--mdc-theme-on-background)",
  transition: "transform 0.2s, scale 0.2s",
  display: "flex",
  alignItems: "center",
  "&::after": {
    boxShadow: "0 0.25rem 0.125rem 0 rgba(0,0,0,0.05)",
    transition: "opacity 0.5s cubic-bezier(0.165, 0.84, 0.44, 1)",
    content: '""',
    position: "absolute",
    top: 0,
    left: 0,
    width: "100%",
    height: "100%",
    zIndex: "-1",
    opacity: 0
  },
  "&:hover": {
    transform: "scale(1.25)",
    "&::after": {
      opacity: 1
    }
  }
});
var transparent =
/*#__PURE__*/
(0, _emotion.css)({
  backgroundSize: "10px 10px",
  backgroundImage: "linear-gradient( 45deg, #555 25%, transparent 25%, transparent)," + "linear-gradient(-45deg, #555 25%, transparent 25%, transparent)," + "linear-gradient( 45deg, transparent 75%, #555 75%)," + "linear-gradient(-45deg, transparent 75%, #555 75%)"
}, "label:transparent;");
var chromePickerStyles =
/*#__PURE__*/
(0, _emotion.css)({
  width: "100%",
  ".chrome-picker": {
    boxShadow: "none !important",
    width: "100% !important"
  }
}, "label:chromePickerStyles;");
var iconPaletteStyle =
/*#__PURE__*/
(0, _emotion.css)({
  height: 20,
  width: "100%",
  marginTop: 1,
  color: "var(--mdc-theme-secondary)"
}, "label:iconPaletteStyle;");
var styles = {
  selectedColor:
  /*#__PURE__*/
  (0, _emotion.css)({
    boxShadow: "0px 0px 0px 2px var(--mdc-theme-secondary)"
  }, "label:selectedColor;"),
  swatch:
  /*#__PURE__*/
  (0, _emotion.css)({
    padding: "5px",
    background: "#fff",
    borderRadius: "1px",
    boxShadow: "0 0 0 1px rgba(0,0,0,.1)",
    display: "inline-block",
    cursor: "pointer",
    height: 30,
    boxSizing: "border-box"
  }, "label:swatch;"),
  color:
  /*#__PURE__*/
  (0, _emotion.css)({
    width: "40px",
    height: "100%",
    borderRadius: "2px"
  }, "label:color;")
};

var ColorPicker =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(ColorPicker, _React$Component);

  function ColorPicker() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, ColorPicker);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(ColorPicker)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "state", {
      showPicker: false
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "getColorValue", function (rgb) {
      return "rgba(".concat(rgb.r, ", ").concat(rgb.g, ", ").concat(rgb.b, ", ").concat(rgb.a, ")");
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "onChange", function (color) {
      _this.props.onChange(_this.getColorValue(color.rgb));
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "onChangeComplete", function (_ref) {
      var rgb = _ref.rgb;

      _this.props.onChangeComplete(_this.getColorValue(rgb));
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "hidePicker", function () {
      _this.setState({
        showPicker: false
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "togglePicker", function (e) {
      e.stopPropagation();

      _this.setState(function (state) {
        return {
          showPicker: !state.showPicker
        };
      });
    });
    return _this;
  }

  (0, _createClass2.default)(ColorPicker, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(props, state) {
      return !(0, _isEqual2.default)(props, this.props) || !(0, _isEqual2.default)(state, this.state);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          theme = _this$props.cms.theme,
          value = _this$props.value,
          _this$props$compact = _this$props.compact,
          compact = _this$props$compact === void 0 ? false : _this$props$compact;
      var themeColor = false;

      var colorPicker = _react.default.createElement(ColorPickerStyle, {
        onClick: this.hidePicker
      }, Object.values(theme.colors).map(function (color, index) {
        if (color === value || value === "transparent") {
          themeColor = true;
        }

        return _react.default.createElement(ColorBox, {
          key: index
        }, _react.default.createElement(Color, {
          className: color === value ? styles.selectedColor : null,
          style: {
            backgroundColor: color
          },
          onClick: function onClick() {
            _this2.hidePicker();

            _this2.props.onChangeComplete(color);
          }
        }));
      }), _react.default.createElement(ColorBox, null, _react.default.createElement(Color, {
        className: (0, _classnames2.default)(transparent, (0, _defineProperty2.default)({}, styles.selectedColor, value === "transparent")),
        onClick: function onClick() {
          _this2.hidePicker();

          _this2.props.onChangeComplete("transparent");
        }
      })), _react.default.createElement(ColorBox, null, _react.default.createElement(Color, {
        className: value && !themeColor ? styles.selectedColor : null,
        style: {
          backgroundColor: themeColor ? "#fff" : value
        },
        onClick: this.togglePicker
      }, _react.default.createElement(_roundColor_lens24px.ReactComponent, {
        className: iconPaletteStyle
      }))), this.state.showPicker && _react.default.createElement("span", {
        onClick: function onClick(e) {
          return e.stopPropagation();
        },
        className: chromePickerStyles
      }, _react.default.createElement(_reactColor.ChromePicker, {
        color: value || "#fff",
        onChange: this.onChange,
        onChangeComplete: this.onChangeComplete
      })));

      if (compact) {
        return _react.default.createElement(CompactColorPicker, null, _react.default.createElement(_Menu.Menu, {
          handle: _react.default.createElement("div", {
            className: styles.swatch
          }, _react.default.createElement("div", {
            className: styles.color,
            style: {
              backgroundColor: value
            }
          }))
        }, _react.default.createElement(ColorList, null, _react.default.cloneElement(colorPicker, {
          style: {
            width: 240
          }
        }))));
      }

      return colorPicker;
    }
  }]);
  return ColorPicker;
}(_react.default.Component);

var _default = (0, _context.withCms)()(ColorPicker);

exports.default = _default;
//# sourceMappingURL=index.js.map