"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _noop2 = _interopRequireDefault(require("lodash/noop"));

var React = _interopRequireWildcard(require("react"));

/**
 * This component is used to wrap Input and Textarea components to optimize form re-render.
 * These 2 are the only components that trigger form model change on each character input.
 * This means, whenever you type a letter an entire form re-renders.
 * On complex forms you will feel and see a significant delay if this component is not used.
 *
 * The logic behind this component is to serve as a middleware between Form and Input/Textarea, and only notify form of a change when
 * a user stops typing for given period of time (400ms by default).
 */
var DelayedOnChange =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(DelayedOnChange, _React$Component);

  function DelayedOnChange() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, DelayedOnChange);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(DelayedOnChange)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "delay", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "state", {
      value: ""
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "applyValue", function (value) {
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _noop2.default;
      _this.delay && clearTimeout(_this.delay);
      _this.delay = null;

      _this.props.onChange(value, callback);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "onChange", function (value) {
      _this.setState({
        value: value
      }, _this.changed);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "changed", function () {
      _this.delay && clearTimeout(_this.delay);
      _this.delay = null;
      _this.delay = setTimeout(function () {
        return _this.applyValue(_this.state.value);
      }, _this.props.delay);
    });
    return _this;
  }

  (0, _createClass2.default)(DelayedOnChange, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.setState({
        value: this.props.value
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          children = _this$props.children,
          other = (0, _objectWithoutProperties2.default)(_this$props, ["children"]);
      var newProps = (0, _objectSpread2.default)({}, other, {
        value: this.state.value,
        onChange: this.onChange
      });
      var renderProp = typeof children === "function" ? children : false;
      var child = renderProp ? renderProp(newProps) : React.cloneElement(children, newProps);
      var props = (0, _objectSpread2.default)({}, child.props);
      var realOnKeyDown = props.onKeyDown || _noop2.default;
      var realOnBlur = props.onBlur || _noop2.default; // Need to apply value if input lost focus

      props.onBlur = function (e) {
        e.persist();

        _this2.applyValue(e.target.value, function () {
          return realOnBlur(e);
        });
      }; // Need to listen for TAB key to apply new value immediately, without delay. Otherwise validation will be triggered with old value.


      props.onKeyDown = function (e) {
        e.persist();

        if (e.key === "Tab") {
          _this2.applyValue(e.target.value, function () {
            return realOnKeyDown(e);
          });
        } else if (e.key === "Enter" && props["data-on-enter"]) {
          _this2.applyValue(e.target.value, function () {
            return realOnKeyDown(e);
          });
        } else {
          realOnKeyDown(e);
        }
      };

      return React.cloneElement(child, props);
    }
  }]);
  return DelayedOnChange;
}(React.Component);

(0, _defineProperty2.default)(DelayedOnChange, "defaultProps", {
  delay: 400
});
var _default = DelayedOnChange;
exports.default = _default;
//# sourceMappingURL=DelayedOnChange.js.map