"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = withDelayedOnChange;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _DelayedOnChange = _interopRequireDefault(require("./DelayedOnChange"));

function withDelayedOnChange() {
  return function decorator(Component) {
    return function (props) {
      var value = props.value,
          onChange = props.onChange,
          rest = (0, _objectWithoutProperties2.default)(props, ["value", "onChange"]);
      return _react.default.createElement(_DelayedOnChange.default, {
        value: value,
        onChange: onChange
      }, function (_ref) {
        var value = _ref.value,
            onChange = _ref.onChange;
        return _react.default.createElement(Component, (0, _extends2.default)({}, rest, {
          value: value,
          onChange: onChange
        }));
      });
    };
  };
}
//# sourceMappingURL=withDelayedOnChange.js.map