"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _lifecycle2 = _interopRequireDefault(require("recompose/lifecycle"));

var _pure2 = _interopRequireDefault(require("recompose/pure"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _reactDnd = require("react-dnd");

var _reactDndHtml5Backend = require("react-dnd-html5-backend");

var Draggable = (0, _pure2.default)(function (_ref) {
  var children = _ref.children,
      connectDragSource = _ref.connectDragSource,
      isDragging = _ref.isDragging;
  return children({
    isDragging: isDragging,
    connectDragSource: connectDragSource
  });
});
var itemSource = {
  beginDrag: function beginDrag(props, monitor) {
    if (props.beginDrag) {
      return props.beginDrag(props, monitor);
    }

    return (0, _objectSpread2.default)({}, props);
  },
  endDrag: function endDrag(props, monitor) {
    if (props.endDrag) {
      return props.endDrag(props, monitor);
    }
  }
};

var collect = function collect(connect, monitor) {
  return {
    connectDragSource: connect.dragSource(),
    connectDragPreview: connect.dragPreview(),
    isDragging: monitor.isDragging()
  };
};

var _default = (0, _compose2.default)((0, _reactDnd.DragSource)("element", itemSource, collect), (0, _lifecycle2.default)({
  componentDidMount: function componentDidMount() {
    var connectDragPreview = this.props.connectDragPreview;

    if (connectDragPreview) {
      connectDragPreview((0, _reactDndHtml5Backend.getEmptyImage)(), {
        captureDraggingState: true
      });
    }
  }
}))(Draggable);

exports.default = _default;
//# sourceMappingURL=Draggable.js.map