"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _pure2 = _interopRequireDefault(require("recompose/pure"));

var React = _interopRequireWildcard(require("react"));

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _selectors = require("webiny-app-cms/editor/selectors");

var _redux = require("webiny-app-cms/editor/redux");

var _Droppable = _interopRequireDefault(require("./../Droppable"));

var Container = (0, _pure2.default)(
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "et4y5870",
  label: "Container"
})(function (_ref) {
  var isOver = _ref.isOver;
  return {
    backgroundColor: "transparent",
    boxSizing: "border-box",
    height: "100%",
    minHeight: 100,
    position: "relative",
    userSelect: "none",
    width: "100%",
    border: isOver ? "1px dashed var(--mdc-theme-primary)" : "1px dashed var(--mdc-theme-secondary)",
    ".addIcon": {
      color: isOver ? "var(--mdc-theme-primary) !important" : "var(--mdc-theme-secondary) !important"
    }
  };
}));
var Add =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "et4y5871",
  label: "Add"
})({
  position: "absolute",
  top: "50%",
  left: "50%",
  transform: "translate(-50%,-50%)",
  margin: 0
});

var isVisible = function isVisible() {
  return true;
};

var Center = (0, _pure2.default)(function (_ref2) {
  var type = _ref2.type,
      onDrop = _ref2.onDrop,
      children = _ref2.children,
      active = _ref2.active,
      highlight = _ref2.highlight;
  return React.createElement(_Droppable.default, {
    onDrop: onDrop,
    type: type,
    isVisible: isVisible
  }, function (_ref3) {
    var isOver = _ref3.isOver,
        isDroppable = _ref3.isDroppable;
    return React.createElement("div", {
      style: {
        width: "100%",
        height: "100%"
      }
    }, React.createElement(Container, {
      isOver: isOver && isDroppable || active,
      highlight: highlight
    }, React.createElement(Add, null, children)));
  });
});

var _default = (0, _redux.connect)(function (state, props) {
  return (0, _selectors.getElementProps)(state, props);
})(Center);

exports.default = _default;
//# sourceMappingURL=Center.js.map