"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _pure2 = _interopRequireDefault(require("recompose/pure"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _reactDnd = require("react-dnd");

var _redux = require("webiny-app-cms/editor/redux");

var _selectors = require("webiny-app-cms/editor/selectors");

var defaultVisibility = function defaultVisibility(_ref) {
  var type = _ref.type,
      isDragging = _ref.isDragging,
      item = _ref.item;
  var target = item && item.target || [];

  if (!item || !target.includes(type)) {
    return false;
  }

  return isDragging;
};

var Droppable = (0, _pure2.default)(function (_ref2) {
  var item = _ref2.item,
      type = _ref2.type,
      children = _ref2.children,
      connectDropTarget = _ref2.connectDropTarget,
      isDragging = _ref2.isDragging,
      isOver = _ref2.isOver,
      _ref2$isDroppable = _ref2.isDroppable,
      isDroppable = _ref2$isDroppable === void 0 ? function () {
    return true;
  } : _ref2$isDroppable,
      isVisible = _ref2.isVisible;

  if (!isVisible) {
    isVisible = defaultVisibility;
  }

  if (!isVisible({
    type: type,
    item: item,
    isDragging: isDragging
  })) {
    return null;
  } // $FlowFixMe


  return connectDropTarget(children({
    isDragging: isDragging,
    isOver: isOver,
    isDroppable: isDroppable(item)
  }));
}); // Dragging

var spec = {
  drop: function drop(props, monitor) {
    props.onDrop(monitor.getItem());
  }
};

var props = function props(connect, monitor) {
  return {
    connectDropTarget: connect.dropTarget(),
    isOver: monitor.isOver() && monitor.isOver({
      shallow: true
    }),
    item: monitor.getItem()
  };
};

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  return {
    isDragging: (0, _selectors.getIsDragging)(state)
  };
}), (0, _reactDnd.DropTarget)("element", spec, props))(Droppable);

exports.default = _default;
//# sourceMappingURL=Droppable.js.map