"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _dotPropImmutable = require("dot-prop-immutable");

var _redux = require("webiny-app-cms/editor/redux");

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _emotion = require("emotion");

var _webinyPlugins = require("webiny-plugins");

var _context = require("webiny-app-cms/context");

var _selectors = require("webiny-app-cms/editor/selectors");

var _Element = _interopRequireDefault(require("webiny-app-cms/editor/components/Element"));

var _Elevation = require("webiny-ui/Elevation");

var ContentContainer =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e2xs0q40",
  label: "ContentContainer"
})(function (_ref) {
  var theme = _ref.theme;
  return {
    backgroundColor: (0, _dotPropImmutable.get)(theme, "colors.background"),
    ".webiny-cms-page-document": {
      overflowY: "visible",
      // cuts off the block selector tooltip
      overflowX: "visible"
    }
  };
});
var contentContainerWrapper =
/*#__PURE__*/
(0, _emotion.css)({
  margin: "95px 65px 50px 85px",
  padding: 0,
  position: "absolute",
  width: "calc(100vw - 115px)",
  //overflow: "hidden", // cuts off the block selector tooltip
  top: 0,
  boxSizing: "border-box",
  zIndex: 1
}, "label:contentContainerWrapper;");
var BaseContainer =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e2xs0q41",
  label: "BaseContainer"
})({
  width: "100%",
  left: 52,
  margin: "0 auto"
});

var Content = function Content(_ref2) {
  var rootElement = _ref2.rootElement,
      theme = _ref2.cms.theme,
      renderLayout = _ref2.renderLayout,
      layout = _ref2.layout;
  var plugins = (0, _webinyPlugins.getPlugins)("cms-editor-content");
  var themeLayout = theme.layouts.find(function (l) {
    return l.name === layout;
  });

  if (renderLayout && !themeLayout) {
    return "Layout \"".concat(layout, "\" was not found in your theme!");
  }

  var content = _react.default.createElement(_Element.default, {
    id: rootElement.id
  });

  content = renderLayout ? _react.default.createElement(themeLayout.component, null, content) : content;
  return _react.default.createElement(_Elevation.Elevation, {
    className: contentContainerWrapper,
    z: 2
  }, _react.default.createElement(ContentContainer, {
    theme: theme
  }, plugins.map(function (plugin) {
    return _react.default.cloneElement(plugin.render(), {
      key: plugin.name
    });
  }), _react.default.createElement(BaseContainer, {
    className: "webiny-cms-editor-content-preview"
  }, content)));
};

var stateToProps = function stateToProps(state) {
  return {
    rootElement: state.elements[(0, _selectors.getContent)(state).id],
    layout: (0, _dotPropImmutable.get)((0, _selectors.getPage)(state), "settings.general.layout"),
    renderLayout: (0, _selectors.isPluginActive)("cms-toolbar-preview")(state)
  };
};

var _default = (0, _compose2.default)((0, _redux.connect)(stateToProps), (0, _context.withCms)())(Content);

exports.default = _default;
//# sourceMappingURL=Content.js.map