"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDnd = require("react-dnd");

var layerStyles = {
  position: "fixed",
  pointerEvents: "none",
  zIndex: 100,
  left: 0,
  top: 0,
  width: "100%",
  height: "100%"
};
var subscribedToOffsetChange = false;
var dragPreviewRef = null;

var onOffsetChange = function onOffsetChange(monitor) {
  return function () {
    if (!dragPreviewRef) return;
    var offset = monitor.getClientOffset();
    if (!offset) return;
    var transform = "translate(".concat(offset.x - 15, "px, ").concat(offset.y - 15, "px)");
    dragPreviewRef.style["transform"] = transform;
    dragPreviewRef.style["-webkit-transform"] = transform;
  };
};

var _default = (0, _reactDnd.DragLayer)(function (monitor) {
  if (!subscribedToOffsetChange) {
    monitor.subscribeToOffsetChange(onOffsetChange(monitor));
    subscribedToOffsetChange = true;
  }

  return {
    item: monitor.getItem(),
    itemType: monitor.getItemType(),
    currentOffset: monitor.getClientOffset(),
    isDragging: monitor.isDragging()
  };
})(_react.default.memo(function (_ref) {
  var isDragging = _ref.isDragging;

  if (!isDragging) {
    return null;
  }

  return _react.default.createElement("div", {
    style: layerStyles
  }, _react.default.createElement("div", {
    style: {
      display: "block"
    },
    ref: function ref(el) {
      return dragPreviewRef = el;
    }
  }, _react.default.createElement("div", {
    style: {
      width: 30,
      height: 30,
      backgroundColor: "var(--mdc-theme-primary)",
      borderRadius: "50%"
    }
  })));
}));

exports.default = _default;
//# sourceMappingURL=DragPreview.js.map