"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lifecycle2 = _interopRequireDefault(require("recompose/lifecycle"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _classnames = _interopRequireDefault(require("classnames"));

var _reduxUndo = require("redux-undo");

var _reactDndHtml5Backend = _interopRequireDefault(require("react-dnd-html5-backend"));

var _reactDnd = require("react-dnd");

var _selectors = require("webiny-app-cms/editor/selectors");

var _components = require("webiny-app-cms/editor/components");

require("./Editor.scss");

var _Bar = _interopRequireDefault(require("./Bar"));

var _Toolbar = _interopRequireDefault(require("./Toolbar"));

var _Content = _interopRequireDefault(require("./Content"));

var _DragPreview = _interopRequireDefault(require("./DragPreview"));

var _Dialogs = _interopRequireDefault(require("./Dialogs"));

// Components
var Editor = function Editor(_ref) {
  var isDragging = _ref.isDragging,
      isResizing = _ref.isResizing;
  var classes = {
    "cms-editor": true,
    "cms-editor-dragging": isDragging,
    "cms-editor-resizing": isResizing
  };
  return _react.default.createElement("div", {
    className: (0, _classnames.default)(classes)
  }, _react.default.createElement(_Bar.default, null), _react.default.createElement(_Toolbar.default, null), _react.default.createElement(_Content.default, null), _react.default.createElement(_Dialogs.default, null), _react.default.createElement(_DragPreview.default, null));
};

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  var ui = (0, _selectors.getUi)(state);
  return {
    slateFocused: ui.slateFocused,
    isDragging: ui.dragging,
    isResizing: ui.resizing
  };
}, {
  undo: _reduxUndo.ActionCreators.undo,
  redo: _reduxUndo.ActionCreators.redo
}), (0, _components.withKeyHandler)(), (0, _lifecycle2.default)({
  componentDidMount: function componentDidMount() {
    var _this = this;

    var _this$props = this.props,
        addKeyHandler = _this$props.addKeyHandler,
        undo = _this$props.undo,
        redo = _this$props.redo;
    addKeyHandler("mod+z", function (e) {
      if (!_this.props.slateFocused) {
        e.preventDefault();
        undo();
      }
    });
    addKeyHandler("mod+shift+z", function (e) {
      if (!_this.props.slateFocused) {
        e.preventDefault();
        redo();
      }
    });
  },
  componentWillUnmount: function componentWillUnmount() {
    this.props.removeKeyHandler("mod+z");
    this.props.removeKeyHandler("mod+shift+z");
  }
}), (0, _reactDnd.DragDropContext)(_reactDndHtml5Backend.default))(Editor);

exports.default = _default;
//# sourceMappingURL=Editor.js.map