"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lifecycle2 = _interopRequireDefault(require("recompose/lifecycle"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var _react = _interopRequireDefault(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _emotion = require("emotion");

var _Drawer = require("webiny-ui/Drawer");

var _webinyPlugins = require("webiny-plugins");

var _components = require("webiny-app-cms/editor/components");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var ToolbarDrawerContainer =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eoqhtnt0",
  label: "ToolbarDrawerContainer"
})({
  top: 64,
  left: 0,
  position: "fixed",
  backgroundColor: "var(--mdc-theme-surface)",
  zIndex: 2
});
var ToolbarContainer =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eoqhtnt1",
  label: "ToolbarContainer"
})({
  position: "fixed",
  display: "inline-block",
  padding: "2px 1px 2px 3px",
  width: 50,
  top: 64,
  height: "calc(100vh - 68px)",
  backgroundColor: "var(--mdc-theme-surface)",
  boxShadow: "1px 0px 5px 0px var(--mdc-theme-on-background)",
  zIndex: 3
});
var DrawerContainer =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eoqhtnt2",
  label: "DrawerContainer"
})(function (props) {
  return {
    pointerEvents: props.open ? "all" : "none",
    ".mdc-drawer__drawer": {
      "> .mdc-list": {
        padding: 0
      }
    }
  };
});
var ToolbarActions =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eoqhtnt3",
  label: "ToolbarActions"
})({
  position: "relative",
  display: "flex",
  flexDirection: "column",
  justifyContent: "space-between",
  height: "100%"
});
var drawerStyle =
/*#__PURE__*/
(0, _emotion.css)({
  zIndex: 10,
  "&.mdc-drawer--dismissible": {
    marginLeft: 54,
    position: "fixed",
    top: 64,
    width: "490px !important",
    maxWidth: "490px !important",
    ".mdc-drawer__content": {
      width: "100%"
    }
  }
}, "label:drawerStyle;");
var drawerKeyHandler = (0, _compose2.default)((0, _redux.connect)(null, {
  deactivatePlugin: _actions.deactivatePlugin
}), (0, _components.withKeyHandler)(), (0, _lifecycle2.default)({
  componentDidUpdate: function componentDidUpdate(_ref) {
    var _this = this;

    var active = _ref.active,
        name = _ref.name;

    if (!active && this.props.active) {
      this.props.addKeyHandler("escape", function (e) {
        e.preventDefault();

        _this.props.deactivatePlugin({
          name: name
        });
      });
    }

    if (active && !this.props.active) {
      this.props.removeKeyHandler("escape");
    }
  }
}));
var ToolbarDrawer = drawerKeyHandler(function (_ref2) {
  var active = _ref2.active,
      children = _ref2.children;
  return _react.default.createElement(DrawerContainer, {
    open: active
  }, _react.default.createElement(_Drawer.Drawer, {
    dismissible: true,
    open: active,
    className: drawerStyle
  }, _react.default.createElement(_Drawer.DrawerContent, null, children)));
});

var renderPlugin = function renderPlugin(plugin) {
  return _react.default.cloneElement(plugin.renderAction(), {
    key: plugin.name
  });
};

var Toolbar = function Toolbar(_ref3) {
  var activePluginsTop = _ref3.activePluginsTop;
  var actionsTop = (0, _webinyPlugins.getPlugins)("cms-toolbar-top");
  var actionsBottom = (0, _webinyPlugins.getPlugins)("cms-toolbar-bottom");
  return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(ToolbarDrawerContainer, null, actionsTop.filter(function (plugin) {
    return typeof plugin.renderDrawer === "function";
  }).map(function (plugin) {
    return _react.default.createElement(ToolbarDrawer, {
      key: plugin.name,
      name: plugin.name,
      active: Boolean(activePluginsTop.includes(plugin.name))
    }, plugin.renderDrawer());
  })), _react.default.createElement(ToolbarContainer, null, _react.default.createElement(ToolbarActions, null, _react.default.createElement("div", null, actionsTop.map(renderPlugin)), _react.default.createElement("div", null, actionsBottom.map(renderPlugin)))));
};

var _default = (0, _redux.connect)(function (state) {
  return {
    activePluginsTop: (0, _selectors.getActivePlugins)("cms-toolbar-top")(state).map(function (pl) {
      return pl.name;
    }),
    activePluginsBottom: (0, _selectors.getActivePlugins)("cms-toolbar-bottom")(state).map(function (pl) {
      return pl.name;
    })
  };
}, null, null, {
  areStatePropsEqual: _isEqual2.default
})(Toolbar);

exports.default = _default;
//# sourceMappingURL=Toolbar.js.map