"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _setDisplayName2 = _interopRequireDefault(require("recompose/setDisplayName"));

var _withProps2 = _interopRequireDefault(require("recompose/withProps"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _pure2 = _interopRequireDefault(require("recompose/pure"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _reactTransitionGroup = require("react-transition-group");

var _redux = require("webiny-app-cms/editor/redux");

var _isEqual = _interopRequireDefault(require("lodash/isEqual"));

var _webinyPlugins = require("webiny-plugins");

var _plugins = require("webiny-app/plugins");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var _Draggable = _interopRequireDefault(require("./Draggable"));

var _ElementStyled = require("./Element/ElementStyled");

var Element = (0, _pure2.default)(function (_ref) {
  var plugin = _ref.plugin,
      renderDraggable = _ref.renderDraggable,
      element = _ref.element,
      highlight = _ref.highlight,
      active = _ref.active,
      onMouseOver = _ref.onMouseOver,
      beginDrag = _ref.beginDrag,
      endDrag = _ref.endDrag,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? "" : _ref$className;

  if (!plugin) {
    return null;
  }

  return React.createElement(_reactTransitionGroup.Transition, {
    in: true,
    timeout: 250,
    appear: true
  }, function (state) {
    return React.createElement(_ElementStyled.ElementContainer, {
      id: element.id,
      onMouseOver: onMouseOver,
      highlight: highlight,
      active: active,
      style: (0, _objectSpread2.default)({}, _ElementStyled.defaultStyle, _ElementStyled.transitionStyles[state]),
      className: "webiny-cms-element-container"
    }, React.createElement("div", {
      className: ["innerWrapper", className].filter(function (c) {
        return c;
      }).join(" ")
    }, React.createElement(_Draggable.default, {
      target: plugin.target,
      beginDrag: beginDrag,
      endDrag: endDrag
    }, renderDraggable), plugin.render({
      element: element
    })));
  });
});

var _default = (0, _compose2.default)((0, _setDisplayName2.default)("Element"), (0, _redux.connect)(function (state, props) {
  return (0, _objectSpread2.default)({}, (0, _selectors.getElementProps)(state, props), {
    element: (0, _selectors.getElement)(state, props.id)
  });
}, {
  dragStart: _actions.dragStart,
  dragEnd: _actions.dragEnd,
  activateElement: _actions.activateElement,
  highlightElement: _actions.highlightElement
}, null, {
  areStatePropsEqual: _isEqual.default
}), (0, _withProps2.default)(function (_ref2) {
  var element = _ref2.element;
  return {
    plugin: element ? (0, _webinyPlugins.getPlugin)(element.type) : null
  };
}), (0, _withHandlers2.default)({
  beginDrag: function beginDrag(_ref3) {
    var plugin = _ref3.plugin,
        element = _ref3.element,
        dragStart = _ref3.dragStart;
    return function () {
      var data = {
        id: element.id,
        type: element.type,
        path: element.path
      };
      setTimeout(function () {
        dragStart({
          element: data
        });
      });
      return (0, _objectSpread2.default)({}, data, {
        target: plugin.target
      });
    };
  },
  endDrag: function endDrag(_ref4) {
    var dragEnd = _ref4.dragEnd;
    return function (props, monitor) {
      dragEnd({
        element: monitor.getItem()
      });
    };
  },
  onClick: function onClick(_ref5) {
    var element = _ref5.element,
        active = _ref5.active,
        activateElement = _ref5.activateElement;
    return function () {
      if (element.type === "cms-element-document") {
        return;
      }

      if (!active) {
        activateElement({
          element: element.id
        });
      }
    };
  },
  onMouseOver: function onMouseOver(_ref6) {
    var element = _ref6.element,
        highlight = _ref6.highlight,
        highlightElement = _ref6.highlightElement;
    return function (e) {
      if (element.type === "cms-element-document") {
        return;
      }

      e.stopPropagation();

      if (!highlight) {
        highlightElement({
          element: element.id
        });
      }
    };
  }
}), (0, _withHandlers2.default)({
  renderDraggable: function renderDraggable(_ref7) {
    var element = _ref7.element,
        plugin = _ref7.plugin,
        onClick = _ref7.onClick;
    return function (_ref8) {
      var connectDragSource = _ref8.connectDragSource;
      return connectDragSource(React.createElement("div", {
        className: "type " + _ElementStyled.typeStyle
      }, React.createElement("div", {
        className: "background",
        onClick: onClick
      }), React.createElement("div", {
        className: "element-holder",
        onClick: onClick
      }, (0, _plugins.renderPlugins)("cms-element-action", {
        element: element,
        plugin: plugin
      }), React.createElement("span", null, plugin.name.replace("cms-element-", "")))));
    };
  }
}))(Element);

exports.default = _default;
//# sourceMappingURL=Element.js.map