"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _withProps2 = _interopRequireDefault(require("recompose/withProps"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _withState2 = _interopRequireDefault(require("recompose/withState"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _emotion = require("emotion");

var _webinyPlugins = require("webiny-plugins");

var _Typography = require("webiny-ui/Typography");

var _reactVirtualized = require("react-virtualized");

var _reactFontawesome = require("@fortawesome/react-fontawesome");

var _DelayedOnChange = require("webiny-app-cms/editor/components/DelayedOnChange");

var _Menu = require("webiny-ui/Menu");

var _Input = require("webiny-ui/Input");

var icons = null;
var COLUMN_COUNT = 6;
var gridItem =
/*#__PURE__*/
(0, _emotion.css)({
  display: "flex",
  flexDirection: "column",
  justifyContent: "flex-start",
  boxSizing: "border-box",
  paddingTop: 15,
  alignItems: "center",
  textAlign: "center",
  cursor: "pointer",
  transform: "translateZ(0)",
  borderRadius: 2,
  color: "var(--mdc-theme-text-secondary-on-background)",
  transition: "all 0.5s cubic-bezier(0.165, 0.84, 0.44, 1)",
  "&::after": {
    boxShadow: "0 0.25rem 0.125rem 0 rgba(0,0,0,0.05)",
    transition: "opacity 0.5s cubic-bezier(0.165, 0.84, 0.44, 1)",
    content: '""',
    position: "absolute",
    top: 0,
    left: 0,
    width: "100%",
    height: "100%",
    zIndex: "-1",
    opacity: 0
  },
  "&:hover": {
    backgroundColor: "var(--mdc-theme-background)",
    color: "var(--mdc-theme-text-primary-on-background)",
    "&::after": {
      opacity: 1
    }
  },
  ">svg": {
    width: 42,
    marginBottom: 5
  }
}, "label:gridItem;");
var grid =
/*#__PURE__*/
(0, _emotion.css)({
  padding: 20
}, "label:grid;");
var pickIcon =
/*#__PURE__*/
(0, _emotion.css)({
  width: 50,
  textAlign: "center",
  cursor: "pointer"
}, "label:pickIcon;");
var searchInput =
/*#__PURE__*/
(0, _emotion.css)({
  input: {
    padding: "20px 12px 20px"
  }
}, "label:searchInput;");

var IconPicker = function IconPicker(_ref) {
  var value = _ref.value,
      renderGrid = _ref.renderGrid;
  return React.createElement(_Menu.Menu, {
    handle: React.createElement("div", {
      className: pickIcon
    }, React.createElement(_reactFontawesome.FontAwesomeIcon, {
      icon: value || ["far", "star"],
      size: "2x"
    }))
  }, renderGrid);
};

var _default = (0, _compose2.default)((0, _withState2.default)("filter", "setFilter", ""), (0, _withProps2.default)(function (_ref2) {
  var filter = _ref2.filter;

  if (!icons) {
    icons = (0, _webinyPlugins.getPlugins)("cms-icons").reduce(function (icons, pl) {
      return icons.concat(pl.getIcons());
    }, []);
  }

  return {
    icons: icons ? filter ? icons.filter(function (ic) {
      return ic.name.includes(filter);
    }) : icons : []
  };
}), (0, _withHandlers2.default)({
  renderCell: function renderCell(_ref3) {
    var onChange = _ref3.onChange,
        icons = _ref3.icons;
    return function (_ref4) {
      var closeMenu = _ref4.closeMenu;
      return function renderCell(_ref5) {
        var columnIndex = _ref5.columnIndex,
            key = _ref5.key,
            rowIndex = _ref5.rowIndex,
            style = _ref5.style;
        var item = icons[rowIndex * COLUMN_COUNT + columnIndex];

        if (!item) {
          return null;
        }

        return React.createElement("div", {
          key: key,
          style: style,
          className: gridItem,
          onClick: function onClick() {
            onChange(item);
            closeMenu();
          }
        }, React.createElement(_reactFontawesome.FontAwesomeIcon, {
          icon: item.id,
          size: "2x"
        }), React.createElement(_Typography.Typography, {
          use: "body2"
        }, item.name));
      };
    };
  }
}), (0, _withHandlers2.default)({
  renderGrid: function renderGrid(_ref6) {
    var filter = _ref6.filter,
        setFilter = _ref6.setFilter,
        renderCell = _ref6.renderCell,
        icons = _ref6.icons;
    return function renderGrid(_ref7) {
      var closeMenu = _ref7.closeMenu;
      return React.createElement(React.Fragment, null, React.createElement(_DelayedOnChange.DelayedOnChange, {
        value: filter,
        onChange: setFilter
      }, function (_ref8) {
        var value = _ref8.value,
            onChange = _ref8.onChange;
        return React.createElement(_Input.Input, {
          autoFocus: true,
          className: searchInput,
          value: value,
          onChange: onChange,
          placeholder: "Search icons..."
        });
      }), React.createElement(_reactVirtualized.Grid, {
        className: grid,
        cellRenderer: renderCell({
          closeMenu: closeMenu
        }),
        columnCount: COLUMN_COUNT,
        columnWidth: 100,
        height: 440,
        rowCount: Math.ceil(icons.length / COLUMN_COUNT),
        rowHeight: 100,
        width: 640
      }));
    };
  }
}))(IconPicker);

exports.default = _default;
//# sourceMappingURL=IconPicker.js.map