"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _get3 = _interopRequireDefault(require("lodash/get"));

var _lifecycle2 = _interopRequireDefault(require("recompose/lifecycle"));

var _shouldUpdate2 = _interopRequireDefault(require("recompose/shouldUpdate"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var React = _interopRequireWildcard(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _emotion = require("emotion");

var _dotPropImmutable = require("dot-prop-immutable");

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _reactApollo = require("react-apollo");

var _actions = require("webiny-app-cms/editor/actions");

var _components = require("webiny-admin/components");

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    query GetOEmbedData($url: String!, $width: String, $height: String) {\n        cms {\n            oembedData(url: $url, width: $width, height: $height) {\n                data\n                error {\n                    code\n                    message\n                }\n            }\n        }\n    }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function appendSDK(props) {
  var sdk = props.sdk,
      global = props.global,
      element = props.element;

  var _ref = (0, _get3.default)(element, "data.source") || {},
      url = _ref.url;

  if (!sdk || !url || window[global]) {
    return;
  }

  return new Promise(function (resolve) {
    var script = document.createElement("script");
    script.type = "text/javascript";
    script.src = encodeURI(sdk);
    script.setAttribute("async", "");
    script.setAttribute("charset", "utf-8");
    script.onload = resolve; // $FlowFixMe

    document.body.appendChild(script);
  });
}

function initEmbed(props) {
  var sdk = props.sdk,
      init = props.init,
      element = props.element;

  if (sdk && (0, _get3.default)(element, "data.source.url")) {
    var node = document.getElementById(element.id);

    if (typeof init === "function" && node) {
      init({
        props: props,
        node: node
      });
    }
  }
}

var oembedQuery = (0, _graphqlTag.default)(_templateObject());
var centerAlign =
/*#__PURE__*/
(0, _emotion.css)({
  "*:first-child": {
    marginLeft: "auto !important",
    marginRight: "auto !important"
  }
}, "label:centerAlign;");

var _default = (0, _compose2.default)((0, _shouldUpdate2.default)(function (props, nextProps) {
  return !(0, _isEqual2.default)(props, nextProps);
}), (0, _redux.connect)(null, {
  updateElement: _actions.updateElement
}), (0, _components.withSnackbar)(), (0, _reactApollo.graphql)(oembedQuery, {
  skip: function skip(_ref2) {
    var element = _ref2.element;
    var source = (0, _get3.default)(element, "data.source") || {};
    var oembed = (0, _get3.default)(element, "data.oembed") || {};
    return !source.url || (0, _isEqual2.default)(oembed.source, source);
  },
  options: function options(_ref3) {
    var element = _ref3.element,
        updateElement = _ref3.updateElement,
        showSnackbar = _ref3.showSnackbar,
        _ref3$onData = _ref3.onData,
        onData = _ref3$onData === void 0 ? function (d) {
      return d;
    } : _ref3$onData;
    var source = (0, _get3.default)(element, "data.source") || {};
    return {
      variables: source,
      onCompleted: function onCompleted(data) {
        var _get2 = (0, _get3.default)(data, "cms.oembedData"),
            oembed = _get2.data,
            error = _get2.error;

        if (oembed) {
          // Store loaded oembed data
          updateElement({
            element: (0, _dotPropImmutable.set)(element, "data.oembed", onData(oembed))
          });
        }

        if (error) {
          showSnackbar(error.message);
        }
      }
    };
  }
}), (0, _withHandlers2.default)({
  renderEmpty: function renderEmpty() {
    return function renderEmpty() {
      return React.createElement("div", null, "You must configure your embed in the settings!");
    };
  },
  renderEmbed: function renderEmbed(_ref4) {
    var _renderEmbed = _ref4.renderEmbed,
        props = (0, _objectWithoutProperties2.default)(_ref4, ["renderEmbed"]);
    return function embedRenderer() {
      if (typeof _renderEmbed === "function") {
        return _renderEmbed(props);
      }

      var element = props.element,
          data = props.data;

      if (data && data.loading) {
        return "Loading embed data...";
      }

      return React.createElement("div", {
        id: element.id,
        className: centerAlign + " cms-editor-dragging--disabled cms-editor-resizing--disabled",
        dangerouslySetInnerHTML: {
          __html: (0, _get3.default)(element, "data.oembed.html") || ""
        }
      });
    };
  }
}), (0, _lifecycle2.default)({
  componentDidMount: function () {
    var _componentDidMount = (0, _asyncToGenerator2.default)(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee() {
      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return appendSDK(this.props);

            case 2:
              initEmbed(this.props);

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function componentDidMount() {
      return _componentDidMount.apply(this, arguments);
    }

    return componentDidMount;
  }(),
  componentDidUpdate: function () {
    var _componentDidUpdate = (0, _asyncToGenerator2.default)(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee2() {
      return _regenerator.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return appendSDK(this.props);

            case 2:
              initEmbed(this.props);

            case 3:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function componentDidUpdate() {
      return _componentDidUpdate.apply(this, arguments);
    }

    return componentDidUpdate;
  }()
}))(function (_ref5) {
  var element = _ref5.element,
      renderEmbed = _ref5.renderEmbed,
      renderEmpty = _ref5.renderEmpty;

  var _ref6 = (0, _get3.default)(element, "data.source") || {},
      url = _ref6.url;

  return url ? renderEmbed() : renderEmpty();
});

exports.default = _default;
//# sourceMappingURL=OEmbed.js.map