"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _lifecycle2 = _interopRequireDefault(require("recompose/lifecycle"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _reactTransitionGroup = require("react-transition-group");

var _webinyPlugins = require("webiny-plugins");

var _components = require("webiny-app-cms/editor/components");

var _emotion = require("emotion");

var _Elevation = require("webiny-ui/Elevation");

var _styled = require("./styled");

var MenuButton = function MenuButton(_ref) {
  var onClick = _ref.onClick,
      active = _ref.active,
      children = _ref.children,
      _ref$onMouseDown = _ref.onMouseDown,
      onMouseDown = _ref$onMouseDown === void 0 ? function (e) {
    return e.preventDefault();
  } : _ref$onMouseDown;
  var buttonStyle =
  /*#__PURE__*/
  (0, _emotion.css)({
    cursor: "pointer",
    color: active ? "var(--mdc-theme-primary)" : "var(--mdc-theme-text-secondary-on-background)",
    "&:hover": {
      color: "var(--mdc-theme-primary)"
    }
  }, "label:buttonStyle;");
  return _react.default.createElement("span", {
    onClick: onClick,
    className: buttonStyle,
    onMouseDown: onMouseDown
  }, children);
};

var MenuContainer = (0, _compose2.default)((0, _components.withKeyHandler)(), (0, _lifecycle2.default)({
  componentDidMount: function componentDidMount() {
    var _this = this;

    this.props.addKeyHandler("escape", function (e) {
      e.preventDefault();

      _this.props.closeMenu();
    });
  },
  componentWillUnmount: function componentWillUnmount() {
    this.props.removeKeyHandler("escape");
  }
}))(function (_ref2) {
  var children = _ref2.children;
  return children;
});

var Menu =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(Menu, _React$Component);

  function Menu() {
    var _getPrototypeOf2;

    var _this2;

    (0, _classCallCheck2.default)(this, Menu);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this2 = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(Menu)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this2)), "menu", _react.default.createRef());
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this2)), "state", {
      activePlugin: null,
      visible: false
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this2)), "activatePlugin", function (plugin) {
      var value = _this2.props.value;
      var jsonValue = {
        selection: value.selection.toJSON(),
        inlines: value.inlines.toJSON(),
        marks: value.marks.toJSON(),
        activeMarks: value.activeMarks.toJSON(),
        blocks: value.blocks.toJSON(),
        texts: value.texts.toJSON()
      };

      _this2.setState({
        visible: true
      }, function () {
        setTimeout(function () {
          _this2.setState({
            lastSelectionWasFocused: true,
            activePlugin: {
              plugin: plugin,
              value: jsonValue
            }
          });
        }, 200);
      });

      Menu.menus.push(function () {
        _this2.deactivatePlugin();
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this2)), "deactivatePlugin", function () {
      _this2.setState({
        visible: false
      }, function () {
        setTimeout(function () {
          _this2.setState({
            activePlugin: null
          });
        }, 100);
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this2)), "renderActivePlugin", function () {
      var _ref3 = _this2.state.activePlugin || {},
          plugin = _ref3.plugin,
          value = _ref3.value;

      var menuPlugin = (0, _webinyPlugins.getPlugin)(plugin);

      if (!menuPlugin) {
        return null;
      }

      return _react.default.createElement(_reactTransitionGroup.Transition, {
        in: _this2.state.visible,
        timeout: 100,
        appear: true,
        mountOnEnter: true
      }, function (state) {
        return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_styled.ToolbarBox, {
          innerRef: _this2.menu,
          style: (0, _objectSpread2.default)({}, _styled.defaultStyle, _styled.transitionStyles[state])
        }, _react.default.createElement(_Elevation.Elevation, {
          z: 2,
          className: "elevationBox"
        }, _react.default.createElement(MenuContainer, {
          closeMenu: _this2.deactivatePlugin
        }, menuPlugin.renderMenu({
          closeMenu: _this2.deactivatePlugin,
          value: value,
          onChange: _this2.props.onChange,
          editor: _this2.props.editor.current
        })))), _react.default.createElement(_styled.Overlay, {
          onClick: _this2.deactivatePlugin
        }));
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this2)), "renderPlugins", function (type) {
      var _this2$props = _this2.props,
          value = _this2$props.value,
          onChange = _this2$props.onChange,
          editor = _this2$props.editor,
          exclude = _this2$props.exclude;
      return (0, _webinyPlugins.getPlugins)(type).filter(function (pl) {
        return !exclude.includes(pl.name);
      }).map(function (plugin) {
        return _react.default.cloneElement(plugin.render({
          MenuButton: MenuButton,
          value: value,
          onChange: onChange,
          editor: editor.current,
          activatePlugin: _this2.activatePlugin
        }), {
          key: plugin.name
        });
      });
    });
    return _this2;
  }

  (0, _createClass2.default)(Menu, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var menu = this.menu.current;

      if (!menu) {
        return;
      }

      var rect = menu.parentNode.getBoundingClientRect();
      var menuLeft = window.pageXOffset - (menu.offsetWidth - rect.width) / 2;
      var absoluteMenuLeft = Math.abs(rect.left + menuLeft); // Check left border

      if (absoluteMenuLeft < 65) {
        menuLeft = -(rect.left - 65);
      } // Check right border


      var absoluteMenuRight = absoluteMenuLeft + menu.offsetWidth;

      if (absoluteMenuRight > window.innerWidth) {
        menuLeft -= absoluteMenuRight - window.innerWidth + 15;
      }

      menu.style.left = "".concat(menuLeft, "px");
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var selection = this.props.value.selection;

      if (this.state.activePlugin) {
        return this.renderActivePlugin();
      }

      if (selection.isFocused && selection.isCollapsed) {
        return null;
      }

      if (!selection.isFocused) {
        return null;
      }

      return _react.default.createElement(_reactTransitionGroup.Transition, {
        in: Boolean(this.menu),
        timeout: 200,
        appear: true
      }, function (state) {
        return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_Elevation.Elevation, {
          z: 1,
          elementRef: _this3.menu,
          className: _styled.hoverMenuStyle,
          style: (0, _objectSpread2.default)({}, _styled.defaultStyle, _styled.transitionStyles[state])
        }, _this3.renderPlugins("cms-slate-menu-item")));
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (!state.activePlugin || !props.value.selection) {
        return null;
      }

      var selection = props.value.selection.toJSON();

      if (state.activePlugin && selection.isFocused && !state.lastSelectionWasFocused) {
        return {
          activePlugin: null
        };
      }

      return {
        lastSelectionWasFocused: selection.isFocused
      };
    }
  }]);
  return Menu;
}(_react.default.Component);

(0, _defineProperty2.default)(Menu, "menus", []);
var _default = Menu;
exports.default = _default;
//# sourceMappingURL=Menu.js.map