"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _pure2 = _interopRequireDefault(require("recompose/pure"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _redux = require("webiny-app-cms/editor/redux");

var _slateReact = require("slate-react");

var _slate = require("slate");

var _webinyPlugins = require("webiny-plugins");

var _actions = require("webiny-app-cms/editor/actions");

var _context = require("webiny-app-cms/context");

var _index = require("./index");

var _Menu = _interopRequireDefault(require("./Menu"));

var SlateEditor =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(SlateEditor, _React$Component);

  function SlateEditor(props) {
    var _this;

    (0, _classCallCheck2.default)(this, SlateEditor);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(SlateEditor).call(this));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "plugins", []);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "editor", _react.default.createRef());
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "onChange", function (change) {
      if (_this.state.readOnly) {
        return;
      } // Prevent `onChange` if it is a `set_value` operation.
      // We only need to handle changes on user input.


      if ((0, _get2.default)(change.operations.toJSON(), "0.type") === "set_value") {
        return;
      } // Only update local state.


      _this.setState(function (state) {
        return (0, _objectSpread2.default)({}, state, {
          value: change.value,
          modified: true
        });
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "onBlur", function () {
      _this.setState({
        modified: false
      });

      _this.props.onChange(_this.state.value.toJSON());
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "onFocus", function () {
      if (_this.state.activePlugin) {
        _this.setState({
          activePlugin: null
        });
      }

      Array.isArray(_Menu.default.menus) && _Menu.default.menus.forEach(function (cb) {
        return cb();
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "getMenuContainer", function () {
      var id = "slate-menu-container"; // Get menu container

      var menuContainer = document.getElementById(id);

      if (!menuContainer) {
        menuContainer = document.createElement("div");
        menuContainer.setAttribute("id", id);
        document.body && document.body.appendChild(menuContainer);
      } // Position menu container


      var rect = _this.getSelectionRect();

      if (rect.top === 0) {
        return menuContainer;
      }

      menuContainer.style.position = "fixed";
      menuContainer.style.pointerEvents = "none";
      menuContainer.style.zIndex = "500";
      menuContainer.style.top = rect.top - 20 + "px";
      menuContainer.style.left = rect.left + "px";
      menuContainer.style.width = rect.width + "px";
      menuContainer.style.height = rect.height + "px";
      return menuContainer;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "getSelectionRect", function () {
      var native = window.getSelection();

      if (native.type === "None") {
        return {
          top: 0,
          left: 0,
          width: 0,
          height: 0
        };
      }

      var range = native.getRangeAt(0);
      return range.getBoundingClientRect();
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "renderFloatingMenu", function () {
      var container = _this.getMenuContainer();

      if (container) {
        return _reactDom.default.createPortal(_react.default.createElement(_Menu.default, {
          exclude: _this.props.exclude,
          value: _this.state.value,
          onChange: _this.onChange,
          editor: _this.editor
        }), container);
      }

      return null;
    });
    var value = typeof props.value === "string" ? (0, _index.createValue)(props.value) : props.value;
    _this.state = {
      modified: false,
      showMenu: false,
      value: _slate.Value.fromJSON(value),
      readOnly: !props.onChange,
      activePlugin: null
    };
    _this.plugins = (0, _webinyPlugins.getPlugins)("cms-slate-editor").filter(function (pl) {
      return !props.exclude.includes(pl.name);
    }).map(function (pl) {
      return pl.slate;
    });
    return _this;
  }

  (0, _createClass2.default)(SlateEditor, [{
    key: "render",
    value: function render() {
      return _react.default.createElement(_react.default.Fragment, null, !this.state.readOnly && this.renderFloatingMenu(), _react.default.createElement(_slateReact.Editor, {
        ref: this.editor,
        onBlur: this.onBlur,
        onFocus: this.onFocus,
        readOnly: this.state.readOnly,
        autoCorrect: false,
        spellCheck: false,
        plugins: this.plugins,
        placeholder: "Enter some text...",
        value: this.state.value,
        onChange: this.onChange,
        theme: this.props.cms.theme
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (!state.modified && !props.readOnly) {
        // Got new editor value through props.
        var value = typeof props.value === "string" ? (0, _index.createValue)(props.value) : props.value;
        return {
          value: _slate.Value.fromJSON(value)
        };
      }

      return null;
    }
  }]);
  return SlateEditor;
}(_react.default.Component);

(0, _defineProperty2.default)(SlateEditor, "defaultProps", {
  exclude: []
});

var _default = (0, _pure2.default)((0, _compose2.default)((0, _redux.connect)(null, {
  focusSlateEditor: _actions.focusSlateEditor,
  blurSlateEditor: _actions.blurSlateEditor
}), (0, _context.withCms)())(SlateEditor));

exports.default = _default;
//# sourceMappingURL=Slate.js.map