"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.createValue = void 0;

var _Slate = _interopRequireDefault(require("./Slate"));

/**
 * Create Slate editor value object using given text and typography.
 *
 * @param text
 * @param typography
 * @returns {{object, document}}
 */
var createValue = function createValue(text) {
  var typography = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "body1";
  return createDocument(createTextLeaf(text), typography);
};
/**
 * Create Slate editor text leaf
 * @param text
 * @returns {{object: string, text: *}}
 */


exports.createValue = createValue;

var createTextLeaf = function createTextLeaf(text) {
  return {
    object: "leaf",
    text: text
  };
};
/**
 * Create Slate editor document
 * @param leaf
 * @param typography
 * @returns {{object: string, document: {object: string, nodes: *[]}}}
 */


var createDocument = function createDocument(leaf) {
  var typography = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "body1";
  return {
    object: "value",
    document: {
      object: "document",
      nodes: [{
        object: "block",
        type: typography,
        nodes: [{
          object: "text",
          leaves: [leaf]
        }]
      }]
    }
  };
};

var _default = _Slate.default;
exports.default = _default;
//# sourceMappingURL=index.js.map