"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withActiveElement = withActiveElement;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _selectors = require("webiny-app-cms/editor/selectors");

function withActiveElement() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$propName = _ref.propName,
      propName = _ref$propName === void 0 ? "element" : _ref$propName,
      _ref$shallow = _ref.shallow,
      shallow = _ref$shallow === void 0 ? false : _ref$shallow,
      _ref$keys = _ref.keys,
      keys = _ref$keys === void 0 ? [] : _ref$keys;

  return function decorator(Component) {
    return (0, _redux.connect)(function (state) {
      var elementId = (0, _selectors.getActiveElementId)(state);

      if (!elementId) {
        return (0, _defineProperty2.default)({}, propName, null);
      }

      var element = shallow ? (0, _selectors.getElement)(state, elementId) : (0, _selectors.getElementWithChildren)(state, elementId);

      if (keys.length > 0) {
        return (0, _defineProperty2.default)({}, propName, keys.reduce(function (el, key) {
          el[key] = element[key];
          return el;
        }, {}));
      }

      return (0, _defineProperty2.default)({}, propName, element);
    })(Component);
  };
}
//# sourceMappingURL=withActiveElement.js.map