"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _reactApollo = require("react-apollo");

var _components = require("webiny-admin/components");

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    query GetOEmbedData($url: String!) {\n        cms {\n            oembedData(url: $url) {\n                data\n                error {\n                    code\n                    message\n                }\n            }\n        }\n    }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var oembedQuery = (0, _graphqlTag.default)(_templateObject());

var _default = function _default() {
  return (0, _compose2.default)(_reactApollo.withApollo, (0, _components.withSnackbar)(), (0, _withHandlers2.default)({
    getOEmbedData: function getOEmbedData(_ref) {
      var client = _ref.client,
          showSnackbar = _ref.showSnackbar;
      return (
        /*#__PURE__*/
        function () {
          var _ref2 = (0, _asyncToGenerator2.default)(
          /*#__PURE__*/
          _regenerator.default.mark(function _callee(url) {
            var _ref3, res, _res$cms$oembedData, data, error;

            return _regenerator.default.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.next = 2;
                    return client.query({
                      query: oembedQuery,
                      variables: {
                        url: url
                      }
                    });

                  case 2:
                    _ref3 = _context.sent;
                    res = _ref3.data;
                    _res$cms$oembedData = res.cms.oembedData, data = _res$cms$oembedData.data, error = _res$cms$oembedData.error;

                    if (!error) {
                      _context.next = 8;
                      break;
                    }

                    showSnackbar(error.message);
                    return _context.abrupt("return", null);

                  case 8:
                    return _context.abrupt("return", data);

                  case 9:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee, this);
          }));

          return function (_x) {
            return _ref2.apply(this, arguments);
          };
        }()
      );
    }
  }));
};

exports.default = _default;
//# sourceMappingURL=withOEmbedData.js.map