"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _components = require("webiny-app-cms/editor/components");

var _actions = require("webiny-app-cms/editor/actions");

var _emotion = require("emotion");

var backgroundStyle =
/*#__PURE__*/
(0, _emotion.css)({
  position: "fixed",
  top: 0,
  left: 0,
  width: "100%",
  minHeight: "100%"
}, "label:backgroundStyle;");

var Background = function Background(_ref) {
  var element = _ref.element,
      deactivateElement = _ref.deactivateElement,
      highlightElement = _ref.highlightElement;
  return _react.default.createElement("div", {
    className: backgroundStyle,
    onMouseOver: function onMouseOver() {
      return highlightElement({
        element: null
      });
    },
    onClick: function onClick() {
      return element && deactivateElement();
    }
  });
};

var _default = (0, _compose2.default)((0, _redux.connect)(null, {
  deactivateElement: _actions.deactivateElement,
  highlightElement: _actions.highlightElement
}), (0, _components.withActiveElement)())(Background);

exports.default = _default;
//# sourceMappingURL=Background.js.map