"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _pure2 = _interopRequireDefault(require("recompose/pure"));

var _react = _interopRequireDefault(require("react"));

var _reactEmotion = _interopRequireWildcard(require("react-emotion"));

var _redux = require("webiny-app-cms/editor/redux");

var _Elevation = require("webiny-ui/Elevation");

var _Button = require("webiny-ui/Button");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var _add = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/add.svg");

var pulse =
/*#__PURE__*/
(0, _reactEmotion.keyframes)("0%{box-shadow:0 0 0 0 rgba(0,204,176,0.4);}70%{box-shadow:0 0 0 30px rgba(0,204,176,0);}100%{box-shadow:0 0 0 0 rgba(0,204,176,0);}label:pulse;");
var AddBlockContainer =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e26saka0",
  label: "AddBlockContainer"
})({
  position: "fixed",
  zIndex: 11,
  top: "50%",
  left: "50%",
  transform: "translate(-50%,-50%)",
  display: "flex",
  flexDirection: "column",
  justifyContent: "center",
  alignItems: "center",
  width: "150px",
  height: "100px",
  borderRadius: 2,
  color: "var(--mdc-theme-on-surface)",
  marginLeft: 54
});
var AddBlockContent =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e26saka1",
  label: "AddBlockContent"
})({
  width: 300,
  margin: 5,
  textAlign: "center",
  display: "flex",
  alignItems: "center"
});
var AddContent = (0, _pure2.default)(function (_ref) {
  var count = _ref.count,
      togglePlugin = _ref.togglePlugin;

  if (count) {
    return null;
  }

  return _react.default.createElement(AddBlockContainer, {
    "data-type": "container"
  }, _react.default.createElement(_Elevation.Elevation, {
    z: 4,
    style: {
      backgroundColor: "var(--mdc-theme-surface)",
      padding: "30px 20px",
      transform: "translateY(-50%)",
      borderRadius: 2
    }
  }, _react.default.createElement(AddBlockContent, null, "Click the", _react.default.createElement(_Button.ButtonFloating, {
    style: {
      animation: pulse + " 3s ease infinite",
      margin: "0 10px"
    },
    small: true,
    icon: _react.default.createElement(_add.ReactComponent, null),
    onClick: function onClick() {
      return togglePlugin({
        name: "cms-search-blocks-bar"
      });
    }
  }), "to start adding content")));
});

var _default = (0, _redux.connect)(function (state) {
  return {
    count: (0, _selectors.getContent)(state).elements.length
  };
}, {
  togglePlugin: _actions.togglePlugin
})(AddContent);

exports.default = _default;
//# sourceMappingURL=AddContent.js.map