"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var React = _interopRequireWildcard(require("react"));

var _reactVirtualized = require("react-virtualized");

var _BlockPreview = _interopRequireDefault(require("./BlockPreview"));

var listWidth = 800;

var BlocksList =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(BlocksList, _React$Component);

  function BlocksList() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, BlocksList);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(BlocksList)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "state", {
      listHeight: 0
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "rightPanelElement", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "getRowHeight", function (_ref) {
      var index = _ref.index;
      var height = (0, _get2.default)(_this.props.blocks[index], "image.meta.height", 50);
      var width = (0, _get2.default)(_this.props.blocks[index], "image.meta.width", 50);

      if (width > listWidth) {
        var downscaleRatio = width / listWidth;
        height = height / downscaleRatio;
      }

      return height + 100;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "renderRow", function (_ref2) {
      var index = _ref2.index,
          key = _ref2.key,
          style = _ref2.style;
      var _this$props = _this.props,
          blocks = _this$props.blocks,
          _onEdit = _this$props.onEdit,
          _onDelete = _this$props.onDelete,
          deactivatePlugin = _this$props.deactivatePlugin,
          addBlock = _this$props.addBlock;
      var plugin = blocks[index];
      return React.createElement("div", {
        key: key,
        style: style
      }, React.createElement(_BlockPreview.default, {
        plugin: plugin,
        onEdit: function onEdit() {
          return _onEdit(plugin);
        },
        onDelete: function onDelete() {
          return _onDelete(plugin);
        },
        addBlockToContent: addBlock,
        deactivatePlugin: deactivatePlugin
      }));
    });
    return _this;
  }

  (0, _createClass2.default)(BlocksList, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      // Scroll only if the active block category has changed
      if (this.rightPanelElement && prevProps.category !== this.props.category) {
        if (this.rightPanelElement.scrollTop === 0) {
          // $FlowFixMe
          this.rightPanelElement.scroll(0, 1);
          return;
        } // $FlowFixMe


        this.rightPanelElement.scroll(0, 0);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var blocks = this.props.blocks;
      this.rightPanelElement = document.getElementById("webiny-secondary-view-right-panel");

      if (!this.rightPanelElement) {
        return null;
      }

      return React.createElement(_reactVirtualized.WindowScroller, {
        scrollElement: this.rightPanelElement
      }, function (_ref3) {
        var isScrolling = _ref3.isScrolling,
            registerChild = _ref3.registerChild,
            onChildScroll = _ref3.onChildScroll,
            scrollTop = _ref3.scrollTop;
        return React.createElement("div", {
          style: {
            flex: "1 1 auto"
          }
        }, React.createElement("div", {
          style: {
            width: "800px",
            margin: "0 auto"
          },
          ref: registerChild
        }, React.createElement(_reactVirtualized.List, {
          autoHeight: true,
          height: window.innerHeight - 70,
          isScrolling: isScrolling,
          onScroll: onChildScroll,
          rowCount: blocks.length,
          rowHeight: _this2.getRowHeight,
          rowRenderer: _this2.renderRow,
          scrollTop: scrollTop,
          width: listWidth,
          overscanRowCount: 2
        })));
      });
    }
  }]);
  return BlocksList;
}(React.Component);

var _default = BlocksList;
exports.default = _default;
//# sourceMappingURL=BlocksList.js.map