"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _withState2 = _interopRequireDefault(require("recompose/withState"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _reactApollo = require("react-apollo");

var _redux = require("webiny-app-cms/editor/redux");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var _components = require("webiny-app-cms/editor/components");

var _webinyPlugins = require("webiny-plugins");

var _utils = require("webiny-app-cms/editor/utils");

var _OverlayLayout = require("webiny-admin/components/OverlayLayout");

var _search = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/search.svg");

var Styled = _interopRequireWildcard(require("./StyledComponents"));

var _SearchBlocksStyled = require("./SearchBlocksStyled");

var _EditBlockDialog = _interopRequireDefault(require("./EditBlockDialog"));

var _graphql = require("./graphql");

var _components2 = require("webiny-admin/components");

var _SimpleForm = require("webiny-admin/components/SimpleForm");

var _SplitView = require("webiny-admin/components/SplitView");

var _Icon = require("webiny-ui/Icon");

var _List = require("webiny-ui/List");

var _Typography = require("webiny-ui/Typography");

var _roundClear_all24px = require("@svgr/webpack!./icons/round-clear_all-24px.svg");

var _createBlockPlugin = _interopRequireDefault(require("webiny-app-cms/admin/components/withSavedElements/createBlockPlugin"));

var _BlocksList = _interopRequireDefault(require("./BlocksList"));

var allBlockCategory = {
  type: "cms-block-category",
  name: "cms-block-category-all",
  title: "All blocks",
  description: "List of all available blocks.",
  icon: React.createElement(_roundClear_all24px.ReactComponent, null)
};

var SearchBar =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(SearchBar, _React$Component);

  function SearchBar() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, SearchBar);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(SearchBar)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "state", {
      search: "",
      activeTab: 0,
      editingBlock: null
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "addBlockToContent", function (plugin) {
      var content = _this.props.content;
      var element = (0, _objectSpread2.default)({}, content, {
        elements: [].concat((0, _toConsumableArray2.default)(content.elements), [(0, _utils.createElement)(plugin.name)])
      });

      _this.props.updateElement({
        element: element
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "deleteBlock",
    /*#__PURE__*/
    function () {
      var _ref2 = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(_ref) {
        var plugin, deleteElement, showSnackbar, response, error;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                plugin = _ref.plugin, deleteElement = _ref.deleteElement;
                showSnackbar = _this.props.showSnackbar;
                _context.next = 4;
                return deleteElement({
                  variables: {
                    id: plugin.id
                  }
                });

              case 4:
                response = _context.sent;
                error = response.data.cms.deleteElement.error;

                if (!error) {
                  _context.next = 9;
                  break;
                }

                showSnackbar(error.message);
                return _context.abrupt("return");

              case 9:
                (0, _webinyPlugins.unregisterPlugin)(plugin.name);
                showSnackbar("Block " + plugin.title + " successfully deleted.");

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function (_x) {
        return _ref2.apply(this, arguments);
      };
    }());
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "updateBlock",
    /*#__PURE__*/
    function () {
      var _ref4 = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(_ref3) {
        var updateElement, _ref3$data, name, category, plugin, showSnackbar, response, _response$data$cms$up, error, data;

        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                updateElement = _ref3.updateElement, _ref3$data = _ref3.data, name = _ref3$data.title, category = _ref3$data.category;
                plugin = _this.state.editingBlock;

                if (plugin) {
                  _context2.next = 4;
                  break;
                }

                return _context2.abrupt("return");

              case 4:
                showSnackbar = _this.props.showSnackbar;
                _context2.next = 7;
                return updateElement({
                  variables: {
                    id: plugin.id,
                    data: {
                      name: name,
                      category: category
                    }
                  }
                });

              case 7:
                response = _context2.sent;
                _response$data$cms$up = response.data.cms.updateElement, error = _response$data$cms$up.error, data = _response$data$cms$up.data;

                if (!error) {
                  _context2.next = 12;
                  break;
                }

                showSnackbar(error.message);
                return _context2.abrupt("return");

              case 12:
                // This will replace previously registered block plugin.
                (0, _createBlockPlugin.default)(data);

                _this.setState({
                  editingBlock: null
                });

                setTimeout(function () {
                  // For better UX, success message is shown after 300ms has passed.
                  showSnackbar("Block " + plugin.title + " successfully saved.");
                }, 300);

              case 15:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function (_x2) {
        return _ref4.apply(this, arguments);
      };
    }());
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "renderSearchInput", function () {
      return React.createElement(Styled.Input, null, React.createElement(_Icon.Icon, {
        className: Styled.searchIcon,
        icon: React.createElement(_search.ReactComponent, null)
      }), React.createElement("input", {
        autoFocus: true,
        type: "text",
        placeholder: "Search blocks...",
        value: _this.state.search,
        onChange: function onChange(e) {
          return _this.setState({
            search: e.target.value
          });
        }
      }));
    });
    return _this;
  }

  (0, _createClass2.default)(SearchBar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.props.addKeyHandler("escape", function (e) {
        e.preventDefault();

        _this2.props.deactivatePlugin({
          name: "cms-search-blocks-bar"
        });
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.props.removeKeyHandler("escape");
    }
  }, {
    key: "getCategoryBlocksCount",
    value: function getCategoryBlocksCount(_ref5) {
      var plugins = _ref5.plugins,
          category = _ref5.category;
      return this.getBlocksList({
        blocks: plugins.blocks,
        categories: {
          active: {
            name: category
          }
        }
      }).length;
    }
    /**
     * Returns a list of blocks - by selected category and by searched term (if present).
     * @param blocks
     * @param categories
     * @returns {*}
     */

  }, {
    key: "getBlocksList",
    value: function getBlocksList(_ref6) {
      var _this3 = this;

      var blocks = _ref6.blocks,
          categories = _ref6.categories;
      var activeCategory = categories.active;

      if (!activeCategory) {
        return [];
      }

      var output = blocks; // If "all" is selected, no category filtering is required.

      if (activeCategory.name !== "cms-block-category-all") {
        if (activeCategory.name === "cms-block-category-saved") {
          output = output.filter(function (item) {
            return item.tags && item.tags.includes("saved");
          });
        } else {
          output = output.filter(function (item) {
            return item.category === activeCategory.name;
          });
        }
      } // Finally, filter by typed search term.


      if (this.state.search) {
        output = output.filter(function (item) {
          return item.title.toLowerCase().includes(_this3.state.search.toLowerCase());
        });
      }

      return output;
    }
  }, {
    key: "renderBlocksList",
    value: function renderBlocksList(_ref7) {
      var _this4 = this;

      var plugins = _ref7.plugins,
          category = _ref7.category,
          deleteElement = _ref7.deleteElement,
          updateElement = _ref7.updateElement,
          blocksList = _ref7.blocksList;
      return React.createElement(_SimpleForm.SimpleForm, null, React.createElement(_SimpleForm.SimpleFormHeader, {
        title: plugins.categories.active.title,
        icon: plugins.categories.active.icon
      }), React.createElement(_SimpleForm.SimpleFormContent, null, React.createElement(Styled.BlockList, null, React.createElement(_BlocksList.default, {
        category: category,
        addBlock: this.addBlockToContent,
        deactivatePlugin: this.props.deactivatePlugin,
        blocks: blocksList,
        onEdit: function onEdit(plugin) {
          return _this4.setState({
            editingBlock: plugin
          });
        },
        onDelete: function onDelete(plugin) {
          return _this4.deleteBlock({
            plugin: plugin,
            deleteElement: deleteElement
          });
        }
      })), React.createElement(_EditBlockDialog.default, {
        onClose: function onClose() {
          return _this4.setState({
            editingBlock: null
          });
        },
        onSubmit: function onSubmit(data) {
          return _this4.updateBlock({
            data: data,
            updateElement: updateElement
          });
        },
        open: !!this.state.editingBlock,
        plugin: this.state.editingBlock
      })));
    }
  }, {
    key: "render",
    value: function render() {
      var _this5 = this;

      var _this$props = this.props,
          active = _this$props.active,
          setActive = _this$props.setActive;
      var plugins = {
        categories: {
          list: [allBlockCategory].concat((0, _toConsumableArray2.default)((0, _webinyPlugins.getPlugins)("cms-block-category"))),
          active: null
        },
        blocks: (0, _webinyPlugins.getPlugins)("cms-block")
      };
      plugins.categories.active = plugins.categories.list.find(function (_ref8) {
        var name = _ref8.name;
        return name === active;
      });
      var blocksList = this.getBlocksList(plugins);
      return React.createElement(_OverlayLayout.OverlayLayout, {
        barMiddle: this.renderSearchInput(),
        onExited: function onExited() {
          return _this5.props.deactivatePlugin({
            name: "cms-search-blocks-bar"
          });
        }
      }, React.createElement(_SplitView.SplitView, null, React.createElement(_SplitView.LeftPanel, {
        span: 3
      }, React.createElement(_List.List, {
        twoLine: true,
        className: _SearchBlocksStyled.listStyle
      }, plugins.categories.list.map(function (p) {
        return React.createElement(_List.ListItem, {
          key: p.name,
          className: _SearchBlocksStyled.listItem,
          onClick: function onClick() {
            setActive(p.name);
          }
        }, React.createElement(_List.ListItemGraphic, null, React.createElement(_Icon.Icon, {
          icon: p.icon
        })), React.createElement(_SearchBlocksStyled.TitleContent, null, React.createElement(_SearchBlocksStyled.ListItemTitle, null, p.title, " (", _this5.getCategoryBlocksCount({
          plugins: plugins,
          category: p.name
        }), ")"), React.createElement(_Typography.Typography, {
          use: "subtitle2"
        }, p.description)));
      }))), React.createElement(_SplitView.RightPanel, {
        span: 9
      }, React.createElement(_reactApollo.Mutation, {
        mutation: _graphql.updateElement
      }, function (updateElement) {
        return React.createElement(_reactApollo.Mutation, {
          mutation: _graphql.deleteElement
        }, function (deleteElement) {
          return plugins.categories.active && _this5.renderBlocksList({
            plugins: plugins,
            category: active,
            deleteElement: deleteElement,
            updateElement: updateElement,
            blocksList: blocksList
          });
        });
      }))));
    }
  }]);
  return SearchBar;
}(React.Component);

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  return {
    content: (0, _selectors.getContent)(state)
  };
}, {
  deactivatePlugin: _actions.deactivatePlugin,
  updateElement: _actions.updateElement
}), (0, _components.withKeyHandler)(), (0, _components2.withSnackbar)(), (0, _withState2.default)("active", "setActive", "cms-block-category-all"))(SearchBar);

exports.default = _default;
//# sourceMappingURL=SearchBlocks.js.map