"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Title = exports.Overlay = exports.EditBlock = exports.DeleteBlock = exports.AddBlock = exports.Backdrop = exports.blockStyle = exports.BlockPreview = exports.BlockList = exports.wrapper = exports.searchIcon = exports.Input = exports.List = void 0;

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _emotion = require("emotion");

var List =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eebfgb50",
  label: "List"
})({
  position: "fixed",
  top: 64,
  left: 0,
  width: "100%",
  height: "100%",
  //overflow: "scroll",
  backgroundColor: "#fff",
  zIndex: 10000
});
exports.List = List;
var Input =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eebfgb51",
  label: "Input"
})({
  backgroundColor: "var(--mdc-theme-on-background)",
  position: "relative",
  height: 30,
  padding: 3,
  width: "100%",
  borderRadius: 2,
  "> input": {
    border: "none",
    fontSize: 16,
    width: "calc(100% - 10px)",
    height: "100%",
    marginLeft: 50,
    backgroundColor: "transparent",
    outline: "none",
    color: "var(--mdc-theme-text-primary-on-background)"
  }
});
exports.Input = Input;
var searchIcon =
/*#__PURE__*/
(0, _emotion.css)({
  "&.mdc-button__icon": {
    color: "var(--mdc-theme-text-secondary-on-background)",
    position: "absolute",
    width: 24,
    height: 24,
    left: 15,
    top: 7
  }
}, "label:searchIcon;");
exports.searchIcon = searchIcon;
var wrapper =
/*#__PURE__*/
(0, _emotion.css)({
  height: "100vh",
  //overflow: "scroll",
  backgroundColor: "var(--mdc-theme-background)"
}, "label:wrapper;");
exports.wrapper = wrapper;
var BlockList =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eebfgb52",
  label: "BlockList"
})({
  display: "flex",
  padding: 50,
  justifyContent: "space-around",
  maxWidth: 1200,
  margin: "0 auto",
  flexWrap: "wrap",
  color: "var(--mdc-theme-text-secondary-on-background)"
});
exports.BlockList = BlockList;
var BlockPreview =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eebfgb53",
  label: "BlockPreview"
})({
  pointerEvents: "none",
  display: "flex",
  width: "100%",
  height: "100%",
  alignItems: "center",
  justifyContent: "center",
  position: "relative",
  backgroundColor: "#fff"
});
exports.BlockPreview = BlockPreview;
var blockStyle =
/*#__PURE__*/
(0, _emotion.css)({
  position: "relative",
  width: "100%",
  maxWidth: 800,
  boxSizing: "border-box",
  overflow: "hidden",
  border: "1px solid var(--mdc-theme-on-background)",
  backgroundColor: "var(--mdc-theme-surface)",
  padding: "15px 15px 35px 15px",
  marginBottom: 25
}, "label:blockStyle;");
exports.blockStyle = blockStyle;
var Backdrop =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eebfgb54",
  label: "Backdrop"
})({
  display: "none",
  position: "absolute",
  top: 0,
  left: 0,
  width: "100%",
  height: "100%",
  backgroundColor: "#000",
  opacity: 0.5
});
exports.Backdrop = Backdrop;
var AddBlock =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eebfgb55",
  label: "AddBlock"
})({
  display: "none",
  width: 300,
  margin: 5,
  textAlign: "center"
});
exports.AddBlock = AddBlock;
var DeleteBlock =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eebfgb56",
  label: "DeleteBlock"
})({
  margin: 5,
  textAlign: "center",
  position: "absolute",
  top: 0,
  right: 0,
  zIndex: 100,
  cursor: "pointer",
  color: "white"
});
exports.DeleteBlock = DeleteBlock;
var EditBlock =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eebfgb57",
  label: "EditBlock"
})({
  margin: 5,
  textAlign: "center",
  position: "absolute",
  top: 0,
  left: 0,
  zIndex: 100,
  cursor: "pointer",
  color: "white"
});
exports.EditBlock = EditBlock;
var Overlay =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eebfgb58",
  label: "Overlay"
})({
  position: "absolute",
  display: "flex",
  justifyContent: "center",
  alignItems: "center",
  top: 0,
  left: 0,
  width: "100%",
  height: "100%",
  zIndex: 10,
  opacity: 0,
  transform: "scale(0.9)",
  transition: "opacity 0.2s, transform 0.1s",
  "&:hover": {
    opacity: 1,
    transform: "scale(1)",
    "> .backdrop, > .add-block": {
      display: "block"
    }
  }
});
exports.Overlay = Overlay;
var Title =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eebfgb59",
  label: "Title"
})({
  position: "absolute",
  left: 15,
  bottom: 0
});
exports.Title = Title;
//# sourceMappingURL=StyledComponents.js.map