"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var React = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

var _emotion = require("emotion");

var _selectors = require("webiny-app-cms/editor/selectors");

var _actions = require("webiny-app-cms/editor/actions");

var breadcrumbs =
/*#__PURE__*/
(0, _emotion.css)({
  display: "flex",
  zIndex: 20,
  flexDirection: "row",
  padding: 0,
  position: "fixed",
  left: 55,
  bottom: 0,
  width: "calc(100% - 55px)",
  backgroundColor: "var(--mdc-theme-surface)",
  borderTop: "1px solid var(--mdc-theme-on-background)",
  fontSize: "14px",
  "> li": {
    cursor: "pointer",
    ".element": {
      color: "var(--mdc-theme-secondary)",
      padding: "5px",
      display: "inline-block",
      "&:hover": {
        backgroundColor: "var(--mdc-theme-background)",
        color: "var(--mdc-theme-on-surface)"
      }
    },
    ".divider": {
      color: "var(--mdc-theme-text-secondary-on-background)"
    }
  }
}, "label:breadcrumbs;");

var Breadcrumbs = function Breadcrumbs(_ref) {
  var elements = _ref.elements,
      activateElement = _ref.activateElement,
      highlightElement = _ref.highlightElement;

  if (!elements) {
    return null;
  }

  return React.createElement("ul", {
    className: breadcrumbs
  }, elements.map(function (el, index) {
    return React.createElement("li", {
      key: el.id,
      onMouseOver: function onMouseOver() {
        return highlightElement({
          element: el.id
        });
      },
      onClick: function onClick() {
        return activateElement({
          element: el.id
        });
      }
    }, React.createElement("span", {
      className: "element"
    }, el.type.replace("cms-element-", "")), elements.length - 1 > index ? React.createElement("span", {
      className: "divider"
    }, "\xA0>\xA0") : null);
  }));
};

var _default = (0, _reactRedux.connect)(function (state) {
  var element = (0, _selectors.getActiveElement)(state);

  if (!element) {
    return {
      elements: null
    };
  }

  var paths = element.path.split(".").slice(1);
  var elements = paths.map(function (path, index) {
    var elPath = [0].concat((0, _toConsumableArray2.default)(paths.slice(0, index + 1))).join(".");
    var el = (0, _selectors.getElement)(state, elPath);
    return {
      id: el.id,
      type: el.type,
      index: path,
      active: el.id === element.id
    };
  });
  return {
    elements: elements
  };
}, {
  activateElement: _actions.activateElement,
  highlightElement: _actions.highlightElement
}, null, {
  areStatePropsEqual: _isEqual2.default
})(Breadcrumbs);

exports.default = _default;
//# sourceMappingURL=Breadcrumbs.js.map