"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _omit2 = _interopRequireDefault(require("lodash/omit"));

var _withState2 = _interopRequireDefault(require("recompose/withState"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _lifecycle2 = _interopRequireDefault(require("recompose/lifecycle"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _webinyPlugins = require("webiny-plugins");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var _components = require("webiny-app-cms/editor/components");

var _components2 = require("webiny-admin/components");

var _OverlayLayout = require("webiny-admin/components/OverlayLayout");

var _SplitView = require("webiny-admin/components/SplitView");

var _Typography = require("webiny-ui/Typography");

var _webinyForm = require("webiny-form");

var _Icon = require("webiny-ui/Icon");

var _Button = require("webiny-ui/Button");

var _List = require("webiny-ui/List");

var _SimpleForm = require("webiny-admin/components/SimpleForm");

var _PageSettingsStyled = require("./PageSettingsStyled");

var PageSettings = function PageSettings(_ref) {
  var deactivatePlugin = _ref.deactivatePlugin,
      page = _ref.page,
      savePage = _ref.savePage,
      active = _ref.active,
      setActive = _ref.setActive;
  var plugins = (0, _webinyPlugins.getPlugins)("cms-editor-page-settings");
  var activePlugin = plugins.find(function (pl) {
    return pl.name === active;
  });

  if (!activePlugin) {
    return null;
  }

  return _react.default.createElement(_OverlayLayout.OverlayLayout, {
    barMiddle: _PageSettingsStyled.Title,
    onExited: function onExited() {
      return deactivatePlugin({
        name: "cms-page-settings-bar"
      });
    }
  }, _react.default.createElement(_SplitView.SplitView, null, _react.default.createElement(_SplitView.LeftPanel, {
    span: 5
  }, _react.default.createElement(_List.List, {
    twoLine: true,
    className: _PageSettingsStyled.listStyle
  }, plugins.map(function (pl) {
    return _react.default.createElement(_List.ListItem, {
      key: pl.name,
      className: _PageSettingsStyled.listItem,
      onClick: function onClick() {
        return setActive(pl.name);
      }
    }, _react.default.createElement(_List.ListItemGraphic, null, _react.default.createElement(_Icon.Icon, {
      icon: pl.icon
    })), _react.default.createElement(_PageSettingsStyled.TitleContent, null, _react.default.createElement(_PageSettingsStyled.ListItemTitle, null, pl.title), _react.default.createElement(_Typography.Typography, {
      use: "subtitle2"
    }, pl.description)));
  }))), _react.default.createElement(_SplitView.RightPanel, {
    span: 7
  }, _react.default.createElement(_webinyForm.Form, {
    data: page,
    onSubmit: savePage
  }, function (_ref2) {
    var Bind = _ref2.Bind,
        submit = _ref2.submit,
        form = _ref2.form,
        data = _ref2.data;
    return _react.default.createElement(_SimpleForm.SimpleForm, null, _react.default.createElement(_SimpleForm.SimpleFormHeader, {
      title: activePlugin.title
    }), _react.default.createElement(_SimpleForm.SimpleFormContent, null, activePlugin ? activePlugin.render({
      Bind: Bind,
      form: form,
      data: data
    }) : null), _react.default.createElement(_SimpleForm.SimpleFormFooter, null, _react.default.createElement(_Button.ButtonPrimary, {
      type: "primary",
      onClick: submit,
      align: "right"
    }, "Save settings")));
  }))));
};

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  return {
    page: (0, _omit2.default)((0, _selectors.getPage)(state), ["content"])
  };
}, {
  deactivatePlugin: _actions.deactivatePlugin,
  updateRevision: _actions.updateRevision
}), (0, _components2.withSnackbar)(), (0, _components.withKeyHandler)(), (0, _withState2.default)("active", "setActive", "cms-editor-page-settings-general"), (0, _withHandlers2.default)({
  savePage: function savePage(_ref3) {
    var showSnackbar = _ref3.showSnackbar,
        updateRevision = _ref3.updateRevision;
    return function (page) {
      return updateRevision(page, {
        onFinish: function onFinish() {
          return showSnackbar("Settings saved");
        }
      });
    };
  }
}), (0, _lifecycle2.default)({
  componentDidMount: function componentDidMount() {
    var _this = this;

    this.props.addKeyHandler("escape", function (e) {
      e.preventDefault();

      _this.props.deactivatePlugin({
        name: "cms-page-settings-bar"
      });
    });
  },
  componentWillUnmount: function componentWillUnmount() {
    this.props.removeKeyHandler("escape");
  }
}))(PageSettings);

exports.default = _default;
//# sourceMappingURL=PageSettings.js.map