"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var _omit2 = _interopRequireDefault(require("lodash/omit"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _ConfirmationDialog = require("webiny-ui/ConfirmationDialog");

var _Button = require("webiny-ui/Button");

var _selectors = require("webiny-app-cms/editor/selectors");

var _reactApollo = require("react-apollo");

var _components = require("webiny-admin/components");

var _components2 = require("webiny-app/components");

var _graphql = require("./PublishPageButton/graphql");

var PublishPageButton = function PublishPageButton(_ref) {
  var page = _ref.page,
      showSnackbar = _ref.showSnackbar,
      router = _ref.router;
  return _react.default.createElement(_ConfirmationDialog.ConfirmationDialog, {
    title: "Publish page",
    message: "You are about to publish this page, are you sure want to continue?"
  }, function (_ref2) {
    var showConfirmation = _ref2.showConfirmation;
    return _react.default.createElement(_reactApollo.Mutation, {
      mutation: _graphql.publishRevision
    }, function (update) {
      return _react.default.createElement(_Button.ButtonPrimary, {
        onClick:
        /*#__PURE__*/
        (0, _asyncToGenerator2.default)(
        /*#__PURE__*/
        _regenerator.default.mark(function _callee2() {
          return _regenerator.default.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  showConfirmation(
                  /*#__PURE__*/
                  (0, _asyncToGenerator2.default)(
                  /*#__PURE__*/
                  _regenerator.default.mark(function _callee() {
                    var response, error;
                    return _regenerator.default.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            _context.next = 2;
                            return update({
                              variables: {
                                id: page.id
                              }
                            });

                          case 2:
                            response = _context.sent;
                            error = response.data.cms.publishRevision.error;

                            if (!error) {
                              _context.next = 6;
                              break;
                            }

                            return _context.abrupt("return", showSnackbar(error.message));

                          case 6:
                            _context.next = 8;
                            return router.goToRoute({
                              name: "Cms.Pages",
                              params: {
                                id: page.id
                              }
                            });

                          case 8:
                            // Let's wait a bit, because we are also redirecting the user.
                            setTimeout(function () {
                              showSnackbar("Your page was published successfully!");
                            }, 500);

                          case 9:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee, this);
                  })));

                case 1:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }))
      }, "Publish");
    });
  });
};

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  return {
    page: (0, _omit2.default)((0, _selectors.getPage)(state), ["content"])
  };
}, null, null, {
  areStatePropsEqual: _isEqual2.default
}), (0, _components.withSnackbar)(), (0, _components2.withRouter)())(PublishPageButton);

exports.default = _default;
//# sourceMappingURL=PublishPageButton.js.map