"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _pure2 = _interopRequireDefault(require("recompose/pure"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _emotion = require("emotion");

var _components = require("webiny-app/components");

var _Menu = require("webiny-ui/Menu");

var _selectors = require("webiny-app-cms/editor/selectors");

var _Button = require("webiny-ui/Button");

var _Icon = require("webiny-ui/Icon");

var _Typography = require("webiny-ui/Typography");

var _roundArrow_drop_down24px = require("@svgr/webpack!./icons/round-arrow_drop_down-24px.svg");

var buttonStyle =
/*#__PURE__*/
(0, _emotion.css)({
  "&.mdc-button": {
    color: "var(--mdc-theme-text-primary-on-background) !important"
  }
}, "label:buttonStyle;");
var menuList =
/*#__PURE__*/
(0, _emotion.css)({
  ".mdc-list-item": {
    flexDirection: "column",
    justifyContent: "center",
    alignItems: "baseline",
    textAlign: "left"
  }
}, "label:menuList;");
var Revisions = (0, _pure2.default)(function (_ref) {
  var revisions = _ref.revisions,
      router = _ref.router;
  return _react.default.createElement(_Menu.Menu, {
    className: menuList,
    onSelect: function onSelect(evt) {
      return router.goToRoute({
        params: {
          id: revisions[evt.detail.index].id
        },
        merge: true
      });
    },
    handle: _react.default.createElement(_Button.ButtonDefault, {
      className: buttonStyle
    }, "Revisions ", _react.default.createElement(_Icon.Icon, {
      icon: _react.default.createElement(_roundArrow_drop_down24px.ReactComponent, null)
    }))
  }, revisions.map(function (rev) {
    var status = "draft";
    if (rev.published) status = "published";
    if (rev.locked && !rev.published) status = "locked";
    return _react.default.createElement(_Menu.MenuItem, {
      key: rev.id
    }, _react.default.createElement(_Typography.Typography, {
      use: "body2"
    }, "v", rev.version), _react.default.createElement(_Typography.Typography, {
      use: "caption"
    }, "(", status, ")"));
  }));
});

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  return {
    revisions: (0, _selectors.getRevisions)(state)
  };
}), (0, _components.withRouter)())(Revisions);

exports.default = _default;
//# sourceMappingURL=Revisions.js.map