"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _cloneDeep2 = _interopRequireDefault(require("lodash/cloneDeep"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _dotPropImmutable = require("dot-prop-immutable");

var _webinyPlugins = require("webiny-plugins");

var _plugins = require("webiny-app/plugins");

var _selectors = require("webiny-app-cms/editor/selectors");

var _components = require("webiny-app-cms/editor/components");

var _emotion = require("emotion");

var _Dialog = require("webiny-ui/Dialog");

var _webinyForm = require("webiny-form");

var _Tabs = require("webiny-ui/Tabs");

var _actions = require("webiny-app-cms/editor/actions");

var emptyElement = {
  data: {},
  type: null
};
var dialogBody =
/*#__PURE__*/
(0, _emotion.css)({
  "&.mdc-dialog__body": {
    marginTop: 0,
    padding: "24px 0 0 0"
  }
}, "label:dialogBody;");

var AdvancedSettings =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(AdvancedSettings, _React$Component);

  function AdvancedSettings() {
    (0, _classCallCheck2.default)(this, AdvancedSettings);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(AdvancedSettings).apply(this, arguments));
  }

  (0, _createClass2.default)(AdvancedSettings, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(props) {
      return this.props.open !== props.open;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var _this$props = this.props,
          open = _this$props.open,
          addKeyHandler = _this$props.addKeyHandler,
          removeKeyHandler = _this$props.removeKeyHandler,
          closeDialog = _this$props.closeDialog;
      open ? addKeyHandler("escape", closeDialog) : removeKeyHandler("escape");
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          element = _this$props2.element,
          open = _this$props2.open,
          onClose = _this$props2.onClose,
          onSubmit = _this$props2.onSubmit;

      var _ref = element || (0, _cloneDeep2.default)(emptyElement),
          data = _ref.data,
          type = _ref.type;

      return React.createElement(_Dialog.Dialog, {
        open: open,
        onClose: onClose
      }, React.createElement(_Dialog.DialogHeader, null, React.createElement(_Dialog.DialogHeaderTitle, null, "Settings")), React.createElement(_webinyForm.Form, {
        key: element && element.id,
        data: data,
        onSubmit: onSubmit
      }, function (_ref2) {
        var submit = _ref2.submit,
            Bind = _ref2.Bind,
            data = _ref2.data;
        return React.createElement(React.Fragment, null, React.createElement(_Dialog.DialogBody, {
          className: dialogBody
        }, React.createElement(_Tabs.Tabs, null, (0, _plugins.renderPlugins)("cms-element-advanced-settings", {
          Bind: Bind,
          data: data
        }, {
          wrapper: false,
          filter: function filter(pl) {
            return pl.element === type;
          }
        }))), React.createElement(_Dialog.DialogFooter, null, React.createElement(_Dialog.DialogCancel, null, "Cancel"), React.createElement(_Dialog.DialogAccept, {
          onClick: submit
        }, "Save")));
      }));
    }
  }]);
  return AdvancedSettings;
}(React.Component);

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  return {
    open: (0, _selectors.isPluginActive)("cms-element-settings-advanced")(state)
  };
}, {
  updateElement: _actions.updateElement,
  deactivatePlugin: _actions.deactivatePlugin
}), (0, _components.withActiveElement)({
  shallow: true
}), (0, _components.withKeyHandler)(), (0, _withHandlers2.default)({
  closeDialog: function closeDialog(_ref3) {
    var deactivatePlugin = _ref3.deactivatePlugin;
    return function () {
      deactivatePlugin({
        name: "cms-element-settings-advanced"
      });
    };
  }
}), (0, _withHandlers2.default)({
  onSubmit: function onSubmit(_ref4) {
    var element = _ref4.element,
        updateElement = _ref4.updateElement,
        closeDialog = _ref4.closeDialog;
    return function (formData) {
      // Get element settings plugins
      var plugins = (0, _webinyPlugins.getPlugins)("cms-element-advanced-settings").filter(function (pl) {
        return pl.element === element.type;
      });
      formData = plugins.reduce(function (formData, pl) {
        if (pl.onSave) {
          return pl.onSave(formData);
        }

        return formData;
      }, formData);
      updateElement({
        element: (0, _dotPropImmutable.merge)(element, "data", formData)
      });
      closeDialog();
    };
  },
  onClose: function onClose(_ref5) {
    var closeDialog = _ref5.closeDialog;
    return function () {
      return closeDialog();
    };
  }
}))(AdvancedSettings);

exports.default = _default;
//# sourceMappingURL=AdvancedSettings.js.map