"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _webinyPlugins = require("webiny-plugins");

var _redux = require("webiny-app-cms/editor/redux");

var _actions = require("webiny-app-cms/editor/actions");

var _settings = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/settings.svg");

var _AdvancedSettings = _interopRequireDefault(require("./AdvancedSettings"));

var _Action = _interopRequireDefault(require("../components/Action"));

var _AdvancedAction = _interopRequireDefault(require("./AdvancedAction"));

var _default = [{
  name: "cms-element-advanced-settings",
  type: "cms-editor-content",
  init: function init() {
    (0, _redux.addMiddleware)([_actions.ELEMENT_CREATED], function (_ref) {
      var store = _ref.store,
          action = _ref.action,
          next = _ref.next;
      var _action$payload = action.payload,
          element = _action$payload.element,
          source = _action$payload.source;
      next(action); // Check the source of the element (could be `saved` element which behaves differently from other elements)

      var sourcePlugin = (0, _webinyPlugins.getPlugin)(source.type);

      if (!sourcePlugin) {
        return;
      }

      var onCreate = sourcePlugin.onCreate;

      if (!onCreate || onCreate !== "skip") {
        // If source element does not define a specific `onCreate` behavior - continue with the actual element plugin
        var plugin = (0, _webinyPlugins.getPlugin)(element.type);

        if (!plugin) {
          return;
        }

        var _onCreate = plugin.onCreate;

        if (_onCreate && _onCreate === "open-settings") {
          store.dispatch((0, _actions.activateElement)({
            element: element.id
          }));
          store.dispatch((0, _actions.togglePlugin)({
            name: "cms-element-settings-advanced"
          }));
        }
      }
    });
  },
  render: function render() {
    return React.createElement(_AdvancedSettings.default, null);
  }
}, {
  name: "cms-element-settings-advanced",
  type: "cms-element-settings",
  renderAction: function renderAction() {
    return React.createElement(_AdvancedAction.default, null, React.createElement(_Action.default, {
      plugin: this.name,
      icon: React.createElement(_settings.ReactComponent, null),
      tooltip: "Advanced settings"
    }));
  }
}];
exports.default = _default;
//# sourceMappingURL=index.js.map