"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _withProps2 = _interopRequireDefault(require("recompose/withProps"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _webinyPlugins = require("webiny-plugins");

var _dotPropImmutable = require("dot-prop-immutable");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var _format_align_center = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/format_align_center.svg");

var _format_align_left = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/format_align_left.svg");

var _format_align_right = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/format_align_right.svg");

// Icons map for dynamic render
var icons = {
  "flex-start": React.createElement(_format_align_left.ReactComponent, null),
  center: React.createElement(_format_align_center.ReactComponent, null),
  "flex-end": React.createElement(_format_align_right.ReactComponent, null)
};

var HorizontalAlignActionFlex = function HorizontalAlignActionFlex(_ref) {
  var element = _ref.element,
      children = _ref.children,
      alignElement = _ref.alignElement,
      align = _ref.align;
  var plugin = (0, _webinyPlugins.getPlugin)(element.type);

  if (!plugin) {
    return null;
  }

  return React.cloneElement(children, {
    onClick: alignElement,
    icon: icons[align]
  });
};

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  return {
    element: (0, _selectors.getActiveElement)(state)
  };
}, {
  updateElement: _actions.updateElement
}), (0, _withProps2.default)(function (_ref2) {
  var element = _ref2.element;
  return {
    align: (0, _dotPropImmutable.get)(element, "data.settings.horizontalAlignFlex") || "flex-start"
  };
}), (0, _withHandlers2.default)({
  alignElement: function alignElement(_ref3) {
    var updateElement = _ref3.updateElement,
        element = _ref3.element,
        align = _ref3.align;
    return function () {
      var alignments = Object.keys(icons);
      var nextAlign = alignments[alignments.indexOf(align) + 1] || "flex-start";
      updateElement({
        element: (0, _dotPropImmutable.set)(element, "data.settings.horizontalAlignFlex", nextAlign)
      });
    };
  }
}))(HorizontalAlignActionFlex);

exports.default = _default;
//# sourceMappingURL=HorizontalAlignFlex.js.map