"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = AnimationSettings;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _Tabs = require("webiny-ui/Tabs");

var _selectors = require("webiny-app-cms/editor/selectors");

var _withUpdateHandlers = _interopRequireDefault(require("../components/withUpdateHandlers"));

var _Footer = _interopRequireDefault(require("../components/Footer"));

var _Select = _interopRequireDefault(require("../components/Select"));

var _Input = _interopRequireDefault(require("../components/Input"));

var _SliderWithInput = _interopRequireDefault(require("../components/SliderWithInput"));

var _roundAv_timer24px = require("@svgr/webpack!./icons/round-av_timer-24px.svg");

var _ElementAnimation = _interopRequireDefault(require("webiny-app-cms/render/components/ElementAnimation"));

var DATA_NAMESPACE = "data.settings.animation";

var Settings = function Settings(_ref) {
  var title = _ref.title,
      advanced = _ref.advanced,
      getUpdateValue = _ref.getUpdateValue,
      getUpdatePreview = _ref.getUpdatePreview;
  return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_Tabs.Tabs, null, _react.default.createElement(_Tabs.Tab, {
    label: title
  }, _react.default.createElement(_Select.default, {
    label: "Animation",
    valueKey: DATA_NAMESPACE + ".name",
    updateValue: getUpdateValue("name")
  }, _react.default.createElement("option", {
    value: ""
  }, "No animation"), _react.default.createElement("optgroup", {
    label: "Fade"
  }, _react.default.createElement("option", {
    value: "fade"
  }, "Fade"), _react.default.createElement("option", {
    value: "fade-up"
  }, "Fade Up"), _react.default.createElement("option", {
    value: "fade-down"
  }, "Fade Down"), _react.default.createElement("option", {
    value: "fade-left"
  }, "Fade Left"), _react.default.createElement("option", {
    value: "fade-right"
  }, "Fade Right"), _react.default.createElement("option", {
    value: "fade-up-right"
  }, "Fade Up Right"), _react.default.createElement("option", {
    value: "fade-up-left"
  }, "Fade Up Left"), _react.default.createElement("option", {
    value: "fade-down-right"
  }, "Fade Down Right"), _react.default.createElement("option", {
    value: "fade-down-left"
  }, "Fade Down Left")), _react.default.createElement("optgroup", {
    label: "Flip"
  }, _react.default.createElement("option", {
    value: "flip-up"
  }, "Flip Up"), _react.default.createElement("option", {
    value: "flip-down"
  }, "Flip Down"), _react.default.createElement("option", {
    value: "flip-left"
  }, "Flip Left"), _react.default.createElement("option", {
    value: "flip-right"
  }, "Flip Right")), _react.default.createElement("optgroup", {
    label: "Slide"
  }, _react.default.createElement("option", {
    value: "slide-up"
  }, "Slide Up"), _react.default.createElement("option", {
    value: "slide-down"
  }, "Slide Down"), _react.default.createElement("option", {
    value: "slide-left"
  }, "Slide Left"), _react.default.createElement("option", {
    value: "slide-right"
  }, "Slide Right"))), advanced && _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_SliderWithInput.default, {
    className: "no-bottom-padding",
    label: "Duration",
    icon: _react.default.createElement(_roundAv_timer24px.ReactComponent, null),
    valueKey: DATA_NAMESPACE + ".duration",
    updateValue: getUpdateValue("duration"),
    updatePreview: getUpdatePreview("duration")
  }), _react.default.createElement(_Input.default, {
    className: "no-bottom-padding",
    placeholder: "ms",
    label: "Delay",
    valueKey: DATA_NAMESPACE + ".delay",
    updateValue: getUpdateValue("delay")
  }), _react.default.createElement(_Input.default, {
    className: "no-bottom-padding",
    placeholder: "px",
    label: "offset",
    valueKey: DATA_NAMESPACE + ".offset",
    updateValue: getUpdateValue("offset")
  }), _react.default.createElement(_Select.default, {
    label: "Easing",
    valueKey: DATA_NAMESPACE + ".easing",
    updateValue: getUpdateValue("easing")
  }, _react.default.createElement("option", {
    value: ""
  }, "Default"), _react.default.createElement("option", {
    value: "linear"
  }, "Linear "), _react.default.createElement("option", {
    value: "ease"
  }, "Ase "), _react.default.createElement("option", {
    value: "ease-in"
  }, "Ase in"), _react.default.createElement("option", {
    value: "ease-out"
  }, "Out"), _react.default.createElement("option", {
    value: "ease-in-out"
  }, "In out"), _react.default.createElement("option", {
    value: "ease-in-back"
  }, "In back"), _react.default.createElement("option", {
    value: "ease-out-back"
  }, "Out back"), _react.default.createElement("option", {
    value: "ease-in-out-back"
  }, "In out-back"), _react.default.createElement("option", {
    value: "ease-in-sine"
  }, "In sine"), _react.default.createElement("option", {
    value: "ease-out-sine"
  }, "Out sine"), _react.default.createElement("option", {
    value: "ease-in-out-sine"
  }, "In out-sine"), _react.default.createElement("option", {
    value: "ease-in-quad"
  }, "In quad"), _react.default.createElement("option", {
    value: "ease-out-quad"
  }, "Out quad"), _react.default.createElement("option", {
    value: "ease-in-out-quad"
  }, "In out-quad"), _react.default.createElement("option", {
    value: "ease-in-cubic"
  }, "In cubic"), _react.default.createElement("option", {
    value: "ease-out-cubic"
  }, "Out cubic"), _react.default.createElement("option", {
    value: "ease-in-out-cubic"
  }, "In out-cubic"), _react.default.createElement("option", {
    value: "ease-in-quart"
  }, "In quart"), _react.default.createElement("option", {
    value: "ease-out-quart"
  }, "Out quart"), _react.default.createElement("option", {
    value: "ease-in-out-quart"
  }, "In out-quart"))), _react.default.createElement(_Footer.default, {
    advanced: advanced,
    toggleAdvanced: getUpdateValue("advanced")
  }))));
};

var ConnectedSettings = (0, _compose2.default)((0, _redux.connect)(function (state) {
  var element = (0, _selectors.getActiveElement)(state);
  return {
    advanced: (0, _get2.default)(element, DATA_NAMESPACE + ".advanced", false),
    element: {
      id: element.id,
      type: element.type,
      path: element.path
    }
  };
}, null, null, {
  areStatePropsEqual: _isEqual2.default
}), (0, _withUpdateHandlers.default)({
  namespace: DATA_NAMESPACE
}))(Settings);

function AnimationSettings(props) {
  return _react.default.createElement(_ElementAnimation.default, null, function (animation) {
    return _react.default.createElement(ConnectedSettings, (0, _extends2.default)({}, props, {
      animation: animation
    }));
  });
}
//# sourceMappingURL=AnimationSettings.js.map