"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _Tooltip = require("webiny-ui/Tooltip");

var _Typography = require("webiny-ui/Typography");

var positions = ["top left", "top", "top right", "center left", "center", "center right", "bottom left", "bottom center", "bottom right"];
var Ul =
/*#__PURE__*/
(0, _reactEmotion.default)("ul", {
  target: "e1uuog9f0",
  label: "Ul"
})({
  listStyle: "none",
  margin: "0 auto",
  width: 100,
  textAlign: "center",
  "&.disabled": {
    opacity: 0.5,
    pointerEvents: "none"
  },
  li: {
    display: "inline-block",
    border: "1px solid lightgray",
    width: 25,
    height: 25,
    margin: 2,
    cursor: "pointer",
    "&.active": {
      border: "1px solid gray",
      backgroundColor: "var(--mdc-theme-background)"
    }
  }
});
var PositionWrapper =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e1uuog9f1",
  label: "PositionWrapper"
})({
  width: "100%",
  display: "flex"
});

var BackgroundPositionSelector = function BackgroundPositionSelector(props) {
  return React.createElement(PositionWrapper, null, React.createElement(_Typography.Typography, {
    style: {
      width: "60%"
    },
    use: "overline"
  }, "Position"), React.createElement(Ul, {
    className: (0, _classnames.default)({
      disabled: props.disabled
    })
  }, positions.map(function (position) {
    return React.createElement(_Tooltip.Tooltip, {
      key: position,
      content: React.createElement("span", null, position),
      placement: "top"
    }, React.createElement("li", {
      onClick: function onClick() {
        return props.onChange(position);
      },
      className: (0, _classnames.default)({
        active: props.value === position
      })
    }));
  })));
};

var _default = BackgroundPositionSelector;
exports.default = _default;
//# sourceMappingURL=BackgroundPositionSelector.js.map