"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _Tabs = require("webiny-ui/Tabs");

var _dotPropImmutable = require("dot-prop-immutable");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var _ColorPicker = _interopRequireDefault(require("webiny-app-cms/editor/components/ColorPicker"));

var _Grid = require("webiny-ui/Grid");

var _Select = _interopRequireDefault(require("webiny-app-cms/editor/plugins/elementSettings/components/Select"));

var _BackgroundImage = _interopRequireDefault(require("./BackgroundImage"));

var _BackgroundPositionSelector = _interopRequireDefault(require("./BackgroundPositionSelector"));

var _emotion = require("emotion");

var imageSelect =
/*#__PURE__*/
(0, _emotion.css)({
  width: "100%"
}, "label:imageSelect;");
var root = "data.settings.background";

var Settings =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(Settings, _React$Component);

  function Settings() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, Settings);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(Settings)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "setImage", function (image) {
      var _this$props = _this.props,
          element = _this$props.element,
          updateElement = _this$props.updateElement;
      updateElement({
        element: (0, _dotPropImmutable.set)(element, "".concat(root, ".image.src"), image ? image.src : null),
        history: true
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "setScaling", function (value) {
      var _this$props2 = _this.props,
          element = _this$props2.element,
          updateElement = _this$props2.updateElement;
      updateElement({
        element: (0, _dotPropImmutable.set)(element, "".concat(root, ".image.scaling"), value),
        history: true
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "setPosition", function (position) {
      var _this$props3 = _this.props,
          element = _this$props3.element,
          updateElement = _this$props3.updateElement;
      updateElement({
        element: (0, _dotPropImmutable.set)(element, "".concat(root, ".image.position"), position),
        history: true
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "setColor", function (value, history) {
      var _this$props4 = _this.props,
          element = _this$props4.element,
          updateElement = _this$props4.updateElement;
      updateElement({
        element: (0, _dotPropImmutable.set)(element, "".concat(root, ".color"), value),
        history: history
      });
    });
    return _this;
  }

  (0, _createClass2.default)(Settings, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props5 = this.props,
          element = _this$props5.element,
          options = _this$props5.options;
      var bg = (0, _dotPropImmutable.get)(element, "data.settings.background");
      var hasImage = (0, _dotPropImmutable.get)(bg, "image.src");
      return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_Tabs.Tabs, null, _react.default.createElement(_Tabs.Tab, {
        label: "Color"
      }, _react.default.createElement(_Grid.Grid, null, _react.default.createElement(_Grid.Cell, {
        span: 12
      }, _react.default.createElement(_ColorPicker.default, {
        value: (0, _dotPropImmutable.get)(bg, "color", "#fff"),
        onChange: function onChange(value) {
          return _this2.setColor(value, false);
        },
        onChangeComplete: function onChangeComplete(value) {
          return _this2.setColor(value);
        }
      })))), options.image !== false && _react.default.createElement(_Tabs.Tab, {
        label: "Image"
      }, _react.default.createElement(_Grid.Grid, null, _react.default.createElement(_Grid.Cell, {
        span: 12
      }, _react.default.createElement(_BackgroundImage.default, {
        className: imageSelect,
        onChange: this.setImage,
        value: {
          src: hasImage ? bg.image.src : ""
        }
      }))), _react.default.createElement(_Select.default, {
        disabled: !hasImage,
        label: "Scaling",
        value: (0, _dotPropImmutable.get)(bg, "image.scaling"),
        updateValue: this.setScaling
      }, _react.default.createElement("option", {
        value: "cover"
      }, "Cover"), _react.default.createElement("option", {
        value: "contain"
      }, "Contain"), _react.default.createElement("option", {
        value: "originalSize"
      }, "Original size"), _react.default.createElement("option", {
        value: "tile"
      }, "Tile"), _react.default.createElement("option", {
        value: "tileHorizontally"
      }, "Tile Horizontally"), _react.default.createElement("option", {
        value: "tileVertically"
      }, "Tile Vertically")), _react.default.createElement(_Grid.Grid, null, _react.default.createElement(_Grid.Cell, {
        span: 12
      }, _react.default.createElement(_BackgroundPositionSelector.default, {
        disabled: !hasImage,
        value: (0, _dotPropImmutable.get)(bg, "image.position"),
        onChange: this.setPosition
      }))))));
    }
  }]);
  return Settings;
}(_react.default.Component);

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  return {
    element: (0, _selectors.getActiveElement)(state)
  };
}, {
  updateElement: _actions.updateElement
}))(Settings);

exports.default = _default;
//# sourceMappingURL=Settings.js.map