"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _pure2 = _interopRequireDefault(require("recompose/pure"));

var _lifecycle2 = _interopRequireDefault(require("recompose/lifecycle"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _TopAppBar = require("webiny-ui/TopAppBar");

var _Button = require("webiny-ui/Button");

var _actions = require("webiny-app-cms/editor/actions");

var _webinyPlugins = require("webiny-plugins");

var _selectors = require("webiny-app-cms/editor/selectors");

var _components = require("webiny-app-cms/editor/components");

var _Menu = _interopRequireDefault(require("./components/Menu"));

var _navigate_before = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/navigate_before.svg");

var divider = "cms-element-settings-divider";

var getElementActions = function getElementActions(plugin) {
  if (!plugin.settings) {
    return [];
  }

  var actions = plugin.settings.map(function (pl) {
    if (typeof pl === "string") {
      return {
        plugin: (0, _webinyPlugins.getPlugin)(pl || divider),
        options: {}
      };
    }

    if (Array.isArray(pl)) {
      return {
        plugin: (0, _webinyPlugins.getPlugin)(pl[0] || divider),
        options: pl[1]
      };
    }

    return null;
  });
  return [].concat((0, _toConsumableArray2.default)(actions), [{
    plugin: (0, _webinyPlugins.getPlugin)("cms-element-settings-advanced")
  }, {
    plugin: (0, _webinyPlugins.getPlugin)("cms-element-settings-save")
  }]).filter(function (pl) {
    return pl;
  });
};

var ElementSettingsBar = (0, _pure2.default)(function (_ref) {
  var elementType = _ref.elementType,
      deactivateElement = _ref.deactivateElement;

  if (!elementType) {
    return null;
  }

  var plugin = (0, _webinyPlugins.getPlugin)(elementType);

  if (!plugin) {
    return null;
  }

  var actions = getElementActions(plugin);
  return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_TopAppBar.TopAppBarSecondary, {
    fixed: true
  }, _react.default.createElement(_TopAppBar.TopAppBarSection, {
    alignStart: true
  }, _react.default.createElement(_Button.ButtonDefault, {
    onClick: deactivateElement
  }, _react.default.createElement(_Button.ButtonIcon, {
    icon: _react.default.createElement(_navigate_before.ReactComponent, null)
  }), " Back")), _react.default.createElement(_TopAppBar.TopAppBarSection, null, actions.map(function (_ref2, index) {
    var plugin = _ref2.plugin,
        options = _ref2.options;
    return _react.default.createElement("div", {
      key: plugin.name + "-" + index,
      style: {
        position: "relative"
      }
    }, plugin.renderAction({
      options: options
    }), typeof plugin.renderMenu === "function" && _react.default.createElement(_Menu.default, {
      plugin: plugin,
      options: options
    }));
  }))));
});

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  var element = (0, _selectors.getActiveElement)(state);
  return {
    elementType: element ? element.type : null
  };
}, {
  deactivateElement: _actions.deactivateElement
}), (0, _components.withKeyHandler)(), (0, _lifecycle2.default)({
  componentDidMount: function componentDidMount() {
    var _this$props = this.props,
        addKeyHandler = _this$props.addKeyHandler,
        deactivateElement = _this$props.deactivateElement;
    addKeyHandler("escape", function (e) {
      e.preventDefault();
      deactivateElement();
    });
  },
  componentWillUnmount: function componentWillUnmount() {
    this.props.removeKeyHandler("escape");
  }
}))(ElementSettingsBar);

exports.default = _default;
//# sourceMappingURL=ElementSettingsBar.js.map