"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactTransitionGroup = require("react-transition-group");

var _redux = require("webiny-app-cms/editor/redux");

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _Elevation = require("webiny-ui/Elevation");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var Overlay =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e50ci2p0",
  label: "Overlay"
})({
  position: "fixed",
  top: 64,
  left: 0,
  width: "100%",
  height: "100%",
  zIndex: 5
});
var defaultStyle = {
  transform: "translateY(-5px)",
  opacity: 0,
  transitionProperty: "opacity, transform",
  transitionTimingFunction: "cubic-bezier(0, 0, .2, 1)",
  transitionDuration: "250ms",
  willChange: "opacity, transform"
};
var transitionStyles = {
  entering: {
    opacity: 0,
    transform: "translateY(-5px)"
  },
  entered: {
    opacity: 1,
    transform: "translateY(0px)"
  }
};
var Wrapper =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e50ci2p1",
  label: "Wrapper"
})({
  padding: 0,
  boxSizing: "border-box",
  ".mdc-tab-content": {
    padding: 15
  },
  ".mdc-layout-grid": {
    padding: 0,
    "&.no-bottom-padding": {
      paddingBottom: 0
    },
    ".mdc-layout-grid__inner": {
      gridGap: 0,
      '[class*="mdc-layout-grid__cell--span-"]': {
        display: "flex",
        alignItems: "center",
        color: "var(--mdc-theme-text-secondary-on-background)",
        marginBottom: 10,
        justifyContent: "flex-end",
        '[class*="mdc-typography--"], .mdc-button__icon': {
          lineHeight: "120%",
          width: "100%"
        },
        ".mdc-button__icon": {
          marginRight: 20
        }
      }
    }
  }
});
var ToolbarBox =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e50ci2p2",
  label: "ToolbarBox"
})({
  position: "absolute",
  color: "var(--mdc-theme-on-surface)",
  zIndex: 6,
  width: 270,
  top: 56,
  left: 25,
  ".elevationBox": {
    backgroundColor: "var(--mdc-theme-surface)",
    borderRadius: 2,
    "&::after": {
      content: "''",
      width: 0,
      height: 0,
      borderLeft: "7px solid transparent",
      borderRight: "7px solid transparent",
      borderBottom: "7px solid var(--mdc-theme-on-background)",
      position: "absolute",
      top: -7,
      left: "50%",
      transform: "translateX(-50%)"
    }
  }
}, function (props) {
  return {
    left: props.left || 0
  };
});

var Menu =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(Menu, _React$Component);

  function Menu() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, Menu);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(Menu)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "ref", _react.default.createRef());
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "state", {
      left: null
    });
    return _this;
  }

  (0, _createClass2.default)(Menu, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.ref.current && this.state.left === null) {
        this.setState({
          left: -(this.ref.current.offsetWidth - 48) / 2
        }, function () {
          /*eslint-env browser */
          window.dispatchEvent(new Event("resize"));
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          active = _this$props.active,
          plugin = _this$props.plugin,
          options = _this$props.options,
          togglePlugin = _this$props.togglePlugin;
      var content = plugin.renderMenu({
        options: options
      });
      return _react.default.createElement(_reactTransitionGroup.Transition, {
        in: active,
        timeout: 125,
        appear: true,
        unmountOnExit: true
      }, function (state) {
        return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(ToolbarBox, {
          left: _this2.state.left,
          style: (0, _objectSpread2.default)({}, defaultStyle, transitionStyles[state])
        }, _react.default.createElement(_Elevation.Elevation, {
          z: 2,
          className: "elevationBox"
        }, _react.default.createElement("div", {
          ref: _this2.ref
        }, _react.default.createElement(Wrapper, null, content)))), _react.default.createElement(Overlay, {
          onClick: function onClick() {
            return togglePlugin({
              name: plugin.name
            });
          }
        }));
      });
    }
  }]);
  return Menu;
}(_react.default.Component);

var _default = (0, _redux.connect)(function (state, props) {
  return {
    active: (0, _selectors.isPluginActive)(props.plugin.name)(state)
  };
}, {
  togglePlugin: _actions.togglePlugin
})(Menu);

exports.default = _default;
//# sourceMappingURL=Menu.js.map