"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _pure2 = _interopRequireDefault(require("recompose/pure"));

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var React = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

var _emotion = require("emotion");

var _Typography = require("webiny-ui/Typography");

var _Grid = require("webiny-ui/Grid");

var _Button = require("webiny-ui/Button");

var _selectors = require("webiny-app-cms/editor/selectors");

var _roundBorder_top24px = require("@svgr/webpack!./icons/round-border_top-24px.svg");

var _roundBorder_right24px = require("@svgr/webpack!./icons/round-border_right-24px.svg");

var _roundBorder_bottom24px = require("@svgr/webpack!./icons/round-border_bottom-24px.svg");

var _roundBorder_left24px = require("@svgr/webpack!./icons/round-border_left-24px.svg");

var enabled =
/*#__PURE__*/
(0, _emotion.css)({
  color: "var(--mdc-theme-primary, #fa5723)"
}, "label:enabled;");
var cellStyle = {
  marginBottom: 0
};

var getValue = function getValue(value, side) {
  var enabled = value[side];
  return typeof enabled === "undefined" ? true : enabled;
};

var Selector = (0, _pure2.default)(function (_ref) {
  var label = _ref.label,
      value = _ref.value,
      updateValue = _ref.updateValue;
  var top = getValue(value, "top");
  var right = getValue(value, "right");
  var bottom = getValue(value, "bottom");
  var left = getValue(value, "left");
  return React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
    span: 4
  }, React.createElement(_Typography.Typography, {
    use: "overline"
  }, label)), React.createElement(_Grid.Cell, {
    span: 8
  }, React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
    span: 3,
    style: cellStyle
  }, React.createElement(_Button.IconButton, {
    onClick: function onClick() {
      return updateValue((0, _objectSpread2.default)({}, value, {
        top: !top
      }));
    },
    className: top && enabled,
    icon: React.createElement(_roundBorder_top24px.ReactComponent, null)
  })), React.createElement(_Grid.Cell, {
    span: 3,
    style: cellStyle
  }, React.createElement(_Button.IconButton, {
    onClick: function onClick() {
      return updateValue((0, _objectSpread2.default)({}, value, {
        right: !right
      }));
    },
    className: right && enabled,
    icon: React.createElement(_roundBorder_right24px.ReactComponent, null)
  })), React.createElement(_Grid.Cell, {
    span: 3,
    style: cellStyle
  }, React.createElement(_Button.IconButton, {
    onClick: function onClick() {
      return updateValue((0, _objectSpread2.default)({}, value, {
        bottom: !bottom
      }));
    },
    className: bottom && enabled,
    icon: React.createElement(_roundBorder_bottom24px.ReactComponent, null)
  })), React.createElement(_Grid.Cell, {
    span: 3,
    style: cellStyle
  }, React.createElement(_Button.IconButton, {
    onClick: function onClick() {
      return updateValue((0, _objectSpread2.default)({}, value, {
        left: !left
      }));
    },
    className: left && enabled,
    icon: React.createElement(_roundBorder_left24px.ReactComponent, null)
  })))));
});

var _default = (0, _reactRedux.connect)(function (state, _ref2) {
  var valueKey = _ref2.valueKey;
  return {
    value: (0, _get2.default)((0, _selectors.getActiveElement)(state), valueKey, 0)
  };
}, null, null, {
  areStatePropsEqual: _isEqual2.default
})(Selector);

exports.default = _default;
//# sourceMappingURL=Selector.js.map