"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _Tabs = require("webiny-ui/Tabs");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var _ColorPicker = _interopRequireDefault(require("webiny-app-cms/editor/plugins/elementSettings/components/ColorPicker"));

var _Select = _interopRequireDefault(require("webiny-app-cms/editor/plugins/elementSettings/components/Select"));

var _Slider = _interopRequireDefault(require("webiny-app-cms/editor/plugins/elementSettings/components/Slider"));

var _Selector = _interopRequireDefault(require("./Selector"));

var _withUpdateHandlers = _interopRequireDefault(require("../components/withUpdateHandlers"));

var options = ["none", "solid", "dashed", "dotted"];
var DATA_NAMESPACE = "data.settings.border";
var EMPTY_OBJECT = {};

var Settings = function Settings(_ref) {
  var getUpdateValue = _ref.getUpdateValue,
      getUpdatePreview = _ref.getUpdatePreview;
  return React.createElement(React.Fragment, null, React.createElement(_Tabs.Tabs, null, React.createElement(_Tabs.Tab, {
    label: "Border"
  }, React.createElement(_ColorPicker.default, {
    label: "Color",
    valueKey: DATA_NAMESPACE + ".color",
    defaultValue: "#fff",
    updateValue: getUpdateValue("color"),
    updatePreview: getUpdatePreview("color")
  }), React.createElement(_Slider.default, {
    label: "Width",
    valueKey: DATA_NAMESPACE + ".width",
    defaultValue: 0,
    updateValue: getUpdateValue("width"),
    updatePreview: getUpdatePreview("width"),
    min: 0,
    max: 20,
    step: 1
  }), React.createElement(_Slider.default, {
    label: "Radius",
    valueKey: DATA_NAMESPACE + ".radius",
    defaultValue: 0,
    updateValue: getUpdateValue("radius"),
    updatePreview: getUpdatePreview("radius"),
    min: 0,
    max: 100,
    step: 1
  }), React.createElement(_Select.default, {
    label: "Style",
    valueKey: DATA_NAMESPACE + ".style",
    defaultValue: "none",
    updateValue: getUpdateValue("style"),
    options: options
  }), React.createElement(_Selector.default, {
    label: "Borders",
    valueKey: DATA_NAMESPACE + ".borders",
    defaultValue: EMPTY_OBJECT,
    updateValue: getUpdateValue("borders")
  }))));
};

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  var _getActiveElement = (0, _selectors.getActiveElement)(state),
      id = _getActiveElement.id,
      type = _getActiveElement.type,
      path = _getActiveElement.path;

  return {
    element: {
      id: id,
      type: type,
      path: path
    }
  };
}, {
  updateElement: _actions.updateElement
}, null, {
  areStatePropsEqual: _isEqual2.default
}), (0, _withUpdateHandlers.default)({
  namespace: DATA_NAMESPACE
}))(Settings);

exports.default = _default;
//# sourceMappingURL=Settings.js.map