"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _webinyPlugins = require("webiny-plugins");

var _dotPropImmutable = require("dot-prop-immutable");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var _utils = require("webiny-app-cms/editor/utils");

var CloneAction = function CloneAction(_ref) {
  var element = _ref.element,
      children = _ref.children,
      duplicate = _ref.duplicate;
  var plugin = (0, _webinyPlugins.getPlugin)(element.type);

  if (!plugin) {
    return null;
  }

  return React.cloneElement(children, {
    onClick: duplicate
  });
};

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  return {
    element: (0, _selectors.getActiveElement)(state)
  };
}, {
  updateElement: _actions.updateElement
}), (0, _withHandlers2.default)({
  duplicate: function duplicate(_ref2) {
    var element = _ref2.element;
    return function () {
      var state = _redux.redux.store.getState();

      element = (0, _selectors.getElementWithChildren)(state, element.id);
      var parent = (0, _selectors.getParentElementWithChildren)(state, element.id);
      var position = parent.elements.findIndex(function (el) {
        return el.id === element.id;
      }) + 1;
      var newElement = (0, _dotPropImmutable.set)(parent, "elements", [].concat((0, _toConsumableArray2.default)(parent.elements.slice(0, position)), [(0, _utils.cloneElement)(element)], (0, _toConsumableArray2.default)(position < parent.elements.length ? parent.elements.slice(position) : [])));
      return _redux.redux.store.dispatch((0, _actions.updateElement)({
        element: newElement
      }));
    };
  }
}))(CloneAction);

exports.default = _default;
//# sourceMappingURL=CloneAction.js.map