"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _lifecycle2 = _interopRequireDefault(require("recompose/lifecycle"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _emotion = require("emotion");

var _redux = require("webiny-app-cms/editor/redux");

var _actions = require("webiny-app-cms/editor/actions");

var _Button = require("webiny-ui/Button");

var _components = require("webiny-app-cms/editor/components");

var _selectors = require("webiny-app-cms/editor/selectors");

var _Tooltip = require("webiny-ui/Tooltip");

var activeStyle =
/*#__PURE__*/
(0, _emotion.css)({
  "&.mdc-icon-button": {
    color: "var(--mdc-theme-primary)"
  }
}, "label:activeStyle;");

var Action = function Action(_ref) {
  var icon = _ref.icon,
      active = _ref.active,
      tooltip = _ref.tooltip,
      onClick = _ref.onClick;
  return _react.default.createElement(_Tooltip.Tooltip, (0, _extends2.default)({
    placement: "bottom",
    content: _react.default.createElement("span", null, tooltip)
  }, active ? {
    visible: false
  } : {}), _react.default.createElement(_Button.IconButton, {
    icon: icon,
    onClick: onClick,
    className: active && activeStyle
  }));
};

var _default = (0, _compose2.default)((0, _redux.connect)(function (state, props) {
  return {
    active: (0, _selectors.isPluginActive)(props.plugin)(state),
    // $FlowFixMe
    slateFocused: (0, _selectors.getUi)(state).slateFocused,
    settingsActive: (0, _selectors.getActivePlugins)("cms-element-settings")(state).length > 0
  };
}, {
  togglePlugin: _actions.togglePlugin
}), (0, _components.withKeyHandler)(), (0, _withHandlers2.default)({
  onClick: function onClick(_ref2) {
    var _onClick = _ref2.onClick,
        togglePlugin = _ref2.togglePlugin,
        plugin = _ref2.plugin;
    return function () {
      if (typeof _onClick === "function") {
        return _onClick();
      }

      togglePlugin({
        name: plugin,
        closeOtherInGroup: true
      });
    };
  }
}), (0, _lifecycle2.default)({
  componentDidMount: function componentDidMount() {
    var _this = this;

    var _this$props = this.props,
        addKeyHandler = _this$props.addKeyHandler,
        onClick = _this$props.onClick,
        shortcut = _this$props.shortcut;
    addKeyHandler(shortcut, function (e) {
      var _this$props2 = _this.props,
          slateFocused = _this$props2.slateFocused,
          settingsActive = _this$props2.settingsActive;

      if (slateFocused || settingsActive) {
        return;
      }

      e.preventDefault();
      onClick();
    });
  },
  componentWillUnmount: function componentWillUnmount() {
    var _this$props3 = this.props,
        removeKeyHandler = _this$props3.removeKeyHandler,
        shortcut = _this$props3.shortcut;
    removeKeyHandler(shortcut);
  }
}))(Action);

exports.default = _default;
//# sourceMappingURL=Action.js.map