"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _Tabs = require("webiny-ui/Tabs");

var _dotPropImmutable = require("dot-prop-immutable");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var _border_outer = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/border_outer.svg");

var _border_left = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/border_left.svg");

var _border_right = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/border_right.svg");

var _border_top = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/border_top.svg");

var _border_bottom = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/border_bottom.svg");

var _SliderWithInput = _interopRequireDefault(require("./SliderWithInput"));

var _Footer = _interopRequireDefault(require("./Footer"));

var PMSettings = function PMSettings(_ref) {
  var advanced = _ref.advanced,
      valueKey = _ref.valueKey,
      getUpdateValue = _ref.getUpdateValue,
      getUpdatePreview = _ref.getUpdatePreview;
  return _react.default.createElement(_Tabs.Tabs, null, _react.default.createElement(_Tabs.Tab, {
    label: "Desktop"
  }, !advanced ? _react.default.createElement(_SliderWithInput.default, {
    className: "no-bottom-padding",
    icon: _react.default.createElement(_border_outer.ReactComponent, null),
    valueKey: valueKey + ".desktop.all",
    updateValue: getUpdateValue("desktop.all"),
    updatePreview: getUpdatePreview("desktop.all")
  }) : _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_SliderWithInput.default, {
    icon: _react.default.createElement(_border_top.ReactComponent, null),
    valueKey: valueKey + ".desktop.top",
    updateValue: getUpdateValue("desktop.top"),
    updatePreview: getUpdatePreview("desktop.top")
  }), _react.default.createElement(_SliderWithInput.default, {
    icon: _react.default.createElement(_border_right.ReactComponent, null),
    valueKey: valueKey + ".desktop.right",
    updateValue: getUpdateValue("desktop.right"),
    updatePreview: getUpdatePreview("desktop.right")
  }), _react.default.createElement(_SliderWithInput.default, {
    icon: _react.default.createElement(_border_bottom.ReactComponent, null),
    valueKey: valueKey + ".desktop.bottom",
    updateValue: getUpdateValue("desktop.bottom"),
    updatePreview: getUpdatePreview("desktop.bottom")
  }), _react.default.createElement(_SliderWithInput.default, {
    className: "no-bottom-padding",
    icon: _react.default.createElement(_border_left.ReactComponent, null),
    valueKey: valueKey + ".desktop.left",
    updateValue: getUpdateValue("desktop.left"),
    updatePreview: getUpdatePreview("desktop.left")
  })), _react.default.createElement(_Footer.default, {
    advanced: advanced || false,
    toggleAdvanced: getUpdateValue("advanced")
  })), _react.default.createElement(_Tabs.Tab, {
    label: "Mobile"
  }, !advanced ? _react.default.createElement(_SliderWithInput.default, {
    className: "no-bottom-padding",
    icon: _react.default.createElement(_border_outer.ReactComponent, null),
    valueKey: valueKey + ".mobile.all",
    updateValue: getUpdateValue("mobile.all"),
    updatePreview: getUpdatePreview("mobile.all")
  }) : _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_SliderWithInput.default, {
    icon: _react.default.createElement(_border_top.ReactComponent, null),
    valueKey: valueKey + ".mobile.top",
    updateValue: getUpdateValue("mobile.top"),
    updatePreview: getUpdatePreview("mobile.top")
  }), _react.default.createElement(_SliderWithInput.default, {
    icon: _react.default.createElement(_border_right.ReactComponent, null),
    valueKey: valueKey + ".mobile.right",
    updateValue: getUpdateValue("mobile.right"),
    updatePreview: getUpdatePreview("mobile.right")
  }), _react.default.createElement(_SliderWithInput.default, {
    icon: _react.default.createElement(_border_bottom.ReactComponent, null),
    valueKey: valueKey + ".mobile.bottom",
    updateValue: getUpdateValue("mobile.bottom"),
    updatePreview: getUpdatePreview("mobile.bottom")
  }), _react.default.createElement(_SliderWithInput.default, {
    className: "no-bottom-padding",
    icon: _react.default.createElement(_border_left.ReactComponent, null),
    valueKey: valueKey + ".mobile.left",
    updateValue: getUpdateValue("mobile.left"),
    updatePreview: getUpdatePreview("mobile.left")
  })), _react.default.createElement(_Footer.default, {
    advanced: advanced || false,
    toggleAdvanced: getUpdateValue("advanced")
  })));
};

var _default = (0, _compose2.default)((0, _redux.connect)(function (state, _ref2) {
  var styleAttribute = _ref2.styleAttribute;
  var valueKey = "data.settings." + styleAttribute;
  var element = (0, _selectors.getActiveElement)(state);
  return {
    valueKey: valueKey,
    advanced: (0, _get2.default)(element, valueKey + ".advanced", false),
    element: {
      id: element.id,
      type: element.type,
      path: element.path
    }
  };
}, {
  updateElement: _actions.updateElement
}, null, {
  areStatePropsEqual: _isEqual2.default
}), (0, _withHandlers2.default)({
  updateSettings: function updateSettings(_ref3) {
    var element = _ref3.element,
        updateElement = _ref3.updateElement,
        valueKey = _ref3.valueKey;
    var historyUpdated = {};
    return function (name, newValue) {
      var history = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var propName = "".concat(valueKey, ".").concat(name);

      if (name !== "advanced") {
        newValue = parseInt(newValue) || 0;
      }

      var newElement = (0, _dotPropImmutable.set)(element, propName, newValue); // Update all values in advanced settings

      if (propName.endsWith(".all")) {
        var prefix = propName.includes("desktop") ? "desktop" : "mobile";
        newElement = (0, _dotPropImmutable.merge)(newElement, "".concat(valueKey, ".").concat(prefix), {
          top: newValue,
          right: newValue,
          bottom: newValue,
          left: newValue
        });
      }

      if (!history) {
        updateElement({
          element: newElement,
          history: history,
          merge: true
        });
        return;
      }

      if (historyUpdated[propName] !== newValue) {
        historyUpdated[propName] = newValue;
        updateElement({
          element: newElement,
          merge: true
        });
      }
    };
  }
}), (0, _withHandlers2.default)({
  getUpdateValue: function getUpdateValue(_ref4) {
    var updateSettings = _ref4.updateSettings;
    var handlers = {};
    return function (name) {
      if (!handlers[name]) {
        return function (value) {
          return updateSettings(name, value, true);
        };
      }

      return handlers[name];
    };
  },
  getUpdatePreview: function getUpdatePreview(_ref5) {
    var updateSettings = _ref5.updateSettings;
    var handlers = {};
    return function (name) {
      if (!handlers[name]) {
        return function (value) {
          return updateSettings(name, value, false);
        };
      }

      return handlers[name];
    };
  }
}))(PMSettings);

exports.default = _default;
//# sourceMappingURL=PMSettings.js.map