"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _set2 = _interopRequireDefault(require("lodash/set"));

var _reactRedux = require("react-redux");

var _actions = require("webiny-app-cms/editor/actions");

var _default = function _default(_ref) {
  var namespace = _ref.namespace;
  return (0, _compose2.default)((0, _reactRedux.connect)(null, {
    updateElement: _actions.updateElement
  }), (0, _withHandlers2.default)({
    updateSettings: function updateSettings(_ref2) {
      var element = _ref2.element,
          updateElement = _ref2.updateElement;
      var historyUpdated = {};
      return function (name, newValue) {
        var history = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
        var propName = "".concat(namespace, ".").concat(name);
        var newElement = (0, _set2.default)(element, propName, newValue);

        if (!history) {
          updateElement({
            element: newElement,
            history: history,
            merge: true
          });
          return;
        }

        if (historyUpdated[propName] !== newValue) {
          historyUpdated[propName] = newValue;
          updateElement({
            element: newElement,
            merge: true
          });
        }
      };
    }
  }), (0, _withHandlers2.default)({
    getUpdateValue: function getUpdateValue(_ref3) {
      var updateSettings = _ref3.updateSettings;
      var handlers = {};
      return function (name) {
        if (!handlers[name]) {
          return function (value) {
            return updateSettings(name, value, true);
          };
        }

        return handlers[name];
      };
    },
    getUpdatePreview: function getUpdatePreview(_ref4) {
      var updateSettings = _ref4.updateSettings;
      var handlers = {};
      return function (name) {
        if (!handlers[name]) {
          return function (value) {
            return updateSettings(name, value, false);
          };
        }

        return handlers[name];
      };
    }
  }));
};

exports.default = _default;
//# sourceMappingURL=withUpdateHandlers.js.map