"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _webinyPlugins = require("webiny-plugins");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var DeleteAction = function DeleteAction(_ref) {
  var element = _ref.element,
      children = _ref.children,
      deleteElement = _ref.deleteElement;
  var plugin = (0, _webinyPlugins.getPlugin)(element.type);

  if (!plugin) {
    return null;
  }

  if (typeof plugin.canDelete === "function") {
    if (!plugin.canDelete({
      element: element
    })) {
      return null;
    }
  }

  return React.cloneElement(children, {
    onClick: deleteElement
  });
};

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  return {
    element: (0, _selectors.getActiveElement)(state)
  };
}, {
  deleteElement: _actions.deleteElement
}), (0, _withHandlers2.default)({
  deleteElement: function deleteElement(_ref2) {
    var _deleteElement = _ref2.deleteElement,
        element = _ref2.element;
    return function () {
      _deleteElement({
        element: element
      });
    };
  }
}))(DeleteAction);

exports.default = _default;
//# sourceMappingURL=DeleteAction.js.map