"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _cloneDeep2 = _interopRequireDefault(require("lodash/cloneDeep"));

var _shouldUpdate2 = _interopRequireDefault(require("recompose/shouldUpdate"));

var _lifecycle2 = _interopRequireDefault(require("recompose/lifecycle"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _withState2 = _interopRequireDefault(require("recompose/withState"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _reactApollo = require("react-apollo");

var _webinyPlugins = require("webiny-plugins");

var _SaveDialog = _interopRequireDefault(require("./SaveDialog"));

var _components = require("webiny-admin/components");

var _components2 = require("webiny-app-cms/editor/components");

var _selectors = require("webiny-app-cms/editor/selectors");

var _components3 = require("webiny-app-cms/admin/components");

var _pages = require("webiny-app-cms/admin/graphql/pages");

var _components4 = require("webiny-app/components");

var SaveAction = function SaveAction(_ref) {
  var showDialog = _ref.showDialog,
      hideDialog = _ref.hideDialog,
      isDialogOpened = _ref.isDialogOpened,
      children = _ref.children,
      onSubmit = _ref.onSubmit,
      element = _ref.element;

  if (!element) {
    return null;
  }

  var plugin = (0, _webinyPlugins.getPlugin)(element.type);

  if (!plugin) {
    return null;
  }

  return React.createElement(React.Fragment, null, React.createElement(_SaveDialog.default, {
    key: element.id,
    element: element,
    open: isDialogOpened,
    onClose: hideDialog,
    onSubmit: onSubmit,
    type: element.type === "cms-element-block" ? "block" : "element"
  }), React.cloneElement(children, {
    onClick: showDialog
  }));
};

var removeIdsAndPaths = function removeIdsAndPaths(el) {
  delete el.id;
  delete el.path;
  el.elements = el.elements.map(function (el) {
    delete el.id;
    delete el.path;

    if (el.elements && el.elements.length) {
      el = removeIdsAndPaths(el);
    }

    return el;
  });
  return el;
};

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  return {
    element: (0, _selectors.getElementWithChildren)(state, (0, _selectors.getActiveElementId)(state))
  };
}), (0, _withState2.default)("isDialogOpened", "setOpenDialog", false), (0, _shouldUpdate2.default)(function (props, nextProps) {
  return props.isDialogOpened !== nextProps.isDialogOpened;
}), (0, _components4.withFileUpload)(), (0, _components2.withKeyHandler)(), (0, _withHandlers2.default)({
  showDialog: function showDialog(_ref2) {
    var setOpenDialog = _ref2.setOpenDialog;
    return function () {
      return setOpenDialog(true);
    };
  },
  hideDialog: function hideDialog(_ref3) {
    var setOpenDialog = _ref3.setOpenDialog;
    return function () {
      return setOpenDialog(false);
    };
  }
}), (0, _reactApollo.graphql)(_pages.createElement, {
  name: "createElement"
}), (0, _reactApollo.graphql)(_pages.updateElement, {
  name: "updateElement"
}), (0, _components.withSnackbar)(), (0, _withHandlers2.default)({
  onSubmit: function onSubmit(_ref4) {
    var element = _ref4.element,
        hideDialog = _ref4.hideDialog,
        createElement = _ref4.createElement,
        updateElement = _ref4.updateElement,
        showSnackbar = _ref4.showSnackbar,
        uploadFile = _ref4.uploadFile;
    return (
      /*#__PURE__*/
      function () {
        var _ref5 = (0, _asyncToGenerator2.default)(
        /*#__PURE__*/
        _regenerator.default.mark(function _callee(formData) {
          var mutation, _ref6, res, data;

          return _regenerator.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return uploadFile({
                    src: formData.preview,
                    name: "cms-element-" + element.source
                  });

                case 2:
                  formData.preview = _context.sent;
                  formData.content = removeIdsAndPaths((0, _cloneDeep2.default)(element));
                  mutation = formData.overwrite ? updateElement : createElement;
                  _context.next = 7;
                  return mutation({
                    variables: formData.overwrite ? {
                      id: element.source,
                      data: {
                        content: formData.content,
                        preview: formData.preview
                      }
                    } : {
                      data: formData
                    }
                  });

                case 7:
                  _ref6 = _context.sent;
                  res = _ref6.data;
                  hideDialog();
                  data = res.cms.element.data;

                  if (data.type === "block") {
                    (0, _components3.createBlockPlugin)(data);
                  } else {
                    (0, _components3.createElementPlugin)(data);
                  }

                  showSnackbar(React.createElement("span", null, formData.type[0].toUpperCase() + formData.type.slice(1), " ", React.createElement("strong", null, data.name), " saved!"));

                case 13:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        return function (_x) {
          return _ref5.apply(this, arguments);
        };
      }()
    );
  }
}), (0, _lifecycle2.default)({
  componentDidUpdate: function componentDidUpdate() {
    var _this$props = this.props,
        isDialogOpened = _this$props.isDialogOpened,
        addKeyHandler = _this$props.addKeyHandler,
        removeKeyHandler = _this$props.removeKeyHandler,
        hideDialog = _this$props.hideDialog;
    isDialogOpened ? addKeyHandler("escape", hideDialog) : removeKeyHandler("escape");
  }
}))(SaveAction);

exports.default = _default;
//# sourceMappingURL=SaveAction.js.map