"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _shouldUpdate2 = _interopRequireDefault(require("recompose/shouldUpdate"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _emotion = require("emotion");

var _webinyPlugins = require("webiny-plugins");

var _ElementPreview = _interopRequireDefault(require("./SaveDialog/ElementPreview"));

var _Dialog = require("webiny-ui/Dialog");

var _Input = require("webiny-ui/Input");

var _Switch = require("webiny-ui/Switch");

var _Select = require("webiny-ui/Select");

var _Grid = require("webiny-ui/Grid");

var _webinyForm = require("webiny-form");

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var narrowDialog =
/*#__PURE__*/
(0, _emotion.css)({
  ".mdc-dialog__surface": {
    width: 600,
    minWidth: 600
  }
}, "label:narrowDialog;");
var PreviewBox =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e1y8idw60",
  label: "PreviewBox"
})({
  width: 500,
  minHeight: 250,
  border: "1px solid var(--mdc-theme-on-background)",
  backgroundColor: "#fff",
  // this must always be white
  display: "flex",
  justifyContent: "center",
  alignItems: "center",
  img: {
    maxHeight: 500,
    maxWidth: 500
  }
});

var SaveDialog = function SaveDialog(props) {
  var element = props.element,
      open = props.open,
      onClose = props.onClose,
      onSubmit = props.onSubmit,
      type = props.type;
  var blockCategoriesOptions = (0, _webinyPlugins.getPlugins)("cms-block-category").map(function (item) {
    return {
      value: item.name,
      label: item.title
    };
  });
  return _react.default.createElement(_Dialog.Dialog, {
    open: open,
    onClose: onClose,
    className: narrowDialog
  }, _react.default.createElement(_webinyForm.Form, {
    onSubmit: onSubmit,
    data: {
      type: type,
      category: "cms-block-category-general"
    }
  }, function (_ref) {
    var data = _ref.data,
        submit = _ref.submit,
        Bind = _ref.Bind;
    return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_Dialog.DialogHeader, null, _react.default.createElement(_Dialog.DialogHeaderTitle, null, "Save ", type)), _react.default.createElement(_Dialog.DialogBody, null, element.source && _react.default.createElement(_Grid.Grid, null, _react.default.createElement(_Grid.Cell, {
      span: 12
    }, _react.default.createElement(Bind, {
      name: "overwrite"
    }, _react.default.createElement(_Switch.Switch, {
      label: "Update existing"
    })))), !data.overwrite && _react.default.createElement(_Grid.Grid, null, _react.default.createElement(_Grid.Cell, {
      span: 12
    }, _react.default.createElement(Bind, {
      name: "name",
      validators: "required"
    }, _react.default.createElement(_Input.Input, {
      label: "Name",
      autoFocus: true
    })))), data.type === "block" && !data.overwrite && _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_Grid.Grid, null, _react.default.createElement(_Grid.Cell, {
      span: 12
    }, _react.default.createElement(Bind, {
      name: "category",
      validators: ["required"]
    }, _react.default.createElement(_Select.Select, {
      label: "Category",
      description: "Select a block category",
      options: blockCategoriesOptions
    }))))), _react.default.createElement(_Grid.Grid, null, _react.default.createElement(_Grid.Cell, {
      span: 12
    }, _react.default.createElement(PreviewBox, null, _react.default.createElement(Bind, {
      name: "preview"
    }, function (_ref2) {
      var value = _ref2.value,
          onChange = _ref2.onChange;
      return value ? _react.default.createElement("img", {
        src: value,
        alt: ""
      }) : open ? _react.default.createElement(_ElementPreview.default, {
        key: element.id,
        onChange: onChange,
        element: element
      }) : null;
    }))))), _react.default.createElement(_Dialog.DialogFooter, null, _react.default.createElement(_Dialog.DialogCancel, null, "Cancel"), _react.default.createElement(_Dialog.DialogFooterButton, {
      onClick: submit
    }, "Save")));
  }));
};

var _default = (0, _compose2.default)((0, _shouldUpdate2.default)(function (props, nextProps) {
  return props.open !== nextProps.open;
}))(SaveDialog);

exports.default = _default;
//# sourceMappingURL=SaveDialog.js.map