"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireDefault(require("react"));

var _server = require("react-dom/server");

var _webinyPlugins = require("webiny-plugins");

var _domToImage = _interopRequireDefault(require("./domToImage"));

var ElementPreview =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(ElementPreview, _React$Component);

  function ElementPreview() {
    (0, _classCallCheck2.default)(this, ElementPreview);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(ElementPreview).apply(this, arguments));
  }

  (0, _createClass2.default)(ElementPreview, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.generateImage();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.generateImage();
    }
  }, {
    key: "replaceContent",
    value: function replaceContent(element, doc) {
      var _this = this;

      var pl = (0, _webinyPlugins.getPlugin)(element.type);

      if (!pl) {
        return doc;
      }

      if (typeof pl.renderElementPreview === "function") {
        var elementNode = document.getElementById(element.id);

        if (!elementNode) {
          return doc;
        }

        var newContentString = (0, _server.renderToStaticMarkup)(pl.renderElementPreview({
          element: element,
          width: elementNode.offsetWidth || 0,
          height: elementNode.offsetHeight || 0
        }));
        var wrapper = document.createElement("div");
        wrapper.innerHTML = newContentString;
        var newContentDoc = wrapper.firstChild; // $FlowFixMe

        doc.querySelector("#" + element.id).replaceWith(newContentDoc);
      }

      if (element.elements.length) {
        element.elements.forEach(function (el) {
          doc = _this.replaceContent(el, doc);
        });
      }

      return doc;
    }
  }, {
    key: "generateImage",
    value: function () {
      var _generateImage = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var _this2 = this;

        var element, node, editor, dataUrl;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                element = this.props.element;
                node = document.getElementById(element.id);

                if (node) {
                  _context.next = 4;
                  break;
                }

                return _context.abrupt("return", null);

              case 4:
                editor = document.querySelector(".cms-editor"); // Hide element highlight while creating the image
                // $FlowFixMe

                editor.classList.add("cms-editor-no-highlight");
                _context.next = 8;
                return _domToImage.default.toPng(node, {
                  onDocument: function onDocument(doc) {
                    return _this2.replaceContent(element, doc);
                  },
                  width: 1000
                });

              case 8:
                dataUrl = _context.sent;
                // $FlowFixMe
                editor.classList.remove("cms-editor-no-highlight");
                this.props.onChange(dataUrl);

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function generateImage() {
        return _generateImage.apply(this, arguments);
      }

      return generateImage;
    }()
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }]);
  return ElementPreview;
}(_react.default.Component);

exports.default = ElementPreview;
//# sourceMappingURL=ElementPreview.js.map