"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _selectors = require("webiny-app-cms/editor/selectors");

var _Tabs = require("webiny-ui/Tabs");

var _actions = require("webiny-app-cms/editor/actions");

var _ColorPicker = _interopRequireDefault(require("webiny-app-cms/editor/plugins/elementSettings/components/ColorPicker"));

var _Input = _interopRequireDefault(require("webiny-app-cms/editor/plugins/elementSettings/components/Input"));

var _withUpdateHandlers = _interopRequireDefault(require("webiny-app-cms/editor/plugins/elementSettings/components/withUpdateHandlers"));

var DATA_NAMESPACE = "data.settings.shadow";

var Settings = function Settings(_ref) {
  var getUpdateValue = _ref.getUpdateValue,
      getUpdatePreview = _ref.getUpdatePreview;
  return React.createElement(React.Fragment, null, React.createElement(_Tabs.Tabs, null, React.createElement(_Tabs.Tab, {
    label: "Shadow"
  }, React.createElement(_ColorPicker.default, {
    label: "Color",
    valueKey: DATA_NAMESPACE + ".color",
    updateValue: getUpdateValue("color"),
    updatePreview: getUpdatePreview("color")
  }), React.createElement(_Input.default, {
    label: "Horizontal offset",
    valueKey: DATA_NAMESPACE + ".horizontal",
    updateValue: getUpdateValue("horizontal")
  }), React.createElement(_Input.default, {
    label: "Vertical offset",
    valueKey: DATA_NAMESPACE + ".vertical",
    updateValue: getUpdateValue("vertical")
  }), React.createElement(_Input.default, {
    label: "Blur",
    valueKey: DATA_NAMESPACE + ".blur",
    updateValue: getUpdateValue("blur")
  }), React.createElement(_Input.default, {
    label: "Spread",
    valueKey: DATA_NAMESPACE + ".spread",
    updateValue: getUpdateValue("spread")
  }))));
};

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  var _getActiveElement = (0, _selectors.getActiveElement)(state),
      id = _getActiveElement.id,
      type = _getActiveElement.type,
      path = _getActiveElement.path;

  return {
    element: {
      id: id,
      type: type,
      path: path
    }
  };
}, {
  updateElement: _actions.updateElement
}, null, {
  areStatePropsEqual: _isEqual2.default
}), (0, _withUpdateHandlers.default)({
  namespace: DATA_NAMESPACE
}))(Settings);

exports.default = _default;
//# sourceMappingURL=Settings.js.map