"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var React = _interopRequireWildcard(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _emotion = require("emotion");

var _Element = _interopRequireDefault(require("webiny-app-cms/editor/components/Element"));

var _DropZone = _interopRequireDefault(require("webiny-app-cms/editor/components/DropZone"));

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var BlockContainer = function BlockContainer(_ref) {
  var elementStyle = _ref.elementStyle,
      elementAttributes = _ref.elementAttributes,
      customClasses = _ref.customClasses,
      combineClassNames = _ref.combineClassNames,
      element = _ref.element,
      dropElement = _ref.dropElement;
  var width = elementStyle.width,
      alignItems = elementStyle.alignItems,
      justifyContent = elementStyle.justifyContent,
      containerStyle = (0, _objectWithoutProperties2.default)(elementStyle, ["width", "alignItems", "justifyContent"]);
  var id = element.id,
      type = element.type,
      elements = element.elements;
  return React.createElement("div", (0, _extends2.default)({
    style: {
      width: "100%",
      display: "flex",
      justifyContent: "center"
    },
    className: "webiny-cms-layout-block-container " +
    /*#__PURE__*/
    (0, _emotion.css)(containerStyle, "label:BlockContainer;")
  }, elementAttributes), React.createElement("div", {
    style: {
      width: width ? width : "100%",
      alignSelf: justifyContent,
      alignItems: alignItems
    },
    className: combineClassNames.apply(void 0, (0, _toConsumableArray2.default)(customClasses))
  }, !elements.length && React.createElement(_DropZone.default.Center, {
    element: element
  }, "Add an element here"), elements.map(function (childId, index) {
    return React.createElement(React.Fragment, {
      key: childId
    }, React.createElement(_DropZone.default.Above, {
      type: type,
      onDrop: function onDrop(source) {
        return dropElement({
          source: source,
          target: {
            id: id,
            type: type,
            position: index
          }
        });
      }
    }), React.createElement(_Element.default, {
      key: childId,
      id: childId
    }), index === elements.length - 1 && React.createElement(_DropZone.default.Below, {
      type: type,
      onDrop: function onDrop(source) {
        dropElement({
          source: source,
          target: {
            id: id,
            type: type,
            position: elements.length
          }
        });
      }
    }));
  })));
};

var _default = (0, _redux.connect)(function (state, props) {
  return {
    element: (0, _selectors.getElement)(state, props.elementId)
  };
}, {
  dropElement: _actions.dropElement
}, null, {
  areStatePropsEqual: _isEqual2.default
})(BlockContainer);

exports.default = _default;
//# sourceMappingURL=BlockContainer.js.map