"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _react = _interopRequireDefault(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _Block = _interopRequireDefault(require("./Block"));

var _dotPropImmutable = require("dot-prop-immutable");

var _utils = require("webiny-app-cms/editor/utils");

var _actions = require("webiny-app-cms/editor/actions");

var _default = function _default() {
  return {
    name: "cms-element-block",
    type: "cms-element",
    settings: ["cms-element-settings-background", "cms-element-settings-animation", "", "cms-element-settings-border", "cms-element-settings-shadow", "", "cms-element-settings-padding", "cms-element-settings-margin", "cms-element-settings-width", "cms-element-settings-height", "cms-element-settings-horizontal-align-flex", "cms-element-settings-vertical-align", "", "cms-element-settings-clone", "cms-element-settings-delete", ""],
    create: function create() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      return (0, _objectSpread2.default)({
        type: "cms-element-block",
        elements: [(0, _utils.createRow)({
          elements: [(0, _utils.createColumn)({
            data: {
              width: 100
            }
          })]
        })],
        data: {
          settings: {
            width: {
              value: "1000px"
            },
            margin: {
              mobile: {
                top: 15,
                left: 15,
                right: 15,
                bottom: 15
              },
              desktop: {
                top: 25,
                left: 0,
                right: 0,
                bottom: 25
              },
              advanced: true
            },
            padding: {
              mobile: {
                all: 10
              },
              desktop: {
                all: 0
              }
            }
          }
        }
      }, options);
    },
    render: function render(props) {
      return _react.default.createElement(_Block.default, props);
    },
    // This callback is executed when another element is dropped on the drop zones with type "block"
    onReceived: function onReceived(_ref) {
      var source = _ref.source,
          target = _ref.target,
          _ref$position = _ref.position,
          position = _ref$position === void 0 ? null : _ref$position;
      var dispatchNew = false;
      var element;

      if (source.path) {
        // $FlowFixMe
        element = (0, _utils.cloneElement)(source);
      } else {
        dispatchNew = true;
        element = (0, _utils.createElement)(source.type, {}, target);
      }

      var block = (0, _utils.addElementToParent)(element, target, position); // Dispatch update action

      _redux.redux.store.dispatch((0, _actions.updateElement)({
        element: block
      })); // Delete exiting element


      if (source.path) {
        _redux.redux.store.dispatch((0, _actions.deleteElement)({
          element: source
        }));
      }

      if (dispatchNew) {
        _redux.redux.store.dispatch((0, _actions.elementCreated)({
          element: element,
          source: source
        }));
      }
    },
    onChildDeleted: function onChildDeleted(_ref2) {
      var element = _ref2.element;

      if (element.elements.length === 0) {
        element = (0, _dotPropImmutable.set)(element, "elements", [(0, _utils.createRow)({
          elements: [(0, _utils.createColumn)({
            data: {
              width: 100
            }
          })]
        })]);

        _redux.redux.store.dispatch((0, _actions.updateElement)({
          element: element
        }));
      }
    }
  };
};

exports.default = _default;
//# sourceMappingURL=index.js.map