"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _dotPropImmutable = require("dot-prop-immutable");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var _ConnectedSlate = _interopRequireDefault(require("webiny-app-cms/editor/components/ConnectedSlate"));

var excludePlugins = ["align", "align-menu-item", "ordered-list-menu-item", "unordered-list-menu-item", "lists", "code-menu-item"];

var ButtonContainer = function ButtonContainer(_ref) {
  var getAllClasses = _ref.getAllClasses,
      elementStyle = _ref.elementStyle,
      elementAttributes = _ref.elementAttributes,
      element = _ref.element,
      onChange = _ref.onChange;

  var _ref2 = element.data || {},
      _ref2$type = _ref2.type,
      type = _ref2$type === void 0 ? "default" : _ref2$type,
      _ref2$icon = _ref2.icon,
      icon = _ref2$icon === void 0 ? {} : _ref2$icon;

  var svg = icon.svg || null;
  var alignItems = elementStyle.alignItems;
  var _icon$position = icon.position,
      position = _icon$position === void 0 ? "left" : _icon$position;
  return React.createElement("div", {
    style: {
      display: "flex",
      justifyContent: alignItems
    }
  }, React.createElement("a", (0, _extends2.default)({
    href: null,
    style: elementStyle
  }, elementAttributes, {
    className: getAllClasses("webiny-cms-element-button", "webiny-cms-element-button--" + type, "webiny-cms-element-button__icon--" + position)
  }), svg && React.createElement("span", {
    dangerouslySetInnerHTML: {
      __html: svg
    }
  }), React.createElement(_ConnectedSlate.default, {
    elementId: element.id,
    onChange: onChange,
    exclude: excludePlugins
  })));
};

var _default = (0, _compose2.default)((0, _redux.connect)(function (state, props) {
  return {
    element: (0, _selectors.getElement)(state, props.elementId)
  };
}, {
  updateElement: _actions.updateElement
}), (0, _withHandlers2.default)({
  onChange: function onChange(_ref3) {
    var element = _ref3.element,
        updateElement = _ref3.updateElement;
    return function (value) {
      updateElement({
        element: (0, _dotPropImmutable.set)(element, "data.text", value)
      });
    };
  }
}))(ButtonContainer);

exports.default = _default;
//# sourceMappingURL=ButtonContainer.js.map