"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var _get5 = _interopRequireDefault(require("lodash/get"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _server = require("react-dom/server");

var _webinyPlugins = require("webiny-plugins");

var _redux = require("webiny-app-cms/editor/redux");

var _dotPropImmutable = require("dot-prop-immutable");

var _Tabs = require("webiny-ui/Tabs");

var _Select = require("webiny-ui/Select");

var _Grid = require("webiny-ui/Grid");

var _Typography = require("webiny-ui/Typography");

var _context = require("webiny-app-cms/context");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var _Input = _interopRequireDefault(require("webiny-app-cms/editor/plugins/elementSettings/components/Input"));

var _ColorPicker = _interopRequireDefault(require("webiny-app-cms/editor/plugins/elementSettings/components/ColorPicker"));

var _IconPicker = _interopRequireDefault(require("webiny-app-cms/editor/plugins/elementSettings/components/IconPicker"));

var ButtonSettings = function ButtonSettings(_ref) {
  var element = _ref.element,
      theme = _ref.cms.theme,
      updateType = _ref.updateType,
      updateIcon = _ref.updateIcon,
      updateIconColor = _ref.updateIconColor,
      updateIconColorPreview = _ref.updateIconColorPreview,
      updateIconWidth = _ref.updateIconWidth,
      updateIconPosition = _ref.updateIconPosition;

  var _get2 = (0, _get5.default)(theme, "elements.button", []),
      types = _get2.types;

  var _get3 = (0, _get5.default)(element, "data", {}),
      _get3$type = _get3.type,
      type = _get3$type === void 0 ? (0, _get5.default)(types, "0.name", "") : _get3$type,
      _get3$icon = _get3.icon,
      icon = _get3$icon === void 0 ? {} : _get3$icon;

  return React.createElement(React.Fragment, null, React.createElement(_Tabs.Tabs, null, React.createElement(_Tabs.Tab, {
    label: "Button"
  }, React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
    span: 6
  }, React.createElement(_Typography.Typography, {
    use: "overline"
  }, "Type")), React.createElement(_Grid.Cell, {
    span: 6
  }, React.createElement(_Select.Select, {
    value: type,
    onChange: updateType
  }, types.map(function (type) {
    return React.createElement("option", {
      key: type.className,
      value: type.className
    }, type.label);
  }))))), React.createElement(_Tabs.Tab, {
    label: "Icon"
  }, React.createElement(_IconPicker.default, {
    label: "Icon",
    value: icon.id,
    updateValue: updateIcon
  }), React.createElement(_Input.default, {
    label: "Width",
    value: icon.width || 50,
    updateValue: updateIconWidth
  }), React.createElement(_ColorPicker.default, {
    label: "Color",
    value: icon.color,
    updateValue: updateIconColor,
    updatePreview: updateIconColorPreview
  }), React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
    span: 6
  }, React.createElement(_Typography.Typography, {
    use: "overline"
  }, "Position")), React.createElement(_Grid.Cell, {
    span: 6
  }, React.createElement(_Select.Select, {
    value: icon.position || "left",
    onChange: updateIconPosition
  }, React.createElement("option", {
    value: "left"
  }, "Left"), React.createElement("option", {
    value: "right"
  }, "Right"), React.createElement("option", {
    value: "top"
  }, "Top"), React.createElement("option", {
    value: "bottom"
  }, "Bottom")))))));
};

var icons;

var getIcons = function getIcons() {
  if (!icons) {
    icons = (0, _webinyPlugins.getPlugins)("cms-icons").reduce(function (icons, pl) {
      return icons.concat(pl.getIcons());
    }, []);
  }

  return icons;
};

var getSvg = function getSvg(id, props) {
  if (!props.width) {
    props.width = 50;
  }

  var icon = getIcons().find(function (ic) {
    return (0, _isEqual2.default)(ic.id, id);
  });

  if (!icon) {
    return null;
  }

  return (0, _server.renderToStaticMarkup)(React.cloneElement(icon.svg, props));
};

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  return {
    element: (0, _selectors.getActiveElement)(state)
  };
}, {
  updateElement: _actions.updateElement
}), (0, _context.withCms)(), (0, _withHandlers2.default)({
  updateData: function updateData(_ref2) {
    var updateElement = _ref2.updateElement,
        element = _ref2.element;
    var historyUpdated = {};
    return function (name, value) {
      var history = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var attrKey = "data.".concat(name);
      var newElement = (0, _dotPropImmutable.set)(element, attrKey, value);

      if (name.startsWith("icon")) {
        var _get4 = (0, _get5.default)(newElement, "data.icon"),
            id = _get4.id,
            width = _get4.width,
            color = _get4.color;

        newElement = (0, _dotPropImmutable.set)(newElement, "data.icon.svg", getSvg(id, {
          width: width,
          color: color
        }));
      }

      if (!history) {
        updateElement({
          element: newElement,
          history: history
        });
        return;
      }

      if (historyUpdated[name] !== value) {
        historyUpdated[name] = value;
        updateElement({
          element: newElement
        });
      }
    };
  }
}), (0, _withHandlers2.default)({
  updateType: function updateType(_ref3) {
    var updateData = _ref3.updateData;
    return function (value) {
      return updateData("type", value);
    };
  },
  updateIcon: function updateIcon(_ref4) {
    var updateData = _ref4.updateData;
    return function (value) {
      return updateData("icon.id", value.id);
    };
  },
  updateIconColor: function updateIconColor(_ref5) {
    var updateData = _ref5.updateData;
    return function (value) {
      return updateData("icon.color", value);
    };
  },
  updateIconColorPreview: function updateIconColorPreview(_ref6) {
    var updateData = _ref6.updateData;
    return function (value) {
      return updateData("icon.color", value, false);
    };
  },
  updateIconWidth: function updateIconWidth(_ref7) {
    var updateData = _ref7.updateData;
    return function (value) {
      return updateData("icon.width", value);
    };
  },
  updateIconPosition: function updateIconPosition(_ref8) {
    var updateData = _ref8.updateData;
    return function (value) {
      return updateData("icon.position", value);
    };
  }
}))(ButtonSettings);

exports.default = _default;
//# sourceMappingURL=ButtonSettings.js.map