"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _Tabs = require("webiny-ui/Tabs");

var _Input = require("webiny-ui/Input");

var _Grid = require("webiny-ui/Grid");

var _code = require("@svgr/webpack!./../../../elementGroups/code/code.svg");

var _createEmbedPlugin = require("./../../utils/oembed/createEmbedPlugin");

var _codesandboxLogo = require("@svgr/webpack!./codesandbox-logo.svg");

var PreviewBox =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e1hswh2u0",
  label: "PreviewBox"
})({
  textAlign: "center",
  height: 50,
  svg: {
    height: 50,
    width: 50
  }
});

var _default = function _default() {
  return [(0, _createEmbedPlugin.createEmbedPlugin)({
    type: "codesandbox",
    toolbar: {
      title: "CodeSandbox",
      group: "cms-element-group-code",
      preview: function preview() {
        return _react.default.createElement(PreviewBox, null, _react.default.createElement(_codesandboxLogo.ReactComponent, null));
      }
    },
    oembed: {
      onData: function onData(data) {
        data.html = data.html.replace(/1000px/g, "100%").replace(/1000/g, "100%");
        return data;
      }
    }
  }), (0, _createEmbedPlugin.createEmbedSettingsPlugin)({
    type: "codesandbox",
    render: function render(_ref) {
      var Bind = _ref.Bind;
      return _react.default.createElement(_Tabs.Tab, {
        icon: _react.default.createElement(_code.ReactComponent, null),
        label: "CodeSandbox"
      }, _react.default.createElement(_Grid.Grid, null, _react.default.createElement(_Grid.Cell, {
        span: 12
      }, _react.default.createElement(Bind, {
        name: "source.url",
        validators: ["required", "url"]
      }, _react.default.createElement(_Input.Input, {
        label: "CodeSandbox URL",
        description: "Enter a CodeSandbox URL"
      })))));
    }
  })];
};

exports.default = _default;
//# sourceMappingURL=index.js.map