"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _pure2 = _interopRequireDefault(require("recompose/pure"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _emotion = require("emotion");

var _redux = require("webiny-app-cms/editor/redux");

var _Button = require("webiny-ui/Button");

var _ElementRoot = require("webiny-app-cms/render/components/ElementRoot");

var _DropZone = _interopRequireDefault(require("webiny-app-cms/editor/components/DropZone"));

var _ConnectedElement = _interopRequireDefault(require("webiny-app-cms/editor/components/ConnectedElement"));

var _baselineAdd_circle24px = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/baseline-add_circle-24px.svg");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var _ColumnChild = _interopRequireDefault(require("./ColumnChild"));

var _ElementAnimation = _interopRequireDefault(require("webiny-app-cms/render/components/ElementAnimation"));

var ColumnContainer =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "er8a0t90",
  label: "ColumnContainer"
})({
  position: "relative",
  flex: "1 100%",
  boxSizing: "border-box",
  height: "100%",
  width: "100%",
  zIndex: 20,
  display: "flex"
});
var addIcon =
/*#__PURE__*/
(0, _emotion.css)({
  color: "var(--mdc-theme-secondary)",
  transition: "transform 0.2s",
  "&:hover": {
    transform: "scale(1.3)"
  },
  "&::before, &::after": {
    display: "none"
  }
}, "label:addIcon;");
var Column = (0, _pure2.default)(function (_ref) {
  var element = _ref.element,
      dropElement = _ref.dropElement,
      togglePlugin = _ref.togglePlugin;
  return _react.default.createElement(_ElementAnimation.default, null, _react.default.createElement(ColumnContainer, {
    style: {
      justifyContent: "center"
    }
  }, _react.default.createElement(_ElementRoot.ElementRoot, {
    element: element,
    className: "webiny-cms-base-element-style webiny-cms-layout-column",
    style: {
      width: "100%",
      display: "flex",
      flexDirection: "column"
    }
  }, _react.default.createElement(_ConnectedElement.default, {
    elementId: element.id
  }, function (_ref2) {
    var id = _ref2.id,
        path = _ref2.path,
        type = _ref2.type,
        elements = _ref2.elements;
    return _react.default.createElement(_react.default.Fragment, null, !elements.length && _react.default.createElement(_DropZone.default.Center, {
      key: id,
      id: id,
      type: type,
      onDrop: dropElement
    }, _react.default.createElement(_Button.IconButton, {
      className: addIcon + " addIcon",
      icon: _react.default.createElement(_baselineAdd_circle24px.ReactComponent, null),
      onClick: togglePlugin
    })), elements.map(function (childId, index) {
      return _react.default.createElement(_ColumnChild.default, {
        key: childId,
        id: childId,
        index: index,
        count: elements.length,
        last: index === elements.length - 1,
        target: {
          id: id,
          path: path,
          type: type
        }
      });
    }));
  }))));
});

var _default = (0, _compose2.default)((0, _redux.connect)(function (state, props) {
  var element = (0, _selectors.getElement)(state, props.element.id);
  return {
    element: (0, _objectSpread2.default)({}, element, {
      elements: element.elements.map(function (id) {
        return (0, _selectors.getElement)(state, id);
      })
    })
  };
}, {
  dropElement: _actions.dropElement,
  togglePlugin: _actions.togglePlugin
}), (0, _withHandlers2.default)({
  togglePlugin: function togglePlugin(_ref3) {
    var _togglePlugin = _ref3.togglePlugin,
        _ref3$element = _ref3.element,
        id = _ref3$element.id,
        path = _ref3$element.path,
        type = _ref3$element.type;
    return function () {
      _togglePlugin({
        name: "cms-toolbar-add-element",
        params: {
          id: id,
          path: path,
          type: type
        }
      });
    };
  },
  dropElement: function dropElement(_ref4) {
    var _dropElement = _ref4.dropElement,
        _ref4$element = _ref4.element,
        id = _ref4$element.id,
        path = _ref4$element.path,
        type = _ref4$element.type;
    return function (source) {
      _dropElement({
        source: source,
        target: {
          id: id,
          path: path,
          type: type,
          position: null
        }
      });
    };
  }
}))(Column);

exports.default = _default;
//# sourceMappingURL=Column.js.map