"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _isEqual = _interopRequireDefault(require("lodash/isEqual"));

var _DropZone = _interopRequireDefault(require("webiny-app-cms/editor/components/DropZone"));

var _Element = _interopRequireDefault(require("webiny-app-cms/editor/components/Element"));

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var ColumnChild = function ColumnChild(_ref) {
  var target = _ref.target,
      element = _ref.element,
      _ref$last = _ref.last,
      last = _ref$last === void 0 ? false : _ref$last,
      dropElementAbove = _ref.dropElementAbove,
      dropElementBelow = _ref.dropElementBelow;
  return React.createElement("div", {
    style: {
      width: "100%",
      position: "relative"
    }
  }, React.createElement(_DropZone.default.Above, {
    type: target.type,
    onDrop: dropElementAbove
  }), React.createElement(_Element.default, {
    id: element.id
  }), last && React.createElement(_DropZone.default.Below, {
    type: target.type,
    onDrop: dropElementBelow
  }));
};

var _default = (0, _compose2.default)((0, _redux.connect)(function (state, props) {
  return {
    element: (0, _selectors.getElement)(state, props.id)
  };
}, {
  dropElement: _actions.dropElement
}, null, {
  areStatePropsEqual: _isEqual.default
}), (0, _withHandlers2.default)({
  dropElementAbove: function dropElementAbove(_ref2) {
    var dropElement = _ref2.dropElement,
        target = _ref2.target,
        index = _ref2.index;
    return function (source) {
      dropElement({
        source: source,
        target: (0, _objectSpread2.default)({}, target, {
          position: index
        })
      });
    };
  },
  dropElementBelow: function dropElementBelow(_ref3) {
    var dropElement = _ref3.dropElement,
        target = _ref3.target,
        count = _ref3.count;
    return function (source) {
      dropElement({
        source: source,
        target: (0, _objectSpread2.default)({}, target, {
          position: count
        })
      });
    };
  }
}))(ColumnChild);

exports.default = _default;
//# sourceMappingURL=ColumnChild.js.map