"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _Tabs = require("webiny-ui/Tabs");

var _dotPropImmutable = require("dot-prop-immutable");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var _Input = _interopRequireDefault(require("webiny-app-cms/editor/plugins/elementSettings/components/Input"));

var _ColorPicker = _interopRequireDefault(require("webiny-app-cms/editor/plugins/elementSettings/components/ColorPicker"));

var _IconPicker = _interopRequireDefault(require("webiny-app-cms/editor/plugins/elementSettings/components/IconPicker"));

var _utils = require("./utils");

var IconSettings = function IconSettings(props) {
  var element = props.element,
      updateIcon = props.updateIcon,
      updateWidth = props.updateWidth,
      updateColor = props.updateColor,
      updateColorPreview = props.updateColorPreview;
  var _element$data = element.data;
  _element$data = _element$data === void 0 ? {} : _element$data;
  var _element$data$icon = _element$data.icon,
      icon = _element$data$icon === void 0 ? {} : _element$data$icon;
  return React.createElement(React.Fragment, null, React.createElement(_Tabs.Tabs, null, React.createElement(_Tabs.Tab, {
    label: "Icon"
  }, React.createElement(_IconPicker.default, {
    label: "Icon",
    value: icon.id,
    updateValue: updateIcon
  }), React.createElement(_Input.default, {
    label: "Width",
    value: icon.width || 50,
    updateValue: updateWidth
  }), React.createElement(_ColorPicker.default, {
    label: "Color",
    value: icon.color,
    updateValue: updateColor,
    updatePreview: updateColorPreview
  }))));
};

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  return {
    element: (0, _selectors.getActiveElement)(state)
  };
}, {
  updateElement: _actions.updateElement
}), (0, _withHandlers2.default)({
  updateSettings: function updateSettings(_ref) {
    var updateElement = _ref.updateElement,
        element = _ref.element;
    var historyUpdated = {};
    return function (name, value) {
      var history = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var attrKey = "data.icon.".concat(name);
      var newElement = (0, _dotPropImmutable.set)(element, attrKey, value);

      var _get = (0, _dotPropImmutable.get)(newElement, "data.icon"),
          id = _get.id,
          width = _get.width,
          color = _get.color;

      newElement = (0, _dotPropImmutable.set)(newElement, "data.icon.svg", (0, _utils.getSvg)(id, {
        width: width,
        color: color
      }));

      if (!history) {
        updateElement({
          element: newElement,
          history: history
        });
        return;
      }

      if (historyUpdated[name] !== value) {
        historyUpdated[name] = value;
        updateElement({
          element: newElement
        });
      }
    };
  }
}), (0, _withHandlers2.default)({
  updateIcon: function updateIcon(_ref2) {
    var updateSettings = _ref2.updateSettings;
    return function (value) {
      return updateSettings("id", value.id);
    };
  },
  updateColor: function updateColor(_ref3) {
    var updateSettings = _ref3.updateSettings;
    return function (value) {
      return updateSettings("color", value);
    };
  },
  updateColorPreview: function updateColorPreview(_ref4) {
    var updateSettings = _ref4.updateSettings;
    return function (value) {
      return updateSettings("color", value, false);
    };
  },
  updateWidth: function updateWidth(_ref5) {
    var updateSettings = _ref5.updateSettings;
    return function (value) {
      return updateSettings("width", value);
    };
  }
}))(IconSettings);

exports.default = _default;
//# sourceMappingURL=IconSettings.js.map