"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getSvg = exports.getIcons = void 0;

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var React = _interopRequireWildcard(require("react"));

var _server = require("react-dom/server");

var _webinyPlugins = require("webiny-plugins");

var icons;

var getIcons = function getIcons() {
  if (!icons) {
    icons = (0, _webinyPlugins.getPlugins)("cms-icons").reduce(function (icons, pl) {
      return icons.concat(pl.getIcons());
    }, []);
  }

  return icons;
};

exports.getIcons = getIcons;

var getSvg = function getSvg(id) {
  var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  if (!props.width) {
    props.width = 50;
  }

  var icon = getIcons().find(function (ic) {
    return (0, _isEqual2.default)(ic.id, id);
  });

  if (!icon) {
    return null;
  }

  return (0, _server.renderToStaticMarkup)(React.cloneElement(icon.svg, props));
};

exports.getSvg = getSvg;
//# sourceMappingURL=utils.js.map