"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var _set2 = _interopRequireDefault(require("lodash/set"));

var _pure2 = _interopRequireDefault(require("recompose/pure"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _isnumeric = _interopRequireDefault(require("isnumeric"));

var _components = require("webiny-app/components");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var _components2 = require("webiny-admin/components");

var position = {
  left: "flex-start",
  center: "center",
  right: "flex-end"
};
var AlignImage =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e1eby0890",
  label: "AlignImage"
})(function (props) {
  return {
    img: {
      alignSelf: position[props.align]
    }
  };
});
var ImageContainer = (0, _pure2.default)(function (props) {
  var horizontalAlign = props.horizontalAlign,
      onChange = props.onChange;
  var image = (0, _objectSpread2.default)({}, props.image);
  var imgStyle = {};

  if (image.width) {
    var width = image.width;
    imgStyle.width = (0, _isnumeric.default)(width) ? parseInt(width) : width;
  }

  if (image.height) {
    var height = image.height;
    imgStyle.height = (0, _isnumeric.default)(height) ? parseInt(height) : height;
  }

  return React.createElement(AlignImage, {
    align: horizontalAlign
  }, React.createElement(_components.SingleImageUpload, {
    renderImagePreview: function renderImagePreview(props) {
      return React.createElement(_components.Image, (0, _extends2.default)({}, props, {
        style: imgStyle,
        srcSet: "auto"
      }));
    },
    onChange: onChange,
    value: image,
    showRemoveImageButton: false
  }));
});

var _default = (0, _compose2.default)((0, _redux.connect)(function (state, _ref) {
  var elementId = _ref.elementId;
  var element = (0, _selectors.getElement)(state, elementId);
  var _element$data = element.data,
      _element$data$image = _element$data.image,
      image = _element$data$image === void 0 ? {} : _element$data$image,
      _element$data$setting = _element$data.settings,
      settings = _element$data$setting === void 0 ? {} : _element$data$setting;
  return {
    element: {
      id: element.id,
      type: element.type,
      path: element.path
    },
    image: image,
    horizontalAlign: settings.horizontalAlign || "center"
  };
}, {
  updateElement: _actions.updateElement
}, null, {
  areStatePropsEqual: _isEqual2.default
}), (0, _components.withFileUpload)(), (0, _components2.withSnackbar)(), (0, _withHandlers2.default)({
  onChange: function onChange(_ref2) {
    var uploadFile = _ref2.uploadFile,
        updateElement = _ref2.updateElement,
        element = _ref2.element,
        showSnackbar = _ref2.showSnackbar;
    return (
      /*#__PURE__*/
      function () {
        var _ref3 = (0, _asyncToGenerator2.default)(
        /*#__PURE__*/
        _regenerator.default.mark(function _callee(data) {
          var response;
          return _regenerator.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.prev = 0;
                  _context.next = 3;
                  return uploadFile(data);

                case 3:
                  response = _context.sent;
                  updateElement({
                    element: (0, _set2.default)(element, "data.image", response),
                    merge: true
                  });
                  showSnackbar("File uploaded successfully.");
                  _context.next = 11;
                  break;

                case 8:
                  _context.prev = 8;
                  _context.t0 = _context["catch"](0);
                  showSnackbar("Ooops, something went wrong.");

                case 11:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this, [[0, 8]]);
        }));

        return function (_x) {
          return _ref3.apply(this, arguments);
        };
      }()
    );
  }
}))(ImageContainer);

exports.default = _default;
//# sourceMappingURL=ImageContainer.js.map