"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _get3 = _interopRequireDefault(require("lodash/get"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _dotPropImmutable = require("dot-prop-immutable");

var _Tabs = require("webiny-ui/Tabs");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var _Input = _interopRequireDefault(require("webiny-app-cms/editor/plugins/elementSettings/components/Input"));

var _roundImage24px = require("@svgr/webpack!./round-image-24px.svg");

var ImageSettings = function ImageSettings(_ref) {
  var element = _ref.element,
      updateTitle = _ref.updateTitle,
      updateWidth = _ref.updateWidth,
      updateHeight = _ref.updateHeight;

  var _get2 = (0, _get3.default)(element, "data", {}),
      _get2$image = _get2.image,
      image = _get2$image === void 0 ? {} : _get2$image;

  return React.createElement(_Tabs.Tabs, null, React.createElement(_Tabs.Tab, {
    icon: React.createElement(_roundImage24px.ReactComponent, null),
    label: "Image"
  }, React.createElement(_Input.default, {
    label: "Title",
    value: image.title || "",
    updateValue: updateTitle,
    inputWidth: "max-content"
  }), React.createElement(_Input.default, {
    label: "Width",
    placeholder: "auto",
    description: "eg. 300 or 50%",
    value: image.width || "",
    updateValue: updateWidth,
    inputWidth: 80
  }), React.createElement(_Input.default, {
    label: "Height",
    placeholder: "auto",
    description: "eg. 300 or 50%",
    value: image.height || "",
    updateValue: updateHeight,
    inputWidth: 80
  })));
};

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  return {
    element: (0, _selectors.getActiveElement)(state)
  };
}, {
  updateElement: _actions.updateElement
}), (0, _withHandlers2.default)({
  updateData: function updateData(_ref2) {
    var updateElement = _ref2.updateElement,
        element = _ref2.element;
    var historyUpdated = {};
    return function (name, value) {
      var history = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var attrKey = "data.image.".concat(name);
      var newElement = (0, _dotPropImmutable.set)(element, attrKey, value);

      if (!history) {
        updateElement({
          element: newElement,
          history: history
        });
        return;
      }

      if (historyUpdated[name] !== value) {
        historyUpdated[name] = value;
        updateElement({
          element: newElement
        });
      }
    };
  }
}), (0, _withHandlers2.default)({
  updateTitle: function updateTitle(_ref3) {
    var updateData = _ref3.updateData;
    return function (value) {
      return updateData("title", value);
    };
  },
  updateAlt: function updateAlt(_ref4) {
    var updateData = _ref4.updateData;
    return function (value) {
      return updateData("alt", value);
    };
  },
  updateWidth: function updateWidth(_ref5) {
    var updateData = _ref5.updateData;
    return function (value) {
      return updateData("width", value);
    };
  },
  updateHeight: function updateHeight(_ref6) {
    var updateData = _ref6.updateData;
    return function (value) {
      return updateData("height", value);
    };
  },
  updateAlign: function updateAlign(_ref7) {
    var updateData = _ref7.updateData;
    return function (value) {
      return updateData("align", value);
    };
  }
}))(ImageSettings);

exports.default = _default;
//# sourceMappingURL=ImageSettings.js.map