"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _react = _interopRequireDefault(require("react"));

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _webinyPlugins = require("webiny-plugins");

var _redux = require("webiny-app-cms/editor/redux");

var _actions = require("webiny-app-cms/editor/actions");

var _roundImage24px = require("@svgr/webpack!./round-image-24px.svg");

var _ImageSettings = _interopRequireDefault(require("./ImageSettings"));

var _Image = _interopRequireDefault(require("./Image"));

var _Action = _interopRequireDefault(require("../../elementSettings/components/Action"));

var _default = function _default() {
  var PreviewBox =
  /*#__PURE__*/
  (0, _reactEmotion.default)("div", {
    target: "e1cozauj0",
    label: "PreviewBox"
  })({
    textAlign: "center",
    height: 50,
    svg: {
      height: 50,
      width: 50
    }
  });
  return [{
    name: "cms-element-image",
    type: "cms-element",
    toolbar: {
      title: "Image",
      group: "cms-element-group-basic",
      preview: function preview() {
        return _react.default.createElement(PreviewBox, null, _react.default.createElement(_roundImage24px.ReactComponent, null));
      }
    },
    settings: ["cms-element-settings-image", ["cms-element-settings-background", {
      image: false
    }], "cms-element-settings-link", "", "cms-element-settings-border", "cms-element-settings-shadow", "", ["cms-element-settings-horizontal-align", {
      alignments: ["left", "center", "right"]
    }], "cms-element-settings-padding", "cms-element-settings-margin", "", "cms-element-settings-clone", "cms-element-settings-delete", ""],
    target: ["cms-element-column", "cms-element-row"],
    init: function init() {
      (0, _redux.addMiddleware)([_actions.ELEMENT_CREATED], function (_ref) {
        var action = _ref.action,
            next = _ref.next;
        var _action$payload = action.payload,
            element = _action$payload.element,
            source = _action$payload.source;
        next(action);

        if (element.type !== "cms-element-image") {
          return;
        } // Check the source of the element (could be `saved` element which behaves differently from other elements)


        var imagePlugin = (0, _webinyPlugins.getPlugin)(source.type);

        if (!imagePlugin) {
          return;
        }

        var onCreate = imagePlugin.onCreate;

        if (!onCreate || onCreate !== "skip") {
          // If source element does not define a specific `onCreate` behavior - continue with the actual element plugin
          var image = document.querySelector("#".concat(window.CSS.escape(element.id), " [data-role=\"select-image\"]"));

          if (image) {
            image.click();
          }
        }
      });
    },
    create: function create(options) {
      return (0, _objectSpread2.default)({
        type: "cms-element-image",
        elements: [],
        data: {
          settings: {
            horizontalAlign: "center",
            margin: {
              desktop: {
                all: 0
              },
              mobile: {
                top: 0,
                left: 0,
                right: 0,
                bottom: 15
              },
              advanced: true
            },
            padding: {
              desktop: {
                all: 0
              },
              mobile: {
                all: 0
              }
            }
          }
        }
      }, options);
    },
    render: function render(_ref2) {
      var element = _ref2.element;
      return _react.default.createElement(_Image.default, {
        element: element
      });
    }
  }, {
    name: "cms-element-settings-image",
    type: "cms-element-settings",
    renderAction: function renderAction() {
      return _react.default.createElement(_Action.default, {
        plugin: this.name,
        tooltip: "Image",
        icon: _react.default.createElement(_roundImage24px.ReactComponent, null)
      });
    },
    renderMenu: function renderMenu() {
      return _react.default.createElement(_ImageSettings.default, null);
    }
  }];
};

exports.default = _default;
//# sourceMappingURL=index.js.map