"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _Tabs = require("webiny-ui/Tabs");

var _Input = require("webiny-ui/Input");

var _Grid = require("webiny-ui/Grid");

var _createEmbedPlugin = require("./../../utils/oembed/createEmbedPlugin");

var _roundMusic_video24px = require("@svgr/webpack!./../../../elementGroups/media/round-music_video-24px.svg");

var _VimeoEmbed = _interopRequireDefault(require("./VimeoEmbed"));

var _vimeoVBrands = require("@svgr/webpack!./vimeo-v-brands.svg");

var PreviewBox =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "ehed920",
  label: "PreviewBox"
})({
  textAlign: "center",
  height: 50,
  svg: {
    height: 50,
    width: 50
  }
});

var _default = function _default() {
  return [(0, _createEmbedPlugin.createEmbedPlugin)({
    type: "vimeo",
    toolbar: {
      title: "Vimeo",
      group: "cms-element-group-media",
      preview: function preview() {
        return _react.default.createElement(PreviewBox, null, _react.default.createElement(_vimeoVBrands.ReactComponent, null));
      }
    },
    oembed: {
      renderEmbed: function renderEmbed(props) {
        return _react.default.createElement(_VimeoEmbed.default, props);
      }
    },
    renderElementPreview: function renderElementPreview() {
      return _react.default.createElement("div", null, "Vimeo video");
    }
  }), (0, _createEmbedPlugin.createEmbedSettingsPlugin)({
    type: "vimeo",
    render: function render(_ref) {
      var Bind = _ref.Bind;
      return _react.default.createElement(_Tabs.Tab, {
        icon: _react.default.createElement(_roundMusic_video24px.ReactComponent, null),
        label: "Vimeo"
      }, _react.default.createElement(_Grid.Grid, null, _react.default.createElement(_Grid.Cell, {
        span: 12
      }, _react.default.createElement(Bind, {
        name: "source.url",
        validators: ["required", "url"]
      }, _react.default.createElement(_Input.Input, {
        label: "Video URL",
        description: "Enter a video URL"
      })))));
    }
  })];
};

exports.default = _default;
//# sourceMappingURL=index.js.map