"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var _emotion = require("emotion");

var _dotPropImmutable = require("dot-prop-immutable");

var outerWrapper =
/*#__PURE__*/
(0, _emotion.css)({
  boxSizing: "border-box"
}, "label:outerWrapper;");
var innerWrapper =
/*#__PURE__*/
(0, _emotion.css)({
  left: 0,
  width: "100%",
  height: "auto",
  position: "relative",
  paddingBottom: 0
}, "label:innerWrapper;");
var scaleableVideo =
/*#__PURE__*/
(0, _emotion.css)((0, _defineProperty2.default)({
  position: "relative",
  height: 0,
  paddingTop: "56.25%",
  width: "100%",
  backgroundColor: "#000"
}, "iframe", {
  maxWidth: "100%",
  border: "none",
  display: "block",
  height: "100%",
  margin: 0,
  padding: 0,
  position: "absolute",
  top: 0,
  width: "100%"
}), "label:scaleableVideo;");

var YoutubeEmbed = function YoutubeEmbed(props) {
  var element = props.element,
      data = props.data;

  if (data && data.loading) {
    return "Loading Youtube data...";
  }

  return React.createElement("div", {
    className: "webiny-cms-base-element-style webiny-cms-element-embed-youtube " + outerWrapper
  }, React.createElement("div", {
    className: innerWrapper
  }, React.createElement("div", {
    id: element.id,
    className: [scaleableVideo, "cms-editor-dragging--disabled", "cms-editor-resizing--disabled"].join(" "),
    dangerouslySetInnerHTML: {
      __html: (0, _dotPropImmutable.get)(element, "data.oembed.html") || ""
    }
  })));
};

var _default = YoutubeEmbed;
exports.default = _default;
//# sourceMappingURL=YoutubeEmbed.js.map