"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _Tabs = require("webiny-ui/Tabs");

var _Input = require("webiny-ui/Input");

var _Grid = require("webiny-ui/Grid");

var _oembed = require("./../../utils/oembed");

var _roundMusic_video24px = require("@svgr/webpack!./../../../elementGroups/media/round-music_video-24px.svg");

var _YoutubeEmbed = _interopRequireDefault(require("./YoutubeEmbed"));

var _placeholder = _interopRequireDefault(require("./placeholder.png"));

var _youtubeBrands = require("@svgr/webpack!./youtube-brands.svg");

var PreviewBox =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e10mcv9p0",
  label: "PreviewBox"
})({
  textAlign: "center",
  height: 50,
  svg: {
    height: 50,
    width: 50
  }
});

var _default = function _default() {
  return [(0, _oembed.createEmbedPlugin)({
    type: "youtube",
    toolbar: {
      title: "Youtube",
      group: "cms-element-group-media",
      preview: function preview() {
        return _react.default.createElement(PreviewBox, null, _react.default.createElement(_youtubeBrands.ReactComponent, null));
      }
    },
    onCreate: "open-settings",
    oembed: {
      renderEmbed: function renderEmbed(props) {
        return _react.default.createElement(_YoutubeEmbed.default, props);
      }
    },
    renderElementPreview: function renderElementPreview(_ref) {
      var width = _ref.width,
          height = _ref.height;
      return _react.default.createElement("img", {
        style: {
          width: width,
          height: height
        },
        src: _placeholder.default,
        alt: "Youtube"
      });
    }
  }), (0, _oembed.createEmbedSettingsPlugin)({
    type: "youtube",
    render: function render(_ref2) {
      var Bind = _ref2.Bind;
      return _react.default.createElement(_Tabs.Tab, {
        icon: _react.default.createElement(_roundMusic_video24px.ReactComponent, null),
        label: "YouTube"
      }, _react.default.createElement(_Grid.Grid, null, _react.default.createElement(_Grid.Cell, {
        span: 12
      }, _react.default.createElement(Bind, {
        name: "source.url",
        validators: ["required", "url"]
      }, _react.default.createElement(_Input.Input, {
        label: "Video URL",
        description: "Enter a video URL"
      })))));
    }
  })];
};

exports.default = _default;
//# sourceMappingURL=index.js.map