"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _pure2 = _interopRequireDefault(require("recompose/pure"));

var React = _interopRequireWildcard(require("react"));

var _reactApollo = require("react-apollo");

var _context = require("webiny-app-cms/context");

var _graphql = require("./graphql");

var _webinyPlugins = require("webiny-plugins");

var PagesList = (0, _pure2.default)(function () {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$data = _ref.data,
      data = _ref$data === void 0 ? {} : _ref$data,
      theme = _ref.cms.theme;

  var component = data.component,
      vars = (0, _objectWithoutProperties2.default)(data, ["component"]);
  var components = (0, _webinyPlugins.getPlugins)("cms-element-pages-list-component");
  var pageList = components.find(function (cmp) {
    return cmp.name === component;
  });

  if (!pageList) {
    return "Selected page list component not found!";
  }

  var ListComponent = pageList.component;

  if (!ListComponent) {
    return "You must select a component to render your list!";
  }

  var sort = null;

  if (vars.sortBy) {
    sort = (0, _defineProperty2.default)({}, vars.sortBy, vars.sortDirection || -1);
  }

  var variables = {
    category: vars.category,
    sort: sort,
    tags: vars.tags,
    tagsRule: vars.tagsRule,
    perPage: parseInt(vars.resultsPerPage),
    pagesLimit: parseInt(vars.pagesLimit),
    page: 1
  };
  return React.createElement(_reactApollo.Query, {
    query: _graphql.loadPages,
    variables: variables
  }, function (_ref2) {
    var data = _ref2.data,
        loading = _ref2.loading,
        refetch = _ref2.refetch;

    if (loading) {
      return "Loading...";
    }

    var pages = data.cms.listPublishedPages;

    if (!pages || !pages.data.length) {
      return "No pages match the criteria.";
    }

    var prevPage = null;

    if (pages.meta.previousPage !== null) {
      prevPage = function prevPage() {
        return refetch((0, _objectSpread2.default)({}, variables, {
          page: pages.meta.previousPage
        }));
      };
    }

    var nextPage = null;

    if (pages.meta.nextPage !== null) {
      if (!variables.pagesLimit || variables.pagesLimit >= pages.meta.nextPage) {
        nextPage = function nextPage() {
          return refetch((0, _objectSpread2.default)({}, variables, {
            page: pages.meta.nextPage
          }));
        };
      }
    }

    return React.createElement(ListComponent, (0, _extends2.default)({}, pages, {
      nextPage: nextPage,
      prevPage: prevPage,
      theme: theme
    }));
  });
});

var _default = (0, _context.withCms)()(PagesList);

exports.default = _default;
//# sourceMappingURL=PagesList.js.map