"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _Grid = require("webiny-ui/Grid");

var _Input = require("webiny-ui/Input");

var _Select = require("webiny-ui/Select");

var _context = require("webiny-app-cms/context");

var _PagesList = _interopRequireDefault(require("./PagesList"));

var _webinyPlugins = require("webiny-plugins");

var PagesListDesignSettings = function PagesListDesignSettings(_ref) {
  var theme = _ref.cms.theme,
      Bind = _ref.Bind,
      data = _ref.data;
  var components = (0, _webinyPlugins.getPlugins)("cms-element-pages-list-component");
  return React.createElement(React.Fragment, null, React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
    span: 6
  }, React.createElement(Bind, {
    name: "component",
    defaultValue: components[0] ? components[0].name : null
  }, React.createElement(_Select.Select, {
    label: "Design",
    description: "Select a component to render the list"
  }, components.map(function (cmp) {
    return React.createElement("option", {
      key: cmp.name,
      value: cmp.name
    }, cmp.title);
  })))), React.createElement(_Grid.Cell, {
    span: 6
  }, React.createElement(Bind, {
    name: "resultsPerPage",
    defaultValue: 10,
    validators: ["numeric"]
  }, React.createElement(_Input.Input, {
    label: "Results per page"
  })))), React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
    span: 12,
    style: {
      overflowY: "scroll"
    }
  }, React.createElement(_PagesList.default, {
    data: data,
    theme: theme
  }))));
};

var _default = (0, _context.withCms)()(PagesListDesignSettings);

exports.default = _default;
//# sourceMappingURL=PagesListDesignSettings.js.map