"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _Grid = require("webiny-ui/Grid");

var _Input = require("webiny-ui/Input");

var _Select = require("webiny-ui/Select");

var _context = require("webiny-app-cms/context");

var _components = require("webiny-app-cms/admin/components");

var PagesListFilterSettings = function PagesListFilterSettings(_ref) {
  var Bind = _ref.Bind;
  return React.createElement(React.Fragment, null, React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
    span: 6
  }, React.createElement(Bind, {
    name: "category"
  }, React.createElement(_components.CategoriesAutoComplete, {
    label: "Category"
  }))), React.createElement(_Grid.Cell, {
    span: 6
  }, React.createElement(Bind, {
    name: "pagesLimit",
    validators: "numeric"
  }, React.createElement(_Input.Input, {
    label: "Number of pages to show",
    description: "Leave empty to show all"
  }))), React.createElement(_Grid.Cell, {
    span: 6
  }, React.createElement(Bind, {
    name: "sortBy",
    defaultValue: "publishedOn"
  }, React.createElement(_Select.Select, {
    label: "Sort by"
  }, React.createElement("option", {
    value: "publishedOn"
  }, "Publishing date"), React.createElement("option", {
    value: "title"
  }, "Title")))), React.createElement(_Grid.Cell, {
    span: 6
  }, React.createElement(Bind, {
    name: "sortDirection",
    defaultValue: -1
  }, React.createElement(_Select.Select, {
    label: "Sort direction"
  }, React.createElement("option", {
    value: -1
  }, "Descending"), React.createElement("option", {
    value: 1
  }, "Ascending")))), React.createElement(_Grid.Cell, {
    span: 6
  }, React.createElement(Bind, {
    name: "tags"
  }, React.createElement(_components.TagsMultiAutoComplete, {
    label: "Filter by tags",
    description: "Enter tags to filter pages"
  }))), React.createElement(_Grid.Cell, {
    span: 6
  }, React.createElement(Bind, {
    name: "tagsRule",
    defaultValue: "ALL"
  }, React.createElement(_Select.Select, {
    label: "Filter by tags rule"
  }, React.createElement("option", {
    value: "ALL"
  }, "Page must include all tags"), React.createElement("option", {
    value: "ANY"
  }, "Page must include any of the tags"))))));
};

var _default = (0, _context.withCms)()(PagesListFilterSettings);

exports.default = _default;
//# sourceMappingURL=PagesListFilterSettings.js.map