"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.loadPages = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    query ListPublishedPages(\n        $category: String\n        $sort: PageSortInput\n        $tags: [String]\n        $tagsRule: TagsRule\n        $page: Int\n        $perPage: Int\n    ) {\n        cms {\n            listPublishedPages(\n                category: $category\n                sort: $sort\n                tags: $tags\n                tagsRule: $tagsRule\n                page: $page\n                perPage: $perPage\n            ) {\n                data {\n                    id\n                    title\n                    url\n                    snippet\n                    publishedOn\n                    settings {\n                        general {\n                            image {\n                                src\n                            }\n                        }\n                    }\n                    createdBy {\n                        firstName\n                        lastName\n                    }\n                    category {\n                        id\n                        name\n                    }\n                }\n                meta {\n                    from\n                    to\n                    nextPage\n                    previousPage\n                    page\n                    perPage\n                    totalCount\n                    totalPages\n                }\n            }\n        }\n    }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

/*, $sortBy: String, $sortDirection: String*/
var loadPages = (0, _graphqlTag.default)(_templateObject());
exports.loadPages = loadPages;
//# sourceMappingURL=graphql.js.map