"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _react = _interopRequireDefault(require("react"));

var _Tabs = require("webiny-ui/Tabs");

var _roundStyle24px = require("@svgr/webpack!./icons/round-style-24px.svg");

var _roundFilter_list24px = require("@svgr/webpack!./icons/round-filter_list-24px.svg");

var _pageListIcon = require("@svgr/webpack!./page-list-icon.svg");

var _PagesList = _interopRequireDefault(require("./PagesList"));

var _PagesListFilterSettings = _interopRequireDefault(require("./PagesListFilterSettings"));

var _PagesListDesignSettings = _interopRequireDefault(require("./PagesListDesignSettings"));

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _default = function _default() {
  var PreviewBox =
  /*#__PURE__*/
  (0, _reactEmotion.default)("div", {
    target: "e6ntwe30",
    label: "PreviewBox"
  })({
    textAlign: "center",
    margin: "0 auto",
    width: 100,
    svg: {
      width: 100
    }
  });
  return [{
    name: "cms-element-pages-list",
    type: "cms-element",
    toolbar: {
      title: "List of pages",
      group: "cms-element-group-basic",
      preview: function preview() {
        return _react.default.createElement(PreviewBox, null, _react.default.createElement(_pageListIcon.ReactComponent, null));
      }
    },
    settings: ["cms-element-settings-delete"],
    target: ["cms-element-row", "cms-element-column"],
    onCreate: "open-settings",
    create: function create() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      return (0, _objectSpread2.default)({
        type: "cms-element-pages-list",
        data: {
          limit: 3,
          component: "default",
          settings: {
            margin: {
              desktop: {
                all: 0
              },
              mobile: {
                all: 0
              }
            },
            padding: {
              desktop: {
                all: 0
              },
              mobile: {
                all: 0
              }
            }
          }
        }
      }, options);
    },
    render: function render(_ref) {
      var element = _ref.element;
      return _react.default.createElement(_PagesList.default, {
        data: element.data
      });
    }
  }, {
    name: "cms-element-advanced-settings-pages-list-filter",
    type: "cms-element-advanced-settings",
    element: "cms-element-pages-list",
    render: function render(props) {
      return _react.default.createElement(_Tabs.Tab, {
        icon: _react.default.createElement(_roundFilter_list24px.ReactComponent, null),
        label: "Filter"
      }, _react.default.createElement(_PagesListFilterSettings.default, (0, _extends2.default)({}, props, {
        filter: true
      })));
    }
  }, {
    name: "cms-element-advanced-settings-pages-list-design",
    type: "cms-element-advanced-settings",
    element: "cms-element-pages-list",
    render: function render(props) {
      return _react.default.createElement(_Tabs.Tab, {
        icon: _react.default.createElement(_roundStyle24px.ReactComponent, null),
        label: "Design"
      }, _react.default.createElement(_PagesListDesignSettings.default, (0, _extends2.default)({}, props, {
        design: true
      })));
    }
  }];
};

exports.default = _default;
//# sourceMappingURL=index.js.map