"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _pure2 = _interopRequireDefault(require("recompose/pure"));

var _react = _interopRequireDefault(require("react"));

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var Handle = (0, _pure2.default)(
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e128idxe0",
  label: "Handle"
})(function (_ref) {
  var isResizing = _ref.isResizing;
  return {
    position: "absolute",
    left: -5,
    top: "10%",
    height: "80%",
    minHeight: 25,
    translate: "width 0.5s",
    zIndex: 30,
    width: 10,
    borderRadius: 10,
    cursor: "col-resize",
    backgroundColor: isResizing ? "var(--mdc-theme-primary)" : "var(--mdc-theme-secondary)",
    display: "none",
    transition: "background-color 0.5s, opacity 0.2s",
    opacity: 0.2,
    "&:hover": {
      opacity: 1
    }
  };
}));
var RatioContainer = (0, _pure2.default)(
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e128idxe1",
  label: "RatioContainer"
})({
  position: "absolute",
  top: -12,
  transform: "translateX(-50%)",
  color: "#fff",
  fontSize: 12,
  backgroundColor: "var(--mdc-theme-secondary)",
  padding: 5,
  borderRadius: 5,
  zIndex: 10
}));
var Ratio = (0, _pure2.default)(function (_ref2) {
  var left = _ref2.left,
      right = _ref2.right;
  return _react.default.createElement(RatioContainer, null, left.toFixed(1), _react.default.createElement("small", null, "%"), " / ", right.toFixed(1), _react.default.createElement("small", null, "%"));
});
var ResizeHandle = (0, _pure2.default)(function (_ref3) {
  var leftWidth = _ref3.leftWidth,
      rightWidth = _ref3.rightWidth,
      props = (0, _objectWithoutProperties2.default)(_ref3, ["leftWidth", "rightWidth"]);
  return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(Handle, (0, _extends2.default)({
    className: "resize-handle"
  }, props)), props.isResizing && _react.default.createElement(Ratio, {
    left: leftWidth,
    right: rightWidth
  }));
});
var _default = ResizeHandle;
exports.default = _default;
//# sourceMappingURL=ResizeHandle.js.map