"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _setDisplayName2 = _interopRequireDefault(require("recompose/setDisplayName"));

var _pure2 = _interopRequireDefault(require("recompose/pure"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _emotion = require("emotion");

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _DropZone = _interopRequireDefault(require("webiny-app-cms/editor/components/DropZone"));

var _Resizer = _interopRequireDefault(require("webiny-app-cms/editor/components/Resizer"));

var _Element = _interopRequireDefault(require("webiny-app-cms/editor/components/Element"));

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var _ResizeHandle = _interopRequireDefault(require("./ResizeHandle"));

var ColumnContainer =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e1n3w9js0",
  label: "ColumnContainer"
})({
  position: "relative",
  display: "flex",
  "&:hover": {
    ">.resize-handle": {
      display: "block !important"
    }
  }
});
var noPointer =
/*#__PURE__*/
(0, _emotion.css)({
  "> *": {
    pointerEvents: "none"
  }
}, "label:noPointer;");
var RowChild = (0, _pure2.default)(function (_ref) {
  var target = _ref.target,
      resizing = _ref.resizing,
      element = _ref.element,
      index = _ref.index,
      leftElement = _ref.leftElement,
      _ref$last = _ref.last,
      last = _ref$last === void 0 ? false : _ref$last,
      dropElementLeft = _ref.dropElementLeft,
      dropElementRight = _ref.dropElementRight,
      resizeStart = _ref.resizeStart,
      resizeStop = _ref.resizeStop,
      resize = _ref.resize;
  return React.createElement(ColumnContainer, {
    "data-type": "row-column-container",
    style: {
      width: (element.data.width || 100) + "%",
      position: "relative"
    }
  }, index > 0 && React.createElement(_Resizer.default, {
    axis: "x",
    onResizeStart: resizeStart,
    onResizeStop: resizeStop,
    onResize: resize
  }, function (resizeProps) {
    return React.createElement(_ResizeHandle.default, (0, _extends2.default)({}, resizeProps, {
      leftWidth: leftElement.data.width,
      rightWidth: element.data.width
    }));
  }), React.createElement(_DropZone.default.Left, {
    type: target.type,
    onDrop: dropElementLeft
  }), React.createElement(_Element.default, {
    id: element.id,
    className: resizing && noPointer
  }), last && React.createElement(_DropZone.default.Right, {
    type: target.type,
    onDrop: dropElementRight
  }));
});

var _default = (0, _compose2.default)((0, _setDisplayName2.default)("RowChild"), (0, _redux.connect)(function (state) {
  return {
    isDragging: (0, _selectors.getIsDragging)(state)
  };
}, {
  dropElement: _actions.dropElement
}), (0, _withHandlers2.default)({
  resizeStart: function resizeStart(_ref2) {
    var onResizeStart = _ref2.onResizeStart,
        element = _ref2.element,
        leftElement = _ref2.leftElement;
    return function () {
      onResizeStart(leftElement, element);
    };
  },
  resizeStop: function resizeStop(_ref3) {
    var onResizeStop = _ref3.onResizeStop;
    return function () {
      return onResizeStop();
    };
  },
  resize: function resize(_ref4) {
    var onResize = _ref4.onResize;
    return function (diff) {
      return onResize(diff);
    };
  },
  dropElementLeft: function dropElementLeft(_ref5) {
    var dropElement = _ref5.dropElement,
        target = _ref5.target,
        index = _ref5.index;
    return function (source) {
      dropElement({
        source: source,
        target: (0, _objectSpread2.default)({}, target, {
          position: index
        })
      });
    };
  },
  dropElementRight: function dropElementRight(_ref6) {
    var dropElement = _ref6.dropElement,
        target = _ref6.target,
        count = _ref6.count;
    return function (source) {
      dropElement({
        source: source,
        target: (0, _objectSpread2.default)({}, target, {
          position: count
        })
      });
    };
  }
}))(RowChild);

exports.default = _default;
//# sourceMappingURL=RowChild.js.map