"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _setDisplayName2 = _interopRequireDefault(require("recompose/setDisplayName"));

var _withState2 = _interopRequireDefault(require("recompose/withState"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var React = _interopRequireWildcard(require("react"));

var _emotion = require("emotion");

var _redux = require("webiny-app-cms/editor/redux");

var _dotPropImmutable = require("dot-prop-immutable");

var _selectors = require("webiny-app-cms/editor/selectors");

var _actions = require("webiny-app-cms/editor/actions");

var _actions2 = require("./actions");

var _RowChild = _interopRequireDefault(require("./RowChild"));

var innerElement =
/*#__PURE__*/
(0, _emotion.css)({
  position: "relative",
  display: "flex",
  flex: "1 100%",
  boxSizing: "border-box"
}, "label:innerElement;");

var RowContainer = function RowContainer(_ref) {
  var element = _ref.element,
      getRef = _ref.getRef,
      onResizeStart = _ref.onResizeStart,
      onResizeStop = _ref.onResizeStop,
      onResize = _ref.onResize,
      width = _ref.width,
      resizing = _ref.resizing;
  var ref = getRef();
  var id = element.id,
      path = element.path,
      type = element.type,
      elements = element.elements;
  return React.createElement("div", {
    ref: ref,
    className: innerElement
  }, elements.map(function (childElement, index) {
    var last = index === elements.length - 1;
    var leftElement = index > 0 && elements[index - 1];

    if (resizing) {
      if (resizing.left.id === childElement.id) {
        childElement = (0, _dotPropImmutable.set)(childElement, "data.width", width.left);
      }

      if (resizing.right.id === childElement.id) {
        childElement = (0, _dotPropImmutable.set)(childElement, "data.width", width.right);
        leftElement = (0, _dotPropImmutable.set)(leftElement, "data.width", width.left);
      }
    }

    return React.createElement(_RowChild.default, {
      key: childElement.id,
      resizing: resizing,
      element: childElement,
      index: index,
      leftElement: leftElement,
      count: elements.length,
      last: last,
      target: {
        id: id,
        path: path,
        type: type
      },
      onResizeStart: onResizeStart,
      onResizeStop: onResizeStop,
      onResize: onResize
    });
  }));
};

var _default = (0, _compose2.default)((0, _setDisplayName2.default)("RowContainer"), (0, _redux.connect)(function (state, props) {
  var element = (0, _selectors.getElement)(state, props.elementId);
  return {
    element: (0, _objectSpread2.default)({}, element, {
      elements: element.elements.map(function (id) {
        return (0, _selectors.getElement)(state, id);
      })
    })
  };
}, {
  updateElement: _actions.updateElement,
  resizeStart: _actions2.resizeStart,
  resizeStop: _actions2.resizeStop
}, null, {
  areStatePropsEqual: _isEqual2.default
}), (0, _withState2.default)("resizing", "setResizing", false), (0, _withState2.default)("width", "setWidth", null), (0, _withHandlers2.default)(function () {
  var rowRef = React.createRef();
  return {
    getRef: function getRef() {
      return function () {
        return rowRef;
      };
    }
  };
}), (0, _withHandlers2.default)({
  onResizeStart: function onResizeStart(_ref2) {
    var setResizing = _ref2.setResizing,
        setWidth = _ref2.setWidth,
        resizeStart = _ref2.resizeStart;
    return function (leftElement, rightElement) {
      resizeStart();
      setResizing({
        left: leftElement,
        right: rightElement
      });
      setWidth({
        left: leftElement.data.width,
        right: rightElement.data.width
      });
    };
  },
  onResizeStop: function onResizeStop(_ref3) {
    var resizeStop = _ref3.resizeStop,
        updateElement = _ref3.updateElement,
        setResizing = _ref3.setResizing,
        setWidth = _ref3.setWidth,
        resizing = _ref3.resizing,
        width = _ref3.width;
    return function () {
      var left = resizing.left,
          right = resizing.right;
      setResizing(false);
      updateElement({
        element: (0, _dotPropImmutable.set)(left, "data.width", width.left)
      });
      updateElement({
        element: (0, _dotPropImmutable.set)(right, "data.width", width.right)
      });
      setWidth(null);
      resizeStop();
    };
  },
  onResize: function onResize(_ref4) {
    var getRef = _ref4.getRef,
        width = _ref4.width,
        setWidth = _ref4.setWidth;
    return function (diff) {
      var change = parseFloat((diff / getRef().current.offsetWidth * 100).toFixed(2));
      var totalWidth = width.left + width.right; // Apply the change

      var rightWidth = width.right + change;
      var leftWidth = totalWidth - rightWidth;

      if (rightWidth < 10) {
        rightWidth = 10;
        leftWidth = totalWidth - rightWidth;
      }

      if (leftWidth < 10) {
        leftWidth = 10;
        rightWidth = totalWidth - leftWidth;
      }

      setWidth({
        left: leftWidth,
        right: rightWidth
      });
    };
  }
}))(RowContainer);

exports.default = _default;
//# sourceMappingURL=RowContainer.js.map