"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _Tabs = require("webiny-ui/Tabs");

var _Input = require("webiny-ui/Input");

var _Grid = require("webiny-ui/Grid");

var _roundPeople24px = require("@svgr/webpack!./../../../elementGroups/social/round-people-24px.svg");

var _placeholder = _interopRequireDefault(require("./placeholder.jpg"));

var _createEmbedPlugin = require("./../../utils/oembed/createEmbedPlugin");

var _instagramBrands = require("@svgr/webpack!./instagram-brands.svg");

var PreviewBox =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "ew127bn0",
  label: "PreviewBox"
})({
  textAlign: "center",
  height: 50,
  svg: {
    height: 50,
    width: 50
  }
});

var _default = function _default() {
  return [(0, _createEmbedPlugin.createEmbedPlugin)({
    type: "instagram",
    toolbar: {
      title: "Instagram Post",
      group: "cms-element-group-social",
      preview: function preview() {
        return _react.default.createElement(PreviewBox, null, _react.default.createElement(_instagramBrands.ReactComponent, null));
      }
    },
    oembed: {
      global: "instgrm",
      sdk: "https://www.instagram.com/embed.js",
      init: function init(_ref) {
        var node = _ref.node;
        window.instgrm.Embeds.process(node.firstChild);
      }
    },
    renderElementPreview: function renderElementPreview(_ref2) {
      var width = _ref2.width,
          height = _ref2.height;
      return _react.default.createElement("img", {
        style: {
          width: width,
          height: height
        },
        src: _placeholder.default,
        alt: "Instagram"
      });
    }
  }), (0, _createEmbedPlugin.createEmbedSettingsPlugin)({
    type: "instagram",
    render: function render(_ref3) {
      var Bind = _ref3.Bind;
      return _react.default.createElement(_Tabs.Tab, {
        icon: _react.default.createElement(_roundPeople24px.ReactComponent, null),
        label: "Instagram"
      }, _react.default.createElement(_Grid.Grid, null, _react.default.createElement(_Grid.Cell, {
        span: 12
      }, _react.default.createElement(Bind, {
        name: "source.url",
        validators: ["required", "url"]
      }, _react.default.createElement(_Input.Input, {
        label: "Instagram URL",
        description: "Enter an Instagram URL"
      })))));
    }
  })];
};

exports.default = _default;
//# sourceMappingURL=index.js.map