"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _lifecycle2 = _interopRequireDefault(require("recompose/lifecycle"));

var _shouldUpdate2 = _interopRequireDefault(require("recompose/shouldUpdate"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var React = _interopRequireWildcard(require("react"));

var _emotion = require("emotion");

function appendSDK(props) {
  var element = props.element;

  var _ref = (0, _get2.default)(element, "data.source") || {},
      url = _ref.url;

  if (!url || window["PinUtils"]) {
    return;
  }

  return new Promise(function (resolve) {
    var script = document.createElement("script");
    script.type = "text/javascript";
    script.src = encodeURI("https://assets.pinterest.com/js/pinit.js");
    script.setAttribute("async", "");
    script.setAttribute("charset", "utf-8");
    script.onload = resolve; // $FlowFixMe

    document.body.appendChild(script);
  });
}

function initEmbed(props) {
  var element = props.element;
  var node = document.getElementById(element.id);

  if (node && window.PinUtils) {
    window.PinUtils.build();
  }
}

var centerAlign =
/*#__PURE__*/
(0, _emotion.css)({
  textAlign: "center"
}, "label:centerAlign;");

var getHTML = function getHTML(data) {
  return "<a\n        data-pin-do=\"embedPin\"\n        data-pin-width=\"".concat(data.size || "small", "\"\n        href=\"").concat(data.url, "\"\n    />");
};

var _default = (0, _compose2.default)((0, _shouldUpdate2.default)(function (props, nextProps) {
  return !(0, _isEqual2.default)(props, nextProps);
}), (0, _withHandlers2.default)({
  renderEmpty: function renderEmpty() {
    return function renderEmpty() {
      return React.createElement("div", null, "You must configure your embed in the settings!");
    };
  },
  renderEmbed: function renderEmbed(_ref2) {
    var element = _ref2.element;
    return function renderEmbed() {
      var data = (0, _get2.default)(element, "data.source");
      return React.createElement("div", {
        id: element.id,
        className: centerAlign,
        dangerouslySetInnerHTML: {
          __html: getHTML(data)
        }
      });
    };
  }
}), (0, _lifecycle2.default)({
  componentDidMount: function () {
    var _componentDidMount = (0, _asyncToGenerator2.default)(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee() {
      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return appendSDK(this.props);

            case 2:
              initEmbed(this.props);

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function componentDidMount() {
      return _componentDidMount.apply(this, arguments);
    }

    return componentDidMount;
  }(),
  componentDidUpdate: function () {
    var _componentDidUpdate = (0, _asyncToGenerator2.default)(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee2() {
      return _regenerator.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return appendSDK(this.props);

            case 2:
              initEmbed(this.props);

            case 3:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function componentDidUpdate() {
      return _componentDidUpdate.apply(this, arguments);
    }

    return componentDidUpdate;
  }()
}))(function (_ref3) {
  var element = _ref3.element,
      renderEmbed = _ref3.renderEmbed,
      renderEmpty = _ref3.renderEmpty;

  var _ref4 = (0, _get2.default)(element, "data.source") || {},
      url = _ref4.url;

  return url ? renderEmbed() : renderEmpty();
});

exports.default = _default;
//# sourceMappingURL=PinterestEmbed.js.map