"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "MIN_HEIGHT", {
  enumerable: true,
  get: function get() {
    return _SpacerContainer.MIN_HEIGHT;
  }
});
Object.defineProperty(exports, "INIT_HEIGHT", {
  enumerable: true,
  get: function get() {
    return _SpacerContainer.INIT_HEIGHT;
  }
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _ElementRoot = require("webiny-app-cms/render/components/ElementRoot");

var _SpacerContainer = _interopRequireWildcard(require("./SpacerContainer"));

var SpacerElement =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e1a12bbv0",
  label: "SpacerElement"
})({
  position: "relative",
  width: "100%",
  border: "2px dotted var(--mdc-theme-secondary)",
  textAlign: "center",
  opacity: 0,
  cursor: "ns-resize",
  transition: "opacity 0.2s",
  backgroundColor: "var(--mdc-theme-secondary)",
  minHeight: 20,
  "&:hover": {
    opacity: 1
  }
});

var Spacer = function Spacer(_ref) {
  var element = _ref.element;
  return _react.default.createElement(SpacerElement, null, _react.default.createElement(_ElementRoot.ElementRoot, {
    element: element
  }, function (_ref2) {
    var elementStyle = _ref2.elementStyle,
        customClasses = _ref2.customClasses,
        combineClassNames = _ref2.combineClassNames;
    return _react.default.createElement(_SpacerContainer.default, {
      elementId: element.id,
      elementStyle: elementStyle,
      customClasses: customClasses,
      combineClassNames: combineClassNames
    });
  }));
};

var _default = Spacer;
exports.default = _default;
//# sourceMappingURL=Spacer.js.map