"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.INIT_HEIGHT = exports.MIN_HEIGHT = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _withState2 = _interopRequireDefault(require("recompose/withState"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _emotion = require("emotion");

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _redux = require("webiny-app-cms/editor/redux");

var _dotPropImmutable = require("dot-prop-immutable");

var _Resizer = _interopRequireDefault(require("webiny-app-cms/editor/components/Resizer"));

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var _actions2 = require("./actions");

var SpacerHandle =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "elgdqeh0",
  label: "SpacerHandle"
})({
  height: "100%",
  width: "100%",
  position: "absolute",
  left: 0,
  bottom: -8
});
var SpacerHeight =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "elgdqeh1",
  label: "SpacerHeight"
})({
  position: "absolute",
  width: 50,
  top: "calc(50% - 12px)",
  left: "calc(50% - 25px)",
  color: "white",
  fontSize: 12,
  padding: 5,
  borderRadius: 5
});
var MIN_HEIGHT = 20;
exports.MIN_HEIGHT = MIN_HEIGHT;
var INIT_HEIGHT = 100;
exports.INIT_HEIGHT = INIT_HEIGHT;

var SpacerContainer = function SpacerContainer(_ref) {
  var localHeight = _ref.localHeight,
      onResizeStart = _ref.onResizeStart,
      onResizeStop = _ref.onResizeStop,
      onResize = _ref.onResize,
      elementStyle = _ref.elementStyle,
      customClasses = _ref.customClasses,
      combineClassNames = _ref.combineClassNames;
  var _elementStyle$height = elementStyle.height,
      height = _elementStyle$height === void 0 ? MIN_HEIGHT : _elementStyle$height,
      spacerStyle = (0, _objectWithoutProperties2.default)(elementStyle, ["height"]);

  if (localHeight) {
    height = localHeight;
  }

  return React.createElement("div", {
    style: {
      height: height
    },
    className: combineClassNames.apply(void 0, [
    /*#__PURE__*/
    (0, _emotion.css)(spacerStyle, "label:SpacerContainer;")].concat((0, _toConsumableArray2.default)(customClasses)))
  }, React.createElement(_Resizer.default, {
    axis: "y",
    onResizeStart: onResizeStart,
    onResizeStop: onResizeStop,
    onResize: onResize
  }, function (_ref2) {
    var otherProps = (0, _extends2.default)({}, _ref2);
    return React.createElement(React.Fragment, null, React.createElement(SpacerHeight, null, height, "px"), React.createElement(SpacerHandle, otherProps));
  }));
};

var _default = (0, _compose2.default)((0, _redux.connect)(function (state, props) {
  return {
    element: (0, _selectors.getElement)(state, props.elementId)
  };
}, {
  updateElement: _actions.updateElement,
  resizeStart: _actions2.resizeStart,
  resizeStop: _actions2.resizeStop
}), (0, _withState2.default)("localHeight", "setHeight", null), (0, _withHandlers2.default)({
  onResizeStart: function onResizeStart(_ref3) {
    var element = _ref3.element,
        setHeight = _ref3.setHeight,
        resizeStart = _ref3.resizeStart;
    return function () {
      resizeStart();
      setHeight((0, _get2.default)(element, "data.settings.height.value", MIN_HEIGHT));
    };
  },
  onResizeStop: function onResizeStop(_ref4) {
    var resizeStop = _ref4.resizeStop,
        updateElement = _ref4.updateElement,
        element = _ref4.element,
        setHeight = _ref4.setHeight,
        localHeight = _ref4.localHeight;
    return function () {
      resizeStop();
      updateElement({
        element: (0, _dotPropImmutable.set)(element, "data.settings.height.value", localHeight)
      });
      setHeight(null);
    };
  },
  onResize: function onResize(_ref5) {
    var setHeight = _ref5.setHeight,
        localHeight = _ref5.localHeight;
    return function (diff) {
      setHeight(Math.max(MIN_HEIGHT, localHeight - diff));
    };
  }
}))(SpacerContainer);

exports.default = _default;
//# sourceMappingURL=SpacerContainer.js.map