"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _loremIpsum = _interopRequireDefault(require("lorem-ipsum"));

var _Text = _interopRequireWildcard(require("./Text"));

var _Slate = require("webiny-app-cms/editor/components/Slate");

var _default = function _default() {
  var defaultLipsum = {
    count: 3,
    units: "sentences",
    sentenceLowerBound: 5,
    sentenceUpperBound: 15
  };
  return {
    name: "cms-element-text",
    type: "cms-element",
    toolbar: {
      title: "Text",
      group: "cms-element-group-basic",
      preview: function preview() {
        var previewText = (0, _loremIpsum.default)(defaultLipsum);
        return _react.default.createElement("p", {
          className: _Text.className
        }, previewText);
      }
    },
    settings: ["cms-element-settings-background", "", "cms-element-settings-border", "cms-element-settings-shadow", "", "cms-element-settings-padding", "cms-element-settings-margin", "", "cms-element-settings-clone", "cms-element-settings-delete", ""],
    target: ["cms-element-column", "cms-element-row", "cms-element-list-item"],
    create: function create(_ref) {
      var _ref$content = _ref.content,
          content = _ref$content === void 0 ? {} : _ref$content,
          options = (0, _objectWithoutProperties2.default)(_ref, ["content"]);
      var previewText = content.text || (0, _loremIpsum.default)(content.lipsum || defaultLipsum);
      return (0, _objectSpread2.default)({
        type: "cms-element-text",
        elements: [],
        data: {
          text: (0, _Slate.createValue)(previewText, content.typography || "paragraph"),
          settings: {
            margin: {
              mobile: {
                top: 0,
                left: 0,
                right: 0,
                bottom: 15
              },
              desktop: {
                top: 0,
                left: 0,
                right: 0,
                bottom: 25
              },
              advanced: true
            },
            padding: {
              desktop: {
                all: 0
              },
              mobile: {
                all: 0
              }
            }
          }
        }
      }, options);
    },
    render: function render(_ref2) {
      var element = _ref2.element;
      return _react.default.createElement(_Text.default, {
        elementId: element.id
      });
    }
  };
};

exports.default = _default;
//# sourceMappingURL=index.js.map