"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createEmbedSettingsPlugin = exports.createEmbedPlugin = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var React = _interopRequireWildcard(require("react"));

var _OEmbed = _interopRequireDefault(require("webiny-app-cms/editor/components/OEmbed"));

var createEmbedPlugin = function createEmbedPlugin(config) {
  return {
    name: "cms-element-" + config.type,
    type: "cms-element",
    toolbar: config.toolbar,
    settings: config.settings || ["cms-element-settings-delete", ""],
    target: config.target || ["cms-element-column", "cms-element-row", "cms-element-list-item"],
    // eslint-disable-next-line
    create: function create(_ref) {
      var _ref$content = _ref.content,
          content = _ref$content === void 0 ? {} : _ref$content,
          options = (0, _objectWithoutProperties2.default)(_ref, ["content"]);
      return (0, _objectSpread2.default)({
        type: "cms-element-" + config.type,
        elements: [],
        data: {
          settings: {
            margin: {
              desktop: {
                all: 0
              },
              mobile: {
                all: 0
              }
            },
            padding: {
              desktop: {
                all: 0
              },
              mobile: {
                all: 0
              }
            }
          }
        }
      }, options);
    },
    render: function render(props) {
      if (config.render) {
        return config.render(props);
      }

      return React.createElement(_OEmbed.default, (0, _extends2.default)({
        element: props.element
      }, config.oembed || {}));
    },
    onCreate: config.onCreate || "open-settings",
    renderElementPreview: config.renderElementPreview
  };
};

exports.createEmbedPlugin = createEmbedPlugin;

var createEmbedSettingsPlugin = function createEmbedSettingsPlugin(_ref2) {
  var type = _ref2.type,
      render = _ref2.render;
  return {
    name: "cms-element-advanced-settings-" + type,
    type: "cms-element-advanced-settings",
    element: "cms-element-" + type,
    render: render
  };
};

exports.createEmbedSettingsPlugin = createEmbedSettingsPlugin;
//# sourceMappingURL=createEmbedPlugin.js.map