"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _get2 = _interopRequireDefault(require("lodash/get"));

var _set2 = _interopRequireDefault(require("lodash/set"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _slugify = _interopRequireDefault(require("slugify"));

var _context = require("webiny-app-cms/context");

var _Grid = require("webiny-ui/Grid");

var _components = require("webiny-app-cms/admin/components");

var _Input = require("webiny-ui/Input");

var _Select = require("webiny-ui/Select");

var _PageImage = _interopRequireDefault(require("./PageImage"));

var toSlug = function toSlug(value, cb) {
  cb((0, _slugify.default)(value, {
    replacement: "-",
    lower: true,
    remove: /[*#\?<>_\{\}\[\]+~.()'"!:;@]/g
  })); // eslint-disable-line
};

var GeneralSettings = function GeneralSettings(_ref) {
  var Bind = _ref.Bind,
      onAfterChangeImage = _ref.onAfterChangeImage,
      theme = _ref.cms.theme;
  return React.createElement(React.Fragment, null, React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
    span: 12
  }, React.createElement(Bind, {
    name: "title",
    validators: ["required"]
  }, React.createElement(_Input.Input, {
    label: "Title",
    description: "Page title"
  }))), React.createElement(_Grid.Cell, {
    span: 12
  }, React.createElement(Bind, {
    name: "url",
    validators: ["required"],
    beforeChange: toSlug
  }, React.createElement(_Input.Input, {
    label: "URL",
    description: "Page URL"
  }))), React.createElement(_Grid.Cell, {
    span: 12
  }, React.createElement(Bind, {
    name: "snippet"
  }, React.createElement(_Input.Input, {
    rows: 4,
    label: "Snippet",
    description: "Page snippet"
  }))), React.createElement(_Grid.Cell, {
    span: 12
  }, React.createElement(Bind, {
    name: "settings.general.layout",
    defaultValue: theme.layouts[0].name
  }, React.createElement(_Select.Select, {
    label: "Layout",
    description: "Render this page using the selected layout"
  }, theme.layouts.map(function (_ref2) {
    var name = _ref2.name,
        title = _ref2.title;
    return React.createElement("option", {
      key: name,
      value: name
    }, title);
  })))), React.createElement(_Grid.Cell, {
    span: 12
  }, React.createElement(Bind, {
    name: "settings.general.tags"
  }, React.createElement(_components.TagsMultiAutoComplete, {
    description: "Enter tags to filter pages"
  }))), React.createElement(_Grid.Cell, {
    span: 12
  }, React.createElement(Bind, {
    name: "settings.general.image",
    afterChange: onAfterChangeImage
  }, React.createElement(_PageImage.default, {
    label: "Page Image"
  })))));
};

var _default = (0, _compose2.default)((0, _context.withCms)(), (0, _withHandlers2.default)({
  hasOgImage: function hasOgImage(_ref3) {
    var data = _ref3.data;
    return function () {
      var src = (0, _get2.default)(data, "settings.social.image.src");
      return typeof src === "string" && !src.startsWith("data:");
    };
  }
}), (0, _withHandlers2.default)({
  onAfterChangeImage: function onAfterChangeImage(_ref4) {
    var hasOgImage = _ref4.hasOgImage,
        form = _ref4.form;
    return function (selectedImage) {
      // If not already set, set selectedImage as og:image too.
      if (selectedImage && !hasOgImage()) {
        form.setState(function (state) {
          (0, _set2.default)(state, "data.settings.social.image", selectedImage);
          return state;
        });
      }
    };
  }
}))(GeneralSettings);

exports.default = _default;
//# sourceMappingURL=GeneralSettings.js.map