"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _trim2 = _interopRequireDefault(require("lodash/trim"));

var React = _interopRequireWildcard(require("react"));

var _DynamicFieldset = require("webiny-ui/DynamicFieldset");

var _Button = require("webiny-ui/Button");

var _Grid = require("webiny-ui/Grid");

var _Input = require("webiny-ui/Input");

var _Typography = require("webiny-ui/Typography");

var _emotion = require("emotion");

var controlButtons =
/*#__PURE__*/
(0, _emotion.css)({
  display: "flex",
  alignItems: "center",
  justifyContent: "center",
  ">button": {
    marginRight: 15
  }
}, "label:controlButtons;");
var textStyling =
/*#__PURE__*/
(0, _emotion.css)({
  color: "var(--mdc-theme-text-secondary-on-background)"
}, "label:textStyling;");

var MetaTags = function MetaTags(_ref) {
  var prefix = _ref.prefix,
      value = _ref.value,
      onChange = _ref.onChange,
      Bind = _ref.Bind,
      other = (0, _objectWithoutProperties2.default)(_ref, ["prefix", "value", "onChange", "Bind"]);
  return React.createElement(_DynamicFieldset.DynamicFieldset, (0, _extends2.default)({
    value: value,
    onChange: onChange
  }, other), function (_ref2) {
    var actions = _ref2.actions,
        header = _ref2.header,
        row = _ref2.row,
        empty = _ref2.empty;
    return React.createElement(React.Fragment, null, header(function () {
      return React.createElement(_Grid.Grid, {
        style: {
          paddingTop: 0,
          paddingBottom: 0
        }
      }, React.createElement(_Grid.Cell, {
        span: 12,
        className: textStyling
      }, React.createElement(_Typography.Typography, {
        use: "button"
      }, "Open Graph tags")));
    }), row(function (_ref3) {
      var index = _ref3.index;
      return React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
        span: 3
      }, React.createElement(Bind, {
        name: "".concat(prefix, ".").concat(index, ".property"),
        validators: ["required"],
        beforeChange: function beforeChange(tag, cb) {
          return cb((0, _trim2.default)(tag));
        }
      }, React.createElement(_Input.Input, {
        label: "Property"
      }))), React.createElement(_Grid.Cell, {
        span: 4
      }, React.createElement(Bind, {
        name: "".concat(prefix, ".").concat(index, ".content"),
        validators: ["required"]
      }, React.createElement(_Input.Input, {
        label: "Content"
      }))), React.createElement(_Grid.Cell, {
        span: 3,
        className: controlButtons
      }, React.createElement(_Button.ButtonPrimary, {
        small: true,
        onClick: actions.add(index)
      }, "+"), React.createElement(_Button.ButtonSecondary, {
        small: true,
        onClick: actions.remove(index)
      }, "-")));
    }), empty(function () {
      return React.createElement(_Grid.Grid, null, React.createElement(_Grid.Cell, {
        span: 12,
        className: textStyling
      }, React.createElement(_Typography.Typography, {
        use: "button"
      }, "To add other Open Graph tags, click", " ", React.createElement(_Button.ButtonPrimary, {
        onClick: actions.add()
      }, "Add Open Graph tag"))));
    }));
  });
};

var _default = MetaTags;
exports.default = _default;
//# sourceMappingURL=OpenGraphTags.js.map