"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _GeneralSettings = _interopRequireDefault(require("./components/GeneralSettings"));

var _SeoSettings = _interopRequireDefault(require("./components/SeoSettings"));

var _SocialSettings = _interopRequireDefault(require("./components/SocialSettings"));

var _roundSettings24px = require("@svgr/webpack!./icons/round-settings-24px.svg");

var _roundThumb_up24px = require("@svgr/webpack!./icons/round-thumb_up-24px.svg");

var _roundSearch24px = require("@svgr/webpack!./icons/round-search-24px.svg");

var _default = [{
  name: "cms-editor-page-settings-general",
  type: "cms-editor-page-settings",
  title: "General settings",
  description: "Manage things like title, page status,url and more.",
  icon: React.createElement(_roundSettings24px.ReactComponent, null),
  fields: "\n            general {\n                image {\n                    src\n                }\n                tags\n                layout\n            }\n    ",
  render: function render(props) {
    return React.createElement(_GeneralSettings.default, props);
  }
}, {
  name: "cms-editor-page-settings-seo",
  type: "cms-editor-page-settings",
  title: "SEO",
  description: "Control SEO settings like description and keywords.",
  icon: React.createElement(_roundSearch24px.ReactComponent, null),
  fields: "\n            seo {\n                title\n                description\n                meta {\n                    name\n                    content\n                }\n            }\n    ",
  render: function render(props) {
    return React.createElement(_SeoSettings.default, props);
  }
}, {
  name: "cms-editor-page-settings-social",
  type: "cms-editor-page-settings",
  title: "Social media",
  description: "Set share images and settings for social media sites.",
  icon: React.createElement(_roundThumb_up24px.ReactComponent, null),
  fields: "\n            social {\n                image {\n                    src\n                }\n                title\n                description\n                meta {\n                    property\n                    content\n                }\n            }\n    ",
  render: function render(props) {
    return React.createElement(_SocialSettings.default, props);
  }
}];
exports.default = _default;
//# sourceMappingURL=index.js.map