"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _downshift = _interopRequireDefault(require("downshift"));

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _emotion = require("emotion");

var _Elevation = require("webiny-ui/Elevation");

var _context = require("webiny-app-cms/context");

var Item =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e1acaksw0",
  label: "Item"
})(function (_ref) {
  var isActive = _ref.isActive,
      isSelected = _ref.isSelected;
  return {
    cursor: "pointer",
    display: "block",
    border: "none",
    height: "auto",
    textAlign: "left",
    borderTop: "none",
    lineHeight: "1em",
    color: "var(--mdc-theme-text-primary-on-background)",
    fontSize: "1rem",
    textTransform: "none",
    boxShadow: "none",
    padding: ".8rem 1.1rem",
    boxSizing: "border-box",
    whiteSpace: "nowrap",
    wordWrap: "normal",
    backgroundColor: isActive ? "var(--mdc-theme-on-background)" : "var(--mdc-theme-surface)",
    fontWeight: isSelected ? "bold" : "normal",
    "&:hover, &:focus": {
      borderColor: "#96c8da",
      boxShadow: "0 2px 3px 0 rgba(34,36,38,.15)"
    }
  };
});
var List =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e1acaksw1",
  label: "List"
})({
  border: "var(--mdc-theme-on-background)",
  backgroundColor: "var(--mdc-theme-surface)",
  position: "relative",
  left: 0,
  top: 0,
  height: "200px",
  width: "100%",
  overflow: "scroll"
});
var dropDownDialog =
/*#__PURE__*/
(0, _emotion.css)({
  position: "absolute",
  zIndex: "2",
  top: 27,
  left: -5,
  width: 200
}, "label:dropDownDialog;");
var Button =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e1acaksw2",
  label: "Button"
})({
  padding: "1px 3px 3px 3px",
  backgroundColor: "var(--mdc-theme-on-background)",
  fontSize: "0.8em",
  whiteSpace: "nowrap",
  lineHeight: "110%"
});

var TypographySelector =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(TypographySelector, _React$Component);

  function TypographySelector() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, TypographySelector);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(TypographySelector)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "state", {
      showMenu: false
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "dropdown", _react.default.createRef());
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "setBlock", function (type) {
      var _this$props = _this.props,
          editor = _this$props.editor,
          onChange = _this$props.onChange;
      editor.change(function (change) {
        return onChange(change.setBlocks(type));
      });
    });
    return _this;
  }

  (0, _createClass2.default)(TypographySelector, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.state.showMenu) {
        // $FlowFixMe
        var domRect = this.dropdown.current.getBoundingClientRect();

        if (domRect.right > window.innerWidth) {
          // $FlowFixMe
          this.dropdown.current.style.left = window.innerWidth - domRect.right + "px";
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          editor = _this$props2.editor,
          theme = _this$props2.cms.theme;
      var blockType = editor.value.blocks.first().type;
      var style = theme.typography[blockType] || theme.typography.paragraph;
      return _react.default.createElement(_downshift.default, {
        selectedItem: blockType,
        onChange: this.setBlock,
        onStateChange: function onStateChange(_ref2) {
          var isOpen = _ref2.isOpen;
          return _this2.setState({
            showMenu: isOpen
          });
        }
      }, function (_ref3) {
        var isOpen = _ref3.isOpen,
            getToggleButtonProps = _ref3.getToggleButtonProps,
            getItemProps = _ref3.getItemProps,
            highlightedIndex = _ref3.highlightedIndex,
            selectedItem = _ref3.selectedItem;
        return _react.default.createElement("div", null, _react.default.createElement(Button, getToggleButtonProps(), style.label), isOpen && _react.default.createElement(_Elevation.Elevation, {
          z: 2,
          className: dropDownDialog
        }, _react.default.createElement("div", {
          ref: _this2.dropdown
        }, _react.default.createElement(List, null, Object.keys(theme.typography).map(function (name, index) {
          var style = theme.typography[name];
          return _react.default.createElement(Item, (0, _extends2.default)({}, getItemProps({
            item: name,
            isActive: highlightedIndex === index,
            isSelected: selectedItem === name
          }), {
            key: name
          }), _react.default.createElement(style.component || "span", {
            style: style.style
          }, style.label));
        })))));
      });
    }
  }]);
  return TypographySelector;
}(_react.default.Component);

var _default = (0, _context.withCms)()(TypographySelector);

exports.default = _default;
//# sourceMappingURL=TypographySelector.js.map