"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _format_align_center = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/format_align_center.svg");

var _format_align_left = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/format_align_left.svg");

var _format_align_justify = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/format_align_justify.svg");

var _format_align_right = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/format_align_right.svg");

var _TypographySelector = _interopRequireDefault(require("./TypographySelector"));

// Icons map for dynamic render
var icons = {
  left: _format_align_left.ReactComponent,
  center: _format_align_center.ReactComponent,
  right: _format_align_right.ReactComponent,
  justify: _format_align_justify.ReactComponent
}; // Alignment types for faster access

var alignments = Object.keys(icons);

var setAlign = function setAlign(align, blockType, onChange, editor) {
  editor.change(function (change) {
    change.setBlocks({
      type: blockType,
      data: {
        align: align
      }
    }).focus();
    onChange(change);
  });
};

var _default = function _default() {
  return {
    menu: [{
      name: "typography-menu-item",
      type: "cms-slate-menu-item",
      render: function render(_ref) {
        var MenuButton = _ref.MenuButton,
            props = (0, _objectWithoutProperties2.default)(_ref, ["MenuButton"]);
        return _react.default.createElement(MenuButton, null, _react.default.createElement(_TypographySelector.default, props));
      }
    }, {
      name: "align-menu-item",
      type: "cms-slate-menu-item",
      render: function render(_ref2) {
        var MenuButton = _ref2.MenuButton,
            editor = _ref2.editor,
            onChange = _ref2.onChange;
        var block = editor.value.blocks.first();
        var align = block.data.get("align") || "left";
        var nextAlign = alignments[alignments.indexOf(align) + 1] || "left";
        return (// eslint-disable-next-line react/jsx-no-bind
          _react.default.createElement(MenuButton, {
            onClick: function onClick() {
              return setAlign(nextAlign, block.type, onChange, editor);
            }
          }, _react.default.createElement(icons[align]))
        );
      }
    }],
    editor: [{
      name: "cms-slate-editor-typography",
      type: "cms-slate-editor",
      slate: {
        renderNode: function renderNode(props, next) {
          var attributes = props.attributes,
              children = props.children,
              node = props.node,
              editor = props.editor;
          var type = node.type;
          var typography = editor.props.theme.typography;

          if (typography.hasOwnProperty(type) && typography[type].component) {
            var _typography$type = typography[type],
                Node = _typography$type.component,
                _typography$type$clas = _typography$type.className,
                className = _typography$type$clas === void 0 ? null : _typography$type$clas;
            var nodeProps = (0, _objectSpread2.default)({}, attributes, {
              className: className,
              style: {
                textAlign: "".concat(node.data.get("align"))
              }
            });

            if (typeof Node !== "string") {
              nodeProps = props;
            }

            return _react.default.createElement(Node, nodeProps, children);
          }

          return next();
        }
      }
    }]
  };
};

exports.default = _default;
//# sourceMappingURL=index.js.map