"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var React = _interopRequireWildcard(require("react"));

var _emotion = require("emotion");

var _format_bold = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/format_bold.svg");

var _isHotkey = require("is-hotkey");

var isBoldHotkey = (0, _isHotkey.isKeyHotkey)("mod+b");

var hasMark = function hasMark(value, type) {
  return Boolean(value.activeMarks.find(function (mark) {
    return mark.type === type;
  }));
};

var onClickMark = function onClickMark(type, editor, onChange) {
  editor.change(function (change) {
    return onChange(change.toggleMark(type));
  });
};

var mark = "bold";
var strongStyle =
/*#__PURE__*/
(0, _emotion.css)({
  "[class*='mdc-typography--']": {
    fontWeight: "bold !important"
  }
}, "label:strongStyle;");

var _default = function _default() {
  return {
    menu: [{
      name: "bold-menu-item",
      type: "cms-slate-menu-item",
      render: function render(_ref) {
        var MenuButton = _ref.MenuButton,
            editor = _ref.editor,
            onChange = _ref.onChange;
        var isActive = hasMark(editor.value, mark);
        return (// eslint-disable-next-line react/jsx-no-bind
          React.createElement(MenuButton, {
            onClick: function onClick() {
              return onClickMark(mark, editor, onChange);
            },
            active: isActive
          }, React.createElement(_format_bold.ReactComponent, null))
        );
      }
    }],
    editor: [{
      name: "cms-slate-editor-bold",
      type: "cms-slate-editor",
      slate: {
        onKeyDown: function onKeyDown(event, change, next) {
          // Decide what to do based on the key code...
          if (isBoldHotkey(event)) {
            event.preventDefault();
            change.toggleMark(mark);
            return true;
          }

          return next();
        },
        renderMark: function renderMark(props, next) {
          if (props.mark.type === mark) {
            return React.createElement("strong", (0, _extends2.default)({
              className: strongStyle
            }, props.attributes), props.children);
          }

          return next();
        }
      }
    }]
  };
};

exports.default = _default;
//# sourceMappingURL=index.js.map