"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var React = _interopRequireWildcard(require("react"));

var _code = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/code.svg");

var MARK = "code";

var hasMark = function hasMark(value, type) {
  return Boolean(value.marks.find(function (mark) {
    return mark.type === type;
  }));
};

var onClickMark = function onClickMark(type, editor, onChange) {
  editor.change(function (change) {
    return onChange(change.toggleMark(type));
  });
};

var _default = function _default() {
  return {
    menu: [{
      name: "code-menu-item",
      type: "cms-slate-menu-item",
      render: function render(_ref) {
        var MenuButton = _ref.MenuButton,
            editor = _ref.editor,
            onChange = _ref.onChange;
        var isActive = hasMark(editor.value, MARK);
        return (// eslint-disable-next-line react/jsx-no-bind
          React.createElement(MenuButton, {
            onClick: function onClick() {
              return onClickMark(MARK, editor, onChange);
            },
            active: isActive
          }, React.createElement(_code.ReactComponent, null))
        );
      }
    }],
    editor: [{
      name: "cms-slate-editor-code",
      type: "cms-slate-editor",
      slate: {
        renderMark: function renderMark(props, next) {
          if (props.mark.type === MARK) {
            return React.createElement("code", (0, _extends2.default)({
              className: "webiny-cms-typography-code"
            }, props.attributes), props.children);
          }

          return next();
        }
      }
    }]
  };
};

exports.default = _default;
//# sourceMappingURL=index.js.map