"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _format_italic = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/format_italic.svg");

var _isHotkey = require("is-hotkey");

var isItalicHotkey = (0, _isHotkey.isKeyHotkey)("mod+i");

var hasMark = function hasMark(value, type) {
  return Boolean(value.activeMarks.find(function (mark) {
    return mark.type === type;
  }));
};

var onClickMark = function onClickMark(type, onChange, editor) {
  editor.change(function (change) {
    return onChange(change.toggleMark(type));
  });
};

var mark = "italic";

var _default = function _default() {
  return {
    menu: [{
      name: "italic-menu-item",
      type: "cms-slate-menu-item",
      render: function render(_ref) {
        var MenuButton = _ref.MenuButton,
            editor = _ref.editor,
            onChange = _ref.onChange;
        var isActive = hasMark(editor.value, mark);
        return (// eslint-disable-next-line react/jsx-no-bind
          _react.default.createElement(MenuButton, {
            onClick: function onClick() {
              return onClickMark(mark, onChange, editor);
            },
            active: isActive
          }, _react.default.createElement(_format_italic.ReactComponent, null))
        );
      }
    }],
    editor: [{
      name: "cms-slate-editor-italic",
      type: "cms-slate-editor",
      slate: {
        onKeyDown: function onKeyDown(event, change, next) {
          if (isItalicHotkey(event)) {
            event.preventDefault();
            change.toggleMark(mark);
            return true;
          }

          return next();
        },
        renderMark: function renderMark(props, next) {
          if (props.mark.type === mark) {
            return _react.default.createElement("em", props.attributes, props.children);
          }

          return next();
        }
      }
    }]
  };
};

exports.default = _default;
//# sourceMappingURL=index.js.map