"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _withProps2 = _interopRequireDefault(require("recompose/withProps"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _emotion = require("emotion");

var _Button = require("webiny-ui/Button");

var _webinyForm = require("webiny-form");

var _Input = require("webiny-ui/Input");

var _Switch = require("webiny-ui/Switch");

var _Grid = require("webiny-ui/Grid");

var _Typography = require("webiny-ui/Typography");

var _close = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/close.svg");

var InputContainer =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e14lsf1z0",
  label: "InputContainer"
})({
  width: "100%",
  "> .mdc-text-field.mdc-text-field--upgraded": {
    height: "30px !important",
    width: "100%",
    ".mdc-text-field__input": {
      paddingTop: 5,
      paddingRight: 30,
      fontSize: "0.8em"
    }
  }
});
var removeButton =
/*#__PURE__*/
(0, _emotion.css)({
  position: "absolute !important",
  top: 5,
  right: 5
}, "label:removeButton;");

var LinkMenu = function LinkMenu(_ref) {
  var linkData = _ref.linkData,
      updateLink = _ref.updateLink,
      closeMenu = _ref.closeMenu,
      removeLink = _ref.removeLink;
  return _react.default.createElement(_webinyForm.Form, {
    data: linkData,
    onSubmit: updateLink
  }, function (_ref2) {
    var Bind = _ref2.Bind,
        submit = _ref2.submit;
    return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_Grid.Grid, null, _react.default.createElement(_Grid.Cell, {
      span: 3
    }, _react.default.createElement(_Typography.Typography, {
      use: "overline"
    }, "URL")), _react.default.createElement(_Grid.Cell, {
      span: 9
    }, _react.default.createElement(InputContainer, null, _react.default.createElement(Bind, {
      name: "href",
      validators: ["required"]
    }, _react.default.createElement(_Input.Input, {
      placeholder: "Enter URL",
      onKeyPress: function onKeyPress(e) {
        if (e.key === "Enter") {
          submit();
          closeMenu();
        }
      }
    })), linkData.href && _react.default.createElement(_Button.IconButton, {
      className: removeButton,
      icon: _react.default.createElement(_close.ReactComponent, null),
      onClick: function onClick() {
        removeLink();
        closeMenu();
      }
    })))), _react.default.createElement(_Grid.Grid, null, _react.default.createElement(_Grid.Cell, {
      span: 3,
      style: {
        marginBottom: 0
      }
    }, _react.default.createElement(_Typography.Typography, {
      use: "overline"
    }, "NEW TAB")), _react.default.createElement(_Grid.Cell, {
      span: 3,
      style: {
        justifySelf: "flex-start",
        marginBottom: 0
      }
    }, _react.default.createElement(Bind, {
      name: "newTab"
    }, _react.default.createElement(_Switch.Switch, {
      onChange: function onChange() {
        return submit();
      }
    }))), _react.default.createElement(_Grid.Cell, {
      span: 3,
      style: {
        marginBottom: 0
      }
    }, _react.default.createElement(_Typography.Typography, {
      use: "overline"
    }, "NO FOLLOW")), _react.default.createElement(_Grid.Cell, {
      span: 3,
      style: {
        justifySelf: "flex-start",
        marginBottom: 0
      }
    }, _react.default.createElement(Bind, {
      name: "noFollow"
    }, _react.default.createElement(_Switch.Switch, {
      onChange: function onChange() {
        return submit();
      }
    })))), _react.default.createElement(_Grid.Grid, null, _react.default.createElement(_Grid.Cell, {
      span: 12,
      style: {
        marginBottom: 0,
        float: "right"
      }
    }, _react.default.createElement(_Button.ButtonPrimary, {
      onClick: function onClick() {
        submit();
        closeMenu();
      }
    }, "Apply"))));
  });
};

var TYPE = "link";

var isLink = function isLink(i) {
  return i.type === TYPE;
};

var createLinkRange = function createLinkRange(change, selection) {
  change.select(selection);
  var link = change.value.inlines.find(isLink);

  if (!link) {
    return selection;
  } // Create full link range


  var firstText = link.getFirstText();
  var lastText = link.getLastText();
  return {
    anchor: {
      path: change.value.document.getPath(firstText.key),
      offset: 0
    },
    focus: {
      path: change.value.document.getPath(lastText.key),
      offset: lastText.text.length
    }
  };
};

var _default = (0, _compose2.default)((0, _withProps2.default)(function (_ref3) {
  var value = _ref3.value;
  var link = value.inlines.some(isLink) && value.inlines.find(isLink);
  return {
    linkData: link && link.data || {}
  };
}), (0, _withHandlers2.default)({
  updateLink: function updateLink(_ref4) {
    var editor = _ref4.editor,
        onChange = _ref4.onChange,
        selection = _ref4.value.selection;
    return function (data) {
      editor.change(function (change) {
        change.select(createLinkRange(change, selection)).unwrapInline(TYPE).wrapInline({
          type: TYPE,
          data: data
        }).moveToEnd();
        onChange(change);
      });
    };
  },
  removeLink: function removeLink(_ref5) {
    var editor = _ref5.editor,
        onChange = _ref5.onChange,
        selection = _ref5.value.selection;
    return function () {
      editor.change(function (change) {
        // Restore selection
        change.select(createLinkRange(change, selection)).unwrapInline(TYPE);
        onChange(change);
      });
    };
  }
}))(LinkMenu);

exports.default = _default;
//# sourceMappingURL=LinkMenu.js.map