"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _link = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/link.svg");

var _LinkMenu = _interopRequireDefault(require("./LinkMenu"));

var _default = function _default() {
  return {
    menu: [{
      name: "link-menu-item",
      type: "cms-slate-menu-item",
      render: function render(props) {
        var _this = this;

        var MenuButton = props.MenuButton;
        return _react.default.createElement(MenuButton, {
          onMouseDown: function onMouseDown() {
            return props.activatePlugin(_this.name);
          }
        }, _react.default.createElement(_link.ReactComponent, null));
      },
      renderMenu: function renderMenu(props) {
        return _react.default.createElement(_LinkMenu.default, props);
      }
    }],
    editor: [{
      name: "cms-slate-editor-link",
      type: "cms-slate-editor",
      slate: {
        renderNode: function renderNode(props, next) {
          var attributes = props.attributes,
              children = props.children,
              node = props.node;

          if (node.type === "link") {
            var data = node.data;
            var href = data.get("href");
            var noFollow = data.get("noFollow");
            return _react.default.createElement("a", (0, _extends2.default)({}, attributes, {
              href: href,
              rel: noFollow ? "nofollow" : null
            }), children);
          }

          return next();
        }
      }
    }]
  };
};

exports.default = _default;
//# sourceMappingURL=index.js.map