"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var React = _interopRequireWildcard(require("react"));

var _format_list_numbered = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/format_list_numbered.svg");

var _format_list_bulleted = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/format_list_bulleted.svg");

var hasBlock = function hasBlock(value, type) {
  return value.blocks.some(function (node) {
    return node.type === type;
  });
};

var onClickBlock = function onClickBlock(type, onChange, editor) {
  editor.change(function (change) {
    var value = change.value;
    var document = value.document; // Handle the extra wrapping required for list buttons.

    var isList = hasBlock(editor.value, "list-item");
    var isType = value.blocks.some(function (block) {
      return !!document.getClosest(block.key, function (parent) {
        return parent.type === type;
      });
    });

    if (isList && isType) {
      change.setBlocks("paragraph").unwrapBlock("unordered-list").unwrapBlock("ordered-list");
    } else if (isList) {
      change.unwrapBlock(type === "unordered-list" ? "ordered-list" : "unordered-list").wrapBlock(type);
    } else {
      change.setBlocks("list-item").wrapBlock(type);
    }

    onChange(change);
  });
};

var _default = function _default() {
  return {
    menu: [{
      name: "ordered-list-menu-item",
      type: "cms-slate-menu-item",
      render: function render(_ref) {
        var MenuButton = _ref.MenuButton,
            editor = _ref.editor,
            onChange = _ref.onChange;
        var isActive = hasBlock(editor.value, "ordered-list");
        return (// eslint-disable-next-line react/jsx-no-bind
          React.createElement(MenuButton, {
            onClick: function onClick() {
              return onClickBlock("ordered-list", onChange, editor);
            },
            active: isActive
          }, React.createElement(_format_list_numbered.ReactComponent, null))
        );
      }
    }, {
      name: "unordered-list-menu-item",
      type: "cms-slate-menu-item",
      render: function render(_ref2) {
        var MenuButton = _ref2.MenuButton,
            editor = _ref2.editor,
            onChange = _ref2.onChange;
        var isActive = hasBlock(editor.value, "unordered-list");
        return (// eslint-disable-next-line react/jsx-no-bind
          React.createElement(MenuButton, {
            onClick: function onClick() {
              return onClickBlock("unordered-list", onChange, editor);
            },
            active: isActive
          }, React.createElement(_format_list_bulleted.ReactComponent, null))
        );
      }
    }],
    editor: [{
      name: "cms-slate-editor-lists",
      type: "cms-slate-editor",
      slate: {
        renderNode: function renderNode(props, next) {
          var attributes = props.attributes,
              children = props.children,
              node = props.node;

          switch (node.type) {
            case "unordered-list":
              return React.createElement("ul", (0, _extends2.default)({
                className: "webiny-cms-typography-unordered-list"
              }, attributes), children);

            case "list-item":
              return React.createElement("li", attributes, children);

            case "ordered-list":
              return React.createElement("ol", (0, _extends2.default)({
                className: "webiny-cms-typography-ordered-list"
              }, attributes), children);

            default:
              return next();
          }
        }
      }
    }]
  };
};

exports.default = _default;
//# sourceMappingURL=index.js.map