"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _format_underlined = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/format_underlined.svg");

var _isHotkey = require("is-hotkey");

var isUnderlineHotkey = (0, _isHotkey.isKeyHotkey)("mod+u");

var hasMark = function hasMark(value, type) {
  return Boolean(value.activeMarks.find(function (mark) {
    return mark.type === type;
  }));
};

var onClickMark = function onClickMark(type, onChange, editor) {
  editor.change(function (change) {
    return onChange(change.toggleMark(type));
  });
};

var mark = "underline";

var _default = function _default() {
  return {
    menu: [{
      name: "underline-menu-item",
      type: "cms-slate-menu-item",
      render: function render(_ref) {
        var MenuButton = _ref.MenuButton,
            editor = _ref.editor,
            onChange = _ref.onChange;
        var isActive = hasMark(editor.value, mark);
        return (// eslint-disable-next-line react/jsx-no-bind
          React.createElement(MenuButton, {
            onClick: function onClick() {
              return onClickMark(mark, onChange, editor);
            },
            active: isActive
          }, React.createElement(_format_underlined.ReactComponent, null))
        );
      }
    }],
    editor: [{
      name: "cms-slate-editor-underline",
      type: "cms-slate-editor",
      slate: {
        onKeyDown: function onKeyDown(event, change, next) {
          // Decide what to do based on the key code...
          if (isUnderlineHotkey(event)) {
            event.preventDefault();
            change.toggleMark(mark);
            return true;
          }

          return next();
        },
        renderMark: function renderMark(props, next) {
          if (props.mark.type === mark) {
            return React.createElement("u", props.attributes, props.children);
          }

          return next();
        }
      }
    }]
  };
};

exports.default = _default;
//# sourceMappingURL=index.js.map