"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _pure2 = _interopRequireDefault(require("recompose/pure"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _emotion = require("emotion");

var _redux = require("webiny-app-cms/editor/redux");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var _Button = require("webiny-ui/Button");

var _Tooltip = require("webiny-ui/Tooltip");

var activeStyle =
/*#__PURE__*/
(0, _emotion.css)({
  ".mdc-icon-button__icon": {
    color: "var(--mdc-theme-primary)"
  }
}, "label:activeStyle;");
var Action = (0, _pure2.default)(function (_ref) {
  var icon = _ref.icon,
      onClick = _ref.onClick,
      active = _ref.active,
      tooltip = _ref.tooltip;
  var btnIcon = icon;

  if (Array.isArray(icon)) {
    btnIcon = active ? icon[0] : icon[1];
  }

  var iconButton = React.createElement(_Button.IconButton, {
    icon: btnIcon,
    onClick: onClick,
    className: active && activeStyle
  });

  if (tooltip) {
    return React.createElement(_Tooltip.Tooltip, (0, _extends2.default)({
      placement: "right",
      content: React.createElement("span", null, tooltip)
    }, active ? {
      visible: false
    } : {}), iconButton);
  }

  return iconButton;
});

var _default = (0, _compose2.default)((0, _redux.connect)(function (state, props) {
  return {
    active: (0, _selectors.isPluginActive)(props.plugin)(state)
  };
}, {
  togglePlugin: _actions.togglePlugin
}), (0, _withHandlers2.default)({
  onClick: function onClick(_ref2) {
    var _onClick = _ref2.onClick,
        togglePlugin = _ref2.togglePlugin,
        plugin = _ref2.plugin;
    return function () {
      if (typeof _onClick === "function") {
        return _onClick();
      }

      togglePlugin({
        name: plugin
      });
    };
  }
}))(Action);

exports.default = _default;
//# sourceMappingURL=Action.js.map