"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _Draggable = _interopRequireDefault(require("webiny-app-cms/editor/components/Draggable"));

var _actions = require("webiny-app-cms/editor/actions");

var _webinyPlugins = require("webiny-plugins");

var _selectors = require("webiny-app-cms/editor/selectors");

var _context = require("webiny-app-cms/context");

var Styled = _interopRequireWildcard(require("./StyledComponents"));

var _emotion = require("emotion");

var _List = require("webiny-ui/List");

var _Icon = require("webiny-ui/Icon");

var _Typography = require("webiny-ui/Typography");

var _Button = require("webiny-ui/Button");

var _add = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/add.svg");

var ADD_ELEMENT = "cms-toolbar-add-element";
var categoriesList =
/*#__PURE__*/
(0, _emotion.css)({
  backgroundColor: "var(--mdc-theme-surface)",
  boxShadow: "inset 1px 0px 5px 0px var(--mdc-theme-background)",
  borderTop: "1px solid var(--mdc-theme-background)",
  ".mdc-list-item": {
    width: 150,
    fontWeight: "600 !important",
    borderBottom: "1px solid var(--mdc-theme-background)",
    "&.active": {
      backgroundColor: "var(--mdc-theme-background)",
      color: "var(--mdc-theme-primary)",
      ".mdc-list-item__meta": {
        color: "var(--mdc-theme-primary)"
      }
    }
  }
}, "label:categoriesList;");

var AddElement =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(AddElement, _React$Component);

  function AddElement() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, AddElement);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(AddElement)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "state", {
      group: _this.getGroups()[0].name
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "renderDraggable", function (element, plugin) {
      var name = plugin.name;
      var _this$props = _this.props,
          dragStart = _this$props.dragStart,
          deactivatePlugin = _this$props.deactivatePlugin,
          dragEnd = _this$props.dragEnd;
      return React.createElement(_Draggable.default, {
        key: plugin.name,
        target: plugin.target,
        beginDrag: function beginDrag(props) {
          dragStart({
            element: {
              type: name
            }
          });
          setTimeout(function () {
            return deactivatePlugin({
              name: ADD_ELEMENT
            });
          }, 20);
          return {
            type: name,
            target: props.target
          };
        },
        endDrag: function endDrag(props, monitor) {
          dragEnd({
            element: monitor.getItem()
          });
        }
      }, function (_ref) {
        var connectDragSource = _ref.connectDragSource;
        return connectDragSource(React.createElement("div", null, _this.renderOverlay(element, null, "Drag to Add")));
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "renderClickable", function (element, plugin) {
      var _this$props2 = _this.props,
          params = _this$props2.params,
          dropElement = _this$props2.dropElement,
          deactivatePlugin = _this$props2.deactivatePlugin;

      var item = _this.renderOverlay(element, function () {
        dropElement({
          source: {
            type: plugin.name
          },
          target: (0, _objectSpread2.default)({}, params)
        });
        deactivatePlugin({
          name: ADD_ELEMENT
        });
      }, "Click to Add");

      return React.cloneElement(item, {
        key: plugin.name
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "renderOverlay", function (element) {
      var onClick = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var label = arguments.length > 2 ? arguments[2] : undefined;
      var _this$props3 = _this.props,
          enableDragOverlay = _this$props3.enableDragOverlay,
          disableDragOverlay = _this$props3.disableDragOverlay;
      return React.createElement(Styled.ElementPreview, null, React.createElement(Styled.Overlay, null, React.createElement(Styled.Backdrop, {
        className: "backdrop"
      }), React.createElement(Styled.AddBlock, {
        className: "add-block"
      }, React.createElement(_Button.ButtonFloating, {
        onClick: onClick,
        label: label,
        icon: React.createElement(_add.ReactComponent, null),
        onMouseDown: enableDragOverlay,
        onMouseUp: disableDragOverlay
      }))), element);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "refresh", function () {
      _this.setState({
        group: _this.state.group
      });
    });
    return _this;
  }

  (0, _createClass2.default)(AddElement, [{
    key: "getGroups",
    value: function getGroups() {
      return (0, _webinyPlugins.getPlugins)("cms-element-group");
    }
  }, {
    key: "getGroupElements",
    value: function getGroupElements(group) {
      return (0, _webinyPlugins.getPlugins)("cms-element").filter(function (el) {
        return el.toolbar && el.toolbar.group === group;
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          params = _this$props4.params,
          theme = _this$props4.cms.theme;
      return React.createElement(Styled.Flex, null, React.createElement(_List.List, {
        className: categoriesList
      }, this.getGroups().map(function (plugin) {
        return React.createElement(_List.ListItem, {
          onClick: function onClick() {
            return _this2.setState({
              group: plugin.name
            });
          },
          key: plugin.name,
          className: plugin.name === _this2.state.group && "active"
        }, plugin.group.title, plugin.group.icon && React.createElement(_List.ListItemMeta, null, React.createElement(_Icon.Icon, {
          icon: plugin.group.icon
        })));
      })), React.createElement(Styled.Elements, null, this.state.group && this.getGroupElements(this.state.group).map(function (plugin) {
        return (params ? _this2.renderClickable : _this2.renderDraggable)(React.createElement("div", {
          "data-role": "draggable"
        }, React.createElement(Styled.ElementBox, null, React.createElement(Styled.ElementTitle, null, typeof plugin.toolbar.title === "function" ? plugin.toolbar.title({
          refresh: _this2.refresh
        }) : React.createElement(_Typography.Typography, {
          use: "overline"
        }, plugin.toolbar.title)), React.createElement(Styled.ElementPreviewCanvas, null, plugin.toolbar.preview({
          theme: theme
        })))), plugin);
      })));
    }
  }]);
  return AddElement;
}(React.Component);

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  var getParams = (0, _selectors.getActivePluginParams)("cms-toolbar-add-element");
  return {
    params: getParams ? getParams(state) : null
  };
}, {
  dragStart: _actions.dragStart,
  dragEnd: _actions.dragEnd,
  deactivatePlugin: _actions.deactivatePlugin,
  dropElement: _actions.dropElement
}), (0, _context.withCms)(), (0, _withHandlers2.default)({
  enableDragOverlay: function enableDragOverlay() {
    return function () {
      var el = document.querySelector(".cms-editor");

      if (el) {
        el.classList.add("cms-editor-dragging");
      }
    };
  },
  disableDragOverlay: function disableDragOverlay() {
    return function () {
      var el = document.querySelector(".cms-editor");

      if (el) {
        el.classList.remove("cms-editor-dragging");
      }
    };
  }
}))(AddElement);

exports.default = _default;
//# sourceMappingURL=AddElement.js.map