"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Overlay = exports.AddBlock = exports.Backdrop = exports.ElementPreviewCanvas = exports.ElementBox = exports.ElementTitle = exports.ElementPreview = exports.Elements = exports.Flex = void 0;

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var Flex =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eyceur0",
  label: "Flex"
})({
  display: "flex",
  height: "100vh"
});
exports.Flex = Flex;
var Elements =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eyceur1",
  label: "Elements"
})({
  flex: "65%",
  backgroundColor: "var(--mdc-theme-background)",
  overflow: "scroll",
  marginBottom: 65
});
exports.Elements = Elements;
var ElementPreview =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eyceur2",
  label: "ElementPreview"
})({
  position: "relative",
  padding: 10
});
exports.ElementPreview = ElementPreview;
var ElementTitle =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eyceur3",
  label: "ElementTitle"
})({
  borderBottom: "1px solid var(--mdc-theme-on-background)",
  color: "var(--mdc-theme-on-surface)"
});
exports.ElementTitle = ElementTitle;
var ElementBox =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eyceur4",
  label: "ElementBox"
})({
  padding: "0px 15px"
});
exports.ElementBox = ElementBox;
var ElementPreviewCanvas =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eyceur5",
  label: "ElementPreviewCanvas"
})({
  marginTop: 10,
  border: "1px solid var(--mdc-theme-on-background)",
  backgroundColor: "var(--mdc-theme-surface)",
  color: "var(--mdc-theme-on-surface)",
  padding: 15,
  boxSizing: "border-box",
  width: 260
});
exports.ElementPreviewCanvas = ElementPreviewCanvas;
var Backdrop =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eyceur6",
  label: "Backdrop"
})({
  display: "none",
  position: "absolute",
  top: 0,
  left: 0,
  width: "100%",
  height: "100%",
  backgroundColor: "var(--mdc-theme-surface)",
  opacity: 0.5
});
exports.Backdrop = Backdrop;
var AddBlock =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eyceur7",
  label: "AddBlock"
})({
  display: "none",
  width: 300,
  margin: 5,
  textAlign: "center" //marginTop: 45

});
exports.AddBlock = AddBlock;
var Overlay =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "eyceur8",
  label: "Overlay"
})({
  position: "absolute",
  display: "flex",
  justifyContent: "center",
  alignItems: "center",
  top: 42,
  left: 0,
  width: "100%",
  height: "calc(100% - 42px)",
  zIndex: 10,
  opacity: 0,
  transform: "scale(0.9)",
  transition: "opacity 0.2s, transform 0.1s",
  "&:hover": {
    opacity: 1,
    transform: "scale(1)",
    "> .backdrop, > .add-block": {
      display: "block"
    }
  }
});
exports.Overlay = Overlay;
//# sourceMappingURL=StyledComponents.js.map