"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _lifecycle2 = _interopRequireDefault(require("recompose/lifecycle"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var _react = _interopRequireDefault(require("react"));

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _Carousel = require("webiny-ui/Carousel");

var _redux = require("webiny-app-cms/editor/redux");

var _actions = require("webiny-app-cms/editor/actions");

var _selectors = require("webiny-app-cms/editor/selectors");

var _components = require("webiny-app-cms/editor/components");

var _nextSlide = require("@svgr/webpack!./assets/next-slide.svg");

var _prevSlide = require("@svgr/webpack!./assets/prev-slide.svg");

var _Slide = _interopRequireDefault(require("./slides/Slide1"));

var _Slide2 = _interopRequireDefault(require("./slides/Slide2"));

var _Slide3 = _interopRequireDefault(require("./slides/Slide3"));

var _Slide4 = _interopRequireDefault(require("./slides/Slide4"));

var _Slide5 = _interopRequireDefault(require("./slides/Slide5"));

var _Slide6 = _interopRequireDefault(require("./slides/Slide6"));

var _Slide7 = _interopRequireDefault(require("./slides/Slide7"));

var Overlay =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e6nx8q30",
  label: "Overlay"
})({
  position: "fixed",
  top: 0,
  left: 0,
  width: "100vw",
  height: "100vh",
  backgroundColor: "rgba(0,0,0,0.5)",
  display: "flex",
  alignItems: "center",
  justifyContent: "center",
  ".slider-control-centerright": {
    right: "-50px !important"
  },
  ".slider-control-centerleft": {
    left: "-50px !important"
  },
  ".slider-control-bottomcenter": {
    bottom: "-50px !important"
  }
});
var Container =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e6nx8q31",
  label: "Container"
})({
  width: 800,
  height: 600,
  backgroundColor: "var(--mdc-theme-surface)",
  borderRadius: 2,
  color: "var(--mdc-theme-text-primary-on-background)"
});
var InnerContainer =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e6nx8q32",
  label: "InnerContainer"
})({
  width: "100%",
  height: "100%",
  display: "flex"
});
var SlideControl =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "e6nx8q33",
  label: "SlideControl"
})({
  background: "var(--mdc-theme-surface)",
  boxShadow: "0 6px 6px 0 rgba(0,0,0,0.26), 0 10px 20px 0 rgba(0,0,0,0.19)",
  borderRadius: "50%",
  width: 40,
  height: 40,
  display: "flex",
  alignItems: "center",
  justifyContent: "center",
  cursor: "pointer",
  color: "var(--mdc-theme-text-secondary-on-background)",
  "&:hover": {
    background: "var(--mdc-theme-background)"
  }
});

var Onboarding =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(Onboarding, _React$Component);

  function Onboarding() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, Onboarding);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(Onboarding)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "state", {
      slideIndex: 0
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "nextSlide", function () {
      _this.setState({
        slideIndex: _this.state.slideIndex + 1
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "closeDialog", function () {
      _this.setState({
        slideIndex: 0
      });

      _this.props.deactivatePlugin({
        name: "toolbar-onboarding"
      });
    });
    return _this;
  }

  (0, _createClass2.default)(Onboarding, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var showOnboarding = this.props.showOnboarding;

      if (!showOnboarding) {
        return null;
      }

      return _react.default.createElement(Overlay, null, _react.default.createElement(Container, null, _react.default.createElement(_Carousel.Carousel, {
        speed: this.state.slideIndex < 1 || this.state.slideIndex > 4 ? 500 : 0,
        dragging: true,
        transitionMode: "scroll",
        slideIndex: this.state.slideIndex,
        afterSlide: function afterSlide(slideIndex) {
          return _this2.setState({
            slideIndex: slideIndex
          });
        },
        renderNextSlide: function renderNextSlide(_ref) {
          var nextSlide = _ref.nextSlide,
              currentSlide = _ref.currentSlide;
          return currentSlide < 6 && _react.default.createElement(SlideControl, {
            onClick: nextSlide
          }, _react.default.createElement(_nextSlide.ReactComponent, null));
        },
        renderPreviousSlide: function renderPreviousSlide(_ref2) {
          var previousSlide = _ref2.previousSlide,
              currentSlide = _ref2.currentSlide;
          return currentSlide > 0 && _react.default.createElement(SlideControl, {
            onClick: previousSlide
          }, _react.default.createElement(_prevSlide.ReactComponent, null));
        }
      }, _react.default.createElement(InnerContainer, null, _react.default.createElement(_Slide.default, {
        nextSlide: this.nextSlide
      })), _react.default.createElement(InnerContainer, null, _react.default.createElement(_Slide2.default, {
        currentSlide: this.state.slideIndex + 1
      })), _react.default.createElement(InnerContainer, null, _react.default.createElement(_Slide3.default, {
        currentSlide: this.state.slideIndex + 1
      })), _react.default.createElement(InnerContainer, null, _react.default.createElement(_Slide4.default, {
        currentSlide: this.state.slideIndex + 1
      })), _react.default.createElement(InnerContainer, null, _react.default.createElement(_Slide5.default, {
        currentSlide: this.state.slideIndex + 1
      })), _react.default.createElement(InnerContainer, null, _react.default.createElement(_Slide6.default, {
        currentSlide: this.state.slideIndex + 1
      })), _react.default.createElement(InnerContainer, null, _react.default.createElement(_Slide7.default, {
        closeDialog: this.closeDialog
      })))));
    }
  }]);
  return Onboarding;
}(_react.default.Component);

var _default = (0, _compose2.default)((0, _redux.connect)(function (state) {
  return {
    showOnboarding: (0, _selectors.isPluginActive)("toolbar-onboarding")(state)
  };
}, {
  deactivatePlugin: _actions.deactivatePlugin
}), (0, _components.withKeyHandler)(), (0, _withHandlers2.default)({
  closeDialog: function closeDialog(_ref3) {
    var deactivatePlugin = _ref3.deactivatePlugin;
    return function () {
      deactivatePlugin({
        name: "toolbar-onboarding"
      });
    };
  }
}), (0, _lifecycle2.default)({
  componentDidUpdate: function componentDidUpdate() {
    var _this$props = this.props,
        showOnboarding = _this$props.showOnboarding,
        addKeyHandler = _this$props.addKeyHandler,
        removeKeyHandler = _this$props.removeKeyHandler,
        closeDialog = _this$props.closeDialog;
    showOnboarding ? addKeyHandler("escape", closeDialog) : removeKeyHandler("escape");
  }
}))(Onboarding);

exports.default = _default;
//# sourceMappingURL=Onboarding.js.map