"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _reactEmotion = _interopRequireDefault(require("react-emotion"));

var _Typography = require("webiny-ui/Typography");

var _List = require("webiny-ui/List");

var _editorMock = require("@svgr/webpack!../assets/editor-mock.svg");

var _helpLearnMore = require("@svgr/webpack!../assets/help-learn-more.svg");

var _learnMoreRightArrow = require("@svgr/webpack!../assets/learn-more-right-arrow.svg");

var SlideContainer =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "ere03jn0",
  label: "SlideContainer"
})({
  display: "flex",
  flexDirection: "column",
  width: 800,
  height: 600,
  alignItems: "center",
  justifyContent: "flex-end"
});
var EditorMock =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "ere03jn1",
  label: "EditorMock"
})({
  width: "100%",
  textAlign: "center",
  marginBottom: -10,
  position: "relative",
  ">svg.editor-mock": {
    width: 725,
    height: "100%"
  }
});
var TextHolder =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "ere03jn2",
  label: "TextHolder"
})({
  backgroundColor: "#B7A2BF",
  width: "100%",
  height: 245,
  display: "flex",
  zIndex: 1
});
var IconHolder =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "ere03jn3",
  label: "IconHolder"
})({
  backgroundColor: "#72457F",
  width: 200,
  height: 245,
  display: "flex",
  alignItems: "center",
  justifyContent: "center"
});
var TextHolderInner =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "ere03jn4",
  label: "TextHolderInner"
})({
  width: 600,
  height: 245,
  padding: 25,
  boxSizing: "border-box",
  color: "white",
  position: "relative"
});
var LearnMore =
/*#__PURE__*/
(0, _reactEmotion.default)("div", {
  target: "ere03jn5",
  label: "LearnMore"
})({
  width: 520,
  color: "white",
  backgroundColor: "#72457F",
  position: "absolute",
  bottom: 25,
  ">.mdc-list": {
    padding: "0 !important",
    ".mdc-list-item": {
      color: "white"
    },
    ".mdc-list-item__meta": {
      color: "white",
      width: 24,
      height: 24,
      display: "inline-flex",
      flexShrink: 0,
      alignItems: "center",
      justifyContent: "center"
    }
  }
});

var SlideOutline = function SlideOutline(props) {
  return React.createElement(SlideContainer, null, React.createElement(EditorMock, null, React.createElement(_editorMock.ReactComponent, {
    className: "editor-mock"
  }), props.editorContent), React.createElement(TextHolder, null, React.createElement(IconHolder, null, props.icon), React.createElement(TextHolderInner, null, React.createElement("h4", null, React.createElement(_Typography.Typography, {
    use: "headline4"
  }, props.title)), React.createElement("p", null, React.createElement(_Typography.Typography, {
    use: "body1"
  }, props.description)), React.createElement(LearnMore, null, React.createElement(_List.List, {
    nonInteractive: true
  }, React.createElement(_List.ListItem, {
    onClick: function onClick() {
      return window.open(props.learnMoreLink, "_blank");
    }
  }, React.createElement(_List.ListItemGraphic, null, React.createElement(_helpLearnMore.ReactComponent, null)), props.learnMoreText, React.createElement(_List.ListItemMeta, null, React.createElement(_learnMoreRightArrow.ReactComponent, null))))))));
};

var _default = SlideOutline;
exports.default = _default;
//# sourceMappingURL=SlideOutline.js.map