"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.redo = exports.undo = void 0;

var _platform = _interopRequireDefault(require("platform"));

var _react = _interopRequireDefault(require("react"));

var _redux = require("webiny-app-cms/editor/redux");

var _reduxUndo = require("redux-undo");

var _undoIcon = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/undo-icon.svg");

var _redoIcon = require("@svgr/webpack!webiny-app-cms/editor/assets/icons/redo-icon.svg");

var _Action = _interopRequireDefault(require("../Action"));

var metaKey = _platform.default.os.family === "OS X" ? "CMD" : "CTRL";
var undo = {
  name: "toolbar-undo",
  type: "cms-toolbar-bottom",
  renderAction: function renderAction() {
    return _react.default.createElement(_Action.default, {
      tooltip: "Undo (".concat(metaKey, "+Z)"),
      onClick: function onClick() {
        return (0, _redux.dispatch)(_reduxUndo.ActionCreators.undo());
      },
      icon: _react.default.createElement(_undoIcon.ReactComponent, null)
    });
  }
};
exports.undo = undo;
var redo = {
  name: "toolbar-redo",
  type: "cms-toolbar-bottom",
  renderAction: function renderAction() {
    return _react.default.createElement(_Action.default, {
      tooltip: "Redo (".concat(metaKey, "+SHIFT+Z)"),
      onClick: function onClick() {
        return (0, _redux.dispatch)(_reduxUndo.ActionCreators.redo());
      },
      icon: _react.default.createElement(_redoIcon.ReactComponent, null)
    });
  }
};
exports.redo = redo;
//# sourceMappingURL=index.js.map