"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var wrapMiddleware = function wrapMiddleware(types, middleware) {
  return function (store) {
    return function (next) {
      return function (action) {
        if (types.includes(action.type)) {
          middleware({
            store: store,
            next: next,
            action: action
          });
        } else {
          next(action);
        }
      };
    };
  };
};

var _default = function _default(redux) {
  return redux.middleware.map(function (mw) {
    return wrapMiddleware(mw.actions, mw.middleware);
  });
};

exports.default = _default;
//# sourceMappingURL=createMiddleware.js.map