"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "connect", {
  enumerable: true,
  get: function get() {
    return _connect.default;
  }
});
exports.dispatch = exports.addMiddleware = exports.addHigherOrderReducer = exports.addReducer = exports.createAction = exports.redux = exports.Redux = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _redux = require("redux");

var _invariant = _interopRequireDefault(require("invariant"));

var _createRootReducer = _interopRequireDefault(require("./createRootReducer"));

var _createMiddleware = _interopRequireDefault(require("./createMiddleware"));

var _connect = _interopRequireDefault(require("./connect"));

var Redux =
/*#__PURE__*/
function () {
  function Redux() {
    (0, _classCallCheck2.default)(this, Redux);
    (0, _defineProperty2.default)(this, "actionMeta", void 0);
    (0, _defineProperty2.default)(this, "store", void 0);
    (0, _defineProperty2.default)(this, "middleware", void 0);
    (0, _defineProperty2.default)(this, "reducers", void 0);
    (0, _defineProperty2.default)(this, "higherOrderReducers", void 0);
    this.reducers = [];
    this.higherOrderReducers = [];
    this.middleware = [];
    this.actionMeta = {};
  }

  (0, _createClass2.default)(Redux, [{
    key: "createAction",
    value: function createAction(type) {
      var _this = this;

      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      return function () {
        var payload = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var meta = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        return {
          type: type,
          payload: payload,
          meta: (0, _objectSpread2.default)({}, _this.actionMeta, {
            log: options.hasOwnProperty("log") ? options.log : true
          }, meta)
        };
      };
    }
  }, {
    key: "addReducer",
    value: function addReducer(actions, statePath, reducer) {
      (0, _invariant.default)(reducer, "Must pass a valid reducer function!");
      this.reducers.push({
        actions: actions,
        statePath: statePath,
        reducer: reducer
      });
    }
  }, {
    key: "addHigherOrderReducer",
    value: function addHigherOrderReducer(actions, statePath, factory) {
      this.higherOrderReducers.push({
        actions: actions,
        statePath: statePath,
        reducer: factory()
      });
    }
  }, {
    key: "addMiddleware",
    value: function addMiddleware(actions, middleware) {
      this.middleware.push({
        actions: actions,
        middleware: middleware
      });
    }
  }, {
    key: "initStore",
    value: function initStore() {
      var INIT_STATE = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var actionMeta = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      this.actionMeta = actionMeta; // dev tool

      var reduxDevTools = window.__REDUX_DEVTOOLS_EXTENSION_COMPOSE__;

      var composeEnhancers = reduxDevTools && reduxDevTools({
        predicate: function predicate(state, action) {
          return (0, _get2.default)(action, "meta.log", true);
        }
      }) || _redux.compose;

      this.store = (0, _redux.createStore)((0, _createRootReducer.default)(INIT_STATE, this), composeEnhancers(_redux.applyMiddleware.apply(void 0, (0, _toConsumableArray2.default)((0, _createMiddleware.default)(this)))));
      return this.store;
    }
  }]);
  return Redux;
}();

exports.Redux = Redux;
var redux = new Redux();
exports.redux = redux;

var createAction = function createAction(type, options) {
  return redux.createAction(type, options);
};

exports.createAction = createAction;

var addReducer = function addReducer(actions, statePath, reducer) {
  redux.addReducer(actions, statePath, reducer);
};

exports.addReducer = addReducer;

var addHigherOrderReducer = function addHigherOrderReducer(actions, statePath, factory) {
  redux.addHigherOrderReducer(actions, statePath, factory);
};

exports.addHigherOrderReducer = addHigherOrderReducer;

var addMiddleware = function addMiddleware(actions, middleware) {
  redux.addMiddleware(actions, middleware);
};

exports.addMiddleware = addMiddleware;

var dispatch = function dispatch(action) {
  return redux.store.dispatch(action);
};

exports.dispatch = dispatch;
//# sourceMappingURL=index.js.map