"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.getMenuBySlug = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var React = _interopRequireWildcard(require("react"));

var _reactApollo = require("react-apollo");

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _context = require("webiny-app-cms/context");

var _invariant = _interopRequireDefault(require("invariant"));

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    query GetMenuBySlug($slug: String!) {\n        cms {\n            menus: getMenuBySlug(slug: $slug) {\n                data {\n                    slug\n                    title\n                    items\n                }\n            }\n        }\n    }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var getMenuBySlug = (0, _graphqlTag.default)(_templateObject());
exports.getMenuBySlug = getMenuBySlug;

var Menu = function Menu(_ref) {
  var slug = _ref.slug,
      Component = _ref.component;
  (0, _invariant.default)(Component, "You must provide a valid Menu component name (via \"component\" prop).");
  return React.createElement(_reactApollo.Query, {
    query: getMenuBySlug,
    variables: {
      slug: slug
    }
  }, function (props) {
    var data = (0, _get2.default)(props, "data.cms.menus.data", {
      items: [],
      title: null,
      slug: null
    });
    return React.createElement(Component, (0, _extends2.default)({}, props, {
      data: data
    }));
  });
};

var _default = (0, _context.withCms)()(Menu);

exports.default = _default;
//# sourceMappingURL=Menu.js.map