"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _lifecycle2 = _interopRequireDefault(require("recompose/lifecycle"));

var _withHandlers2 = _interopRequireDefault(require("recompose/withHandlers"));

var _compose2 = _interopRequireDefault(require("recompose/compose"));

var React = _interopRequireWildcard(require("react"));

var _emotion = require("emotion");

function appendSDK(props) {
  var sdk = props.sdk,
      global = props.global,
      element = props.element;

  var _ref = (0, _get2.default)(element, "data.source") || {},
      url = _ref.url;

  if (!sdk || !url || window[global]) {
    return;
  }

  return new Promise(function (resolve) {
    var script = document.createElement("script");
    script.type = "text/javascript";
    script.src = encodeURI(sdk);
    script.setAttribute("async", "");
    script.setAttribute("charset", "utf-8");
    script.onload = resolve; // $FlowFixMe

    document.body.appendChild(script);
  });
}

function initEmbed(props) {
  var sdk = props.sdk,
      init = props.init,
      element = props.element;

  if (sdk && (0, _get2.default)(element, "data.source.url")) {
    var node = document.getElementById(element.id);

    if (typeof init === "function" && node) {
      init({
        props: props,
        node: node
      });
    }
  }
}

var centerAlign =
/*#__PURE__*/
(0, _emotion.css)({
  "*:first-child": {
    marginLeft: "auto !important",
    marginRight: "auto !important"
  }
}, "label:centerAlign;");

var _default = (0, _compose2.default)((0, _withHandlers2.default)({
  renderEmbed: function renderEmbed(_ref2) {
    var _renderEmbed = _ref2.renderEmbed,
        props = (0, _objectWithoutProperties2.default)(_ref2, ["renderEmbed"]);
    return function () {
      if (typeof _renderEmbed === "function") {
        return _renderEmbed(props);
      }

      var element = props.element;
      return React.createElement("div", {
        id: element.id,
        className: centerAlign,
        dangerouslySetInnerHTML: {
          __html: (0, _get2.default)(element, "data.oembed.html") || ""
        }
      });
    };
  }
}), (0, _lifecycle2.default)({
  componentDidMount: function () {
    var _componentDidMount = (0, _asyncToGenerator2.default)(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee() {
      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return appendSDK(this.props);

            case 2:
              initEmbed(this.props);

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function componentDidMount() {
      return _componentDidMount.apply(this, arguments);
    }

    return componentDidMount;
  }()
}))(function (_ref3) {
  var element = _ref3.element,
      renderEmbed = _ref3.renderEmbed;

  var _ref4 = (0, _get2.default)(element, "data.source") || {},
      url = _ref4.url;

  return url ? renderEmbed() : null;
});

exports.default = _default;
//# sourceMappingURL=OEmbed.js.map