"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _get3 = _interopRequireDefault(require("lodash/get"));

var scaling = {
  cover: {
    backgroundSize: "cover",
    backgroundRepeat: "no-repeat"
  },
  contain: {
    backgroundSize: "contain",
    backgroundRepeat: "no-repeat"
  },
  originalSize: {
    backgroundSize: "auto",
    backgroundRepeat: "no-repeat"
  },
  tile: {
    backgroundSize: "auto",
    backgroundRepeat: "repeat"
  },
  tileHorizontally: {
    backgroundSize: "auto",
    backgroundRepeat: "repeat-x"
  },
  tileVertically: {
    backgroundSize: "auto",
    backgroundRepeat: "repeat-y"
  }
};
var _default = {
  name: "cms-render-element-style-background",
  type: "cms-render-element-style",
  renderStyle: function renderStyle(_ref) {
    var element = _ref.element,
        style = _ref.style;

    var _get2 = (0, _get3.default)(element, "data.settings", {}),
        background = _get2.background;

    if (!background) {
      return style;
    }

    var color = background.color,
        image = background.image;

    if (image && image.src) {
      return (0, _objectSpread2.default)({}, style, scaling[image.scaling || "cover"], {
        backgroundImage: "url(".concat(image.src, ")"),
        backgroundPosition: image.position || "center center"
      });
    }

    if (color) {
      return (0, _objectSpread2.default)({}, style, {
        backgroundColor: color
      });
    }

    return style;
  }
};
exports.default = _default;
//# sourceMappingURL=index.js.map