"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _startCase2 = _interopRequireDefault(require("lodash/startCase"));

var _get3 = _interopRequireDefault(require("lodash/get"));

var _default = {
  name: "cms-render-element-style-border",
  type: "cms-render-element-style",
  renderStyle: function renderStyle(_ref) {
    var element = _ref.element,
        style = _ref.style;

    var _get2 = (0, _get3.default)(element, "data.settings", {}),
        border = _get2.border;

    if (!border) {
      return style;
    }

    if (border.radius) {
      style.borderRadius = border.radius;
    }

    ["top", "right", "bottom", "left"].forEach(function (side) {
      var sideEnabled = (0, _get3.default)(border, "borders.".concat(side));

      if (typeof sideEnabled === "undefined") {
        sideEnabled = true;
      }

      if (sideEnabled) {
        var Side = (0, _startCase2.default)(side);
        style["border".concat(Side, "Style")] = border.style;
        style["border".concat(Side, "Color")] = border.color;
        style["border".concat(Side, "Width")] = border.width;
      }
    });
    return style;
  }
};
exports.default = _default;
//# sourceMappingURL=index.js.map