"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _get3 = _interopRequireDefault(require("lodash/get"));

var _default = {
  name: "cms-render-element-style-margin",
  type: "cms-render-element-style",
  renderStyle: function renderStyle(_ref) {
    var element = _ref.element,
        style = _ref.style;

    var _get2 = (0, _get3.default)(element, "data.settings", {}),
        margin = _get2.margin;

    if (!margin) {
      return style;
    }

    var adv = margin.advanced;
    var _margin$desktop = margin.desktop,
        desktop = _margin$desktop === void 0 ? {} : _margin$desktop,
        _margin$mobile = margin.mobile,
        mobile = _margin$mobile === void 0 ? {} : _margin$mobile;
    ["top", "right", "bottom", "left"].forEach(function (side) {
      style["--desktop-margin-".concat(side)] = ((adv ? desktop[side] : desktop.all) || 0) + "px";
      style["--mobile-margin-".concat(side)] = ((adv ? mobile[side] : mobile.all) || 0) + "px";
    });
    return style;
  }
};
exports.default = _default;
//# sourceMappingURL=index.js.map