"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _get3 = _interopRequireDefault(require("lodash/get"));

var _default = {
  name: "cms-render-element-style-padding",
  type: "cms-render-element-style",
  renderStyle: function renderStyle(_ref) {
    var element = _ref.element,
        style = _ref.style;

    var _get2 = (0, _get3.default)(element, "data.settings", {}),
        padding = _get2.padding;

    if (!padding) {
      return style;
    }

    var adv = padding.advanced;
    var _padding$desktop = padding.desktop,
        desktop = _padding$desktop === void 0 ? {} : _padding$desktop,
        _padding$mobile = padding.mobile,
        mobile = _padding$mobile === void 0 ? {} : _padding$mobile;
    ["top", "right", "bottom", "left"].forEach(function (side) {
      style["--desktop-padding-".concat(side)] = ((adv ? desktop[side] : desktop.all) || 0) + "px";
      style["--mobile-padding-".concat(side)] = ((adv ? mobile[side] : mobile.all) || 0) + "px";
    });
    return style;
  }
};
exports.default = _default;
//# sourceMappingURL=index.js.map