"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _get3 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireDefault(require("react"));

var _ElementRoot = require("webiny-app-cms/render/components/ElementRoot");

var _components = require("webiny-app/components");

var Link = function Link(_ref) {
  var link = _ref.link,
      children = _ref.children;

  if (link && link.href) {
    return _react.default.createElement("a", {
      href: link.href,
      target: link.newTab ? "_blank" : "_self"
    }, children);
  }

  return children;
};

var Image = function Image(props) {
  var _get2 = (0, _get3.default)(props, "element.data", {}),
      _get2$image = _get2.image,
      image = _get2$image === void 0 ? {} : _get2$image,
      _get2$link = _get2.link,
      link = _get2$link === void 0 ? {} : _get2$link,
      _get2$settings = _get2.settings,
      settings = _get2$settings === void 0 ? {} : _get2$settings;

  var width = image.width,
      height = image.height,
      title = image.title,
      src = image.src;
  var _settings$horizontalA = settings.horizontalAlign,
      horizontalAlign = _settings$horizontalA === void 0 ? "center" : _settings$horizontalA;
  var style = {
    width: width,
    height: height
  };

  if (!style.width) {
    style.width = "100%";
  } else {
    style.width += style.width.endsWith("px") ? "" : "px";
  }

  if (!style.height) {
    style.height = "100%";
  } else {
    style.height += style.height.endsWith("px") ? "" : "px";
  }

  return _react.default.createElement(_ElementRoot.ElementRoot, {
    element: props.element,
    style: {
      textAlign: horizontalAlign
    },
    className: "webiny-cms-base-element-style webiny-cms-element-image"
  }, _react.default.createElement(Link, {
    link: link
  }, _react.default.createElement(_components.Image, {
    title: title,
    alt: title,
    style: style,
    src: src,
    srcSet: "auto"
  })));
};

var _default = Image;
exports.default = _default;
//# sourceMappingURL=Image.js.map