"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _pure2 = _interopRequireDefault(require("recompose/pure"));

var React = _interopRequireWildcard(require("react"));

var _warning = _interopRequireDefault(require("warning"));

var _reactApollo = require("react-apollo");

var _graphql = require("./graphql");

var _webinyPlugins = require("webiny-plugins");

var PagesList = (0, _pure2.default)(function () {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var _props$data = props.data,
      data = _props$data === void 0 ? {} : _props$data,
      theme = props.theme;
  var component = data.component,
      vars = (0, _objectWithoutProperties2.default)(data, ["component"]);
  var pageList = (0, _webinyPlugins.getPlugins)("cms-element-pages-list-component").find(function (cmp) {
    return cmp.name === component;
  });

  if (!pageList) {
    (0, _warning.default)(false, "Pages list component \"".concat(component, "\" is missing!"));
    return null;
  }

  var ListComponent = pageList.component;

  if (!ListComponent) {
    (0, _warning.default)(false, "React component is not defined for \"".concat(component, "\"!"));
    return null;
  }

  var sort = null;

  if (vars.sortBy) {
    // $FlowFixMe
    sort = (0, _defineProperty2.default)({}, vars.sortBy, vars.sortDirection || -1);
  }

  var variables = {
    category: vars.category,
    sort: sort,
    tags: vars.tags,
    tagsRule: vars.tagsRule,
    perPage: parseInt(vars.resultsPerPage),
    pagesLimit: parseInt(vars.pagesLimit),
    page: 1
  };
  return React.createElement(_reactApollo.Query, {
    query: _graphql.loadPages,
    variables: variables
  }, function (_ref) {
    var data = _ref.data,
        loading = _ref.loading,
        refetch = _ref.refetch;

    if (loading) {
      return null;
    }

    var pages = data.cms.listPublishedPages;

    if (!pages || !pages.data.length) {
      return null;
    }

    var prevPage = null;

    if (pages.meta.previousPage !== null) {
      prevPage = function prevPage() {
        return refetch((0, _objectSpread2.default)({}, variables, {
          page: pages.meta.previousPage
        }));
      };
    }

    var nextPage = null;

    if (pages.meta.nextPage !== null) {
      if (!variables.pagesLimit || variables.pagesLimit >= pages.meta.nextPage) {
        nextPage = function nextPage() {
          return refetch((0, _objectSpread2.default)({}, variables, {
            page: pages.meta.nextPage
          }));
        };
      }
    }

    return React.createElement(ListComponent, (0, _extends2.default)({}, pages, {
      nextPage: nextPage,
      prevPage: prevPage,
      theme: theme
    }));
  });
});
var _default = PagesList;
exports.default = _default;
//# sourceMappingURL=PagesList.js.map