"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _get2 = _interopRequireDefault(require("lodash/get"));

var React = _interopRequireWildcard(require("react"));

var _roundNavigate_before24px = require("@svgr/webpack!./icons/round-navigate_before-24px.svg");

var _roundNavigate_next24px = require("@svgr/webpack!./icons/round-navigate_next-24px.svg");

var formatDate = function formatDate(date) {
  var d = new Date(date);
  var year = d.getFullYear();
  var month = d.getMonth();
  var day = d.getDate();
  var monthNames = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
  return monthNames[month] + " " + day + ", " + year;
};

var PageItem = function PageItem(_ref) {
  var data = _ref.data,
      className = _ref.className;
  return React.createElement("a", {
    href: data.url,
    className: "webiny-cms-element-page-list__item " + className
  }, React.createElement("div", {
    className: "webiny-cms-element-page-list__media",
    style: {
      backgroundImage: "url(\"".concat((0, _get2.default)(data, "settings.general.image.src"), "\")")
    }
  }), React.createElement("div", {
    className: "webiny-cms-element-page-list__content"
  }, React.createElement("h3", {
    className: "webiny-cms-element-page-list__title webiny-cms-typography-h3"
  }, data.title), React.createElement("p", {
    className: "webiny-cms-element-page-list__snippet webiny-cms-typography-description"
  }, data.snippet), React.createElement("div", {
    className: "webiny-cms-element-page-list__date webiny-cms-typography-description"
  }, formatDate(data.publishedOn))));
};

var GridPageList = function GridPageList(_ref2) {
  var data = _ref2.data,
      nextPage = _ref2.nextPage,
      prevPage = _ref2.prevPage;
  return React.createElement("div", {
    className: "webiny-cms-element-page-list webiny-cms-element-page-list--grid"
  }, React.createElement("div", {
    className: "webiny-cms-element-page-list__items"
  }, data.map(function (page) {
    return React.createElement(PageItem, {
      key: page.id,
      data: page
    });
  })), React.createElement("div", {
    className: "webiny-cms-element-page-list__navigation"
  }, prevPage && React.createElement("a", {
    onClick: prevPage
  }, React.createElement(_roundNavigate_before24px.ReactComponent, null), " Prev page"), nextPage && React.createElement("a", {
    onClick: nextPage
  }, "Next page ", React.createElement(_roundNavigate_next24px.ReactComponent, null))));
};

var _default = GridPageList;
exports.default = _default;
//# sourceMappingURL=GridPageList.js.map