"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _get2 = _interopRequireDefault(require("lodash/get"));

var React = _interopRequireWildcard(require("react"));

var _reactApollo = require("react-apollo");

var _index = require("./Page/index");

var _context = require("webiny-app-cms/context");

var _invariant = _interopRequireDefault(require("invariant"));

var _Progress = require("webiny-ui/Progress");

var defaultPages = {
  error: null,
  notFound: null
};
var NO_404_PAGE_DEFAULT = "Could not fetch 404 (not found) page nor a default page was provided (set via CmsProvider).";
var NO_ERROR_PAGE_DEFAULT = "Could not fetch error page nor a default page was provided (set via CmsProvider).";

var Page = function Page(_ref) {
  var cms = _ref.cms,
      _ref$match = _ref.match,
      url = _ref$match.url,
      query = _ref$match.query;
  return React.createElement(_reactApollo.Query, {
    query: _index.getSettings
  }, function (_ref2) {
    var settings = _ref2.data,
        settingsLoading = _ref2.loading;
    return React.createElement(_reactApollo.Query, (0, _index.buildQueryProps)({
      url: url,
      query: query,
      defaultPages: defaultPages
    }), function (_ref3) {
      var data = _ref3.data,
          gqlError = _ref3.error,
          pageLoading = _ref3.loading;

      if (settingsLoading || pageLoading) {
        return React.createElement(_Progress.CircularProgress, null);
      }

      if (gqlError) {
        var _Component = (0, _get2.default)(cms, "defaults.pages.error");

        (0, _invariant.default)(_Component, NO_ERROR_PAGE_DEFAULT);
        return React.createElement(_Component, null);
      } // Not pretty, but "onComplete" callback executed too late. Will be executed only once.


      if (!defaultPages.error) {
        defaultPages.error = data.cms.errorPage;
      }

      if (!defaultPages.notFound) {
        defaultPages.notFound = data.cms.notFoundPage;
      }

      var _data$cms$page = data.cms.page,
          page = _data$cms$page.data,
          pageError = _data$cms$page.error;

      if (page) {
        return React.createElement(_index.Content, {
          settings: settings.settings,
          page: page
        });
      }

      if (pageError.code === "NOT_FOUND") {
        if (defaultPages.notFound) {
          return React.createElement(_index.Content, {
            settings: settings.settings,
            page: defaultPages.notFound.data
          });
        }

        var _Component2 = (0, _get2.default)(cms, "defaults.pages.notFound");

        (0, _invariant.default)(_Component2, NO_404_PAGE_DEFAULT);
        return React.createElement(_Component2, null);
      }

      if (defaultPages.error) {
        return React.createElement(_index.Content, {
          settings: settings.settings,
          page: defaultPages.error.data
        });
      }

      var Component = (0, _get2.default)(cms, "defaults.pages.error");
      (0, _invariant.default)(Component, NO_ERROR_PAGE_DEFAULT);
      return React.createElement(Component, null);
    });
  });
};

var _default = (0, _context.withCms)()(Page);

exports.default = _default;
//# sourceMappingURL=Page.js.map