"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _graphql = require("./graphql");

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                query CmsGetPage($url: String!) {\n                    cms {\n                        page: getPublishedPage(url: $url) {\n                            data ", "\n                            error {\n                                code\n                                message\n                            }\n                        }\n                        ", "\n                    }\n                }\n            "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                query getHomePage {\n                    cms {\n                        page: getHomePage {\n                            data ", "\n                            error {\n                                code\n                                message\n                            }\n                        }\n                        ", "\n                    }\n                }\n            "]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                query CmsGetPage($id: ID!) {\n                    cms {\n                        page: getPage(id: $id) {\n                            data ", "\n                            error {\n                                code\n                                message\n                            }\n                        }\n                        ", "\n                    }\n                }\n            "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var _default = function _default(_ref) {
  var url = _ref.url,
      query = _ref.query,
      defaultPages = _ref.defaultPages;
  var defaultPagesFields = "";

  if (!defaultPages.error) {
    defaultPagesFields += "".concat((0, _graphql.getErrorPageFields)());
  }

  if (!defaultPages.notFound) {
    defaultPagesFields += "".concat((0, _graphql.getNotFoundPageFields)());
  } // If a preview was requested (from admin):


  if (query.preview) {
    return {
      query: (0, _graphqlTag.default)(_templateObject(), (0, _graphql.getDataFields)(), defaultPagesFields),
      variables: {
        url: url,
        id: query.preview
      }
    };
  }

  if (url === "/") {
    return {
      query: (0, _graphqlTag.default)(_templateObject2(), (0, _graphql.getDataFields)(), defaultPagesFields)
    };
  }

  return {
    query: (0, _graphqlTag.default)(_templateObject3(), (0, _graphql.getDataFields)(), defaultPagesFields),
    variables: {
      url: url
    }
  };
};

exports.default = _default;
//# sourceMappingURL=buildQueryProps.js.map